/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/node/watcher/baseWatcher","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(J){for(var e=[],n=0,C=J.length;n<C;n++)e[n]=ae[J[n]];return e};define(ae[136],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=C,e.$hb=P,e.$ib=O,e.$jb=j,e.$kb=E,e.$lb=u,e.$nb=b,e.$ob=y,e.$pb=k,e.$qb=d,e.$rb=m;function n(v,w,g){const f=C(v,w);if(f!==-1)return v[f]}function C(v,w,g=v.length-1){for(let f=g;f>=0;f--){const h=v[f];if(w(h))return f}return-1}function P(v,w){const g=O(v,w);return g===-1?void 0:v[g]}function O(v,w,g=0,f=v.length){let h=g,$=f;for(;h<$;){const a=Math.floor((h+$)/2);w(v[a])?h=a+1:$=a}return h-1}function j(v,w){const g=E(v,w);return g===v.length?void 0:v[g]}function E(v,w,g=0,f=v.length){let h=g,$=f;for(;h<$;){const a=Math.floor((h+$)/2);w(v[a])?$=a:h=a+1}return h}function u(v,w,g=0,f=v.length){const h=E(v,w,g,f);return h===v.length?-1:h}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const g=O(this.e,w,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=c;function b(v,w){if(v.length===0)return;let g=v[0];for(let f=1;f<v.length;f++){const h=v[f];w(h,g)>0&&(g=h)}return g}function y(v,w){if(v.length===0)return;let g=v[0];for(let f=1;f<v.length;f++){const h=v[f];w(h,g)>=0&&(g=h)}return g}function k(v,w){return b(v,(g,f)=>-w(g,f))}function d(v,w){if(v.length===0)return-1;let g=0;for(let f=1;f<v.length;f++){const h=v[f];w(h,v[g])>0&&(g=f)}return g}function m(v,w){for(const g of v){const f=w(g);if(f!==void 0)return f}}}),define(ae[137],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=C,e.$M=P,e.$N=O;function n(j,E){const u=Object.create(null);for(const c of j){const b=E(c);let y=u[b];y||(y=u[b]=[]),y.push(c)}return u}function C(j,E){const u=[],c=[];for(const b of j)E.has(b)||u.push(b);for(const b of E)j.has(b)||c.push(b);return{removed:u,added:c}}function P(j,E){const u=[],c=[];for(const[b,y]of j)E.has(b)||u.push(y);for(const[b,y]of E)j.has(b)||c.push(y);return{removed:u,added:c}}function O(j,E){const u=new Set;for(const c of E)j.has(c)&&u.add(c);return u}}),define(ae[138],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=e.$Ct=e.$Bt=void 0;function n(E,u){const c=Math.pow(10,u);return Math.round(E*c)/c}class C{constructor(u,c,b,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=n(Math.max(Math.min(1,y),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}e.$Bt=C;class P{constructor(u,c,b,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,b),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,b=u.g/255,y=u.b/255,k=u.a,d=Math.max(c,b,y),m=Math.min(c,b,y);let v=0,w=0;const g=(m+d)/2,f=d-m;if(f>0){switch(w=Math.min(g<=.5?f/(2*g):f/(2-2*g),1),d){case c:v=(b-y)/f+(b<y?6:0);break;case b:v=(y-c)/f+2;break;case y:v=(c-b)/f+4;break}v*=60,v=Math.round(v)}return new P(v,w,g,k)}static i(u,c,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?u+(c-u)*6*b:b<1/2?c:b<2/3?u+(c-u)*(2/3-b)*6:u}static toRGBA(u){const c=u.h/360,{s:b,l:y,a:k}=u;let d,m,v;if(b===0)d=m=v=y;else{const w=y<.5?y*(1+b):y+b-y*b,g=2*y-w;d=P.i(g,w,c+1/3),m=P.i(g,w,c),v=P.i(g,w,c-1/3)}return new C(Math.round(d*255),Math.round(m*255),Math.round(v*255),k)}}e.$Ct=P;class O{constructor(u,c,b,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,b),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,b=u.g/255,y=u.b/255,k=Math.max(c,b,y),d=Math.min(c,b,y),m=k-d,v=k===0?0:m/k;let w;return m===0?w=0:k===c?w=((b-y)/m%6+6)%6:k===b?w=(y-c)/m+2:w=(c-b)/m+4,new O(Math.round(w*60),v,k,u.a)}static toRGBA(u){const{h:c,s:b,v:y,a:k}=u,d=y*b,m=d*(1-Math.abs(c/60%2-1)),v=y-d;let[w,g,f]=[0,0,0];return c<60?(w=d,g=m):c<120?(w=m,g=d):c<180?(g=d,f=m):c<240?(g=m,f=d):c<300?(w=m,f=d):c<=360&&(w=d,f=m),w=Math.round((w+v)*255),g=Math.round((g+v)*255),f=Math.round((f+v)*255),new C(w,g,f,k)}}e.$Dt=O;class j{static fromHex(u){return j.Format.CSS.parseHex(u)||j.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof C)this.rgba=u;else if(u instanceof P)this.i=u,this.rgba=P.toRGBA(u);else if(u instanceof O)this.j=u,this.rgba=O.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&C.equals(this.rgba,u.rgba)&&P.equals(this.hsla,u.hsla)&&O.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=j.k(this.rgba.r),c=j.k(this.rgba.g),b=j.k(this.rgba.b),y=.2126*u+.7152*c+.0722*b;return n(y,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),b=u.getRelativeLuminance();return c>b?(c+.05)/(b+.05):(b+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),b=u.getRelativeLuminance();return c>b}isDarkerThan(u){const c=this.getRelativeLuminance(),b=u.getRelativeLuminance();return c<b}lighten(u){return new j(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new j(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:b,b:y,a:k}=this.rgba;return new j(new C(c,b,y,k*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,b=this.rgba.a,y=c.a,k=b+y*(1-b);if(k<1e-6)return j.transparent;const d=this.rgba.r*b/k+c.r*y*(1-b)/k,m=this.rgba.g*b/k+c.g*y*(1-b)/k,v=this.rgba.b*b/k+c.b*y*(1-b)/k;return new j(new C(d,m,v,k))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:b,b:y,a:k}=this.rgba;return new j(new C(u.rgba.r-k*(u.rgba.r-c),u.rgba.g-k*(u.rgba.g-b),u.rgba.b-k*(u.rgba.b-y),1))}flatten(...u){const c=u.reduceRight((b,y)=>j.o(y,b));return j.o(this,c)}static o(u,c){const b=1-u.rgba.a;return new j(new C(b*c.rgba.r+u.rgba.a*u.rgba.r,b*c.rgba.g+u.rgba.a*u.rgba.g,b*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(u,c,b){if(u.isLighterThan(c))return u;b=b||.5;const y=u.getRelativeLuminance(),k=c.getRelativeLuminance();return b=b*(k-y)/k,u.lighten(b)}static getDarkerColor(u,c,b){if(u.isDarkerThan(c))return u;b=b||.5;const y=u.getRelativeLuminance(),k=c.getRelativeLuminance();return b=b*(y-k)/y,u.darken(b)}static{this.white=new j(new C(255,255,255,1))}static{this.black=new j(new C(0,0,0,1))}static{this.red=new j(new C(255,0,0,1))}static{this.blue=new j(new C(0,0,255,1))}static{this.green=new j(new C(0,255,0,1))}static{this.cyan=new j(new C(0,255,255,1))}static{this.lightgrey=new j(new C(211,211,211,1))}static{this.transparent=new j(new C(0,0,0,0))}}e.$Et=j,function(E){let u;(function(c){let b;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=d;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=m;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function w(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}y.formatHex=g;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function h(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=h;function $(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new C(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new C(r,i,s,l/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new E(new C(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new E(new C(16*r+r,16*i+i,16*s+s,(16*l+l)/255))}return null}y.parseHex=$;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=c.CSS||(c.CSS={}))})(u=E.Format||(E.Format={}))}(j||(e.$Et=j={}))}),define(ae[50],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=C,e.$Mh=P,e.$Nh=O;function n(j){return(E,u,c)=>{let b=null,y=null;if(typeof c.value=="function"?(b="value",y=c.value):typeof c.get=="function"&&(b="get",y=c.get),!y)throw new Error("not supported");c[b]=j(y,u)}}function C(j,E,u){let c=null,b=null;if(typeof u.value=="function"?(c="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",b=u.get),!b)throw new Error("not supported");const y=`$memoize$${E}`;u[c]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,k)}),this[y]}}function P(j,E,u){return n((c,b)=>{const y=`$debounce$${b}`,k=`$debounce$result$${b}`;return function(...d){this[k]||(this[k]=u?u():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...d),d=[this[k]]),this[y]=setTimeout(()=>{c.apply(this,d),this[k]=u?u():void 0},j)}})}function O(j,E,u){return n((c,b)=>{const y=`$throttle$timer$${b}`,k=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...v){if(this[k]||(this[k]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[m])return;const w=this[d]+j;w<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[k]]),this[k]=u?u():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),c.apply(this,[this[k]]),this[k]=u?u():void 0},w-Date.now()))}})}}),define(ae[15],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=P,e.$1=O,e.$2=j,e.$3=E,e.$4=c,e.$6=y,e.$7=k,e.$8=d,e.$0=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function C(a){e.$X.setUnexpectedErrorHandler(a)}function P(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(a){c(a)||e.$X.onUnexpectedError(a)}function j(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(a)}}return a}const u="Canceled";function c(a){return a instanceof b?!0:a instanceof Error&&a.name===u&&a.message===u}class b extends Error{constructor(){super(u),this.name=this.message}}e.$5=b;function y(){const a=new Error(u);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const o=new h;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(ae[22],ce([0,1,15,136]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=P,e.$tb=O,e.$ub=j,e.$vb=E,e.$wb=u,e.$xb=c,e.$yb=b,e.$zb=y,e.$Ab=k,e.$Bb=d,e.$Cb=m,e.$Db=v,e.$Eb=w,e.top=g,e.$Gb=f,e.$Hb=$,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=i,e.$Nb=s,e.$Ob=l,e.$Pb=p,e.$Qb=D,e.$Rb=I,e.$Sb=S,e.$Tb=R,e.$Ub=B,e.$Vb=L,e.$Wb=W,e.$Xb=U,e.$Yb=x,e.$Zb=le,e.$1b=se,e.$2b=ue,e.$3b=Y,e.$4b=Z,e.$5b=q,e.$6b=M,e.$7b=z,e.$8b=oe,e.$$b=A;function P(K,V=0){return K[K.length-(1+V)]}function O(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function j(K,V,H=(T,Q)=>T===Q){if(K===V)return!0;if(!K||!V||K.length!==V.length)return!1;for(let T=0,Q=K.length;T<Q;T++)if(!H(K[T],V[T]))return!1;return!0}function E(K,V){const H=K.length-1;V<H&&(K[V]=K[H]),K.pop()}function u(K,V,H){return c(K.length,T=>H(K[T],V))}function c(K,V){let H=0,T=K-1;for(;H<=T;){const Q=(H+T)/2|0,te=V(Q);if(te<0)H=Q+1;else if(te>0)T=Q-1;else return Q}return-(H+1)}function b(K,V,H){if(K=K|0,K>=V.length)throw new TypeError("invalid index");const T=V[Math.floor(V.length*Math.random())],Q=[],te=[],fe=[];for(const me of V){const ke=H(me,T);ke<0?Q.push(me):ke>0?te.push(me):fe.push(me)}return K<Q.length?b(K,Q,H):K<Q.length+fe.length?fe[0]:b(K-(Q.length+fe.length),te,H)}function y(K,V){const H=[];let T;for(const Q of K.slice(0).sort(V))!T||V(T[0],Q)!==0?(T=[Q],H.push(T)):T.push(Q);return H}function*k(K,V){let H,T;for(const Q of K)T!==void 0&&V(T,Q)?H.push(Q):(H&&(yield H),H=[Q]),T=Q;H&&(yield H)}function d(K,V){for(let H=0;H<=K.length;H++)V(H===0?void 0:K[H-1],H===K.length?void 0:K[H])}function m(K,V){for(let H=0;H<K.length;H++)V(H===0?void 0:K[H-1],K[H],H+1===K.length?void 0:K[H+1])}function v(K,V,H){const T=[];function Q(me,ke,Se){if(ke===0&&Se.length===0)return;const Oe=T[T.length-1];Oe&&Oe.start+Oe.deleteCount===me?(Oe.deleteCount+=ke,Oe.toInsert.push(...Se)):T.push({start:me,deleteCount:ke,toInsert:Se})}let te=0,fe=0;for(;;){if(te===K.length){Q(te,0,V.slice(fe));break}if(fe===V.length){Q(te,K.length-te,[]);break}const me=K[te],ke=V[fe],Se=H(me,ke);Se===0?(te+=1,fe+=1):Se<0?(Q(te,1,[]),te+=1):Se>0&&(Q(te,0,[ke]),fe+=1)}return T}function w(K,V,H){const T=v(K,V,H),Q=[],te=[];for(const fe of T)Q.push(...K.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:Q,added:te}}function g(K,V,H){if(H===0)return[];const T=K.slice(0,H).sort(V);return h(K,V,T,H,K.length),T}function f(K,V,H,T,Q){return H===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const me=K.length,ke=K.slice(0,H).sort(V);for(let Se=H,Oe=Math.min(H+T,me);Se<me;Se=Oe,Oe=Math.min(Oe+T,me)){if(Se>H&&await new Promise(Ve=>setTimeout(Ve)),Q&&Q.isCancellationRequested)throw new n.$5;h(K,V,ke,Se,Oe)}return ke})().then(te,fe)})}function h(K,V,H,T,Q){for(const te=H.length;T<Q;T++){const fe=K[T];if(V(fe,H[te-1])<0){H.pop();const me=(0,C.$kb)(H,ke=>V(fe,ke)<0);H.splice(me,0,fe)}}}function $(K){return K.filter(V=>!!V)}function a(K){let V=0;for(let H=0;H<K.length;H++)K[H]&&(K[V]=K[H],V+=1);K.length=V}function t(K,V,H){K.splice(H,0,K.splice(V,1)[0])}function o(K){return!Array.isArray(K)||K.length===0}function r(K){return Array.isArray(K)&&K.length>0}function i(K,V=H=>H){const H=new Set;return K.filter(T=>{const Q=V(T);return H.has(Q)?!1:(H.add(Q),!0)})}function s(K){const V=new Set;return H=>{const T=K(H);return V.has(T)?!1:(V.add(T),!0)}}function l(K,V){return K.length>0?K[0]:V}function p(K,V){return K.length>0?K[K.length-1]:V}function D(K,V,H=(T,Q)=>T===Q){let T=0;for(let Q=0,te=Math.min(K.length,V.length);Q<te&&H(K[Q],V[Q]);Q++)T++;return T}function I(K){return[].concat(...K)}function S(K,V){let H=typeof V=="number"?K:0;typeof V=="number"?H=K:(H=0,V=K);const T=[];if(H<=V)for(let Q=H;Q<V;Q++)T.push(Q);else for(let Q=H;Q>V;Q--)T.push(Q);return T}function R(K,V,H){return K.reduce((T,Q)=>(T[V(Q)]=H?H(Q):Q,T),Object.create(null))}function B(K,V){return K.push(V),()=>L(K,V)}function L(K,V){const H=K.indexOf(V);if(H>-1)return K.splice(H,1),V}function W(K,V,H){const T=K.slice(0,V),Q=K.slice(V);return T.concat(H,Q)}function U(K,V){let H;if(typeof V=="number"){let T=V;H=()=>{const Q=Math.sin(T++)*179426549;return Q-Math.floor(Q)}}else H=Math.random;for(let T=K.length-1;T>0;T-=1){const Q=Math.floor(H()*(T+1)),te=K[T];K[T]=K[Q],K[Q]=te}}function x(K,V){const H=K.indexOf(V);H>-1&&(K.splice(H,1),K.unshift(V))}function le(K,V){const H=K.indexOf(V);H>-1&&(K.splice(H,1),K.push(V))}function se(K,V){for(const H of V)K.push(H)}function ue(K,V){return Array.isArray(K)?K.map(V):V(K)}function Y(K){return Array.isArray(K)?K:[K]}function Z(K){return K[Math.floor(Math.random()*K.length)]}function q(K,V,H){const T=N(K,V),Q=K.length,te=H.length;K.length=Q+te;for(let fe=Q-1;fe>=T;fe--)K[fe+te]=K[fe];for(let fe=0;fe<te;fe++)K[fe+T]=H[fe]}function M(K,V,H,T){const Q=N(K,V);let te=K.splice(Q,H);return te===void 0&&(te=[]),q(K,Q,T),te}function N(K,V){return V<0?Math.max(V+K.length,0):Math.min(V,K.length)}var G;(function(K){function V(te){return te<0}K.isLessThan=V;function H(te){return te<=0}K.isLessThanOrEqual=H;function T(te){return te>0}K.isGreaterThan=T;function Q(te){return te===0}K.isNeitherLessOrGreaterThan=Q,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function z(K,V){return(H,T)=>V(K(H),K(T))}function oe(...K){return(V,H)=>{for(const T of K){const Q=T(V,H);if(!G.isNeitherLessOrGreaterThan(Q))return Q}return G.neitherLessOrGreaterThan}}const he=(K,V)=>K-V;e.$9b=he;const X=(K,V)=>(0,e.$9b)(K?1:0,V?1:0);e.$0b=X;function A(K){return(V,H)=>-K(V,H)}class F{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let H=this.c;for(;H<this.g.length&&V(this.g[H]);)H++;const T=H===this.c?null:this.g.slice(this.c,H);return this.c=H,T}takeFromEndWhile(V){let H=this.d;for(;H>=0&&V(this.g[H]);)H--;const T=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,T}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const H=this.g.slice(this.c,this.c+V);return this.c+=V,H}}e.$_b=F;class _{static{this.empty=new _(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(H=>(V(H),!0))}toArray(){const V=[];return this.iterate(H=>(V.push(H),!0)),V}filter(V){return new _(H=>this.iterate(T=>V(T)?H(T):!0))}map(V){return new _(H=>this.iterate(T=>H(V(T))))}some(V){let H=!1;return this.iterate(T=>(H=V(T),!H)),H}findFirst(V){let H;return this.iterate(T=>V(T)?(H=T,!1):!0),H}findLast(V){let H;return this.iterate(T=>(V(T)&&(H=T),!0)),H}findLastMaxBy(V){let H,T=!0;return this.iterate(Q=>((T||G.isGreaterThan(V(Q,H)))&&(T=!1,H=Q),!0)),H}}e.$ac=_;class re{constructor(V){this.c=V}static createSortPermutation(V,H){const T=Array.from(V.keys()).sort((Q,te)=>H(V[Q],V[te]));return new re(T)}apply(V){return V.map((H,T)=>V[this.c[T]])}inverse(){const V=this.c.slice();for(let H=0;H<this.c.length;H++)V[this.c[H]]=H;return new re(V)}}e.$bc=re}),define(ae[139],ce([0,1,15]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$0c=P,e.$$c=O,e.$_c=j,e.$ad=E,e.$bd=u;function C(c,b){if(!c)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function P(c,b="Unreachable"){throw new Error(b)}function O(c){if(!c)throw new n.$cb("Assertion Failed")}function j(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function u(c,b){let y=0;for(;y<c.length-1;){const k=c[y],d=c[y+1];if(!b(k,d))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(C,P){const O=this;let j=!1,E;return function(){if(j)return E;if(j=!0,P)try{E=C.apply(O,arguments)}finally{P()}else E=C.apply(O,arguments);return E}}}),define(ae[71],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(C){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=P;const O=Object.freeze([]);function j(){return O}C.empty=j;function*E(t){yield t}C.single=E;function u(t){return P(t)?t:E(t)}C.wrap=u;function c(t){return t||O}C.from=c;function*b(t){for(let o=t.length-1;o>=0;o--)yield t[o]}C.reverse=b;function y(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}C.first=k;function d(t,o){for(const r of t)if(o(r))return!0;return!1}C.some=d;function m(t,o){for(const r of t)if(o(r))return r}C.find=m;function*v(t,o){for(const r of t)o(r)&&(yield r)}C.filter=v;function*w(t,o){let r=0;for(const i of t)yield o(i,r++)}C.map=w;function*g(...t){for(const o of t)yield*o}C.concat=g;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}C.reduce=f;function*h(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}C.slice=h;function $(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const l=i.next();if(l.done)return[r,C.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}C.consume=$;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}C.asyncToArray=a})(n||(e.Iterable=n={}))}),define(ae[42],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=j,e.$tn=y,e.$un=k,e.$vn=d,e.$wn=m,e.$xn=v,e.$yn=w,e.$zn=g,e.$An=f,e.$Bn=h,e.$Cn=$,e.$Dn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function j(t,o=!1){let r=0;const i=t.length;let s="",l=0,p=16,D=0;function I(x){let le=0,se=0;for(;le<x;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)se=se*16+ue-48;else if(ue>=65&&ue<=70)se=se*16+ue-65+10;else if(ue>=97&&ue<=102)se=se*16+ue-97+10;else break;r++,le++}return le<x&&(se=-1),se}function S(x){r=x,s="",l=0,p=16,D=0}function R(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return D=3,t.substring(x,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else D=3;return t.substring(x,le)}function B(){let x="",le=r;for(;;){if(r>=i){x+=t.substring(le,r),D=2;break}const se=t.charCodeAt(r);if(se===34){x+=t.substring(le,r),r++;break}if(se===92){if(x+=t.substring(le,r),r++,r>=i){D=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=I(4);Y>=0?x+=String.fromCharCode(Y):D=4;break}default:D=5}le=r;continue}if(se>=0&&se<=31)if(u(se)){x+=t.substring(le,r),D=2;break}else D=6;r++}return x}function L(){if(s="",D=0,l=r,r>=i)return l=i,p=17;let x=t.charCodeAt(r);if(E(x)){do r++,s+=String.fromCharCode(x),x=t.charCodeAt(r);while(E(x));return p=15}if(u(x))return r++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),p=14;switch(x){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,s=B(),p=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!u(t.charCodeAt(r));)r++;return s=t.substring(le,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const se=i-1;let ue=!1;for(;r<se;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,D=1),s=t.substring(le,r),p=13}return s+=String.fromCharCode(x),r++,p=16}case 45:if(s+=String.fromCharCode(x),r++,r===i||!c(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),p=11;default:for(;r<i&&W(x);)r++,x=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return s+=String.fromCharCode(x),r++,p=16}}function W(x){if(E(x)||u(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let x;do x=L();while(x>=12&&x<=15);return x}return{setPosition:S,getPosition:()=>r,scan:o?U:L,getToken:()=>p,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>D}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function y(t,o){const r=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function D(I,S,R,B){l.value=I,l.offset=S,l.length=R,l.type=B,l.colonOffset=void 0,s=l}try{h(t,{onObjectBegin:(I,S)=>{if(o<=I)throw i;s=void 0,p=o>I,r.push("")},onObjectProperty:(I,S,R)=>{if(o<S||(D(I,S,R,"property"),r[r.length-1]=I,o<=S+R))throw i},onObjectEnd:(I,S)=>{if(o<=I)throw i;s=void 0,r.pop()},onArrayBegin:(I,S)=>{if(o<=I)throw i;s=void 0,r.push(0)},onArrayEnd:(I,S)=>{if(o<=I)throw i;s=void 0,r.pop()},onLiteralValue:(I,S,R)=>{if(o<S||(D(I,S,R,a(I)),o<=S+R))throw i},onSeparator:(I,S,R)=>{if(o<=S)throw i;if(I===":"&&s&&s.type==="property")s.colonOffset=S,p=!1,s=void 0;else if(I===","){const B=r[r.length-1];typeof B=="number"?r[r.length-1]=B+1:(p=!0,r[r.length-1]=""),s=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:s,isAtPropertyKey:p,matches:I=>{let S=0;for(let R=0;S<I.length&&R<r.length;R++)if(I[S]===r[R]||I[S]==="*")S++;else if(I[S]!=="**")return!1;return S===I.length}}}function k(t,o=[],r=O.DEFAULT){let i=null,s=[];const l=[];function p(I){Array.isArray(s)?s.push(I):i!==null&&(s[i]=I)}return h(t,{onObjectBegin:()=>{const I={};p(I),l.push(s),s=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const I=[];p(I),l.push(s),s=I,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:p,onError:(I,S,R)=>{o.push({error:I,offset:S,length:R})}},r),s[0]}function d(t,o=[],r=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function l(I){return i.children.push(I),I}h(t,{onObjectBegin:I=>{i=l({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,S,R)=>{i=l({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:S,length:R,parent:i})},onObjectEnd:(I,S)=>{i.length=I+S-i.offset,i=i.parent,s(I+S)},onArrayBegin:(I,S)=>{i=l({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,S)=>{i.length=I+S-i.offset,i=i.parent,s(I+S)},onLiteralValue:(I,S,R)=>{l({type:a(I),offset:S,length:R,parent:i,value:I}),s(S+R)},onSeparator:(I,S,R)=>{i.type==="property"&&(I===":"?i.colonOffset=S:I===","&&s(S))},onError:(I,S,R)=>{o.push({error:I,offset:S,length:R})}},r);const D=i.children[0];return D&&delete D.parent,D}function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function f(t,o,r=!1){if(g(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const l=f(i[s],o,r);if(l)return l}return t}}function h(t,o,r=O.DEFAULT){const i=j(t,!1);function s(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(z){return z?oe=>z(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=s(o.onObjectBegin),D=l(o.onObjectProperty),I=s(o.onObjectEnd),S=s(o.onArrayBegin),R=s(o.onArrayEnd),B=l(o.onLiteralValue),L=l(o.onSeparator),W=s(o.onComment),U=l(o.onError),x=r&&r.disallowComments,le=r&&r.allowTrailingComma;function se(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:x||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(z){case 12:case 13:x?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return z}}}function ue(z,oe=[],he=[]){if(U(z),oe.length+he.length>0){let X=i.getToken();for(;X!==17;){if(oe.indexOf(X)!==-1){se();break}else if(he.indexOf(X)!==-1)break;X=se()}}}function Y(z){const oe=i.getTokenValue();return z?B(oe):D(oe),se(),!0}function Z(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&(ue(2),z=0)}catch{ue(2)}B(z);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return se(),!0}function q(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(L(":"),se(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function M(){p(),se();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||ue(4,[],[]),L(","),se(),i.getToken()===2&&le)break}else z&&ue(6,[],[]);q()||ue(4,[],[2,5]),z=!0}return I(),i.getToken()!==2?ue(7,[2],[]):se(),!0}function N(){S(),se();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||ue(4,[],[]),L(","),se(),i.getToken()===4&&le)break}else z&&ue(6,[],[]);G()||ue(4,[],[4,5]),z=!0}return R(),i.getToken()!==4?ue(8,[4],[]):se(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return M();case 10:return Y(!0);default:return Z()}}return se(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}function $(t,o){const r=j(t),i=[];let s,l=0,p;do switch(p=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==p&&i.push(t.substring(l,p)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(s!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[140],ce([0,1,42]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=C,e.$Fn=P,e.$Gn=E,e.$Hn=u;function C(c,b,y){let k,d,m,v,w;if(b){for(v=b.offset,w=v+b.length,m=v;m>0&&!u(c,m-1);)m--;let p=w;for(;p<c.length&&!u(c,p);)p++;d=c.substring(m,p),k=j(d,y)}else d=c,k=0,m=0,v=0,w=c.length;const g=E(y,c);let f=!1,h=0,$;y.insertSpaces?$=O(" ",y.tabSize||4):$="	";const a=(0,n.$sn)(d,!1);let t=!1;function o(){return g+O($,k+h)}function r(){let p=a.scan();for(f=!1;p===15||p===14;)f=f||p===14,p=a.scan();return t=p===16||a.getTokenError()!==0,p}const i=[];function s(p,D,I){!t&&D<w&&I>v&&c.substring(D,I)!==p&&i.push({offset:D,length:I-D,content:p})}let l=r();if(l!==17){const p=a.getTokenOffset()+m,D=O($,k);s(D,m,p)}for(;l!==17;){let p=a.getTokenOffset()+a.getTokenLength()+m,D=r(),I="";for(;!f&&(D===12||D===13);){const R=a.getTokenOffset()+m;s(" ",p,R),p=a.getTokenOffset()+a.getTokenLength()+m,I=D===12?o():"",D=r()}if(D===2)l!==1&&(h--,I=o());else if(D===4)l!==3&&(h--,I=o());else{switch(l){case 3:case 1:h++,I=o();break;case 5:case 12:I=o();break;case 13:f?I=o():I=" ";break;case 6:I=" ";break;case 10:if(D===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?I=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}f&&(D===12||D===13)&&(I=o())}const S=a.getTokenOffset()+m;s(I,p,S),l=D}return i}function P(c,b){const y=JSON.stringify(c,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?y.replace(/\r\n|\r|\n/g,b.eol):y}function O(c,b){let y="";for(let k=0;k<b;k++)y+=c;return y}function j(c,b){let y=0,k=0;const d=b.tabSize||4;for(;y<c.length;){const m=c.charAt(y);if(m===" ")k++;else if(m==="	")k+=d;else break;y++}return Math.floor(k/d)}function E(c,b){for(let y=0;y<b.length;y++){const k=b.charAt(y);if(k==="\r")return y+1<b.length&&b.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}function u(c,b){return`\r
`.indexOf(c.charAt(b))!==-1}}),define(ae[103],ce([0,1,42,140]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=P,e.$Jn=O,e.$Kn=j,e.$Ln=E,e.$Mn=u;function P(c,b,y){return O(c,b,void 0,y)}function O(c,b,y,k,d){const m=b.slice(),v=[],w=(0,n.$vn)(c,v);let g,f;for(;m.length>0&&(f=m.pop(),g=(0,n.$wn)(w,m),g===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if(g)if(g.type==="object"&&typeof f=="string"&&Array.isArray(g.children)){const h=(0,n.$wn)(g,[f]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const $=g.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if($>0){const o=g.children[$-1];a=o.offset+o.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return j(c,{offset:a,length:t-a,content:""},k)}else return j(c,{offset:h.offset,length:h.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const $=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=d?d(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(a>0){const o=g.children[a-1];t={offset:o.offset+o.length,length:0,content:","+$}}else g.children.length===0?t={offset:g.offset+1,length:0,content:$}:t={offset:g.offset+1,length:0,content:$+","};return j(c,t,k)}}else if(g.type==="array"&&typeof f=="number"&&Array.isArray(g.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let $;if(g.children.length===0||f===0)$={offset:g.offset+1,length:0,content:g.children.length===0?h:h+","};else{const a=f===-1||f>g.children.length?g.children.length:f,t=g.children[a-1];$={offset:t.offset+t.length,length:0,content:","+h}}return j(c,$,k)}else{const h=f,$=g.children[h];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===h){const t=g.children[h-1],o=t.offset+t.length,r=g.offset+g.length;a={offset:o,length:r-2-o,content:""}}else a={offset:$.offset,length:g.children[h+1].offset-$.offset,content:""};return j(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${g.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return j(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},k)}}function j(c,b,y){let k=E(c,b),d=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;d>0&&!(0,C.$Hn)(k,d-1);)d--;for(;m<k.length&&!(0,C.$Hn)(k,m);)m++}const v=(0,C.$En)(k,{offset:d,length:m-d},y);for(let g=v.length-1;g>=0;g--){const f=v[g];k=E(k,f),d=Math.min(d,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const w=c.length-(k.length-m)-d;return[{offset:d,length:w,content:k.substring(d,m)}]}function E(c,b){return c.substring(0,b.offset)+b.content+c.substring(b.offset+b.length)}function u(c,b){const y=b.slice(0).sort((d,m)=>{const v=d.offset-m.offset;return v===0?d.length-m.length:v});let k=c.length;for(let d=y.length-1;d>=0;d--){const m=y[d];if(m.offset+m.length<=k)c=E(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}}),define(ae[61],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(ae[104],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(O){this.element=O,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let O=this.a;for(;O!==n.Undefined;){const j=O.next;O.prev=n.Undefined,O.next=n.Undefined,O=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,j){const E=new n(O);if(this.a===n.Undefined)this.a=E,this.b=E;else if(j){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==n.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==n.Undefined&&O.next!==n.Undefined){const j=O.prev;j.next=O.next,O.next.prev=j}else O.prev===n.Undefined&&O.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):O.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):O.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==n.Undefined;)yield O.element,O=O.next}}e.$5c=C}),define(ae[31],ce([0,1]),function(J,e){"use strict";var n,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=O,e.$zc=j,e.$Ac=E,e.$Ic=f;function O(h,$,a){let t=h.get($);return t===void 0&&(t=a,h.set($,t)),t}function j(h){const $=[];return h.forEach((a,t)=>{$.push(`${t} => ${a}`)}),`Map(${h.size}) {${$.join(", ")}}`}function E(h){const $=[];return h.forEach(a=>{$.push(a)}),`Set(${h.size}) {${$.join(", ")}}`}class u{constructor($,a){this.uri=$,this.value=a}}function c(h){return Array.isArray(h)}class b{static{this.c=$=>$.toString()}constructor($,a){if(this[n]="ResourceMap",$ instanceof b)this.d=new Map($.d),this.e=a??b.c;else if(c($)){this.d=new Map,this.e=a??b.c;for(const[t,o]of $)this.set(t,o)}else this.d=new Map,this.e=$??b.c}set($,a){return this.d.set(this.e($),new u($,a)),this}get($){return this.d.get(this.e($))?.value}has($){return this.d.has(this.e($))}get size(){return this.d.size}clear(){this.d.clear()}delete($){return this.d.delete(this.e($))}forEach($,a){typeof a<"u"&&($=$.bind(a));for(const[t,o]of this.d)$(o.value,o.uri,this)}*values(){for(const $ of this.d.values())yield $.value}*keys(){for(const $ of this.d.values())yield $.uri}*entries(){for(const $ of this.d.values())yield[$.uri,$.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,$]of this.d)yield[$.uri,$.value]}}e.$Bc=b;class y{constructor($,a){this[C]="ResourceSet",!$||typeof $=="function"?this.c=new b($):(this.c=new b(a),$.forEach(this.add,this))}get size(){return this.c.size}add($){return this.c.set($,$),this}clear(){this.c.clear()}delete($){return this.c.delete($)}forEach($,a){this.c.forEach((t,o)=>$.call(a,o,o,this))}has($){return this.c.has($)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var k;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class d{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has($){return this.c.has($)}get($,a=0){const t=this.c.get($);if(t)return a!==0&&this.l(t,a),t.value}set($,a,t=0){let o=this.c.get($);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:$,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set($,o),this.f++}return this}delete($){return!!this.remove($)}remove($){const a=this.c.get($);if(a)return this.c.delete($),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const $=this.d;return this.c.delete($.key),this.k($),this.f--,$.value}forEach($,a){const t=this.g;let o=this.d;for(;o;){if(a?$.bind(a)(o.value,o.key,this):$(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h($){if($>=this.size)return;if($===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>$;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i($){if(!this.d&&!this.e)this.e=$;else if(this.d)$.next=this.d,this.d.previous=$;else throw new Error("Invalid list");this.d=$,this.g++}j($){if(!this.d&&!this.e)this.d=$;else if(this.e)$.previous=this.e,this.e.next=$;else throw new Error("Invalid list");this.e=$,this.g++}k($){if($===this.d&&$===this.e)this.d=void 0,this.e=void 0;else if($===this.d){if(!$.next)throw new Error("Invalid list");$.next.previous=void 0,this.d=$.next}else if($===this.e){if(!$.previous)throw new Error("Invalid list");$.previous.next=void 0,this.e=$.previous}else{const a=$.next,t=$.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}$.next=void 0,$.previous=void 0,this.g++}l($,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if($===this.d)return;const t=$.next,o=$.previous;$===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),$.previous=void 0,$.next=this.d,this.d.previous=$,this.d=$,this.g++}else if(a===2){if($===this.e)return;const t=$.next,o=$.previous;$===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),$.next=void 0,$.previous=this.e,this.e.next=$,this.e=$,this.g++}}}toJSON(){const $=[];return this.forEach((a,t)=>{$.push([t,a])}),$}fromJSON($){this.clear();for(const[a,t]of $)this.set(a,t)}}e.$Dc=d;class m extends d{constructor($,a=1){super(),this.m=$,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit($){this.m=$,this.o()}get ratio(){return this.n}set ratio($){this.n=Math.min(Math.max(0,$),1),this.o()}get($,a=2){return super.get($,a)}peek($){return super.get($,0)}set($,a){return super.set($,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=m;class v{constructor(){this.c=new Map}add($){return this.c.set($,(this.c.get($)||0)+1),this}delete($){let a=this.c.get($)||0;return a===0?!1:(a--,a===0?this.c.delete($):this.c.set($,a),!0)}has($){return this.c.has($)}}e.$Fc=v;class w{constructor($){if(this.c=new Map,this.d=new Map,$)for(const[a,t]of $)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set($,a){this.c.set($,a),this.d.set(a,$)}get($){return this.c.get($)}getKey($){return this.d.get($)}delete($){const a=this.c.get($);return a===void 0?!1:(this.c.delete($),this.d.delete(a),!0)}forEach($,a){this.c.forEach((t,o)=>{$.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class g{constructor(){this.c=new Map}add($,a){let t=this.c.get($);t||(t=new Set,this.c.set($,t)),t.add(a)}delete($,a){const t=this.c.get($);t&&(t.delete(a),t.size===0&&this.c.delete($))}forEach($,a){const t=this.c.get($);t&&t.forEach(a)}get($){const a=this.c.get($);return a||new Set}}e.$Hc=g;function f(h,$){if(h===$)return!0;if(h.size!==$.size)return!1;for(const[a,t]of h)if(!$.has(a)||$.get(a)!==t)return!1;for(const[a]of $)if(!h.has(a))return!1;return!0}}),define(ae[2],ce([0,1,22,137,31,85,71]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=b,e.$Lc=y,e.$Mc=k,e.$Nc=v,e.$Oc=w,e.$Pc=g,e.$Qc=f,e.$Rc=h,e.$Sc=$,e.$3c=I;const E=!1;let u=null;class c{constructor(){this.b=new Map}static{this.a=0}c(B){let L=this.b.get(B);return L||(L={parent:null,source:null,isSingleton:!1,value:B,idx:c.a++},this.b.set(B,L)),L}trackDisposable(B){const L=this.c(B);L.source||(L.source=new Error().stack)}setParent(B,L){const W=this.c(B);W.parent=L}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,L){const W=L.get(B);if(W)return W;const U=B.parent?this.f(this.c(B.parent),L):B;return L.set(B,U),U}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,B).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(B=10,L){let W;if(L)W=L;else{const ue=new Map,Y=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ue).isSingleton);if(Y.length===0)return;const Z=new Set(Y.map(q=>q.value));if(W=Y.filter(q=>!(q.parent&&Z.has(q.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function U(ue){function Y(q,M){for(;q.length>0&&M.some(N=>typeof N=="string"?N===q[0]:q[0].match(N));)q.shift()}const Z=ue.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Y(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const x=new P.$Hc;for(const ue of W){const Y=U(ue);for(let Z=0;Z<=Y.length;Z++)x.add(Y.slice(0,Z).join(`
`),ue)}W.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",se=0;for(const ue of W.slice(0,B)){se++;const Y=U(ue),Z=[];for(let q=0;q<Y.length;q++){let M=Y[q];M=`(shared with ${x.get(Y.slice(0,q+1).join(`
`)).size}/${W.length} leaks) at ${M}`;const G=x.get(Y.slice(0,q).join(`
`)),z=(0,C.$K)([...G].map(oe=>U(oe)[q]),oe=>oe);delete z[Y[q]];for(const[oe,he]of Object.entries(z))Z.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);Z.unshift(M)}le+=`


==================== Leaking disposable ${se}/${W.length}: ${ue.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return W.length>B&&(le+=`


... and ${W.length-B} more leaking disposables

`),{leaks:W,details:le}}}e.$Jc=c;function b(R){u=R}if(E){const R="__is_disposable_tracked__";b(new class{trackDisposable(B){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[R]||console.log(L)},3e3)}setParent(B,L){if(B&&B!==t.None)try{B[R]=!0}catch{}}markAsDisposed(B){if(B&&B!==t.None)try{B[R]=!0}catch{}}markAsSingleton(B){}})}function y(R){return u?.trackDisposable(R),R}function k(R){u?.markAsDisposed(R)}function d(R,B){u?.setParent(R,B)}function m(R,B){if(u)for(const L of R)u.setParent(L,B)}function v(R){return u?.markAsSingleton(R),R}function w(R){return typeof R.dispose=="function"&&R.dispose.length===0}function g(R){if(j.Iterable.is(R)){const B=[];for(const L of R)if(L)try{L.dispose()}catch(W){B.push(W)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function f(R){for(const B of R)w(B)&&B.dispose();return[]}function h(...R){const B=$(()=>g(R));return m(R,B),B}function $(R){const B=y({dispose:(0,O.$db)(()=>{k(B),R()})});return B}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return d(B,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),d(B,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),d(this.q,this)}dispose(){k(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&d(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&d(B,null),B}}e.$Vc=o;class r{constructor(B){this.a=new o,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class i{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(B){let L=B;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,k(this))},this}}e.$Yc=s;class l{constructor(){this.a=new Map}acquire(B,...L){let W=this.a.get(B);W||(W={counter:0,object:this.b(B,...L)},this.a.set(B,W));const{object:U}=W,x=(0,O.$db)(()=>{--W.counter===0&&(this.c(B,W.object),this.a.delete(B))});return W.counter++,{object:U,dispose:x}}}e.$Zc=l;class p{constructor(B){this.a=B}async acquire(B,...L){const W=this.a.acquire(B,...L);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(U){throw W.dispose(),U}}}e.$1c=p;class D{constructor(B){this.object=B}dispose(){}}e.$2c=D;function I(R){const B=new a;try{R(B)}finally{B.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,L,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(B)?.dispose(),this.a.set(B,L)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=S}),define(ae[86],ce([0,1,31]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=P,e.$Zl=j;const C=new n.$Ec(1e4);function P(c){return u(c,"NFC",C)}const O=new n.$Ec(1e4);function j(c){return u(c,"NFD",O)}const E=/[^\u0000-\u0080]/;function u(c,b,y){if(!c)return c;const k=y.get(c);if(k)return k;let d;return E.test(c)?d=c.normalize(b):d=c,y.set(c,d),d}e.$1l=function(){const c=/[\u0300-\u036f]/g;return function(b){return j(b).replace(c,"")}}()}),define(ae[141],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=n,e.rot=C;function n(E,u,c){return Math.min(Math.max(E,u),c)}function C(E,u){return(u+E%u)%u}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$om=P;class O{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=O;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=j}),function(){function J(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function j(u){O.push(u,Date.now())}function E(){const u=[];for(let c=0;c<O.length;c+=2)u.push({name:O[c],startTime:O[c+1]});return u}return{mark:j,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const j of performance.getEntriesByType("mark"))O.push({name:j.name,startTime:Math.round(P+j.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:J)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function n(C){if(e[C])return e[C].exports;var P=e[C]={i:C,l:!1,exports:{}};return J[C].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=J,n.c=e,n.d=function(C,P,O){n.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:O})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,P){if(1&P&&(C=n(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(n.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var j in C)n.d(O,j,function(E){return C[E]}.bind(null,j));return O},n.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(P,"a",P),P},n.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},n.p="",n(n.s=0)}([function(J,e,n){(function(C){var P;e=J.exports=he,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],c=0,b=c++;u[b]="0|[1-9]\\d*";var y=c++;u[y]="[0-9]+";var k=c++;u[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var m=c++;u[m]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var v=c++;u[v]="(?:"+u[b]+"|"+u[k]+")";var w=c++;u[w]="(?:"+u[y]+"|"+u[k]+")";var g=c++;u[g]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=c++;u[f]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var h=c++;u[h]="[0-9A-Za-z-]+";var $=c++;u[$]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var a=c++,t="v?"+u[d]+u[g]+"?"+u[$]+"?";u[a]="^"+t+"$";var o="[v=\\s]*"+u[m]+u[f]+"?"+u[$]+"?",r=c++;u[r]="^"+o+"$";var i=c++;u[i]="((?:<|>)?=?)";var s=c++;u[s]=u[y]+"|x|X|\\*";var l=c++;u[l]=u[b]+"|x|X|\\*";var p=c++;u[p]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[g]+")?"+u[$]+"?)?)?";var D=c++;u[D]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[$]+"?)?)?";var I=c++;u[I]="^"+u[i]+"\\s*"+u[p]+"$";var S=c++;u[S]="^"+u[i]+"\\s*"+u[D]+"$";var R=c++;u[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;u[B]="(?:~>?)";var L=c++;u[L]="(\\s*)"+u[B]+"\\s+",E[L]=new RegExp(u[L],"g");var W=c++;u[W]="^"+u[B]+u[p]+"$";var U=c++;u[U]="^"+u[B]+u[D]+"$";var x=c++;u[x]="(?:\\^)";var le=c++;u[le]="(\\s*)"+u[x]+"\\s+",E[le]=new RegExp(u[le],"g");var se=c++;u[se]="^"+u[x]+u[p]+"$";var ue=c++;u[ue]="^"+u[x]+u[D]+"$";var Y=c++;u[Y]="^"+u[i]+"\\s*("+o+")$|^$";var Z=c++;u[Z]="^"+u[i]+"\\s*("+t+")$|^$";var q=c++;u[q]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[p]+")",E[q]=new RegExp(u[q],"g");var M=c++;u[M]="^\\s*("+u[p]+")\\s+-\\s+("+u[p]+")\\s*$";var N=c++;u[N]="^\\s*("+u[D]+")\\s+-\\s+("+u[D]+")\\s*$";var G=c++;u[G]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)P(z,u[z]),E[z]||(E[z]=new RegExp(u[z]));function oe(ee,de){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>O||!(de?E[r]:E[a]).test(ee))return null;try{return new he(ee,de)}catch{return null}}function he(ee,de){if(ee instanceof he){if(ee.loose===de)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof he))return new he(ee,de);P("SemVer",ee,de),this.loose=de;var $e=ee.trim().match(de?E[r]:E[a]);if(!$e)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<j)return Re}return Pe}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ee,de){var $e=oe(ee,de);return $e?$e.version:null},e.clean=function(ee,de){var $e=oe(ee.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),A(this.major,ee.major)||A(this.minor,ee.minor)||A(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Pe=ee.prerelease[de];if(P("prerelease compare",de,$e,Pe),$e===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if($e===void 0)return-1;if($e!==Pe)return A($e,Pe)}while(++de)},he.prototype.inc=function(ee,de){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,de,$e,Pe){typeof $e=="string"&&(Pe=$e,$e=void 0);try{return new he(ee,$e).inc(de,Pe).version}catch{return null}},e.diff=function(ee,de){if(K(ee,de))return null;var $e=oe(ee),Pe=oe(de);if($e.prerelease.length||Pe.prerelease.length){for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Pe[Re])return Re},e.compareIdentifiers=A;var X=/^[0-9]+$/;function A(ee,de){var $e=X.test(ee),Pe=X.test(de);return $e&&Pe&&(ee=+ee,de=+de),$e&&!Pe?-1:Pe&&!$e?1:ee<de?-1:ee>de?1:0}function F(ee,de,$e){return new he(ee,$e).compare(new he(de,$e))}function _(ee,de,$e){return F(ee,de,$e)>0}function re(ee,de,$e){return F(ee,de,$e)<0}function K(ee,de,$e){return F(ee,de,$e)===0}function V(ee,de,$e){return F(ee,de,$e)!==0}function H(ee,de,$e){return F(ee,de,$e)>=0}function T(ee,de,$e){return F(ee,de,$e)<=0}function Q(ee,de,$e,Pe){var Re;switch(de){case"===":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),Re=ee===$e;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof $e=="object"&&($e=$e.version),Re=ee!==$e;break;case"":case"=":case"==":Re=K(ee,$e,Pe);break;case"!=":Re=V(ee,$e,Pe);break;case">":Re=_(ee,$e,Pe);break;case">=":Re=H(ee,$e,Pe);break;case"<":Re=re(ee,$e,Pe);break;case"<=":Re=T(ee,$e,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Re}function te(ee,de){if(ee instanceof te){if(ee.loose===de)return ee;ee=ee.value}if(!(this instanceof te))return new te(ee,de);P("comparator",ee,de),this.loose=de,this.parse(ee),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,de){return A(de,ee)},e.major=function(ee,de){return new he(ee,de).major},e.minor=function(ee,de){return new he(ee,de).minor},e.patch=function(ee,de){return new he(ee,de).patch},e.compare=F,e.compareLoose=function(ee,de){return F(ee,de,!0)},e.rcompare=function(ee,de,$e){return F(de,ee,$e)},e.sort=function(ee,de){return ee.sort(function($e,Pe){return e.compare($e,Pe,de)})},e.rsort=function(ee,de){return ee.sort(function($e,Pe){return e.rcompare($e,Pe,de)})},e.gt=_,e.lt=re,e.eq=K,e.neq=V,e.gte=H,e.lte=T,e.cmp=Q,e.Comparator=te;var fe={};function me(ee,de){if(ee instanceof me)return ee.loose===de?ee:new me(ee.raw,de);if(ee instanceof te)return new me(ee.value,de);if(!(this instanceof me))return new me(ee,de);if(this.loose=de,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,de,$e,Pe,Re,qe,Be,Le,Ue,xe,Xe,Fe,ie){return((de=ke($e)?"":ke(Pe)?">="+$e+".0.0":ke(Re)?">="+$e+"."+Pe+".0":">="+de)+" "+(Le=ke(Ue)?"":ke(xe)?"<"+(+Ue+1)+".0.0":ke(Xe)?"<"+Ue+"."+(+xe+1)+".0":Fe?"<="+Ue+"."+xe+"."+Xe+"-"+Fe:"<="+Le)).trim()}function Oe(ee,de){for(var $e=0;$e<ee.length;$e++)if(!ee[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<ee.length;$e++)if(P(ee[$e].semver),ee[$e].semver!==fe&&ee[$e].semver.prerelease.length>0){var Pe=ee[$e].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Ve(ee,de,$e){try{de=new me(de,$e)}catch{return!1}return de.test(ee)}function ye(ee,de,$e,Pe){var Re,qe,Be,Le,Ue;switch(ee=new he(ee,Pe),de=new me(de,Pe),$e){case">":Re=_,qe=T,Be=re,Le=">",Ue=">=";break;case"<":Re=re,qe=H,Be=_,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ee,de,Pe))return!1;for(var xe=0;xe<de.set.length;++xe){var Xe=de.set[xe],Fe=null,ie=null;if(Xe.forEach(function(ge){ge.semver===fe&&(ge=new te(">=0.0.0")),Fe=Fe||ge,ie=ie||ge,Re(ge.semver,Fe.semver,Pe)?Fe=ge:Be(ge.semver,ie.semver,Pe)&&(ie=ge)}),Fe.operator===Le||Fe.operator===Ue||(!ie.operator||ie.operator===Le)&&qe(ee,ie.semver)||ie.operator===Ue&&Be(ee,ie.semver))return!1}return!0}te.prototype.parse=function(ee){var de=this.loose?E[Y]:E[Z],$e=ee.match(de);if(!$e)throw new TypeError("Invalid comparator: "+ee);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=fe},te.prototype.toString=function(){return this.value},te.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===fe||(typeof ee=="string"&&(ee=new he(ee,this.loose)),Q(ee,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ee,de){if(!(ee instanceof te))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(ee.value,de),Ve(this.value,$e,de);if(ee.operator==="")return $e=new me(this.value,de),Ve(ee.semver,$e,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),qe=this.semver.version===ee.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Le=Q(this.semver,"<",ee.semver,de)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ue=Q(this.semver,">",ee.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Pe||Re||qe&&Be||Le||Ue},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var de=this.loose;ee=ee.trim(),P("range",ee,de);var $e=de?E[N]:E[M];ee=ee.replace($e,Se),P("hyphen replace",ee),ee=ee.replace(E[q],"$1$2$3"),P("comparator trim",ee,E[q]),ee=(ee=(ee=ee.replace(E[L],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var Pe=de?E[Y]:E[Z],Re=ee.split(" ").map(function(qe){return function(Be,Le){return P("comp",Be),Be=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Xe){return function(Fe,ie){P("caret",Fe,ie);var ge=ie?E[ue]:E[se];return Fe.replace(ge,function(pe,be,Ee,Ae,Ne){var Ke;return P("caret",Fe,pe,be,Ee,Ae,Ne),ke(be)?Ke="":ke(Ee)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ke(Ae)?Ke=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Ae+Ne+" <"+be+"."+Ee+"."+(+Ae+1):">="+be+"."+Ee+"."+Ae+Ne+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Ae+Ne+" <"+(+be+1)+".0.0"):(P("no pr"),Ke=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Ae+" <"+be+"."+Ee+"."+(+Ae+1):">="+be+"."+Ee+"."+Ae+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Ae+" <"+(+be+1)+".0.0"),P("caret return",Ke),Ke})}(Xe,xe)}).join(" ")}(Be,Le),P("caret",Be),Be=function(Ue,xe){return Ue.trim().split(/\s+/).map(function(Xe){return function(Fe,ie){var ge=ie?E[U]:E[W];return Fe.replace(ge,function(pe,be,Ee,Ae,Ne){var Ke;return P("tilde",Fe,pe,be,Ee,Ae,Ne),ke(be)?Ke="":ke(Ee)?Ke=">="+be+".0.0 <"+(+be+1)+".0.0":ke(Ae)?Ke=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=">="+be+"."+Ee+"."+Ae+Ne+" <"+be+"."+(+Ee+1)+".0"):Ke=">="+be+"."+Ee+"."+Ae+" <"+be+"."+(+Ee+1)+".0",P("tilde return",Ke),Ke})}(Xe,xe)}).join(" ")}(Be,Le),P("tildes",Be),Be=function(Ue,xe){return P("replaceXRanges",Ue,xe),Ue.split(/\s+/).map(function(Xe){return function(Fe,ie){Fe=Fe.trim();var ge=ie?E[S]:E[I];return Fe.replace(ge,function(pe,be,Ee,Ae,Ne,Ke){P("xRange",Fe,pe,be,Ee,Ae,Ne,Ke);var Ye=ke(Ee),Ze=Ye||ke(Ae),Qe=Ze||ke(Ne);return be==="="&&Qe&&(be=""),Ye?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Qe?(Ze&&(Ae=0),Qe&&(Ne=0),be===">"?(be=">=",Ze?(Ee=+Ee+1,Ae=0,Ne=0):Qe&&(Ae=+Ae+1,Ne=0)):be==="<="&&(be="<",Ze?Ee=+Ee+1:Ae=+Ae+1),pe=be+Ee+"."+Ae+"."+Ne):Ze?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Qe&&(pe=">="+Ee+"."+Ae+".0 <"+Ee+"."+(+Ae+1)+".0"),P("xRange return",pe),pe})}(Xe,xe)}).join(" ")}(Be,Le),P("xrange",Be),Be=function(Ue,xe){return P("replaceStars",Ue,xe),Ue.trim().replace(E[G],"")}(Be,Le),P("stars",Be),Be}(qe,de)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(qe){return!!qe.match(Pe)})),Re=Re.map(function(qe){return new te(qe,de)})},me.prototype.intersects=function(ee,de){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Pe){return ee.set.some(function(Re){return Re.every(function(qe){return Pe.intersects(qe,de)})})})})},e.toComparators=function(ee,de){return new me(ee,de).set.map(function($e){return $e.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var de=0;de<this.set.length;de++)if(Oe(this.set[de],ee))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ee,de,$e){var Pe=null,Re=null;try{var qe=new me(de,$e)}catch{return null}return ee.forEach(function(Be){qe.test(Be)&&(Pe&&Re.compare(Be)!==-1||(Re=new he(Pe=Be,$e)))}),Pe},e.minSatisfying=function(ee,de,$e){var Pe=null,Re=null;try{var qe=new me(de,$e)}catch{return null}return ee.forEach(function(Be){qe.test(Be)&&(Pe&&Re.compare(Be)!==1||(Re=new he(Pe=Be,$e)))}),Pe},e.validRange=function(ee,de){try{return new me(ee,de).range||"*"}catch{return null}},e.ltr=function(ee,de,$e){return ye(ee,de,"<",$e)},e.gtr=function(ee,de,$e){return ye(ee,de,">",$e)},e.outside=ye,e.prerelease=function(ee,de){var $e=oe(ee,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(ee,de,$e){return ee=new me(ee,$e),de=new me(de,$e),ee.intersects(de)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var de=ee.match(E[R]);return de==null?null:oe((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,n(1))},function(J,e){var n,C,P=J.exports={};function O(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===O||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:O}catch{n=O}try{C=typeof clearTimeout=="function"?clearTimeout:j}catch{C=j}})();var u,c=[],b=!1,y=-1;function k(){b&&u&&(b=!1,u.length?c=u.concat(c):y=-1,c.length&&d())}function d(){if(!b){var w=E(k);b=!0;for(var g=c.length;g;){for(u=c,c=[];++y<g;)u&&u[y].run();y=-1,g=c.length}u=null,b=!1,function(f){if(C===clearTimeout)return clearTimeout(f);if((C===j||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(f);try{C(f)}catch{try{return C.call(null,f)}catch{return C.call(this,f)}}}(w)}}function m(w,g){this.fun=w,this.array=g}function v(){}P.nextTick=function(w){var g=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)g[f-1]=arguments[f];c.push(new m(w,g)),c.length!==1||b||E(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ae[142],ce([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class C{constructor(E,u,c){this.level=E,this.key=u,this.value=c,this.forward=[]}}const P=void 0;class O{constructor(E,u=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new C(this.c,P,P)}get size(){return this.f}clear(){this.e=new C(this.c,P,P),this.f=0}has(E){return!!O.g(this,E,this.comparator)}get(E){return O.g(this,E,this.comparator)?.value}set(E,u){return O.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=O.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let c=this.e.forward[0];for(;c;)E.call(u,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,c){let b=E.e;for(let y=E.d-1;y>=0;y--)for(;b.forward[y]&&c(b.forward[y].key,u)<0;)b=b.forward[y];if(b=b.forward[0],b&&c(b.key,u)===0)return b}static h(E,u,c,b){const y=[];let k=E.e;for(let d=E.d-1;d>=0;d--){for(;k.forward[d]&&b(k.forward[d].key,u)<0;)k=k.forward[d];y[d]=k}if(k=k.forward[0],k&&b(k.key,u)===0)return k.value=c,!1;{const d=O.j(E);if(d>E.d){for(let m=E.d;m<d;m++)y[m]=E.e;E.d=d}k=new C(d,u,c);for(let m=0;m<d;m++)k.forward[m]=y[m].forward[m],y[m].forward[m]=k;return!0}}static j(E,u=.5){let c=1;for(;Math.random()<u&&c<E.c;)c+=1;return c}static k(E,u,c){const b=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&c(y.forward[k].key,u)<0;)y=y.forward[k];b[k]=y}if(y=y.forward[0],!y||c(y.key,u)!==0)return!1;for(let k=0;k<E.d&&b[k].forward[k]===y;k++)b[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===P;)E.d-=1;return!0}}e.$gs=O}),define(ae[72],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(O){return new C(O)}constructor(O){this.c=n&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=C}),define(ae[3],ce([0,1,15,85,2,104,72]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=k;const E=!1,u=!1;var c;(function(I){I.None=()=>P.$Uc.None;function S(T){if(u){const{onDidAddListener:Q}=T,te=m.create();let fe=0;T.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),Q?.()}}}function R(T,Q){return Z(T,()=>{},0,void 0,!0,void 0,Q)}I.defer=R;function B(T){return(Q,te=null,fe)=>{let me=!1,ke;return ke=T(Se=>{if(!me)return ke?ke.dispose():me=!0,Q.call(te,Se)},null,fe),me&&ke.dispose(),ke}}I.once=B;function L(T,Q,te){return ue((fe,me=null,ke)=>T(Se=>fe.call(me,Q(Se)),null,ke),te)}I.map=L;function W(T,Q,te){return ue((fe,me=null,ke)=>T(Se=>{Q(Se),fe.call(me,Se)},null,ke),te)}I.forEach=W;function U(T,Q,te){return ue((fe,me=null,ke)=>T(Se=>Q(Se)&&fe.call(me,Se),null,ke),te)}I.filter=U;function x(T){return T}I.signal=x;function le(...T){return(Q,te=null,fe)=>{const me=(0,P.$Rc)(...T.map(ke=>ke(Se=>Q.call(te,Se))));return Y(me,fe)}}I.any=le;function se(T,Q,te,fe){let me=te;return L(T,ke=>(me=Q(me,ke),me),fe)}I.reduce=se;function ue(T,Q){let te;const fe={onWillAddFirstListener(){te=T(me.fire,me)},onDidRemoveLastListener(){te?.dispose()}};Q||S(fe);const me=new h(fe);return Q?.add(me),me.event}function Y(T,Q){return Q instanceof Array?Q.push(T):Q&&Q.add(T),T}function Z(T,Q,te=100,fe=!1,me=!1,ke,Se){let Oe,Ve,ye,ee=0,de;const $e={leakWarningThreshold:ke,onWillAddFirstListener(){Oe=T(Re=>{ee++,Ve=Q(Ve,Re),fe&&!ye&&(Pe.fire(Ve),Ve=void 0),de=()=>{const qe=Ve;Ve=void 0,ye=void 0,(!fe||ee>1)&&Pe.fire(qe),ee=0},typeof te=="number"?(clearTimeout(ye),ye=setTimeout(de,te)):ye===void 0&&(ye=0,queueMicrotask(de))})},onWillRemoveListener(){me&&ee>0&&de?.()},onDidRemoveLastListener(){de=void 0,Oe.dispose()}};Se||S($e);const Pe=new h($e);return Se?.add(Pe),Pe.event}I.debounce=Z;function q(T,Q=0,te){return I.debounce(T,(fe,me)=>fe?(fe.push(me),fe):[me],Q,void 0,!0,void 0,te)}I.accumulate=q;function M(T,Q=(fe,me)=>fe===me,te){let fe=!0,me;return U(T,ke=>{const Se=fe||!Q(ke,me);return fe=!1,me=ke,Se},te)}I.latch=M;function N(T,Q,te){return[I.filter(T,Q,te),I.filter(T,fe=>!Q(fe),te)]}I.split=N;function G(T,Q=!1,te=[],fe){let me=te.slice(),ke=T(Ve=>{me?me.push(Ve):Oe.fire(Ve)});fe&&fe.add(ke);const Se=()=>{me?.forEach(Ve=>Oe.fire(Ve)),me=null},Oe=new h({onWillAddFirstListener(){ke||(ke=T(Ve=>Oe.fire(Ve)),fe&&fe.add(ke))},onDidAddFirstListener(){me&&(Q?setTimeout(Se):Se())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return fe&&fe.add(Oe),Oe.event}I.buffer=G;function z(T,Q){return(fe,me,ke)=>{const Se=Q(new he);return T(function(Oe){const Ve=Se.evaluate(Oe);Ve!==oe&&fe.call(me,Ve)},void 0,ke)}}I.chain=z;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(Q){return this.f.push(Q),this}forEach(Q){return this.f.push(te=>(Q(te),te)),this}filter(Q){return this.f.push(te=>Q(te)?te:oe),this}reduce(Q,te){let fe=te;return this.f.push(me=>(fe=Q(fe,me),fe)),this}latch(Q=(te,fe)=>te===fe){let te=!0,fe;return this.f.push(me=>{const ke=te||!Q(me,fe);return te=!1,fe=me,ke?me:oe}),this}evaluate(Q){for(const te of this.f)if(Q=te(Q),Q===oe)break;return Q}}function X(T,Q,te=fe=>fe){const fe=(...Oe)=>Se.fire(te(...Oe)),me=()=>T.on(Q,fe),ke=()=>T.removeListener(Q,fe),Se=new h({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}I.fromNodeEventEmitter=X;function A(T,Q,te=fe=>fe){const fe=(...Oe)=>Se.fire(te(...Oe)),me=()=>T.addEventListener(Q,fe),ke=()=>T.removeEventListener(Q,fe),Se=new h({onWillAddFirstListener:me,onDidRemoveLastListener:ke});return Se.event}I.fromDOMEventEmitter=A;function F(T){return new Promise(Q=>B(T)(Q))}I.toPromise=F;function _(T){const Q=new h;return T.then(te=>{Q.fire(te)},()=>{Q.fire(void 0)}).finally(()=>{Q.dispose()}),Q.event}I.fromPromise=_;function re(T,Q,te){return Q(te),T(fe=>Q(fe))}I.runAndSubscribe=re;class K{constructor(Q,te){this._observable=Q,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};te||S(fe),this.emitter=new h(fe),te&&te.add(this.emitter)}beginUpdate(Q){this.f++}handlePossibleChange(Q){}handleChange(Q,te){this.g=!0}endUpdate(Q){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function V(T,Q){return new K(T,Q).emitter.event}I.fromObservable=V;function H(T){return(Q,te,fe)=>{let me=0,ke=!1;const Se={beginUpdate(){me++},endUpdate(){me--,me===0&&(T.reportChanges(),ke&&(ke=!1,Q.call(te)))},handlePossibleChange(){},handleChange(){ke=!0}};T.addObserver(Se),T.reportChanges();const Oe={dispose(){T.removeObserver(Se)}};return fe instanceof P.$Tc?fe.add(Oe):Array.isArray(fe)&&fe.push(Oe),Oe}}I.fromObservableLight=H})(c||(e.Event=c={}));class b{static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${b.f++}`,b.all.add(this)}start(S){this.g=new j.$3d,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}e.$5d=b;let y=-1;function k(I){const S=y;return y=I,{dispose(){y=S}}}class d{constructor(S,R=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=R,this.g=0}dispose(){this.f?.clear()}check(S,R){const B=this.threshold;if(B<=0||R<B)return;this.f||(this.f=new Map);const L=this.f.get(S.value)||0;if(this.f.set(S.value,L+1),this.g-=1,this.g<=0){this.g=B*.5;let W,U=0;for(const[x,le]of this.f)(!W||U<le)&&(W=x,U=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${U}):`),console.warn(W)}return()=>{const W=this.f.get(S.value)||0;this.f.set(S.value,W-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class w{constructor(S){this.value=S,this.id=v++}}const g=2,f=(I,S)=>{if(I instanceof w)S(I);else for(let R=0;R<I.length;R++){const B=I[R];B&&S(B)}};class h{constructor(S){this.w=0,this.f=S,this.g=y>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??y):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const S=this.t;queueMicrotask(()=>{f(S,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,R,B)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;R&&(S=S.bind(R));const L=new w(S);let W,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(L.stack=m.create(),W=this.g.check(L.stack,this.w+1)),E&&(L.stack=U??m.create()),this.t?this.t instanceof w?(this.u??=new a,this.t=[this.t,L]):this.t.push(L):(this.f?.onWillAddFirstListener?.(this),this.t=L,this.f?.onDidAddFirstListener?.(this)),this.w++;const x=(0,P.$Sc)(()=>{W?.(),this.x(L)});return B instanceof P.$Tc?B.add(x):Array.isArray(B)&&B.push(x),x},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,B=R.indexOf(S);if(B===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[B]=void 0;const L=this.u.current===this;if(this.w*g<=R.length){let W=0;for(let U=0;U<R.length;U++)R[U]?R[W++]=R[U]:L&&(this.u.end--,W<this.u.i&&this.u.i--);R.length=W}}y(S,R){if(!S)return;const B=this.f?.onListenerError||n.$1;if(!B){S.value(R);return}try{S.value(R)}catch(L){B(L)}}z(S){const R=S.current.t;for(;S.i<S.end;)this.y(R[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,S);else{const R=this.u;R.enqueue(this,S,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=h;const $=()=>new a;e.$8d=$;class a{constructor(){this.i=-1,this.end=0}enqueue(S,R,B){this.i=0,this.end=B,this.current=S,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(S,R,B){if(this.t)for(this.h||(this.h=new O.$5c),f(this.t,L=>this.h.push([L.value,S]));this.h.size>0&&!R.isCancellationRequested;){const[L,W]=this.h.shift(),U=[],x={...W,token:R,waitUntil:le=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");B&&(le=B(le,L)),U.push(le)}};try{L(x)}catch(le){(0,n.$1)(le);continue}Object.freeze(U),await Promise.allSettled(U).then(le=>{for(const se of le)se.status==="rejected"&&(0,n.$1)(se.reason)})}}}e.$9d=t;class o extends h{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new O.$5c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}e.$0d=o;class r extends o{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}e.$$d=r;class i extends h{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$_d=i;class s{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const R={event:S,listener:null};this.h.push(R),this.g&&this.m(R);const B=()=>{this.g&&this.o(R);const L=this.h.indexOf(R);this.h.splice(L,1)};return(0,P.$Sc)((0,C.$db)(B))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(R=>this.f.fire(R))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}e.$ae=s;class l{constructor(S,R,B,L){this.f=new P.$Tc;const W=this.f.add(new s),U=this.f.add(new P.$4c);function x(le){U.set(le,W.add(L(le)))}for(const le of S)x(le);this.f.add(R(le=>{x(le)})),this.f.add(B(le=>{U.deleteAndDispose(le)})),this.event=W.event}dispose(){this.f.dispose()}}e.$be=l;class p{constructor(){this.f=[]}wrapEvent(S){return(R,B,L)=>S(W=>{const U=this.f[this.f.length-1];U?U.push(()=>R.call(B,W)):R.call(B,W)},void 0,L)}bufferEvents(S){const R=[];this.f.push(R);const B=S();return this.f.pop(),R.forEach(L=>L()),B}}e.$ce=p;class D{constructor(){this.f=!1,this.g=c.None,this.h=P.$Uc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=D}),define(ae[23],ce([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const C=Object.freeze(function(E,u){const c=setTimeout(E.bind(u),0);return{dispose(){clearTimeout(c)}}});var P;(function(E){function u(c){return c===E.None||c===E.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}E.isCancellationToken=u,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(P||(e.CancellationToken=P={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=P.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=P.None}}e.$ee=j}),define(ae[143],ce([0,1,23]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class C{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new n.$ee,u=this.b(E.token);return this.a={promise:u,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Pe=C;class P{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const u=JSON.stringify(E);return this.b!==u&&(this.b=u,this.a=this.c(E)),this.a}}e.$Qe=P;class O{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const u=this.b(E);return this.a.set(E,u),u}}e.$Re=O}),define(ae[62],ce([0,1,15,2]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=P,e.$ge=O,e.$he=j,e.$ie=E,e.$je=c,e.$ke=b,e.$le=y,e.$me=k,e.$ne=d,e.$oe=m,e.$pe=v,e.$qe=w,e.$re=g,e.$se=f,e.$te=h;function P($){const a=$;return a?typeof a.read=="function":!1}function O($){const a=$;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j($){const a=$;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E($,a){return new u($,a)}class u{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c($,a){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return a(t)}function b($,a,t){const o=[];let r;for(;(r=$.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return $.read()}}}function y($,a){return new Promise((t,o)=>{const r=[];k($,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}function k($,a,t){$.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function d($,a){return new Promise((t,o)=>{const r=new C.$Tc,i=[],s=D=>{if(i.push(D),i.length>a)return r.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},l=D=>(r.dispose(),o(D)),p=()=>(r.dispose(),t({stream:$,buffer:i,ended:!0}));r.add((0,C.$Sc)(()=>$.removeListener("error",l))),$.on("error",l),r.add((0,C.$Sc)(()=>$.removeListener("end",p))),$.on("end",p),r.add((0,C.$Sc)(()=>$.removeListener("data",s))),$.on("data",s)})}function m($,a){const t=E(a);return t.end($),t}function v(){const $=E(()=>{throw new Error("not supported")});return $.end(),$}function w($){let a=!1;return{read:()=>a?null:(a=!0,$)}}function g($,a,t){const o=E(t);return k($,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}function f($,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([$,r]):$)}}}function h($,a,t){let o=!1;const r=E(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([$,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write($)),r.end()}}),r}}),define(ae[17],ce([0,1,61,62]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=c,e.$we=b,e.$xe=y,e.$ye=k,e.$ze=d,e.$Ae=m,e.$Be=v,e.$Ce=w,e.$De=g,e.$Ee=f,e.$Fe=h,e.$Ge=$,e.$He=a,e.$Ie=t,e.$Je=o,e.$Ke=r,e.$Le=i,e.$Me=s,e.$Ne=l,e.$Oe=I;const P=typeof Buffer<"u",O=new n.$V(()=>new Uint8Array(256));let j,E;class u{static alloc(R){return P?new u(Buffer.allocUnsafe(R)):new u(new Uint8Array(R))}static wrap(R){return P&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new u(R)}static fromString(R,B){return!(B?.dontUseNodeBuffer||!1)&&P?new u(Buffer.from(R)):(j||(j=new TextEncoder),new u(j.encode(R)))}static fromByteArray(R){const B=u.alloc(R.length);for(let L=0,W=R.length;L<W;L++)B.buffer[L]=R[L];return B}static concat(R,B){if(typeof B>"u"){B=0;for(let U=0,x=R.length;U<x;U++)B+=R[U].byteLength}const L=u.alloc(B);let W=0;for(let U=0,x=R.length;U<x;U++){const le=R[U];L.set(le,W),W+=le.byteLength}return L}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=u.alloc(this.byteLength);return R.set(this),R}toString(){return P?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(R,B){return new u(this.buffer.subarray(R,B))}set(R,B){if(R instanceof u)this.buffer.set(R.buffer,B);else if(R instanceof Uint8Array)this.buffer.set(R,B);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),B);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return k(this.buffer,R)}writeUInt32BE(R,B){d(this.buffer,R,B)}readUInt32LE(R){return m(this.buffer,R)}writeUInt32LE(R,B){v(this.buffer,R,B)}readUInt8(R){return w(this.buffer,R)}writeUInt8(R,B){g(this.buffer,R,B)}indexOf(R,B=0){return c(this.buffer,R instanceof u?R.buffer:R,B)}}e.$ue=u;function c(S,R,B=0){const L=R.byteLength,W=S.byteLength;if(L===0)return 0;if(L===1)return S.indexOf(R[0]);if(L>W-B)return-1;const U=O.value;U.fill(R.length);for(let ue=0;ue<R.length;ue++)U[R[ue]]=R.length-ue-1;let x=B+R.length-1,le=x,se=-1;for(;x<W;)if(S[x]===R[le]){if(le===0){se=x;break}x--,le--}else x+=Math.max(R.length-le,U[S[x]]),le=R.length-1;return se}function b(S,R){return S[R+0]<<0>>>0|S[R+1]<<8>>>0}function y(S,R,B){S[B+0]=R&255,R=R>>>8,S[B+1]=R&255}function k(S,R){return S[R]*2**24+S[R+1]*2**16+S[R+2]*2**8+S[R+3]}function d(S,R,B){S[B+3]=R,R=R>>>8,S[B+2]=R,R=R>>>8,S[B+1]=R,R=R>>>8,S[B]=R}function m(S,R){return S[R+0]<<0>>>0|S[R+1]<<8>>>0|S[R+2]<<16>>>0|S[R+3]<<24>>>0}function v(S,R,B){S[B+0]=R&255,R=R>>>8,S[B+1]=R&255,R=R>>>8,S[B+2]=R&255,R=R>>>8,S[B+3]=R&255}function w(S,R){return S[R]}function g(S,R,B){S[B]=R}function f(S){return C.$je(S,R=>u.concat(R))}function h(S){return C.$qe(S)}function $(S){return C.$le(S,R=>u.concat(R))}async function a(S){return S.ended?u.concat(S.buffer):u.concat([...S.buffer,await $(S.stream)])}function t(S){return C.$oe(S,R=>u.concat(R))}function o(S){return C.$re(S,{data:R=>typeof R=="string"?u.fromString(R):u.wrap(R)},R=>u.concat(R))}function r(S){return C.$ie(R=>u.concat(R),S)}function i(S,R){return C.$se(S,R,B=>u.concat(B))}function s(S,R){return C.$te(S,R,B=>u.concat(B))}function l(S){let R=0,B=0,L=0;const W=new Uint8Array(Math.floor(S.length/4*3)),U=le=>{switch(B){case 3:W[L++]=R|le,B=0;break;case 2:W[L++]=R|le>>>2,R=le<<6,B=3;break;case 1:W[L++]=R|le>>>4,R=le<<4,B=2;break;default:R=le<<2,B=1}};for(let le=0;le<S.length;le++){const se=S.charCodeAt(le);if(se>=65&&se<=90)U(se-65);else if(se>=97&&se<=122)U(se-97+26);else if(se>=48&&se<=57)U(se-48+52);else if(se===43||se===45)U(62);else if(se===47||se===95)U(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${S[le]}`)}}const x=L;for(;B>0;)U(0);return u.wrap(W).slice(0,x)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:S},R=!0,B=!1){const L=B?D:p;let W="";const U=S.byteLength%3;let x=0;for(;x<S.byteLength-U;x+=3){const le=S[x+0],se=S[x+1],ue=S[x+2];W+=L[le>>>2],W+=L[(le<<4|se>>>4)&63],W+=L[(se<<2|ue>>>6)&63],W+=L[ue&63]}if(U===1){const le=S[x+0];W+=L[le>>>2],W+=L[le<<4&63],R&&(W+="==")}else if(U===2){const le=S[x+0],se=S[x+1];W+=L[le>>>2],W+=L[(le<<4|se>>>4)&63],W+=L[se<<2&63],R&&(W+="=")}return W}}),define(ae[25],ce([0,1,143,61]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=P,e.$Ve=j,e.$We=u,e.$Xe=c,e.$Ye=b,e.$Ze=y,e.$1e=k,e.$2e=d,e.$3e=m,e.$4e=v,e.$5e=w,e.$6e=g,e.$7e=f,e.$8e=h,e.$9e=$,e.$0e=a,e.$$e=t,e.$_e=o,e.$af=r,e.$bf=i,e.$cf=s,e.$df=l,e.$ef=p,e.$ff=D,e.$gf=I,e.$hf=S,e.$if=R,e.$jf=B,e.$kf=L,e.$lf=W,e.$mf=U,e.$nf=x,e.$of=le,e.$pf=se,e.$qf=ue,e.$rf=Y,e.$sf=Z,e.$vf=G,e.$wf=z,e.$xf=oe,e.$yf=he,e.$zf=F,e.$Af=re,e.$Cf=K,e.$Df=V,e.$Ef=H,e.$Ff=T,e.$Gf=fe,e.$If=me,e.$Jf=ke,e.$Kf=Se,e.$Lf=Oe,e.$Mf=Ve,e.$Nf=ye,e.$Of=ee,e.$Pf=de,e.$Qf=Be;function P(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const O=/{(\d+)}/g;function j(ie,...ge){return ge.length===0?ie:ie.replace(O,function(pe,be){const Ee=parseInt(be,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?pe:ge[Ee]})}const E=/{([^}]+)}/g;function u(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(E,(pe,be)=>ge[be]??pe)}function c(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function b(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(ie,ge){let pe=0;const be=ge.charCodeAt(0);for(let Ee=ie.length-1;Ee>=0;Ee--)ie.charCodeAt(Ee)===be&&pe++;return pe}function d(ie,ge,pe="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${pe}`}function m(ie,ge,pe="\u2026"){if(ie.length<=ge)return ie;const be=Math.ceil(ge/2)-pe.length/2,Ee=Math.floor(ge/2)-pe.length/2;return`${ie.substr(0,be)}${pe}${ie.substr(ie.length-Ee)}`}function v(ie,ge=" "){const pe=w(ie,ge);return g(pe,ge)}function w(ie,ge){if(!ie||!ge)return ie;const pe=ge.length;if(pe===0||ie.length===0)return ie;let be=0;for(;ie.indexOf(ge,be)===be;)be=be+pe;return ie.substring(be)}function g(ie,ge){if(!ie||!ge)return ie;const pe=ge.length,be=ie.length;if(pe===0||be===0)return ie;let Ee=be,Ae=-1;for(;Ae=ie.lastIndexOf(ge,Ee-1),!(Ae===-1||Ae+pe!==Ee);){if(Ae===0)return"";Ee=Ae}return ie.substring(0,Ee)}function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(ie){return ie.replace(/\*/g,"")}function $(ie,ge,pe={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=y(ie)),pe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(ie,be)}function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function t(ie){return ie.split(/\r\n|\r|\n/)}function o(ie){const ge=[],pe=ie.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)ge.push(pe[2*be]+(pe[2*be+1]??""));return ge}function r(ie){for(let ge=0,pe=ie.length;ge<pe;ge++){const be=ie.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}function i(ie,ge=0,pe=ie.length){for(let be=ge;be<pe;be++){const Ee=ie.charCodeAt(be);if(Ee!==32&&Ee!==9)return ie.substring(ge,be)}return ie.substring(ge,pe)}function s(ie,ge=ie.length-1){for(let pe=ge;pe>=0;pe--){const be=ie.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function l(ie,ge,pe){const be=[];let Ee=0;for(const Ae of ie.matchAll(ge)){if(be.push(ie.slice(Ee,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Ee=Ae.index+Ae[0].length,be.push(pe(Ae[0],...Ae.slice(1),Ae.index,ie,Ae.groups))}return be.push(ie.slice(Ee)),Promise.all(be).then(Ae=>Ae.join(""))}function p(ie,ge){return ie<ge?-1:ie>ge?1:0}function D(ie,ge,pe=0,be=ie.length,Ee=0,Ae=ge.length){for(;pe<be&&Ee<Ae;pe++,Ee++){const Ye=ie.charCodeAt(pe),Ze=ge.charCodeAt(Ee);if(Ye<Ze)return-1;if(Ye>Ze)return 1}const Ne=be-pe,Ke=Ae-Ee;return Ne<Ke?-1:Ne>Ke?1:0}function I(ie,ge){return S(ie,ge,0,ie.length,0,ge.length)}function S(ie,ge,pe=0,be=ie.length,Ee=0,Ae=ge.length){for(;pe<be&&Ee<Ae;pe++,Ee++){let Ye=ie.charCodeAt(pe),Ze=ge.charCodeAt(Ee);if(Ye===Ze)continue;if(Ye>=128||Ze>=128)return D(ie.toLowerCase(),ge.toLowerCase(),pe,be,Ee,Ae);B(Ye)&&(Ye-=32),B(Ze)&&(Ze-=32);const Qe=Ye-Ze;if(Qe!==0)return Qe}const Ne=be-pe,Ke=Ae-Ee;return Ne<Ke?-1:Ne>Ke?1:0}function R(ie){return ie>=48&&ie<=57}function B(ie){return ie>=97&&ie<=122}function L(ie){return ie>=65&&ie<=90}function W(ie,ge){return ie.length===ge.length&&S(ie,ge)===0}function U(ie,ge){const pe=ge.length;return ge.length>ie.length?!1:S(ie,ge,0,pe)===0}function x(ie,ge){const pe=Math.min(ie.length,ge.length);let be;for(be=0;be<pe;be++)if(ie.charCodeAt(be)!==ge.charCodeAt(be))return be;return pe}function le(ie,ge){const pe=Math.min(ie.length,ge.length);let be;const Ee=ie.length-1,Ae=ge.length-1;for(be=0;be<pe;be++)if(ie.charCodeAt(Ee-be)!==ge.charCodeAt(Ae-be))return be;return pe}function se(ie){return 55296<=ie&&ie<=56319}function ue(ie){return 56320<=ie&&ie<=57343}function Y(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function Z(ie,ge,pe){const be=ie.charCodeAt(pe);if(se(be)&&pe+1<ge){const Ee=ie.charCodeAt(pe+1);if(ue(Ee))return Y(be,Ee)}return be}function q(ie,ge){const pe=ie.charCodeAt(ge-1);if(ue(pe)&&ge>1){const be=ie.charCodeAt(ge-2);if(se(be))return Y(be,pe)}return pe}class M{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=q(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Z(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=M;class N{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new M(ge,pe)}nextGraphemeLength(){const ge=Re.getInstance(),pe=this.c,be=pe.offset;let Ee=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ae=pe.offset,Ne=ge.getGraphemeBreakType(pe.nextCodePoint());if($e(Ee,Ne)){pe.setOffset(Ae);break}Ee=Ne}return pe.offset-be}prevGraphemeLength(){const ge=Re.getInstance(),pe=this.c,be=pe.offset;let Ee=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ae=pe.offset,Ne=ge.getGraphemeBreakType(pe.prevCodePoint());if($e(Ne,Ee)){pe.setOffset(Ae);break}Ee=Ne}return be-pe.offset}eol(){return this.c.eol()}}e.$uf=N;function G(ie,ge){return new N(ie,ge).nextGraphemeLength()}function z(ie,ge){return new N(ie,ge).prevGraphemeLength()}function oe(ie,ge){ge>0&&ue(ie.charCodeAt(ge))&&ge--;const pe=ge+G(ie,ge);return[pe-z(ie,pe),pe]}function he(ie){const ge=new N(ie);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let X;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(ie){return X||(X=A()),X.test(ie)}const _=/^[\t\n\r\x20-\x7E]*$/;function re(ie){return _.test(ie)}e.$Bf=/[\u2028\u2029]/;function K(ie){return e.$Bf.test(ie)}function V(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function H(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function T(ie,ge,pe=""){const be=ie.trimStart();if(be.length<ge)return be;const Ee=/\b/g;let Ae=0;for(;Ee.test(be)&&!(be.length-Ee.lastIndex<ge);)Ae=Ee.lastIndex,Ee.lastIndex+=1;return Ae===0?be:pe+be.substring(Ae).trimStart()}const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function fe(ie){return ie&&(ie=ie.replace(Q,"").replace(te,"")),ie}e.$Hf="\uFEFF";function me(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}function ke(ie){return me(ie)?ie.substr(1):ie}function Se(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const pe=ge.length,be=ie.toLowerCase();let Ee=0,Ae=-1;for(;Ee<pe;){const Ne=be.indexOf(ge[Ee],Ae+1);if(Ne<0)return!1;Ae=Ne,Ee++}return!0}function Oe(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function Ve(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function ye(ie,ge=1){if(ge===0)return"";let pe=-1;do pe=ie.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ie:(ie[pe-1]==="\r"&&pe--,ie.substr(0,pe))}function ee(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}function de(ie){return Re.getInstance().getGraphemeBreakType(ie)}function $e(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}var Pe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=qe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const pe=this.d,be=pe.length/3;let Ee=1;for(;Ee<=be;)if(ge<pe[3*Ee])Ee=2*Ee;else if(ge>pe[3*Ee+1])Ee=2*Ee+1;else return pe[3*Ee+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(ie,ge){if(ie===0)return 0;const pe=Le(ie,ge);if(pe!==void 0)return pe;const be=new M(ge,ie);return be.prevCodePoint(),be.offset}function Le(ie,ge){const pe=new M(ge,ie);let be=pe.prevCodePoint();for(;Ue(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!H(be))return;let Ee=pe.offset;return Ee>0&&pe.prevCodePoint()===8205&&(Ee=pe.offset),Ee}function Ue(ie){return 127995<=ie&&ie<=127999}var xe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.$Rf="\xA0";class Xe{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Qe(ge=>{function pe(Qe){const st=new Map;for(let tt=0;tt<Qe.length;tt+=2)st.set(Qe[tt],Qe[tt+1]);return st}function be(Qe,st){const tt=new Map(Qe);for(const[ot,at]of st)tt.set(ot,at);return tt}function Ee(Qe,st){if(!Qe)return st;const tt=new Map;for(const[ot,at]of Qe)st.has(ot)&&tt.set(ot,at);return tt}const Ae=this.c.value;let Ne=ge.filter(Qe=>!Qe.startsWith("_")&&Qe in Ae);Ne.length===0&&(Ne=["_default"]);let Ke;for(const Qe of Ne){const st=pe(Ae[Qe]);Ke=Ee(Ke,st)}const Ye=pe(Ae._common),Ze=be(Ye,Ke);return new Xe(Ze)})}static getInstance(ge){return Xe.d.get(Array.from(ge))}static{this.e=new C.$V(()=>Object.keys(Xe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=Xe;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(ge){return Fe.e().has(ge)}static get codePoints(){return Fe.e()}}e.$Tf=Fe}),define(ae[46],ce([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=C,e.$9i=P,e.$0i=O,e.$$i=E,e.$aj=v;function C(g){return P(g,0)}function P(g,f){switch(typeof g){case"object":return g===null?O(349,f):Array.isArray(g)?u(g,f):c(g,f);case"string":return E(g,f);case"boolean":return j(g,f);case"number":return O(g,f);case"undefined":return O(937,f);default:return O(617,f)}}function O(g,f){return(f<<5)-f+g|0}function j(g,f){return O(g?433:863,f)}function E(g,f){f=O(149417,f);for(let h=0,$=g.length;h<$;h++)f=O(g.charCodeAt(h),f);return f}function u(g,f){return f=O(104579,f),g.reduce((h,$)=>P($,h),f)}function c(g,f){return f=O(181387,f),Object.keys(g).sort().reduce((h,$)=>(h=E($,h),P(g[$],h)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=P(f,this.g),this.g}}e.$_i=b;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k(g,f,h=32){const $=h-f,a=~((1<<$)-1);return(g<<f|(a&g)>>>$)>>>0}function d(g,f=0,h=g.byteLength,$=0){for(let a=0;a<h;a++)g[f+a]=$}function m(g,f,h="0"){for(;g.length<f;)g=h+g;return g}function v(g,f=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(h=>h.toString(16).padStart(2,"0")).join(""):m((g>>>0).toString(16),f/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const h=f.length;if(h===0)return;const $=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$pf(o))if(r+1<h){const s=f.charCodeAt(r+1);n.$qf(s)?(r++,i=n.$rf(o,s)):i=65533}else{t=o;break}else n.$qf(o)&&(i=65533);if(a=this.w($,a,i),r++,r<h)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,h,$){return $<128?f[h++]=$:$<2048?(f[h++]=192|($&1984)>>>6,f[h++]=128|($&63)>>>0):$<65536?(f[h++]=224|($&61440)>>>12,f[h++]=128|($&4032)>>>6,f[h++]=128|($&63)>>>0):(f[h++]=240|($&1835008)>>>18,f[h++]=128|($&258048)>>>12,f[h++]=128|($&4032)>>>6,f[h++]=128|($&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,h=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,h.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,k(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let $=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,l;for(let p=0;p<80;p++)p<20?(i=a&t|~a&o,s=1518500249):p<40?(i=a^t^o,s=1859775393):p<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),l=k($,5)+i+r+s+f.getUint32(p*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=$,$=l;this.h=this.h+$&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$bj=w}),define(ae[73],ce([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const O="error",j="warning",E="warn",u="info",c="ignore";function b(k){return k?n.$lf(O,k)?P.Error:n.$lf(j,k)||n.$lf(E,k)?P.Warning:n.$lf(u,k)?P.Info:P.Ignore:P.Ignore}P.fromValue=b;function y(k){switch(k){case P.Error:return O;case P.Warning:return j;case P.Info:return u;default:return c}}P.toString=y}(C||(C={})),e.default=C}),define(ae[144],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class P{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const m=d.charCodeAt(0),v=this.b.charCodeAt(this.c);return m-v}value(){return this.b[this.c]}}e.$ji=P;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,C.$ff)(d,this.b,0,d.length,this.c,this.d):(0,C.$hf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=O;class j{constructor(d=!0,m=!0){this.f=d,this.g=m}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let m=d.length-1;m>=0;m--,this.c--){const v=this.b.charCodeAt(m);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,C.$ff)(d,this.b,0,d.length,this.d,this.e):(0,C.$hf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=j;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class u{constructor(d,m){this.f=d,this.g=m,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,C.$gf)(d,this.c.scheme);if(this.d[this.e]===2)return(0,C.$gf)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,C.$ef)(d,this.c.query);if(this.d[this.e]===5)return(0,C.$ef)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(b||(b={}));class y{static forUris(d=()=>!1,m=()=>!1){return new y(new u(d,m))}static forPaths(d=!1){return new y(new j(void 0,!d))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,m){if(m){const v=m.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w,d)}else{const v=d.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w[0],w[1])}}set(d,m){const v=this.b.reset(d);let w;this.c||(this.c=new c,this.c.segment=v.value());const g=[];for(w=this.c;;){const h=v.cmp(w.segment);if(h>0)w.left||(w.left=new c,w.left.segment=v.value()),g.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new c,w.right.segment=v.value()),g.push([1,w]),w=w.right;else if(v.hasNext())v.next(),w.mid||(w.mid=new c,w.mid.segment=v.value()),g.push([0,w]),w=w.mid;else break}const f=w.value;w.value=m,w.key=d;for(let h=g.length-1;h>=0;h--){const $=g[h][1];$.updateHeight();const a=$.balanceFactor();if(a<-1||a>1){const t=g[h][0],o=g[h+1][0];if(t===1&&o===1)g[h][1]=$.rotateLeft();else if(t===-1&&o===-1)g[h][1]=$.rotateRight();else if(t===1&&o===-1)$.right=g[h+1][1]=g[h+1][1].rotateRight(),g[h][1]=$.rotateLeft();else if(t===-1&&o===1)$.left=g[h+1][1]=g[h+1][1].rotateLeft(),g[h][1]=$.rotateRight();else throw new Error;if(h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this.c=g[0][1]}}return f}get(d){return this.d(d)?.value}d(d){const m=this.b.reset(d);let v=this.c;for(;v;){const w=m.cmp(v.segment);if(w>0)v=v.left;else if(w<0)v=v.right;else if(m.hasNext())m.next(),v=v.mid;else break}return v}has(d){const m=this.d(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,m){const v=this.b.reset(d),w=[];let g=this.c;for(;g;){const f=v.cmp(g.segment);if(f>0)w.push([-1,g]),g=g.left;else if(f<0)w.push([1,g]),g=g.right;else if(v.hasNext())v.next(),w.push([0,g]),g=g.mid;else break}if(g){if(m?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const f=this.f(g.right);if(f.key){const{key:h,value:$,segment:a}=f;this.e(f.key,!1),g.key=h,g.value=$,g.segment=a}}else{const f=g.left??g.right;if(w.length>0){const[h,$]=w[w.length-1];switch(h){case-1:$.left=f;break;case 0:$.mid=f;break;case 1:$.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const h=w[f][1];h.updateHeight();const $=h.balanceFactor();if($>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[f][1]=h.rotateLeft()):$<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[f][1]=h.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this.b.reset(d);let v=this.c,w;for(;v;){const g=m.cmp(v.segment);if(g>0)v=v.left;else if(g<0)v=v.right;else if(m.hasNext())m.next(),w=v.value||w,v=v.mid;else break}return v&&v.value||w}findSuperstr(d){return this.g(d,!1)}g(d,m){const v=this.b.reset(d);let w=this.c;for(;w;){const g=v.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(v.hasNext())v.next(),w=w.mid;else return w.mid?this.h(w.mid):m?w.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[m,v]of this)d(v,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const m=[];return this.j(d,m),m[Symbol.iterator]()}j(d,m){d&&(d.left&&this.j(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this.j(d.mid,m),d.right&&this.j(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const v=m.balanceFactor();return v<-1||v>1?!1:d(m.left)&&d(m.right)};return d(this.c)}}e.$ni=y}),define(ae[12],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=n,e.$Vf=C,e.$Wf=P,e.$Xf=O,e.$Yf=j,e.$Zf=E,e.$1f=u,e.$2f=c,e.$3f=b,e.$4f=y,e.$5f=k,e.$6f=d,e.$7f=m,e.$8f=w,e.$9f=g,e.$0f=f,e.$$f=h,e.$_f=$;function n(a){return typeof a=="string"}function C(a){return Array.isArray(a)&&a.every(t=>n(t))}function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function u(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function b(a){return!y(a)}function y(a){return c(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function d(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(y(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const v=Object.prototype.hasOwnProperty;function w(a){if(!P(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function g(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every(g)}function h(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)$(a[r],t[r])}function $(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[105],ce([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=P,e.$Cj=O;const C=Object.create(null);function P(j,E){if((0,n.$Uf)(E)){const u=C[E];if(u===void 0)throw new Error(`${j} references an unknown codicon: ${E}`);E=u}return C[j]=E,{id:j}}function O(){return C}}),define(ae[145],ce([0,1,105]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=void 0,e.$Dj={add:(0,n.$Bj)("add",6e4),plus:(0,n.$Bj)("plus",6e4),gistNew:(0,n.$Bj)("gist-new",6e4),repoCreate:(0,n.$Bj)("repo-create",6e4),lightbulb:(0,n.$Bj)("lightbulb",60001),lightBulb:(0,n.$Bj)("light-bulb",60001),repo:(0,n.$Bj)("repo",60002),repoDelete:(0,n.$Bj)("repo-delete",60002),gistFork:(0,n.$Bj)("gist-fork",60003),repoForked:(0,n.$Bj)("repo-forked",60003),gitPullRequest:(0,n.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Bj)("record-keys",60005),keyboard:(0,n.$Bj)("keyboard",60005),tag:(0,n.$Bj)("tag",60006),gitPullRequestLabel:(0,n.$Bj)("git-pull-request-label",60006),tagAdd:(0,n.$Bj)("tag-add",60006),tagRemove:(0,n.$Bj)("tag-remove",60006),person:(0,n.$Bj)("person",60007),personFollow:(0,n.$Bj)("person-follow",60007),personOutline:(0,n.$Bj)("person-outline",60007),personFilled:(0,n.$Bj)("person-filled",60007),gitBranch:(0,n.$Bj)("git-branch",60008),gitBranchCreate:(0,n.$Bj)("git-branch-create",60008),gitBranchDelete:(0,n.$Bj)("git-branch-delete",60008),sourceControl:(0,n.$Bj)("source-control",60008),mirror:(0,n.$Bj)("mirror",60009),mirrorPublic:(0,n.$Bj)("mirror-public",60009),star:(0,n.$Bj)("star",60010),starAdd:(0,n.$Bj)("star-add",60010),starDelete:(0,n.$Bj)("star-delete",60010),starEmpty:(0,n.$Bj)("star-empty",60010),comment:(0,n.$Bj)("comment",60011),commentAdd:(0,n.$Bj)("comment-add",60011),alert:(0,n.$Bj)("alert",60012),warning:(0,n.$Bj)("warning",60012),search:(0,n.$Bj)("search",60013),searchSave:(0,n.$Bj)("search-save",60013),logOut:(0,n.$Bj)("log-out",60014),signOut:(0,n.$Bj)("sign-out",60014),logIn:(0,n.$Bj)("log-in",60015),signIn:(0,n.$Bj)("sign-in",60015),eye:(0,n.$Bj)("eye",60016),eyeUnwatch:(0,n.$Bj)("eye-unwatch",60016),eyeWatch:(0,n.$Bj)("eye-watch",60016),circleFilled:(0,n.$Bj)("circle-filled",60017),primitiveDot:(0,n.$Bj)("primitive-dot",60017),closeDirty:(0,n.$Bj)("close-dirty",60017),debugBreakpoint:(0,n.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Bj)("primitive-square",60018),edit:(0,n.$Bj)("edit",60019),pencil:(0,n.$Bj)("pencil",60019),info:(0,n.$Bj)("info",60020),issueOpened:(0,n.$Bj)("issue-opened",60020),gistPrivate:(0,n.$Bj)("gist-private",60021),gitForkPrivate:(0,n.$Bj)("git-fork-private",60021),lock:(0,n.$Bj)("lock",60021),mirrorPrivate:(0,n.$Bj)("mirror-private",60021),close:(0,n.$Bj)("close",60022),removeClose:(0,n.$Bj)("remove-close",60022),x:(0,n.$Bj)("x",60022),repoSync:(0,n.$Bj)("repo-sync",60023),sync:(0,n.$Bj)("sync",60023),clone:(0,n.$Bj)("clone",60024),desktopDownload:(0,n.$Bj)("desktop-download",60024),beaker:(0,n.$Bj)("beaker",60025),microscope:(0,n.$Bj)("microscope",60025),vm:(0,n.$Bj)("vm",60026),deviceDesktop:(0,n.$Bj)("device-desktop",60026),file:(0,n.$Bj)("file",60027),fileText:(0,n.$Bj)("file-text",60027),more:(0,n.$Bj)("more",60028),ellipsis:(0,n.$Bj)("ellipsis",60028),kebabHorizontal:(0,n.$Bj)("kebab-horizontal",60028),mailReply:(0,n.$Bj)("mail-reply",60029),reply:(0,n.$Bj)("reply",60029),organization:(0,n.$Bj)("organization",60030),organizationFilled:(0,n.$Bj)("organization-filled",60030),organizationOutline:(0,n.$Bj)("organization-outline",60030),newFile:(0,n.$Bj)("new-file",60031),fileAdd:(0,n.$Bj)("file-add",60031),newFolder:(0,n.$Bj)("new-folder",60032),fileDirectoryCreate:(0,n.$Bj)("file-directory-create",60032),trash:(0,n.$Bj)("trash",60033),trashcan:(0,n.$Bj)("trashcan",60033),history:(0,n.$Bj)("history",60034),clock:(0,n.$Bj)("clock",60034),folder:(0,n.$Bj)("folder",60035),fileDirectory:(0,n.$Bj)("file-directory",60035),symbolFolder:(0,n.$Bj)("symbol-folder",60035),logoGithub:(0,n.$Bj)("logo-github",60036),markGithub:(0,n.$Bj)("mark-github",60036),github:(0,n.$Bj)("github",60036),terminal:(0,n.$Bj)("terminal",60037),console:(0,n.$Bj)("console",60037),repl:(0,n.$Bj)("repl",60037),zap:(0,n.$Bj)("zap",60038),symbolEvent:(0,n.$Bj)("symbol-event",60038),error:(0,n.$Bj)("error",60039),stop:(0,n.$Bj)("stop",60039),variable:(0,n.$Bj)("variable",60040),symbolVariable:(0,n.$Bj)("symbol-variable",60040),array:(0,n.$Bj)("array",60042),symbolArray:(0,n.$Bj)("symbol-array",60042),symbolModule:(0,n.$Bj)("symbol-module",60043),symbolPackage:(0,n.$Bj)("symbol-package",60043),symbolNamespace:(0,n.$Bj)("symbol-namespace",60043),symbolObject:(0,n.$Bj)("symbol-object",60043),symbolMethod:(0,n.$Bj)("symbol-method",60044),symbolFunction:(0,n.$Bj)("symbol-function",60044),symbolConstructor:(0,n.$Bj)("symbol-constructor",60044),symbolBoolean:(0,n.$Bj)("symbol-boolean",60047),symbolNull:(0,n.$Bj)("symbol-null",60047),symbolNumeric:(0,n.$Bj)("symbol-numeric",60048),symbolNumber:(0,n.$Bj)("symbol-number",60048),symbolStructure:(0,n.$Bj)("symbol-structure",60049),symbolStruct:(0,n.$Bj)("symbol-struct",60049),symbolParameter:(0,n.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Bj)("symbol-type-parameter",60050),symbolKey:(0,n.$Bj)("symbol-key",60051),symbolText:(0,n.$Bj)("symbol-text",60051),symbolReference:(0,n.$Bj)("symbol-reference",60052),goToFile:(0,n.$Bj)("go-to-file",60052),symbolEnum:(0,n.$Bj)("symbol-enum",60053),symbolValue:(0,n.$Bj)("symbol-value",60053),symbolRuler:(0,n.$Bj)("symbol-ruler",60054),symbolUnit:(0,n.$Bj)("symbol-unit",60054),activateBreakpoints:(0,n.$Bj)("activate-breakpoints",60055),archive:(0,n.$Bj)("archive",60056),arrowBoth:(0,n.$Bj)("arrow-both",60057),arrowDown:(0,n.$Bj)("arrow-down",60058),arrowLeft:(0,n.$Bj)("arrow-left",60059),arrowRight:(0,n.$Bj)("arrow-right",60060),arrowSmallDown:(0,n.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Bj)("arrow-small-up",60064),arrowUp:(0,n.$Bj)("arrow-up",60065),bell:(0,n.$Bj)("bell",60066),bold:(0,n.$Bj)("bold",60067),book:(0,n.$Bj)("book",60068),bookmark:(0,n.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Bj)("briefcase",60076),broadcast:(0,n.$Bj)("broadcast",60077),browser:(0,n.$Bj)("browser",60078),bug:(0,n.$Bj)("bug",60079),calendar:(0,n.$Bj)("calendar",60080),caseSensitive:(0,n.$Bj)("case-sensitive",60081),check:(0,n.$Bj)("check",60082),checklist:(0,n.$Bj)("checklist",60083),chevronDown:(0,n.$Bj)("chevron-down",60084),chevronLeft:(0,n.$Bj)("chevron-left",60085),chevronRight:(0,n.$Bj)("chevron-right",60086),chevronUp:(0,n.$Bj)("chevron-up",60087),chromeClose:(0,n.$Bj)("chrome-close",60088),chromeMaximize:(0,n.$Bj)("chrome-maximize",60089),chromeMinimize:(0,n.$Bj)("chrome-minimize",60090),chromeRestore:(0,n.$Bj)("chrome-restore",60091),circleOutline:(0,n.$Bj)("circle-outline",60092),circle:(0,n.$Bj)("circle",60092),debugBreakpointUnverified:(0,n.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Bj)("circle-slash",60093),circuitBoard:(0,n.$Bj)("circuit-board",60094),clearAll:(0,n.$Bj)("clear-all",60095),clippy:(0,n.$Bj)("clippy",60096),closeAll:(0,n.$Bj)("close-all",60097),cloudDownload:(0,n.$Bj)("cloud-download",60098),cloudUpload:(0,n.$Bj)("cloud-upload",60099),code:(0,n.$Bj)("code",60100),collapseAll:(0,n.$Bj)("collapse-all",60101),colorMode:(0,n.$Bj)("color-mode",60102),commentDiscussion:(0,n.$Bj)("comment-discussion",60103),creditCard:(0,n.$Bj)("credit-card",60105),dash:(0,n.$Bj)("dash",60108),dashboard:(0,n.$Bj)("dashboard",60109),database:(0,n.$Bj)("database",60110),debugContinue:(0,n.$Bj)("debug-continue",60111),debugDisconnect:(0,n.$Bj)("debug-disconnect",60112),debugPause:(0,n.$Bj)("debug-pause",60113),debugRestart:(0,n.$Bj)("debug-restart",60114),debugStart:(0,n.$Bj)("debug-start",60115),debugStepInto:(0,n.$Bj)("debug-step-into",60116),debugStepOut:(0,n.$Bj)("debug-step-out",60117),debugStepOver:(0,n.$Bj)("debug-step-over",60118),debugStop:(0,n.$Bj)("debug-stop",60119),debug:(0,n.$Bj)("debug",60120),deviceCameraVideo:(0,n.$Bj)("device-camera-video",60121),deviceCamera:(0,n.$Bj)("device-camera",60122),deviceMobile:(0,n.$Bj)("device-mobile",60123),diffAdded:(0,n.$Bj)("diff-added",60124),diffIgnored:(0,n.$Bj)("diff-ignored",60125),diffModified:(0,n.$Bj)("diff-modified",60126),diffRemoved:(0,n.$Bj)("diff-removed",60127),diffRenamed:(0,n.$Bj)("diff-renamed",60128),diff:(0,n.$Bj)("diff",60129),diffSidebyside:(0,n.$Bj)("diff-sidebyside",60129),discard:(0,n.$Bj)("discard",60130),editorLayout:(0,n.$Bj)("editor-layout",60131),emptyWindow:(0,n.$Bj)("empty-window",60132),exclude:(0,n.$Bj)("exclude",60133),extensions:(0,n.$Bj)("extensions",60134),eyeClosed:(0,n.$Bj)("eye-closed",60135),fileBinary:(0,n.$Bj)("file-binary",60136),fileCode:(0,n.$Bj)("file-code",60137),fileMedia:(0,n.$Bj)("file-media",60138),filePdf:(0,n.$Bj)("file-pdf",60139),fileSubmodule:(0,n.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Bj)("file-symlink-file",60142),fileZip:(0,n.$Bj)("file-zip",60143),files:(0,n.$Bj)("files",60144),filter:(0,n.$Bj)("filter",60145),flame:(0,n.$Bj)("flame",60146),foldDown:(0,n.$Bj)("fold-down",60147),foldUp:(0,n.$Bj)("fold-up",60148),fold:(0,n.$Bj)("fold",60149),folderActive:(0,n.$Bj)("folder-active",60150),folderOpened:(0,n.$Bj)("folder-opened",60151),gear:(0,n.$Bj)("gear",60152),gift:(0,n.$Bj)("gift",60153),gistSecret:(0,n.$Bj)("gist-secret",60154),gist:(0,n.$Bj)("gist",60155),gitCommit:(0,n.$Bj)("git-commit",60156),gitCompare:(0,n.$Bj)("git-compare",60157),compareChanges:(0,n.$Bj)("compare-changes",60157),gitMerge:(0,n.$Bj)("git-merge",60158),githubAction:(0,n.$Bj)("github-action",60159),githubAlt:(0,n.$Bj)("github-alt",60160),globe:(0,n.$Bj)("globe",60161),grabber:(0,n.$Bj)("grabber",60162),graph:(0,n.$Bj)("graph",60163),gripper:(0,n.$Bj)("gripper",60164),heart:(0,n.$Bj)("heart",60165),home:(0,n.$Bj)("home",60166),horizontalRule:(0,n.$Bj)("horizontal-rule",60167),hubot:(0,n.$Bj)("hubot",60168),inbox:(0,n.$Bj)("inbox",60169),issueReopened:(0,n.$Bj)("issue-reopened",60171),issues:(0,n.$Bj)("issues",60172),italic:(0,n.$Bj)("italic",60173),jersey:(0,n.$Bj)("jersey",60174),json:(0,n.$Bj)("json",60175),kebabVertical:(0,n.$Bj)("kebab-vertical",60176),key:(0,n.$Bj)("key",60177),law:(0,n.$Bj)("law",60178),lightbulbAutofix:(0,n.$Bj)("lightbulb-autofix",60179),linkExternal:(0,n.$Bj)("link-external",60180),link:(0,n.$Bj)("link",60181),listOrdered:(0,n.$Bj)("list-ordered",60182),listUnordered:(0,n.$Bj)("list-unordered",60183),liveShare:(0,n.$Bj)("live-share",60184),loading:(0,n.$Bj)("loading",60185),location:(0,n.$Bj)("location",60186),mailRead:(0,n.$Bj)("mail-read",60187),mail:(0,n.$Bj)("mail",60188),markdown:(0,n.$Bj)("markdown",60189),megaphone:(0,n.$Bj)("megaphone",60190),mention:(0,n.$Bj)("mention",60191),milestone:(0,n.$Bj)("milestone",60192),gitPullRequestMilestone:(0,n.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Bj)("mortar-board",60193),move:(0,n.$Bj)("move",60194),multipleWindows:(0,n.$Bj)("multiple-windows",60195),mute:(0,n.$Bj)("mute",60196),noNewline:(0,n.$Bj)("no-newline",60197),note:(0,n.$Bj)("note",60198),octoface:(0,n.$Bj)("octoface",60199),openPreview:(0,n.$Bj)("open-preview",60200),package:(0,n.$Bj)("package",60201),paintcan:(0,n.$Bj)("paintcan",60202),pin:(0,n.$Bj)("pin",60203),play:(0,n.$Bj)("play",60204),run:(0,n.$Bj)("run",60204),plug:(0,n.$Bj)("plug",60205),preserveCase:(0,n.$Bj)("preserve-case",60206),preview:(0,n.$Bj)("preview",60207),project:(0,n.$Bj)("project",60208),pulse:(0,n.$Bj)("pulse",60209),question:(0,n.$Bj)("question",60210),quote:(0,n.$Bj)("quote",60211),radioTower:(0,n.$Bj)("radio-tower",60212),reactions:(0,n.$Bj)("reactions",60213),references:(0,n.$Bj)("references",60214),refresh:(0,n.$Bj)("refresh",60215),regex:(0,n.$Bj)("regex",60216),remoteExplorer:(0,n.$Bj)("remote-explorer",60217),remote:(0,n.$Bj)("remote",60218),remove:(0,n.$Bj)("remove",60219),replaceAll:(0,n.$Bj)("replace-all",60220),replace:(0,n.$Bj)("replace",60221),repoClone:(0,n.$Bj)("repo-clone",60222),repoForcePush:(0,n.$Bj)("repo-force-push",60223),repoPull:(0,n.$Bj)("repo-pull",60224),repoPush:(0,n.$Bj)("repo-push",60225),report:(0,n.$Bj)("report",60226),requestChanges:(0,n.$Bj)("request-changes",60227),rocket:(0,n.$Bj)("rocket",60228),rootFolderOpened:(0,n.$Bj)("root-folder-opened",60229),rootFolder:(0,n.$Bj)("root-folder",60230),rss:(0,n.$Bj)("rss",60231),ruby:(0,n.$Bj)("ruby",60232),saveAll:(0,n.$Bj)("save-all",60233),saveAs:(0,n.$Bj)("save-as",60234),save:(0,n.$Bj)("save",60235),screenFull:(0,n.$Bj)("screen-full",60236),screenNormal:(0,n.$Bj)("screen-normal",60237),searchStop:(0,n.$Bj)("search-stop",60238),server:(0,n.$Bj)("server",60240),settingsGear:(0,n.$Bj)("settings-gear",60241),settings:(0,n.$Bj)("settings",60242),shield:(0,n.$Bj)("shield",60243),smiley:(0,n.$Bj)("smiley",60244),sortPrecedence:(0,n.$Bj)("sort-precedence",60245),splitHorizontal:(0,n.$Bj)("split-horizontal",60246),splitVertical:(0,n.$Bj)("split-vertical",60247),squirrel:(0,n.$Bj)("squirrel",60248),starFull:(0,n.$Bj)("star-full",60249),starHalf:(0,n.$Bj)("star-half",60250),symbolClass:(0,n.$Bj)("symbol-class",60251),symbolColor:(0,n.$Bj)("symbol-color",60252),symbolConstant:(0,n.$Bj)("symbol-constant",60253),symbolEnumMember:(0,n.$Bj)("symbol-enum-member",60254),symbolField:(0,n.$Bj)("symbol-field",60255),symbolFile:(0,n.$Bj)("symbol-file",60256),symbolInterface:(0,n.$Bj)("symbol-interface",60257),symbolKeyword:(0,n.$Bj)("symbol-keyword",60258),symbolMisc:(0,n.$Bj)("symbol-misc",60259),symbolOperator:(0,n.$Bj)("symbol-operator",60260),symbolProperty:(0,n.$Bj)("symbol-property",60261),wrench:(0,n.$Bj)("wrench",60261),wrenchSubaction:(0,n.$Bj)("wrench-subaction",60261),symbolSnippet:(0,n.$Bj)("symbol-snippet",60262),tasklist:(0,n.$Bj)("tasklist",60263),telescope:(0,n.$Bj)("telescope",60264),textSize:(0,n.$Bj)("text-size",60265),threeBars:(0,n.$Bj)("three-bars",60266),thumbsdown:(0,n.$Bj)("thumbsdown",60267),thumbsup:(0,n.$Bj)("thumbsup",60268),tools:(0,n.$Bj)("tools",60269),triangleDown:(0,n.$Bj)("triangle-down",60270),triangleLeft:(0,n.$Bj)("triangle-left",60271),triangleRight:(0,n.$Bj)("triangle-right",60272),triangleUp:(0,n.$Bj)("triangle-up",60273),twitter:(0,n.$Bj)("twitter",60274),unfold:(0,n.$Bj)("unfold",60275),unlock:(0,n.$Bj)("unlock",60276),unmute:(0,n.$Bj)("unmute",60277),unverified:(0,n.$Bj)("unverified",60278),verified:(0,n.$Bj)("verified",60279),versions:(0,n.$Bj)("versions",60280),vmActive:(0,n.$Bj)("vm-active",60281),vmOutline:(0,n.$Bj)("vm-outline",60282),vmRunning:(0,n.$Bj)("vm-running",60283),watch:(0,n.$Bj)("watch",60284),whitespace:(0,n.$Bj)("whitespace",60285),wholeWord:(0,n.$Bj)("whole-word",60286),window:(0,n.$Bj)("window",60287),wordWrap:(0,n.$Bj)("word-wrap",60288),zoomIn:(0,n.$Bj)("zoom-in",60289),zoomOut:(0,n.$Bj)("zoom-out",60290),listFilter:(0,n.$Bj)("list-filter",60291),listFlat:(0,n.$Bj)("list-flat",60292),listSelection:(0,n.$Bj)("list-selection",60293),selection:(0,n.$Bj)("selection",60293),listTree:(0,n.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Bj)("symbol-string",60301),debugReverseContinue:(0,n.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Bj)("debug-step-back",60303),debugRestartFrame:(0,n.$Bj)("debug-restart-frame",60304),debugAlt:(0,n.$Bj)("debug-alt",60305),callIncoming:(0,n.$Bj)("call-incoming",60306),callOutgoing:(0,n.$Bj)("call-outgoing",60307),menu:(0,n.$Bj)("menu",60308),expandAll:(0,n.$Bj)("expand-all",60309),feedback:(0,n.$Bj)("feedback",60310),gitPullRequestReviewer:(0,n.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Bj)("ungroup-by-ref-type",60312),account:(0,n.$Bj)("account",60313),gitPullRequestAssignee:(0,n.$Bj)("git-pull-request-assignee",60313),bellDot:(0,n.$Bj)("bell-dot",60314),debugConsole:(0,n.$Bj)("debug-console",60315),library:(0,n.$Bj)("library",60316),output:(0,n.$Bj)("output",60317),runAll:(0,n.$Bj)("run-all",60318),syncIgnored:(0,n.$Bj)("sync-ignored",60319),pinned:(0,n.$Bj)("pinned",60320),githubInverted:(0,n.$Bj)("github-inverted",60321),serverProcess:(0,n.$Bj)("server-process",60322),serverEnvironment:(0,n.$Bj)("server-environment",60323),pass:(0,n.$Bj)("pass",60324),issueClosed:(0,n.$Bj)("issue-closed",60324),stopCircle:(0,n.$Bj)("stop-circle",60325),playCircle:(0,n.$Bj)("play-circle",60326),record:(0,n.$Bj)("record",60327),debugAltSmall:(0,n.$Bj)("debug-alt-small",60328),vmConnect:(0,n.$Bj)("vm-connect",60329),cloud:(0,n.$Bj)("cloud",60330),merge:(0,n.$Bj)("merge",60331),export:(0,n.$Bj)("export",60332),graphLeft:(0,n.$Bj)("graph-left",60333),magnet:(0,n.$Bj)("magnet",60334),notebook:(0,n.$Bj)("notebook",60335),redo:(0,n.$Bj)("redo",60336),checkAll:(0,n.$Bj)("check-all",60337),pinnedDirty:(0,n.$Bj)("pinned-dirty",60338),passFilled:(0,n.$Bj)("pass-filled",60339),circleLargeFilled:(0,n.$Bj)("circle-large-filled",60340),circleLarge:(0,n.$Bj)("circle-large",60341),circleLargeOutline:(0,n.$Bj)("circle-large-outline",60341),combine:(0,n.$Bj)("combine",60342),gather:(0,n.$Bj)("gather",60342),table:(0,n.$Bj)("table",60343),variableGroup:(0,n.$Bj)("variable-group",60344),typeHierarchy:(0,n.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Bj)("git-pull-request-create",60348),runAbove:(0,n.$Bj)("run-above",60349),runBelow:(0,n.$Bj)("run-below",60350),notebookTemplate:(0,n.$Bj)("notebook-template",60351),debugRerun:(0,n.$Bj)("debug-rerun",60352),workspaceTrusted:(0,n.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Bj)("workspace-unknown",60355),terminalCmd:(0,n.$Bj)("terminal-cmd",60356),terminalDebian:(0,n.$Bj)("terminal-debian",60357),terminalLinux:(0,n.$Bj)("terminal-linux",60358),terminalPowershell:(0,n.$Bj)("terminal-powershell",60359),terminalTmux:(0,n.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Bj)("terminal-ubuntu",60361),terminalBash:(0,n.$Bj)("terminal-bash",60362),arrowSwap:(0,n.$Bj)("arrow-swap",60363),copy:(0,n.$Bj)("copy",60364),personAdd:(0,n.$Bj)("person-add",60365),filterFilled:(0,n.$Bj)("filter-filled",60366),wand:(0,n.$Bj)("wand",60367),debugLineByLine:(0,n.$Bj)("debug-line-by-line",60368),inspect:(0,n.$Bj)("inspect",60369),layers:(0,n.$Bj)("layers",60370),layersDot:(0,n.$Bj)("layers-dot",60371),layersActive:(0,n.$Bj)("layers-active",60372),compass:(0,n.$Bj)("compass",60373),compassDot:(0,n.$Bj)("compass-dot",60374),compassActive:(0,n.$Bj)("compass-active",60375),azure:(0,n.$Bj)("azure",60376),issueDraft:(0,n.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Bj)("git-pull-request-draft",60379),debugAll:(0,n.$Bj)("debug-all",60380),debugCoverage:(0,n.$Bj)("debug-coverage",60381),runErrors:(0,n.$Bj)("run-errors",60382),folderLibrary:(0,n.$Bj)("folder-library",60383),debugContinueSmall:(0,n.$Bj)("debug-continue-small",60384),beakerStop:(0,n.$Bj)("beaker-stop",60385),graphLine:(0,n.$Bj)("graph-line",60386),graphScatter:(0,n.$Bj)("graph-scatter",60387),pieChart:(0,n.$Bj)("pie-chart",60388),bracket:(0,n.$Bj)("bracket",60175),bracketDot:(0,n.$Bj)("bracket-dot",60389),bracketError:(0,n.$Bj)("bracket-error",60390),lockSmall:(0,n.$Bj)("lock-small",60391),azureDevops:(0,n.$Bj)("azure-devops",60392),verifiedFilled:(0,n.$Bj)("verified-filled",60393),newline:(0,n.$Bj)("newline",60394),layout:(0,n.$Bj)("layout",60395),layoutActivitybarLeft:(0,n.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Bj)("layout-panel-right",60401),layoutPanel:(0,n.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Bj)("layout-statusbar",60405),layoutMenubar:(0,n.$Bj)("layout-menubar",60406),layoutCentered:(0,n.$Bj)("layout-centered",60407),target:(0,n.$Bj)("target",60408),indent:(0,n.$Bj)("indent",60409),recordSmall:(0,n.$Bj)("record-small",60410),errorSmall:(0,n.$Bj)("error-small",60411),terminalDecorationError:(0,n.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Bj)("layout-sidebar-left-off",60418),blank:(0,n.$Bj)("blank",60419),heartFilled:(0,n.$Bj)("heart-filled",60420),map:(0,n.$Bj)("map",60421),mapFilled:(0,n.$Bj)("map-filled",60422),circleSmall:(0,n.$Bj)("circle-small",60423),bellSlash:(0,n.$Bj)("bell-slash",60424),bellSlashDot:(0,n.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Bj)("search-fuzzy",60429),commentDraft:(0,n.$Bj)("comment-draft",60430),send:(0,n.$Bj)("send",60431),sparkle:(0,n.$Bj)("sparkle",60432),insert:(0,n.$Bj)("insert",60433),mic:(0,n.$Bj)("mic",60434),thumbsdownFilled:(0,n.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Bj)("thumbsup-filled",60436),coffee:(0,n.$Bj)("coffee",60437),snake:(0,n.$Bj)("snake",60438),game:(0,n.$Bj)("game",60439),vr:(0,n.$Bj)("vr",60440),chip:(0,n.$Bj)("chip",60441),piano:(0,n.$Bj)("piano",60442),music:(0,n.$Bj)("music",60443),micFilled:(0,n.$Bj)("mic-filled",60444),repoFetch:(0,n.$Bj)("repo-fetch",60445),copilot:(0,n.$Bj)("copilot",60446),lightbulbSparkle:(0,n.$Bj)("lightbulb-sparkle",60447),robot:(0,n.$Bj)("robot",60448),sparkleFilled:(0,n.$Bj)("sparkle-filled",60449),diffSingle:(0,n.$Bj)("diff-single",60450),diffMultiple:(0,n.$Bj)("diff-multiple",60451),surroundWith:(0,n.$Bj)("surround-with",60452),share:(0,n.$Bj)("share",60453),gitStash:(0,n.$Bj)("git-stash",60454),gitStashApply:(0,n.$Bj)("git-stash-apply",60455),gitStashPop:(0,n.$Bj)("git-stash-pop",60456),vscode:(0,n.$Bj)("vscode",60457),vscodeInsiders:(0,n.$Bj)("vscode-insiders",60458),codeOss:(0,n.$Bj)("code-oss",60459),runCoverage:(0,n.$Bj)("run-coverage",60460),runAllCoverage:(0,n.$Bj)("run-all-coverage",60461),coverage:(0,n.$Bj)("coverage",60462),githubProject:(0,n.$Bj)("github-project",60463)}}),define(ae[74],ce([0,1,105,145]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Ej=P;function P(){return Object.values(e.$Gj)}e.$Fj={dialogError:(0,n.$Bj)("dialog-error","error"),dialogWarning:(0,n.$Bj)("dialog-warning","warning"),dialogInfo:(0,n.$Bj)("dialog-info","info"),dialogClose:(0,n.$Bj)("dialog-close","close"),treeItemExpanded:(0,n.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Bj)("tree-item-loading","loading"),menuSelection:(0,n.$Bj)("menu-selection","check"),menuSubmenu:(0,n.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Bj)("toolbar-more","more"),quickInputBack:(0,n.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Bj)("drop-down-button",60084),symbolCustomColor:(0,n.$Bj)("symbol-customcolor",60252),exportIcon:(0,n.$Bj)("export",60332),workspaceUnspecified:(0,n.$Bj)("workspace-unspecified",60355),newLine:(0,n.$Bj)("newline",60394),thumbsDownFilled:(0,n.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Bj)("thumbsup-filled",60436),gitFetch:(0,n.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Bj)("debug-breakpoint-pending",60377)},e.$Gj={...C.$Dj,...e.$Fj}}),define(ae[35],ce([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=C,e.$On=P,e.$Pn=j,e.$Qn=u,e.$Rn=c,e.$Sn=b,e.$Tn=y,e.$Un=k,e.$Vn=d,e.$Wn=m,e.$Xn=v,e.$Yn=w;function C(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const f=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([h,$])=>{f[h]=$&&typeof $=="object"?C($):$}),f}function P(g){if(!g||typeof g!="object")return g;const f=[g];for(;f.length>0;){const h=f.shift();Object.freeze(h);for(const $ in h)if(O.call(h,$)){const a=h[$];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Xf)(a)&&f.push(a)}}return g}const O=Object.prototype.hasOwnProperty;function j(g,f){return E(g,f,new Set)}function E(g,f,h){if((0,n.$4f)(g))return g;const $=f(g);if(typeof $<"u")return $;if(Array.isArray(g)){const a=[];for(const t of g)a.push(E(t,f,h));return a}if((0,n.$Wf)(g)){if(h.has(g))throw new Error("Cannot clone recursive data-structure");h.add(g);const a={};for(const t in g)O.call(g,t)&&(a[t]=E(g[t],f,h));return h.delete(g),a}return g}function u(g,f,h=!0){return(0,n.$Wf)(g)?((0,n.$Wf)(f)&&Object.keys(f).forEach($=>{$ in g?h&&((0,n.$Wf)(g[$])&&(0,n.$Wf)(f[$])?u(g[$],f[$],h):g[$]=f[$]):g[$]=f[$]}),g):f}function c(g,f){if(g===f)return!0;if(g==null||f===null||f===void 0||typeof g!=typeof f||typeof g!="object"||Array.isArray(g)!==Array.isArray(f))return!1;let h,$;if(Array.isArray(g)){if(g.length!==f.length)return!1;for(h=0;h<g.length;h++)if(!c(g[h],f[h]))return!1}else{const a=[];for($ in g)a.push($);a.sort();const t=[];for($ in f)t.push($);if(t.sort(),!c(a,t))return!1;for(h=0;h<a.length;h++)if(!c(g[a[h]],f[a[h]]))return!1}return!0}function b(g){const f=new Set;return JSON.stringify(g,(h,$)=>{if((0,n.$Wf)($)||Array.isArray($)){if(f.has($))return"[Circular]";f.add($)}return $})}function y(g,f){const h=Object.create(null);return!g||!f||Object.keys(f).forEach(a=>{const t=g[a],o=f[a];c(t,o)||(h[a]=o)}),h}function k(g,f){const h=f.toLowerCase(),$=Object.keys(g).find(a=>a.toLowerCase()===h);return $?g[$]:g[f]}function d(g,f){const h=Object.create(null);for(const[$,a]of Object.entries(g))f($,a)&&(h[$]=a);return h}function m(g){let f=[];for(;Object.prototype!==g;)f=f.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return f}function v(g){const f=[];for(const h of m(g))typeof g[h]=="function"&&f.push(h);return f}function w(g,f){const h=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},$={};for(const a of g)$[a]=h(a);return $}}),define(ae[106],ce([0,1,74]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=P;var C;(function(j){function E(u){return u&&typeof u=="object"&&typeof u.id=="string"}j.isThemeColor=E})(C||(e.ThemeColor=C={}));function P(j){return{id:j}}var O;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function u(f){const h=E.exec(f.id);if(!h)return u(n.$Gj.error);const[,$,a]=h,t=["codicon","codicon-"+$];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=u;function c(f){return u(f).join(" ")}j.asClassName=c;function b(f){return"."+u(f).join(".")}j.asCSSSelector=b;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||C.isThemeColor(f.color))}j.isThemeIcon=y;const k=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function d(f){const h=k.exec(f);if(!h)return;const[,$]=h;return{id:$}}j.fromString=d;function m(f){return{id:f}}j.fromId=m;function v(f,h){let $=f.id;const a=$.lastIndexOf("~");return a!==-1&&($=$.substring(0,a)),h&&($=`${$}~${h}`),{id:$}}j.modify=v;function w(f){const h=f.id.lastIndexOf("~");if(h!==-1)return f.id.substring(h+1)}j.getModifier=w;function g(f,h){return f.id===h.id&&f.color?.id===h.color?.id}j.isEqual=g})(O||(e.ThemeIcon=O={}))}),define(ae[32],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=C;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return n.test(P)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const O=new Uint8Array(16),j=[];for(let E=0;E<256;E++)j.push(E.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let u=0,c="";return c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c+="-",c+=j[O[u++]],c+=j[O[u++]],c+="-",c+=j[O[u++]],c+=j[O[u++]],c+="-",c+=j[O[u++]],c+=j[O[u++]],c+="-",c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c+=j[O[u++]],c}}()}),define(ae[146],ce([0,1,87,43,85]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SV=O;async function O(j,E){if(await new Promise((b,y)=>{const k=C.createReadStream(j),d=n.createHash("sha256");k.pipe(d);const m=(0,P.$db)((v,w)=>{k.removeAllListeners(),d.removeAllListeners(),v?y(v):b(w)});k.once("error",m),k.once("end",m),d.once("error",m),d.once("data",v=>m(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(ae[147],ce([0,1,26]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=O;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(j){const E=j.replace(/\-/g,":").toLowerCase();return!C.has(E)}function O(){const j=(0,n.networkInterfaces)();for(const E in j){const u=j[E];if(u){for(const{mac:c}of u)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[107],ce([0,1,88]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=C,e.$Hg=O;function C(E,u,c,b=1){let y=!1;return new Promise(k=>{const d=setTimeout(()=>{if(!y)return y=!0,k(0)},c);P(E,u,b,m=>{if(!y)return y=!0,clearTimeout(d),k(m)})})}function P(E,u,c,b){if(u===0)return b(0);const y=new n.Socket;y.once("connect",()=>(j(y),P(E+c,u-1,c,b))),y.once("data",()=>{}),y.once("error",k=>(j(y),k.code!=="ECONNREFUSED"?P(E+c,u-1,c,b):b(E))),y.connect(E,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(E,u,c,b="127.0.0.1"){let y=!1,k,d=1;const m=n.createServer({pauseOnConnect:!0});function v(w,g){y||(y=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),g(w))}return new Promise(w=>{k=setTimeout(()=>{v(0,w)},c),m.on("listening",()=>{v(E,w)}),m.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&d<u?(E++,d++,m.listen(E,b)):v(0,w)}),m.on("close",()=>{v(0,w)}),m.listen(E,b)})}function j(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(u){console.error(u)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function n(u){const c=new Set;if(Array.isArray(u))for(const b of u)typeof b=="string"&&c.add(b);return Array.from(c)}function C(){const u=e();return u?Array.from(u):[]}function P(u){if(process.platform!=="win32")return;const c=e();if(c)if(typeof u=="string")c.add(u.toLowerCase());else for(const b of n(u))P(b)}function O(u){if(typeof u!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const y of c){if(u.indexOf(y)!==0)continue;const d=u.indexOf("\\",y.length);if(d===-1)continue;const m=u.substring(y.length,d);if(m){b=m;break}}return b}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:P,getUNCHost:O,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[148],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WV=e.$VV=void 0,e.$VV="vscode:contextmenu",e.$WV="vscode:onCloseContextMenu"}),define(ae[149],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4V=void 0;class n{constructor(P,O){this.a=P,this.onMessage=O}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$4V=n}),define(ae[150],ce([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ae[151],ce([0,1,150]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=c,e.$Nm=b,e.$Om=y;const C=60,P=C*60,O=P*24,j=O*7,E=O*30,u=O*365;function c(k,d,m,v){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,n.localize)(1,null);let g;return w<C?(g=w,d?g===1?m?(0,n.localize)(2,null,g):(0,n.localize)(3,null,g):m?(0,n.localize)(4,null,g):(0,n.localize)(5,null,g):g===1?m?(0,n.localize)(6,null,g):(0,n.localize)(7,null,g):m?(0,n.localize)(8,null,g):(0,n.localize)(9,null,g)):w<P?(g=Math.floor(w/C),d?g===1?m?(0,n.localize)(10,null,g):(0,n.localize)(11,null,g):m?(0,n.localize)(12,null,g):(0,n.localize)(13,null,g):g===1?m?(0,n.localize)(14,null,g):(0,n.localize)(15,null,g):m?(0,n.localize)(16,null,g):(0,n.localize)(17,null,g)):w<O?(g=Math.floor(w/P),d?g===1?m?(0,n.localize)(18,null,g):(0,n.localize)(19,null,g):m?(0,n.localize)(20,null,g):(0,n.localize)(21,null,g):g===1?m?(0,n.localize)(22,null,g):(0,n.localize)(23,null,g):m?(0,n.localize)(24,null,g):(0,n.localize)(25,null,g)):w<j?(g=Math.floor(w/O),d?g===1?(0,n.localize)(26,null,g):(0,n.localize)(27,null,g):g===1?(0,n.localize)(28,null,g):(0,n.localize)(29,null,g)):w<E?(g=Math.floor(w/j),d?g===1?m?(0,n.localize)(30,null,g):(0,n.localize)(31,null,g):m?(0,n.localize)(32,null,g):(0,n.localize)(33,null,g):g===1?m?(0,n.localize)(34,null,g):(0,n.localize)(35,null,g):m?(0,n.localize)(36,null,g):(0,n.localize)(37,null,g)):w<u?(g=Math.floor(w/E),d?g===1?m?(0,n.localize)(38,null,g):(0,n.localize)(39,null,g):m?(0,n.localize)(40,null,g):(0,n.localize)(41,null,g):g===1?m?(0,n.localize)(42,null,g):(0,n.localize)(43,null,g):m?(0,n.localize)(44,null,g):(0,n.localize)(45,null,g)):(g=Math.floor(w/u),d?g===1?m?(0,n.localize)(46,null,g):(0,n.localize)(47,null,g):m?(0,n.localize)(48,null,g):(0,n.localize)(49,null,g):g===1?m?(0,n.localize)(50,null,g):(0,n.localize)(51,null,g):m?(0,n.localize)(52,null,g):(0,n.localize)(53,null,g))}function b(k,d){const m=Math.abs(k/1e3);return m<1?d?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<C?d?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<P?d?(0,n.localize)(58,null,Math.round(k/(1e3*C))):(0,n.localize)(59,null,Math.round(k/(1e3*C))):m<O?d?(0,n.localize)(60,null,Math.round(k/(1e3*P))):(0,n.localize)(61,null,Math.round(k/(1e3*P))):(0,n.localize)(62,null,Math.round(k/(1e3*O)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[152],ce([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,152]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=u,e.$6i=c,e.$7i=b;function O(y,k){return k&&(y.stack||y.stacktrace)?P.localize(0,null,E(y),j(y.stack)||j(y.stacktrace)):E(y)}function j(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function u(y=null,k=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const d=n.$Hb(y),m=u(d[0],k);return d.length>1?P.localize(4,null,m,d.length):m}if(C.$Uf(y))return y;if(y.detail){const d=y.detail;if(d.error)return O(d.error,k);if(d.exception)return O(d.exception,k)}return y.stack?O(y,k):y.message?y.message:P.localize(5,null)}function c(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function b(y,k){let d;return typeof y=="string"?d=new Error(y):d=y,d.actions=k,d}}),define(ae[153],ce([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ae[154],ce([0,1,153]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=C;function C(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(ae[155],ce([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,155]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=D,e.$J=I,e.$g="en";let C=!1,P=!1,O=!1,j=!1,E=!1,u=!1,c=!1,b=!1,y=!1,k=!1,d,m=e.$g,v=e.$g,w,g;const f=globalThis;let h;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?h=f.vscode.process:typeof process<"u"&&(h=process);const $=typeof h?.versions?.electron=="string",a=$&&h?.type==="renderer";if(typeof h=="object"){C=h.platform==="win32",P=h.platform==="darwin",O=h.platform==="linux",j=O&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=$,y=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,m=e.$g;const S=h.env.VSCODE_NLS_CONFIG;if(S)try{const R=JSON.parse(S),B=R.availableLanguages["*"];d=R.locale,v=R.osLocale,m=B||e.$g,w=R._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(g=navigator.userAgent,C=g.indexOf("Windows")>=0,P=g.indexOf("Macintosh")>=0,b=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=g.indexOf("Linux")>=0,k=g?.indexOf("Mobi")>=0,u=!0,d=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=d,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;P?r=1:C?r=3:O&&(r=2),e.$i=C,e.$j=P,e.$k=O,e.$l=j,e.$m=E,e.$n=c,e.$o=u,e.$p=u&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=b,e.$s=k,e.$t=y,e.$u=r,e.$v=g,e.$w=m;var i;(function(S){function R(){return e.$w}S.value=R;function B(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=B;function L(){return e.$w==="en"}S.isDefault=L})(i||(e.Language=i={})),e.$x=d,e.$y=v,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const S=[];f.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let L=0,W=S.length;L<W;L++){const U=S[L];if(U.id===B.data.vscodeScheduleAsyncWork){S.splice(L,1),U.callback();return}}});let R=0;return B=>{const L=++R;S.push({id:L,callback:B}),f.postMessage({vscodeScheduleAsyncWork:L},"*")}}return S=>setTimeout(S)})();var s;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=P||b?2:C?1:3;let l=!0,p=!1;function D(){if(!p){p=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,l=new Uint16Array(S.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(S){return parseFloat(S)>=20}}),define(ae[36],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let C;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const O=P.process;C={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$ec=C.platform,e.$fc=C.arch}),define(ae[9],ce([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const C=65,P=97,O=90,j=122,E=46,u=47,c=92,b=58,y=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const l=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${l} ${s} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=n.$ec==="win32";function w(t){return t===u||t===c}function g(t){return t===u}function f(t){return t>=C&&t<=O||t>=P&&t<=j}function h(t,o,r,i){let s="",l=0,p=-1,D=0,I=0;for(let S=0;S<=t.length;++S){if(S<t.length)I=t.charCodeAt(S);else{if(i(I))break;I=u}if(i(I)){if(!(p===S-1||D===1))if(D===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const R=s.lastIndexOf(r);R===-1?(s="",l=0):(s=s.slice(0,R),l=s.length-1-s.lastIndexOf(r)),p=S,D=0;continue}else if(s.length!==0){s="",l=0,p=S,D=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",l=2)}else s.length>0?s+=`${r}${t.slice(p+1,S)}`:s=t.slice(p+1,S),l=S-p-1;p=S,D=0}else I===E&&D!==-1?++D:D=-1}return s}function $(t,o){d(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],m(l,"path"),l.length===0)continue}else o.length===0?l=n.cwd():(l=n.env[`=${o}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const p=l.length;let D=0,I="",S=!1;const R=l.charCodeAt(0);if(p===1)w(R)&&(D=1,S=!0);else if(w(R))if(S=!0,w(l.charCodeAt(1))){let B=2,L=B;for(;B<p&&!w(l.charCodeAt(B));)B++;if(B<p&&B!==L){const W=l.slice(L,B);for(L=B;B<p&&w(l.charCodeAt(B));)B++;if(B<p&&B!==L){for(L=B;B<p&&!w(l.charCodeAt(B));)B++;(B===p||B!==L)&&(I=`\\\\${W}\\${l.slice(L,B)}`,D=B)}}}else D=1;else f(R)&&l.charCodeAt(1)===b&&(I=l.slice(0,2),D=2,p>2&&w(l.charCodeAt(2))&&(S=!0,D=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${l.slice(D)}\\${r}`,i=S,S&&o.length>0)break}return r=h(r,!i,"\\",w),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const l=t.charCodeAt(0);if(o===1)return g(l)?"\\":t;if(w(l))if(s=!0,w(t.charCodeAt(1))){let D=2,I=D;for(;D<o&&!w(t.charCodeAt(D));)D++;if(D<o&&D!==I){const S=t.slice(I,D);for(I=D;D<o&&w(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!w(t.charCodeAt(D));)D++;if(D===o)return`\\\\${S}\\${t.slice(I)}\\`;D!==I&&(i=`\\\\${S}\\${t.slice(I,D)}`,r=D)}}}else r=1;else f(l)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,o>2&&w(t.charCodeAt(2))&&(s=!0,r=3));let p=r<o?h(t.slice(r),!s,"\\",w):"";return p.length===0&&!s&&(p="."),p.length>0&&w(t.charCodeAt(o-1))&&(p+="\\"),i===void 0?s?`\\${p}`:p:s?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return w(r)||o>2&&f(r)&&t.charCodeAt(1)===b&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let l=0;l<t.length;++l){const p=t[l];m(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++s;const l=r.length;l>1&&w(r.charCodeAt(1))&&(++s,l>2&&(w(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&w(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===c;)l--;const p=l-s;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let I=o.length;for(;I-1>D&&o.charCodeAt(I-1)===c;)I--;const S=I-D,R=p<S?p:S;let B=-1,L=0;for(;L<R;L++){const U=t.charCodeAt(s+L);if(U!==o.charCodeAt(D+L))break;U===c&&(B=L)}if(L!==R){if(B===-1)return i}else{if(S>R){if(o.charCodeAt(D+L)===c)return i.slice(D+L+1);if(L===2)return i.slice(D+L)}p>R&&(t.charCodeAt(s+L)===c?B=L:L===2&&(B=3)),B===-1&&(B=0)}let W="";for(L=s+B+1;L<=l;++L)(L===l||t.charCodeAt(L)===c)&&(W+=W.length===0?"..":"\\..");return D+=B,W.length>0?`${W}${i.slice(D,I)}`:(i.charCodeAt(D)===c&&++D,i.slice(D,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==y&&r!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===b&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return w(s)?t:".";if(w(s)){if(r=i=1,w(t.charCodeAt(1))){let D=2,I=D;for(;D<o&&!w(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&w(t.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!w(t.charCodeAt(D));)D++;if(D===o)return t;D!==I&&(r=i=D+1)}}}}else f(s)&&t.charCodeAt(1)===b&&(r=o>2&&w(t.charCodeAt(2))?3:2,i=r);let l=-1,p=!0;for(let D=o-1;D>=i;--D)if(w(t.charCodeAt(D))){if(!p){l=D;break}}else p=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,D=-1;for(l=t.length-1;l>=r;--l){const I=t.charCodeAt(l);if(w(I)){if(!s){r=l+1;break}}else D===-1&&(s=!1,D=l+1),p>=0&&(I===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(w(t.charCodeAt(l))){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,l=!0,p=0;t.length>=2&&t.charCodeAt(1)===b&&f(t.charCodeAt(0))&&(o=i=2);for(let D=t.length-1;D>=o;--D){const I=t.charCodeAt(D);if(w(I)){if(!l){i=D+1;break}continue}s===-1&&(l=!1,s=D+1),I===E?r===-1?r=D:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||s===-1||p===0||p===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:$.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return w(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(w(s)){if(i=1,w(t.charCodeAt(1))){let B=2,L=B;for(;B<r&&!w(t.charCodeAt(B));)B++;if(B<r&&B!==L){for(L=B;B<r&&w(t.charCodeAt(B));)B++;if(B<r&&B!==L){for(L=B;B<r&&!w(t.charCodeAt(B));)B++;B===r?i=B:B!==L&&(i=B+1)}}}}else if(f(s)&&t.charCodeAt(1)===b){if(r<=2)return o.root=o.dir=t,o;if(i=2,w(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,p=i,D=-1,I=!0,S=t.length-1,R=0;for(;S>=i;--S){if(s=t.charCodeAt(S),w(s)){if(!I){p=S+1;break}continue}D===-1&&(I=!1,D=S+1),s===E?l===-1?l=S:R!==1&&(R=1):l!==-1&&(R=-1)}return D!==-1&&(l===-1||R===0||R===1&&l===D-1&&l===p+1?o.base=o.name=t.slice(p,D):(o.name=t.slice(p,l),o.base=t.slice(p,D),o.ext=t.slice(l,D))),p>0&&p!==i?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===u)}return o=h(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===u,r=t.charCodeAt(t.length-1)===u;return t=h(t,!o,"/",g),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,l=1,p=o.length-l,D=s<p?s:p;let I=-1,S=0;for(;S<D;S++){const B=t.charCodeAt(r+S);if(B!==o.charCodeAt(l+S))break;B===u&&(I=S)}if(S===D)if(p>D){if(o.charCodeAt(l+S)===u)return o.slice(l+S+1);if(S===0)return o.slice(l+S)}else s>D&&(t.charCodeAt(r+S)===u?I=S:S===0&&(I=0));let R="";for(S=r+I+1;S<=i;++S)(S===i||t.charCodeAt(S)===u)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(l+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===u;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===u){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,D=-1;for(l=t.length-1;l>=0;--l){const I=t.charCodeAt(l);if(I===u){if(!s){r=l+1;break}}else D===-1&&(s=!1,D=l+1),p>=0&&(I===o.charCodeAt(p)?--p===-1&&(i=l):(p=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===u){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,l=0;for(let p=t.length-1;p>=0;--p){const D=t.charCodeAt(p);if(D===u){if(!s){r=p+1;break}continue}i===-1&&(s=!1,i=p+1),D===E?o===-1?o=p:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:$.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===u;let i;r?(o.root="/",i=1):i=0;let s=-1,l=0,p=-1,D=!0,I=t.length-1,S=0;for(;I>=i;--I){const R=t.charCodeAt(I);if(R===u){if(!D){l=I+1;break}continue}p===-1&&(D=!1,p=I+1),R===E?s===-1?s=I:S!==1&&(S=1):s!==-1&&(S=-1)}if(p!==-1){const R=l===0&&r?1:l;s===-1||S===0||S===1&&s===p-1&&s===l+1?o.base=o.name=t.slice(R,p):(o.name=t.slice(R,s),o.base=t.slice(R,p),o.ext=t.slice(s,p))}return l>0?o.dir=t.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=j,e.$bg=E,e.$cg=u,e.$dg=c,e.$eg=b,e.$fg=m,e.$gg=v,e.$hg=w,e.$ig=g,e.$jg=f,e.$kg=h,e.$lg=$,e.$mg=a,e.$ng=t,e.$og=o,e.$pg=s;function j(l){return l===47||l===92}function E(l){return l.replace(/[\\/]/g,n.$hc.sep)}function u(l){return l.indexOf("/")===-1&&(l=E(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function c(l,p=n.$hc.sep){if(!l)return"";const D=l.length,I=l.charCodeAt(0);if(j(I)){if(j(l.charCodeAt(1))&&!j(l.charCodeAt(2))){let R=3;const B=R;for(;R<D&&!j(l.charCodeAt(R));R++);if(B!==R&&!j(l.charCodeAt(R+1))){for(R+=1;R<D;R++)if(j(l.charCodeAt(R)))return l.slice(0,R+1).replace(/[\\/]/g,p)}}return p}else if(g(I)&&l.charCodeAt(1)===58)return j(l.charCodeAt(2))?l.slice(0,2)+p:l.slice(0,2);let S=l.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(j(l.charCodeAt(S)))return l.slice(0,S+1)}return""}function b(l){if(!C.$i||!l||l.length<5)return!1;let p=l.charCodeAt(0);if(p!==92||(p=l.charCodeAt(1),p!==92))return!1;let D=2;const I=D;for(;D<l.length&&(p=l.charCodeAt(D),p!==92);D++);return!(I===D||(p=l.charCodeAt(D+1),isNaN(p)||p===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,p=C.$i){const D=p?y:k;return!(!l||l.length===0||/^\s+$/.test(l)||(D.lastIndex=0,D.test(l))||p&&d.test(l)||l==="."||l===".."||p&&l[l.length-1]==="."||p&&l.length!==l.trim().length||l.length>255)}function v(l,p,D){const I=l===p;return!D||I?I:!l||!p?!1:(0,P.$lf)(l,p)}function w(l,p,D,I=n.sep){if(l===p)return!0;if(!l||!p||p.length>l.length)return!1;if(D){if(!(0,P.$mf)(l,p))return!1;if(p.length===l.length)return!0;let R=p.length;return p.charAt(p.length-1)===I&&R--,l.charAt(R)===I}return p.charAt(p.length-1)!==I&&(p+=I),l.indexOf(p)===0}function g(l){return l>=65&&l<=90||l>=97&&l<=122}function f(l,p){return C.$i&&l.endsWith(":")&&(l+=n.sep),(0,n.$jc)(l)||(l=(0,n.$kc)(p,l)),l=(0,n.$ic)(l),C.$i?(l=(0,P.$6e)(l,n.sep),l.endsWith(":")&&(l+=n.sep)):(l=(0,P.$6e)(l,n.sep),l||(l=n.sep)),l}function h(l){const p=(0,n.$ic)(l);return C.$i?l.length>3?!1:$(p)&&(l.length===2||p.charCodeAt(2)===92):p===n.$hc.sep}function $(l,p=C.$i){return p?g(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}function a(l,p=C.$i){return $(l,p)?l[0]:void 0}function t(l,p,D){return p.length>l.length?-1:l===p?0:(D&&(l=l.toLowerCase(),p=p.toLowerCase()),l.indexOf(p))}function o(l){const p=l.split(":");let D,I,S;for(const R of p){const B=Number(R);(0,O.$Yf)(B)?I===void 0?I=B:S===void 0&&(S=B):D=D?[D,R].join(":"):R}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:S!==void 0?S:I!==void 0?1:void 0}}const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(l,p,D=8){let I="";for(let R=0;R<D;R++){let B;R===0&&C.$i&&!p&&(D===3||D===4)?B=i:B=r,I+=B.charAt(Math.floor(Math.random()*B.length))}let S;return p?S=`${p}-${I}`:S=I,l?(0,n.$kc)(l,S):S}}),define(ae[75],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=O,e.$$l=j;var C;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(C||(e.Source=C={}));var P;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function O(E,...u){const c=u.reduce((k,d)=>(k[d]=!0,k),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!c[k]).forEach(k=>{for(let d=0;d<b.length;d++)if(k.search(b[d])!==-1){delete E[k];break}})}function j(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(ae[7],ce([0,1,9,4]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=$;const P=/^\w[\w\d+.-]*$/,O=/^\//,j=/^\/\//;function E(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const b="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,p,D,I,S=!1){typeof s=="object"?(this.scheme=s.scheme||b,this.authority=s.authority||b,this.path=s.path||b,this.query=s.query||b,this.fragment=s.fragment||b):(this.scheme=u(s,S),this.authority=l||b,this.path=c(this.scheme,p||b),this.query=D||b,this.fragment=I||b,E(this,S))}get fsPath(){return $(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:p,path:D,query:I,fragment:S}=s;return l===void 0?l=this.scheme:l===null&&(l=b),p===void 0?p=this.authority:p===null&&(p=b),D===void 0?D=this.path:D===null&&(D=b),I===void 0?I=this.query:I===null&&(I=b),S===void 0?S=this.fragment:S===null&&(S=b),l===this.scheme&&p===this.authority&&D===this.path&&I===this.query&&S===this.fragment?this:new w(l,p,D,I,S)}static parse(s,l=!1){const p=k.exec(s);return p?new w(p[2]||b,r(p[4]||b),r(p[5]||b),r(p[7]||b),r(p[9]||b),l):new w(b,b,b,b,b)}static file(s){let l=b;if(C.$i&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const p=s.indexOf(y,2);p===-1?(l=s.substring(2),s=y):(l=s.substring(2,p),s=s.substring(p)||y)}return new w("file",l,s,b,b)}static from(s,l){return new w(s.scheme,s.authority,s.path,s.query,s.fragment,l)}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return C.$i&&s.scheme==="file"?p=d.file(n.$gc.join($(s,!0),...l)).path:p=n.$hc.join(s.path,...l),s.with({path:p})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const l=new w(s);return l._formatted=s.external??null,l._fsPath=s._sep===v?s.fsPath??null:null,l}}else return s}}e.URI=d;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const v=C.$i?1:void 0;class w extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=v),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,l){let p,D=-1;for(let I=0;I<i.length;I++){const S=i.charCodeAt(I);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||s&&S===47||l&&S===91||l&&S===93||l&&S===58)D!==-1&&(p+=encodeURIComponent(i.substring(D,I)),D=-1),p!==void 0&&(p+=i.charAt(I));else{p===void 0&&(p=i.substr(0,I));const R=g[S];R!==void 0?(D!==-1&&(p+=encodeURIComponent(i.substring(D,I)),D=-1),p+=R):D===-1&&(D=I)}}return D!==-1&&(p+=encodeURIComponent(i.substring(D))),p!==void 0?p:i}function h(i){let s;for(let l=0;l<i.length;l++){const p=i.charCodeAt(l);p===35||p===63?(s===void 0&&(s=i.substr(0,l)),s+=g[p]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function $(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,C.$i&&(l=l.replace(/\//g,"\\")),l}function a(i,s){const l=s?h:f;let p="",{scheme:D,authority:I,path:S,query:R,fragment:B}=i;if(D&&(p+=D,p+=":"),(I||D==="file")&&(p+=y,p+=y),I){let L=I.indexOf("@");if(L!==-1){const W=I.substr(0,L);I=I.substr(L+1),L=W.lastIndexOf(":"),L===-1?p+=l(W,!1,!1):(p+=l(W.substr(0,L),!1,!1),p+=":",p+=l(W.substr(L+1),!1,!0)),p+="@"}I=I.toLowerCase(),L=I.lastIndexOf(":"),L===-1?p+=l(I,!1,!0):(p+=l(I.substr(0,L),!1,!0),p+=I.substr(L))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const L=S.charCodeAt(1);L>=65&&L<=90&&(S=`/${String.fromCharCode(L+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const L=S.charCodeAt(0);L>=65&&L<=90&&(S=`${String.fromCharCode(L+32)}:${S.substr(2)}`)}p+=l(S,!0,!1)}return R&&(p+="?",p+=l(R,!1,!1)),B&&(p+="#",p+=s?B:f(B,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(ae[156],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=C,e.$Eq=P,e.$Fq=O,e.log=E;function C(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}function P(c){const b=[];let y;try{const k=JSON.parse(c.arguments),d=k[k.length-1];d&&d.__$stack&&(k.pop(),y=d.__$stack),b.push(...k)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:y}}function O(c){if(typeof c!="string")return O(P(c).stack);const b=c;if(b){const y=j(b),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function j(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function E(c,b){const{args:y,stack:k}=P(c),d=typeof y[0]=="string"&&y.length===1;let m=j(k);m&&(m=`(${m.trim()})`);let v=[];if(typeof y[0]=="string"?m&&d?v=[`%c[${b}] %c${y[0]} %c${m}`,u("blue"),u(""),u("grey")]:v=[`%c[${b}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:v=[`%c[${b}]%`,u("blue"),...y],m&&!d&&v.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}function u(c){return`color: ${c}`}}),define(ae[76],ce([0,1,17,7]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=P,e.$Ph=O,e.$Qh=E;function P(u){return JSON.stringify(u,j)}function O(u){let c=JSON.parse(u);return c=E(c),c}function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return C.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof n.$ue||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=E(u[b],c+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=E(u[b],c+1))}return u}}),define(ae[13],ce([0,1,15,4,25,7,9]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=u,e.$rg=c,e.$vg=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function u(m,v){return O.URI.isUri(m)?(0,P.$lf)(m.scheme,v):(0,P.$mf)(m,v+":")}function c(m,...v){return v.some(w=>u(m,w))}e.$sg="vscode-tkn",e.$tg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,w){this.f=y(v,w)}getServerRootPath(){return this.f}get g(){return j.$hc.join(this.f,E.vscodeRemoteResource)}set(v,w,g){this.a[v]=w,this.b[v]=g}setConnectionToken(v,w){this.c[v]=w}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return n.$1(a),v}const w=v.authority;let g=this.a[w];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const f=this.b[w],h=this.c[w];let $=`path=${encodeURIComponent(v.path)}`;return typeof h=="string"&&($+=`&${e.$tg}=${encodeURIComponent(h)}`),O.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${g}:${f}`,path:this.g,query:$})}}e.$ug=new b;function y(m,v){return j.$hc.join(v??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class k{static{this.a=e.$Ag}asBrowserUri(v){const w=this.b(v,J);return this.uriToBrowserUri(w)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$ug.rewrite(v):v.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const w=this.b(v,J);return this.uriToFileUri(w)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,w){return O.URI.isUri(v)?v:O.URI.parse(w.toUrl(v))}}e.$Bg=new k;var d;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const w="vscode-coi";function g(h){let $;typeof h=="string"?$=new URL(h).searchParams:h instanceof URL?$=h.searchParams:O.URI.isUri(h)&&($=new URL(h.toString(!0)).searchParams);const a=$?.get(w);if(a)return v.get(a)}m.getHeadersFromQuery=g;function f(h,$,a){if(!globalThis.crossOriginIsolated)return;const t=$&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(w,t):h[w]=t}m.addSearchParam=f})(d||(e.COI=d={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=u,e.$4g=b,e.$5g=k;function u(d){return(0,E.$xc)(d,!0)}class c{constructor(m){this.a=m}compare(m,v,w=!1){return m===v?0:(0,j.$ef)(this.getComparisonKey(m,w),this.getComparisonKey(v,w))}isEqual(m,v,w=!1){return m===v?!0:!m||!v?!1:this.getComparisonKey(m,w)===this.getComparisonKey(v,w)}getComparisonKey(m,v=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,v,w=!1){if(m.scheme===v.scheme){if(m.scheme===C.Schemas.file)return n.$hg(u(m),u(v),this.a(m))&&m.query===v.query&&(w||m.fragment===v.fragment);if((0,e.$Zg)(m.authority,v.authority))return n.$hg(m.path,v.path,this.a(m),"/")&&m.query===v.query&&(w||m.fragment===v.fragment)}return!1}joinPath(m,...v){return E.URI.joinPath(m,...v)}basenameOrAuthority(m){return(0,e.$Rg)(m)||m.authority}basename(m){return P.$hc.basename(m.path)}extname(m){return P.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let v;return m.scheme===C.Schemas.file?v=E.URI.file(P.$nc(u(m))).path:(v=P.$hc.dirname(m.path),m.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),v="/")),m.with({path:v})}normalizePath(m){if(!m.path.length)return m;let v;return m.scheme===C.Schemas.file?v=E.URI.file(P.$ic(u(m))).path:v=P.$hc.normalize(m.path),m.with({path:v})}relativePath(m,v){if(m.scheme!==v.scheme||!(0,e.$Zg)(m.authority,v.authority))return;if(m.scheme===C.Schemas.file){const f=P.$mc(u(m),u(v));return O.$i?n.$bg(f):f}let w=m.path||"/";const g=v.path||"/";if(this.a(m)){let f=0;for(const h=Math.min(w.length,g.length);f<h&&!(w.charCodeAt(f)!==g.charCodeAt(f)&&w.charAt(f).toLowerCase()!==g.charAt(f).toLowerCase());f++);w=g.substr(0,f)+w.substr(f)}return P.$hc.relative(w,g)}resolvePath(m,v){if(m.scheme===C.Schemas.file){const w=E.URI.file(P.$lc(u(m),v));return m.with({authority:w.authority,path:w.path})}return v=n.$cg(v),m.with({path:P.$hc.resolve(m.path,v)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,v){return m===v||m!==void 0&&v!==void 0&&(0,j.$lf)(m,v)}hasTrailingPathSeparator(m,v=P.sep){if(m.scheme===C.Schemas.file){const w=u(m);return w.length>n.$dg(w).length&&w[w.length-1]===v}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,v=P.sep){return(0,e.$1g)(m,v)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,v=P.sep){let w=!1;if(m.scheme===C.Schemas.file){const g=u(m);w=g!==void 0&&g.length===n.$dg(g).length&&g[g.length-1]===v}else{v="/";const g=m.path;w=g.length===1&&g.charCodeAt(g.length-1)===47}return!w&&!(0,e.$1g)(m,v)?m.with({path:m.path+"/"}):m}}e.$Jg=c,e.$Kg=new c(()=>!1),e.$Lg=new c(d=>d.scheme===C.Schemas.file?!O.$k:!0),e.$Mg=new c(d=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function b(d,m){const v=[];for(let w=0;w<d.length;w++){const g=m(d[w]);d.some((f,h)=>h===w?!1:(0,e.$Og)(g,m(f)))||v.push(d[w])}return v}var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(h=>{const[$,a]=h.split(":");$&&a&&w.set($,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&w.set(d.META_DATA_MIME,f),w}d.parseMetaData=m})(y||(e.DataUri=y={}));function k(d,m,v){if(m){let w=d.path;return w&&w[0]!==P.$hc.sep&&(w=P.$hc.sep+w),d.with({scheme:v,authority:m,path:w})}return d.with({scheme:v})}}),define(ae[8],ce([0,1,23,15,3,2,19,4,144,61]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=b,e.$7g=y,e.$8g=k,e.$9g=d,e.$0g=m,e.$$g=v,e.$_g=w,e.$ah=g,e.$ih=l,e.$jh=p,e.$kh=D,e.$lh=I,e.$mh=S,e.$Bh=M,e.$Jh=K;function b(H){return!!H&&typeof H.then=="function"}function y(H){const T=new n.$ee,Q=H(T.token),te=new Promise((fe,me)=>{const ke=T.token.onCancellationRequested(()=>{ke.dispose(),me(new C.$5)});Promise.resolve(Q).then(Se=>{ke.dispose(),T.dispose(),fe(Se)},Se=>{ke.dispose(),T.dispose(),me(Se)})});return new class{cancel(){T.cancel(),T.dispose()}then(fe,me){return te.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}function k(H,T,Q){return new Promise((te,fe)=>{const me=T.onCancellationRequested(()=>{me.dispose(),te(Q)});H.then(te,fe).finally(()=>me.dispose())})}function d(H,T){return new Promise((Q,te)=>{const fe=T.onCancellationRequested(()=>{fe.dispose(),te(new C.$5)});H.then(Q,te).finally(()=>fe.dispose())})}async function m(H){let T=-1;const Q=H.map((te,fe)=>te.then(me=>(T=fe,me)));try{return await Promise.race(Q)}finally{H.forEach((te,fe)=>{fe!==T&&te.cancel()})}}function v(H,T,Q){let te;const fe=setTimeout(()=>{te?.(void 0),Q?.()},T);return Promise.race([H.finally(()=>clearTimeout(fe)),new Promise(me=>te=me)])}function w(H){return new Promise((T,Q)=>{const te=H();b(te)?te.then(T,Q):T(te)})}function g(){let H,T;return{promise:new Promise((te,fe)=>{H=te,T=fe}),resolve:H,reject:T}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const Q=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(Q,Q).then(te)})}return new Promise((Q,te)=>{this.b.then(Q,te)})}return this.a=T(),new Promise((Q,te)=>{this.a.then(fe=>{this.a=null,Q(fe)},fe=>{this.a=null,te(fe)})})}dispose(){this.f=!0}}e.$bh=f;class h{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$ch=h;class ${constructor(){this.a=new Map}queue(T,Q){const fe=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(T)===fe&&this.a.delete(T)});return this.a.set(T,fe),fe}}e.$dh=$;const a=(H,T)=>{let Q=!0;const te=setTimeout(()=>{Q=!1,T()},H);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(te),Q=!1}}},t=H=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,H())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class o{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,Q=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((fe,me)=>{this.d=fe,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=Q===u.$4d?t(te):a(Q,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=o;class r{constructor(T){this.a=new o(T),this.b=new f}trigger(T,Q){return this.a.trigger(()=>this.b.queue(T),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=r;class i{constructor(){this.a=!1,this.b=new Promise((T,Q)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=i;class s extends i{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$hh=s;function l(H,T){return T?new Promise((Q,te)=>{const fe=setTimeout(()=>{me.dispose(),Q()},H),me=T.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),te(new C.$5)})}):y(Q=>l(H,Q))}function p(H,T=0,Q){const te=setTimeout(()=>{H(),Q&&fe.dispose()},T),fe=(0,O.$Sc)(()=>{clearTimeout(te),Q?.deleteAndLeak(fe)});return Q?.add(fe),fe}function D(H){const T=[];let Q=0;const te=H.length;function fe(){return Q<te?H[Q++]():null}function me(ke){ke!=null&&T.push(ke);const Se=fe();return Se?Se.then(me):Promise.resolve(T)}return Promise.resolve(null).then(me)}function I(H,T=te=>!!te,Q=null){let te=0;const fe=H.length,me=()=>{if(te>=fe)return Promise.resolve(Q);const ke=H[te++];return Promise.resolve(ke()).then(Oe=>T(Oe)?Promise.resolve(Oe):me())};return me()}function S(H,T=te=>!!te,Q=null){if(H.length===0)return Promise.resolve(Q);let te=H.length;const fe=()=>{te=-1;for(const me of H)me.cancel?.()};return new Promise((me,ke)=>{for(const Se of H)Se.then(Oe=>{--te>=0&&T(Oe)?(fe(),me(Oe)):te===0&&me(Q)}).catch(Oe=>{--te>=0&&(fe(),ke(Oe))})})}class R{constructor(T){this.a=0,this.b=!1,this.f=T,this.g=[],this.d=0,this.h=new P.$7d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(T){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,te)=>{this.g.push({factory:T,c:Q,e:te}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const T=this.g.shift();this.d++;const Q=T.factory();Q.then(T.c,T.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=R;class B extends R{constructor(){super(1)}}e.$oh=B;class L{constructor(){this.a=new N,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$ph=L;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new oe;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueSize(T,Q=j.$Kg){const te=Q.getComparisonKey(T);return this.a.get(te)?.size??0}queueFor(T,Q,te=j.$Kg){const fe=te.getComparisonKey(T);let me=this.a.get(fe);if(!me){me=new B;const ke=this.f++,Se=P.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(ke),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(ke,Se),this.a.set(fe,me)}return me.queue(Q)}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=W;class U{constructor(T,Q){this.a=-1,typeof T=="function"&&typeof Q=="number"&&this.setIfNotSet(T,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},Q)}setIfNotSet(T,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},Q))}}e.$rh=U;class x{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(T,Q,te=globalThis){this.cancel();const fe=te.setInterval(()=>{T()},Q);this.d=(0,O.$Sc)(()=>{te.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$sh=x;class le{constructor(T,Q){this.b=-1,this.a=T,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=le;class se{constructor(T,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=T,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=se;class ue extends le{constructor(T,Q){super(T,Q),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$vh=ue;class Y extends O.$Uc{constructor(T,Q){super(),this.g=T,this.h=Q,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of T)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(H,T)=>{(0,E.$B)(()=>{if(Q)return;const te=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$yh=(H,T,Q)=>{const te=H.requestIdleCallback(T,typeof Q=="number"?{timeout:Q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,H.cancelIdleCallback(te))}}},e.$xh=H=>(0,e.$yh)(globalThis,H)}();class Z{constructor(T,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$yh)(T,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=Z;class q extends Z{constructor(T){super(globalThis,T)}}e.$Ah=q;async function M(H,T,Q){let te;for(let fe=0;fe<Q;fe++)try{return await H()}catch(me){te=me,await l(T)}throw te}class N{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,Q,te){return this.a={taskId:T,cancel:()=>te?.(),promise:Q},Q.then(()=>this.d(T),()=>this.d(T)),Q}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{const{promise:Q,resolve:te,reject:fe}=g();this.b={run:T,promise:Q,promiseResolve:te,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=N;class G{constructor(T,Q=()=>Date.now()){this.d=T,this.f=Q,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$Dh=G;var z;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(z||(z={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,Q)=>{this.a=T,this.b=Q})}complete(T){return new Promise(Q=>{this.a(T),this.d={outcome:0,value:T},Q()})}error(T){return new Promise(Q=>{this.b(T),this.d={outcome:1,value:T},Q()})}cancel(){return this.error(new C.$5)}}e.$Eh=oe;var he;(function(H){async function T(te){let fe;const me=await Promise.all(te.map(ke=>ke.then(Se=>Se,Se=>{fe||(fe=Se)})));if(typeof fe<"u")throw fe;return me}H.settled=T;function Q(te){return new Promise(async(fe,me)=>{try{await te(fe,me)}catch(ke){me(ke)}})}H.withAsyncBody=Q})(he||(e.Promises=he={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(T){this.a=void 0,this.b=void 0,this.d=!1,this.promise=T.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=X;class A{constructor(T){this.b=T,this.a=new c.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=A;var F;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(F||(F={}));class _{static fromArray(T){return new _(Q=>{Q.emitMany(T)})}static fromPromise(T){return new _(async Q=>{Q.emitMany(await T)})}static fromPromises(T){return new _(async Q=>{await Promise.all(T.map(async te=>Q.emitOne(await te)))})}static merge(T){return new _(async Q=>{await Promise.all(T.map(async te=>{for await(const fe of te)Q.emitOne(fe)}))})}static{this.EMPTY=_.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new P.$7d,queueMicrotask(async()=>{const Q={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(T(Q)),this.j()}catch(te){this.k(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(T,Q){return new _(async te=>{for await(const fe of T)te.emitOne(Q(fe))})}map(T){return _.map(this,T)}static filter(T,Q){return new _(async te=>{for await(const fe of T)Q(fe)&&te.emitOne(fe)})}filter(T){return _.filter(this,T)}static coalesce(T){return _.filter(T,Q=>!!Q)}coalesce(){return _.coalesce(this)}static async toPromise(T){const Q=[];for await(const te of T)Q.push(te);return Q}toPromise(){return _.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$Hh=_;class re extends _{constructor(T,Q){super(Q),this.l=T}cancel(){this.l.cancel()}}e.$Ih=re;function K(H){const T=new n.$ee,Q=H(T.token);return new re(T,async te=>{const fe=T.token.onCancellationRequested(()=>{fe.dispose(),T.dispose(),te.reject(new C.$5)});try{for await(const me of Q){if(T.token.isCancellationRequested)return;te.emitOne(me)}fe.dispose(),T.dispose()}catch(me){fe.dispose(),T.dispose(),te.reject(me)}})}class V{constructor(){this.a=new oe,this.b=new _(te=>{if(T){te.reject(T);return}return Q&&te.emitMany(Q),this.d=fe=>te.reject(fe),this.f=fe=>te.emitOne(fe),this.a.p});let T,Q;this.f=te=>{Q||(Q=[]),Q.push(te)},this.d=te=>{T||(T=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$Kh=V}),define(ae[108],ce([0,1,22,8,33,31,9,4,25]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=c,e.$_j=m,e.$ak=B,e.$bk=L,e.$ck=W,e.$dk=U,e.$ek=x,e.$fk=Y;function c(){return Object.create(null)}e.$0j="**",e.$$j="/";const b="[/\\\\]",y="[^/\\\\]",k=/\//g;function d(Z,q){switch(Z){case 0:return"";case 1:return`${y}*?`;default:return`(?:${b}|${y}+${b}${q?`|${b}${y}+`:""})*?`}}function m(Z,q){if(!Z)return[];const M=[];let N=!1,G=!1,z="";for(const oe of Z){switch(oe){case q:if(!N&&!G){M.push(z),z="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}z+=oe}return z&&M.push(z),M}function v(Z){if(!Z)return"";let q="";const M=m(Z,e.$$j);if(M.every(N=>N===e.$0j))q=".*";else{let N=!1;M.forEach((G,z)=>{if(G===e.$0j){if(N)return;q+=d(2,z===M.length-1)}else{let oe=!1,he="",X=!1,A="";for(const F of G){if(F!=="}"&&oe){he+=F;continue}if(X&&(F!=="]"||!A)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!A?_="^":F===e.$$j?_="":_=(0,u.$Ze)(F),A+=_;continue}switch(F){case"{":oe=!0;continue;case"[":X=!0;continue;case"}":{const re=`(?:${m(he,",").map(K=>v(K)).join("|")})`;q+=re,oe=!1,he="";break}case"]":{q+="["+A+"]",X=!1,A="";break}case"?":q+=y;continue;case"*":q+=d(1);continue;default:q+=(0,u.$Ze)(F)}}z<M.length-1&&(M[z+1]!==e.$0j||z+2<M.length)&&(q+=b)}N=G===e.$0j})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),o=function(){return!1},r=function(){return null};function i(Z,q){if(!Z)return r;let M;typeof Z!="string"?M=Z.pattern:M=Z,M=M.trim();const N=`${M}_${!!q.trimForExclusions}`;let G=t.get(N);if(G)return s(G,Z);let z;return w.test(M)?G=p(M.substr(4),M):(z=g.exec(l(M,q)))?G=D(z[1],M):(q.trimForExclusions?h:f).test(M)?G=I(M,q):(z=$.exec(l(M,q)))?G=S(z[1].substr(1),M,!0):(z=a.exec(l(M,q)))?G=S(z[1],M,!1):G=R(M),t.set(N,G),s(G,Z)}function s(Z,q){if(typeof q=="string")return Z;const M=function(N,G){return(0,P.$hg)(N,q.base,!E.$k)?Z((0,u.$5e)(N.substr(q.base.length),j.sep),G):null};return M.allBasenames=Z.allBasenames,M.allPaths=Z.allPaths,M.basenames=Z.basenames,M.patterns=Z.patterns,M}function l(Z,q){return q.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function p(Z,q){return function(M,N){return typeof M=="string"&&M.endsWith(Z)?q:null}}function D(Z,q){const M=`/${Z}`,N=`\\${Z}`,G=function(oe,he){return typeof oe!="string"?null:he?he===Z?q:null:oe===Z||oe.endsWith(M)||oe.endsWith(N)?q:null},z=[Z];return G.basenames=z,G.patterns=[q],G.allBasenames=z,G}function I(Z,q){const M=ue(Z.slice(1,-1).split(",").map(he=>i(he,q)).filter(he=>he!==r),Z),N=M.length;if(!N)return r;if(N===1)return M[0];const G=function(he,X){for(let A=0,F=M.length;A<F;A++)if(M[A](he,X))return Z;return null},z=M.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const oe=M.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function S(Z,q,M){const N=j.sep===j.$hc.sep,G=N?Z:Z.replace(k,j.sep),z=j.sep+G,oe=j.$hc.sep+Z;let he;return M?he=function(X,A){return typeof X=="string"&&(X===G||X.endsWith(z)||!N&&(X===Z||X.endsWith(oe)))?q:null}:he=function(X,A){return typeof X=="string"&&(X===G||!N&&X===Z)?q:null},he.allPaths=[(M?"*/":"./")+Z],he}function R(Z){try{const q=new RegExp(`^${v(Z)}$`);return function(M){return q.lastIndex=0,typeof M=="string"&&q.test(M)?Z:null}}catch{return r}}function B(Z,q,M){return!Z||typeof q!="string"?!1:L(Z)(q,void 0,M)}function L(Z,q={}){if(!Z)return o;if(typeof Z=="string"||W(Z)){const M=i(Z,q);if(M===r)return o;const N=function(G,z){return!!M(G,z)};return M.allBasenames&&(N.allBasenames=M.allBasenames),M.allPaths&&(N.allPaths=M.allPaths),N}return le(Z,q)}function W(Z){const q=Z;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function U(Z){return Z.allBasenames||[]}function x(Z){return Z.allPaths||[]}function le(Z,q){const M=ue(Object.getOwnPropertyNames(Z).map(he=>se(he,Z[he],q)).filter(he=>he!==r)),N=M.length;if(!N)return r;if(!M.some(he=>!!he.requiresSiblings)){if(N===1)return M[0];const he=function(F,_){let re;for(let K=0,V=M.length;K<V;K++){const H=M[K](F,_);if(typeof H=="string")return H;(0,C.$6g)(H)&&(re||(re=[]),re.push(H))}return re?(async()=>{for(const K of re){const V=await K;if(typeof V=="string")return V}return null})():null},X=M.find(F=>!!F.allBasenames);X&&(he.allBasenames=X.allBasenames);const A=M.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return A.length&&(he.allPaths=A),he}const G=function(he,X,A){let F,_;for(let re=0,K=M.length;re<K;re++){const V=M[re];V.requiresSiblings&&A&&(X||(X=(0,j.$oc)(he)),F||(F=X.substr(0,X.length-(0,j.$pc)(he).length)));const H=V(he,X,F,A);if(typeof H=="string")return H;(0,C.$6g)(H)&&(_||(_=[]),_.push(H))}return _?(async()=>{for(const re of _){const K=await re;if(typeof K=="string")return K}return null})():null},z=M.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const oe=M.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function se(Z,q,M){if(q===!1)return r;const N=i(Z,M);if(N===r)return r;if(typeof q=="boolean")return N;if(q){const G=q.when;if(typeof G=="string"){const z=(oe,he,X,A)=>{if(!A||!N(oe,he))return null;const F=G.replace("$(basename)",()=>X),_=A(F);return(0,C.$6g)(_)?_.then(re=>re?Z:null):_?Z:null};return z.requiresSiblings=!0,z}}return N}function ue(Z,q){const M=Z.filter(he=>!!he.basenames);if(M.length<2)return Z;const N=M.reduce((he,X)=>{const A=X.basenames;return A?he.concat(A):he},[]);let G;if(q){G=[];for(let he=0,X=N.length;he<X;he++)G.push(q)}else G=M.reduce((he,X)=>{const A=X.patterns;return A?he.concat(A):he},[]);const z=function(he,X){if(typeof he!="string")return null;if(!X){let F;for(F=he.length;F>0;F--){const _=he.charCodeAt(F-1);if(_===47||_===92)break}X=he.substr(F)}const A=N.indexOf(X);return A!==-1?G[A]:null};z.basenames=N,z.patterns=G,z.allBasenames=N;const oe=Z.filter(he=>!he.basenames);return oe.push(z),oe}function Y(Z,q){return(0,n.$ub)(Z,q,(M,N)=>typeof M=="string"&&typeof N=="string"?M===N:typeof M!="string"&&typeof N!="string"?M.base===N.base&&M.pattern===N.pattern:!1)}}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=u,e.$fw=b,e.$gw=k,e.$hw=d,e.$iw=g,e.$jw=h,e.$kw=$,e.$lw=a,e.$mw=t,e.$nw=o;function u(i,s){const{os:l,tildify:p,relative:D}=s;if(D){const R=c(i,D,l);if(typeof R=="string")return R}let I=i.fsPath;if(l===1&&!O.$i?I=I.replace(/\//g,"\\"):l!==1&&O.$i&&(I=I.replace(/\\/g,"/")),l!==1&&p?.userHome){const R=p.userHome.fsPath;let B;i.scheme!==p.userHome.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep?B=p.userHome.with({path:i.path}).fsPath:B=I,I=k(B,R,l)}return(l===1?P.$gc:P.$hc).normalize(b(I,l===1))}function c(i,s,l){const p=l===1?P.$gc:P.$hc,D=l===3?j.$Kg:j.$Mg,I=s.getWorkspace(),S=(0,n.$Ob)(I.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep&&(i=S.uri.with({path:i.path}));const R=s.getWorkspaceFolder(i);if(!R)return;let B;if(D.isEqual(R.uri,i)?B="":B=D.relativePath(R.uri,i)??"",B&&(B=p.normalize(B)),I.folders.length>1&&!s.noPrefix){const L=R.name?R.name:D.basenameOrAuthority(R.uri);B=B?`${L} \u2022 ${B}`:L}return B}function b(i,s=O.$i){return(0,C.$lg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function k(i,s,l=O.OS){if(l===1||!i||!s)return i;let p=y.original===s?y.normalized:void 0;p||(p=s,O.$i&&(p=(0,C.$bg)(p)),p=`${(0,E.$6e)(p,P.$hc.sep)}${P.$hc.sep}`,y={original:s,normalized:p});let D=i;return O.$i&&(D=(0,C.$bg)(D)),(l===3?D.startsWith(p):(0,E.$mf)(D,p))?`~/${D.substr(p.length)}`:i}function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}const m="\u2026",v="\\\\",w="~";function g(i,s=P.sep){const l=new Array(i.length);let p=!1;for(let D=0;D<i.length;D++){const I=i[D];if(I===""){l[D]=`.${s}`;continue}if(!I){l[D]=I;continue}p=!0;let S="",R=I;R.indexOf(v)===0?(S=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length)):R.indexOf(s)===0?(S=R.substr(0,R.indexOf(s)+s.length),R=R.substr(R.indexOf(s)+s.length)):R.indexOf(w)===0&&(S=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length));const B=R.split(s);for(let L=1;p&&L<=B.length;L++)for(let W=B.length-L;p&&W>=0;W--){p=!1;let U=B.slice(W,W+L).join(s);for(let x=0;!p&&x<i.length;x++)if(x!==D&&i[x]&&i[x].indexOf(U)>-1){const le=W+L===B.length,se=W>0&&i[x].indexOf(s)>-1?s+U:U,ue=i[x].endsWith(se);p=!le||ue}if(!p){let x="";(B[0].endsWith(":")||S!=="")&&(W===1&&(W=0,L++,U=B[0]+s+U),W>0&&(x=B[0]+s),x=S+x),W>0&&(x=x+m+s),x=x+U,W+L<B.length&&(x=x+s+m),l[D]=x}}p&&(l[D]=I)}return l}var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function h(i,s=Object.create(null)){const l=[];let p=!1,D="";for(const I of i)if(I==="$"||p&&I==="{")D&&l.push({value:D,type:f.TEXT}),D="",p=!0;else if(I==="}"&&p){const S=s[D];if(typeof S=="string")S.length&&l.push({value:S,type:f.VARIABLE});else if(S){const R=l[l.length-1];(!R||R.type!==f.SEPARATOR)&&l.push({value:S.label,type:f.SEPARATOR})}D="",p=!1}else D+=I;return D&&!p&&l.push({value:D,type:f.TEXT}),l.filter((I,S)=>{if(I.type===f.SEPARATOR){const R=l[S-1],B=l[S+1];return[R,B].every(L=>L&&(L.type===f.VARIABLE||L.type===f.TEXT)&&L.value.length>0)}return!0}).map(I=>I.value).join("")}function $(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function a(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,""):O.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const l=r(i.substring(0,s)),p=i.substring(s);return{name:l.name+p,parentPath:l.parentPath}}}return r(i)}function r(i){const s=i.indexOf("/")!==-1?P.$hc:P.$gc,l=s.basename(i),p=s.dirname(i);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}}),define(ae[157],ce([0,1,17,7]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=E,e.$mn=c,e.$nn=b;function P(y){return y.toJSON()}class O{constructor(k){this.a=k}transformIncoming(k){const d=this.a.transformIncoming(k);return d===k?k:P(C.URI.from(d))}transformOutgoing(k){const d=this.a.transformOutgoing(k);return d===k?k:P(C.URI.from(d))}transformOutgoingURI(k){const d=this.a.transformOutgoing(k);return d===k?k:C.URI.from(d)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$jn=O,e.$kn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function j(y,k,d){if(!y||d>200)return null;if(typeof y=="object"){if(y instanceof C.URI)return k.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const v=j(y[m],k,d+1);v!==null&&(y[m]=v)}}return null}function E(y,k){const d=j(y,k,0);return d===null?y:d}function u(y,k,d,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return d?C.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof n.$ue)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const w=u(y[v],k,d,m+1);w!==null&&(y[v]=w)}}return null}function c(y,k){const d=u(y,k,!1,0);return d===null?y:d}function b(y,k){const d=u(y,k,!0,0);return d===null?y:d}}),define(ae[89],ce([0,1,26,59,32,147,4]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$qn=u,e.$rn=y,e.$pn=new class{c(k){return this.a||(this.a=C.$ni.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,d=0;const m=(0,n.networkInterfaces)();for(const v in m){const w=m[v];if(w)for(const{mac:g,internal:f}of w)f||(d+=1,this.c(g.toUpperCase())&&(k+=1))}this.b=d>0?k/d:0}return this.b}};let E;async function u(k){return E||(E=(async()=>await c(k)||P.$Dg())()),E}async function c(k){try{const d=await new Promise((v,w)=>{J(["crypto"],v,w)}),m=(0,O.$on)();return d.createHash("sha256").update(m,"utf8").digest("hex")}catch(d){k(d);return}}const b="Software\\Microsoft\\SQMClient";async function y(k){if(j.$i){const d=await new Promise((m,v)=>{J(["@vscode/windows-registry"],m,v)});try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(m){return k(m),""}}return""}}),define(ae[21],ce([0,1,43,26,158,8,33,86,9,4,19,7]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=D;var k;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function d(se,ue=k.UNLINK,Y){if((0,j.$kg)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?v(se):m(se,Y)}async function m(se,ue=(0,j.$pg)((0,C.tmpdir)())){try{try{await n.promises.rename(se,ue)}catch(Y){return Y.code==="ENOENT"?void 0:v(se)}v(ue).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function v(se){return(0,P.promisify)(n.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,j.$kg)(se))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}async function g(se,ue){return $(await(ue?f(se):(0,P.promisify)(n.readdir)(se)))}async function f(se){try{return await(0,P.promisify)(n.readdir)(se,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const ue=[],Y=await g(se);for(const Z of Y){let q=!1,M=!1,N=!1;try{const G=await e.Promises.lstat((0,u.$kc)(se,Z));q=G.isFile(),M=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Z,isFile:()=>q,isDirectory:()=>M,isSymbolicLink:()=>N})}return ue}function h(se){return $(n.readdirSync(se))}function $(se){return se.map(ue=>typeof ue=="string"?c.$j?(0,E.$Yl)(ue):ue:(ue.name=c.$j?(0,E.$Yl)(ue.name):ue.name,ue))}async function a(se){const ue=await g(se),Y=[];for(const Z of ue)await o.existsDirectory((0,u.$kc)(se,Z))&&Y.push(Z);return Y}function t(se,ue=1e3){return new Promise(Y=>{let Z=!1;const q=setInterval(()=>{Z||(Z=!0,n.access(se,M=>{Z=!1,M&&(clearInterval(q),Y(void 0))}))},ue)})}var o;(function(se){async function ue(q){let M;try{if(M=await e.Promises.lstat(q),!M.isSymbolicLink())return{stat:M}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw G}throw N}}se.stat=ue;async function Y(q){try{const{stat:M,symbolicLink:N}=await se.stat(q);return M.isFile()&&N?.dangling!==!0}catch{}return!1}se.existsFile=Y;async function Z(q){try{const{stat:M,symbolicLink:N}=await se.stat(q);return M.isDirectory()&&N?.dangling!==!0}catch{}return!1}se.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const r=new O.$qh;function i(se,ue,Y){return r.queueFor(y.URI.file(se),()=>{const Z=I(Y);return new Promise((q,M)=>p(se,ue,Z,N=>N?M(N):q()))},b.$Lg)}let s=!0;function l(se){s=se}function p(se,ue,Y,Z){if(!s)return n.writeFile(se,ue,{mode:Y.mode,flag:Y.flag},Z);n.open(se,Y.flag,Y.mode,(q,M)=>{if(q)return Z(q);n.writeFile(M,ue,N=>{if(N)return n.close(M,()=>Z(N));n.fdatasync(M,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),n.close(M,z=>Z(z))))})})}function D(se,ue,Y){const Z=I(Y);if(!s)return n.writeFileSync(se,ue,{mode:Z.mode,flag:Z.flag});const q=n.openSync(se,Z.flag,Z.mode);try{n.writeFileSync(q,ue);try{n.fdatasyncSync(q)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),l(!1)}}finally{n.closeSync(q)}}function I(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function S(se,ue,Y=6e4){if(se!==ue)try{c.$i&&typeof Y=="number"?await R(se,ue,Date.now(),Y):await(0,P.promisify)(n.rename)(se,ue)}catch(Z){if(se.toLowerCase()!==ue.toLowerCase()&&Z.code==="EXDEV"||se.endsWith("."))await B(se,ue,{preserveSymlinks:!1}),await d(se,k.MOVE);else throw Z}}async function R(se,ue,Y,Z,q=0){try{return await(0,P.promisify)(n.rename)(se,ue)}catch(M){if(M.code!=="EACCES"&&M.code!=="EPERM"&&M.code!=="EBUSY")throw M;if(Date.now()-Y>=Z)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${M}`),M;if(q===0){let N=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(N=!0)}catch{}if(N)throw M}return await(0,O.$ih)(Math.min(100,q*10)),R(se,ue,Y,Z,q+1)}}async function B(se,ue,Y){return W(se,ue,{root:{source:se,target:ue},options:Y,handledSourcePaths:new Set})}const L=511;async function W(se,ue,Y){if(Y.handledSourcePaths.has(se))return;Y.handledSourcePaths.add(se);const{stat:Z,symbolicLink:q}=await o.stat(se);if(q){if(Y.options.preserveSymlinks)try{return await le(se,ue,Y)}catch{}if(q.dangling)return}return Z.isDirectory()?U(se,ue,Z.mode&L,Y):x(se,ue,Z.mode&L)}async function U(se,ue,Y,Z){await e.Promises.mkdir(ue,{recursive:!0,mode:Y});const q=await g(se);for(const M of q)await W((0,u.$kc)(se,M),(0,u.$kc)(ue,M),Z)}async function x(se,ue,Y){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,Y)}async function le(se,ue,Y){let Z=await e.Promises.readlink(se);(0,j.$hg)(Z,Y.root.source,!c.$k)&&(Z=(0,u.$kc)(Y.root.target,Z.substr(Y.root.source.length+1))),await e.Promises.symlink(Z,ue)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(se,ue,Y,Z,q)=>new Promise((M,N)=>{n.read(se,ue,Y,Z,q,(G,z,oe)=>G?N(G):M({bytesRead:z,buffer:oe}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(se,ue,Y,Z,q)=>new Promise((M,N)=>{n.write(se,ue,Y,Z,q,(G,z,oe)=>G?N(G):M({bytesWritten:z,buffer:oe}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return d}get rename(){return S}get copy(){return B}}}),define(ae[109],ce([0,1,43,9,4,25,21]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=E,e.$Mq=u,e.$Nq=c,e.$Oq=b;function E(k){if(P.$k)return k;const d=(0,C.$nc)(k);if(k===d)return k;const m=((0,C.$oc)(k)||k).toLowerCase();try{const w=(0,j.readdirSync)(d).filter(g=>g.toLowerCase()===m);if(w.length===1){const g=E(d);if(g)return(0,C.$kc)(g,w[0])}else if(w.length>1){const g=w.indexOf(m);if(g>=0){const f=E(d);if(f)return(0,C.$kc)(f,w[g])}}}catch{}return null}async function u(k){if(P.$k)return k;const d=(0,C.$nc)(k);if(k===d)return k;const m=((0,C.$oc)(k)||k).toLowerCase();try{const w=(await j.Promises.readdir(d)).filter(g=>g.toLowerCase()===m);if(w.length===1){const g=await u(d);if(g)return(0,C.$kc)(g,w[0])}else if(w.length>1){const g=w.indexOf(m);if(g>=0){const f=await u(d);if(f)return(0,C.$kc)(f,w[g])}}}catch{}return null}async function c(k){try{return await j.Promises.realpath(k)}catch{const m=y(k);return await j.Promises.access(m,n.constants.R_OK),m}}function b(k){try{return n.realpathSync(k)}catch{const m=y(k);return n.accessSync(m,n.constants.R_OK),m}}function y(k){return(0,O.$6e)((0,C.$ic)(k),C.sep)}}),define(ae[110],ce([0,1,26,9,21]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=f,e.$9l=h;const O=/^\d+$/,j=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:$=!1}={}){return $?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:$=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:$});if(!t)return null;const o=C.$kc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const p of await P.Promises.readdir(o)){let D=-1;if(a){const S=p.indexOf("-");if(S<0)continue;const R=p.substring(0,S);if(!O.test(R)||p.substring(S+1)!=="preview")continue;D=parseInt(R,10)}else{if(!O.test(p))continue;D=parseInt(p,10)}if(D<=r)continue;const I=C.$kc(o,p,"pwsh.exe");await P.SymlinkSupport.existsFile(I)&&(i=I,r=D)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new y(i,`PowerShell${l}${s}`,!0)}async function m({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const a=C.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=$?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(a))if(t.test(r)){const i=C.$kc(a,r,"pwsh.exe");return new y(i,o)}return null}function v(){const $=C.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new y($,".NET Core PowerShell Global Tool")}function w(){const $=C.$kc(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y($,"Windows PowerShell",!0)}async function*g(){let $=await d();$&&(yield $),$=await d({useAlternateBitness:!0}),$&&(yield $),$=await m(),$&&(yield $),$=v(),$&&(yield $),$=await d({findPreview:!0}),$&&(yield $),$=await m({findPreview:!0}),$&&(yield $),$=await d({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=w(),$&&(yield $)}async function*f(){for await(const $ of g())await $.exists()&&(yield $)}async function h(){for await(const $ of f())return $;return null}}),define(ae[90],ce([0,1,9,4,36,75,12,21]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=u,e.$am=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function u(y=P.env){return y.comspec||"cmd.exe"}function c(y){let k=[],d=!1;const m=function(v){if(d){k.push(v);return}(!y.send(v,g=>{if(g&&console.error(g),d=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(h=>m(h))}})||C.$i)&&(d=!0)};return{send:m}}var b;(function(y){async function k(d,m,v){if(n.$jc(d))return d;if(m===void 0&&(m=P.cwd()),n.$nc(d)!=="."||(v===void 0&&j.$Uf(P.env.PATH)&&(v=P.env.PATH.split(n.$uc)),v===void 0||v.length===0))return n.$kc(m,d);async function g(f){if(await E.Promises.exists(f)){let h;try{h=await E.Promises.stat(f)}catch($){$.message.startsWith("EACCES")&&(h=await E.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(const f of v){let h;if(n.$jc(f)?h=n.$kc(f,d):h=n.$kc(m,f,d),await g(h))return h;let $=h+".com";if(await g($)||($=h+".exe",await g($)))return $}return n.$kc(m,d)}y.findExecutable=k})(b||(e.win32=b={}))}),define(ae[111],ce([0,1,48,13]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=P;function P(j){return new Promise((E,u)=>{let c;const b=new Map;function y(d,m,v,w,g){const f=b.get(m);if(d===j||f){const h={name:k(v),cmd:v,pid:d,ppid:m,load:w,mem:g};b.set(d,h),d===j&&(c=h),f&&(f.children||(f.children=[]),f.children.push(h),f.children.length>1&&(f.children=f.children.sort(($,a)=>$.pid-a.pid)))}}function k(d){const m=/--utility-sub-type=network/i,v=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec(d))return"electron-crash-reporter";if(w.exec(d))return"winpty-agent";if(g.exec(d))return"conpty-agent";let h=f.exec(d);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?m.exec(d)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const $=/[a-zA-Z-]+\.js/g;let a="";do h=$.exec(d),h&&(a+=h+" ");while(h);return a&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${a})`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,v)=>{J(["@vscode/windows-process-tree"],m,v)}).then(m=>{m.getProcessList(j,v=>{if(!v){u(new Error(`Root process ${j} not found`));return}m.getProcessCpuUsage(v,w=>{const g=new Map;w.forEach(f=>{const h=d(f.commandLine||"");g.set(f.pid,{name:k(h),cmd:h,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=g.get(j),c?(g.forEach(f=>{const h=g.get(f.ppid);h&&(h.children||(h.children=[]),h.children.push(f))}),g.forEach(f=>{f.children&&(f.children=f.children.sort((h,$)=>h.pid-$.pid))}),E(c)):u(new Error(`Root process ${j} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[c];const v=[];for(;m.length;){const g=m.shift();g&&(v.push(g.pid),g.children&&(m=m.concat(g.children)))}let w=JSON.stringify(C.$Bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+v.join(" "),(0,n.exec)(w,{},(g,f,h)=>{if(g||h)u(g||new Error(h.toString()));else{const $=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=b.get(v[a]);t.load=parseFloat($[a])}if(!c){u(new Error(`Root process ${j} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(m,v,w)=>{if(m||w)if(process.platform!=="linux")u(m||new Error(w.toString()));else{const g=JSON.stringify(C.$Bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(g,{},(f,h,$)=>{f||$?u(f||new Error($.toString())):(O(h,y),d())})}else{const g=v.toString().trim();(0,n.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,$,a)=>{h||a&&!a.includes("screen size is bogus")?u(h||new Error(a.toString())):(O($,y),process.platform==="linux"?d():c?E(c):u(new Error(`Root process ${j} not found`)))})}})}})}function O(j,E){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=j.toString().split(`
`);for(const b of c){const y=u.exec(b.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ae[112],ce([0,1,26,4,110,90]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=j;async function j(y,k){return y===1?C.$i?b():O.$_l(k):u(y,k)}let E=null;function u(y,k){if(C.$k&&y===2||C.$j&&y===3)return"/bin/bash";if(!E){let d;if(C.$i)d="/bin/bash";else{if(d=k.SHELL,!d)try{d=(0,n.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}E=d}return E}let c=null;async function b(){return c||(c=(await(0,P.$9l)()).exePath),c}});var ve=this&&this.__decorate||function(J,e,n,C){var P=arguments.length,O=P<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(J,e,n,C);else for(var E=J.length-1;E>=0;E--)(j=J[E])&&(O=(P<3?j(O):P>3?j(e,n,O):j(e,n))||O);return P>3&&O&&Object.defineProperty(e,n,O),O};define(ae[44],ce([0,1,22,8,17,23,50,15,3,2,76,25,12]),function(J,e,n,C,P,O,j,E,u,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=l,e.$Uh=p,e.$Zh=L,e.$1h=W;var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d||(d={}));function m(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(v||(v={}));function w(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));function f(q){let M=0;for(let N=0;;N+=7){const G=q.read(1);if(M|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return M}}const h=r(0);function $(q,M){if(M===0){q.write(h);return}let N=0;for(let z=M;z!==0;z=z>>>7)N++;const G=P.$ue.alloc(N);for(let z=0;M!==0;z++)G.buffer[z]=M&127,M=M>>>7,M>0&&(G.buffer[z]|=128);q.write(G)}class a{constructor(M){this.b=M,this.a=0}read(M){const N=this.b.slice(this.a,this.a+M);return this.a+=N.byteLength,N}}e.$Rh=a;class t{constructor(){this.a=[]}get buffer(){return P.$ue.concat(this.a)}write(M){this.a.push(M)}}e.$Sh=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function r(q){const M=P.$ue.alloc(1);return M.writeUInt8(q,0),M}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function l(q,M){if(typeof M>"u")q.write(i.Undefined);else if(typeof M=="string"){const N=P.$ue.fromString(M);q.write(i.String),$(q,N.byteLength),q.write(N)}else if(s&&Buffer.isBuffer(M)){const N=P.$ue.wrap(M);q.write(i.Buffer),$(q,N.byteLength),q.write(N)}else if(M instanceof P.$ue)q.write(i.VSBuffer),$(q,M.byteLength),q.write(M);else if(Array.isArray(M)){q.write(i.Array),$(q,M.length);for(const N of M)l(q,N)}else if(typeof M=="number"&&(M|0)===M)q.write(i.Uint),$(q,M);else{const N=P.$ue.fromString(JSON.stringify(M));q.write(i.Object),$(q,N.byteLength),q.write(N)}}function p(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(f(q)).toString();case o.Buffer:return q.read(f(q)).buffer;case o.VSBuffer:return q.read(f(q));case o.Array:{const N=f(q),G=[];for(let z=0;z<N;z++)G.push(p(q));return G}case o.Object:return JSON.parse(q.read(f(q)).toString());case o.Int:return f(q)}}class D{constructor(M,N,G=null,z=1e3){this.h=M,this.j=N,this.k=G,this.l=z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(M,N){this.b.set(M,N),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const N=this.o([M.type]);this.k?.logOutgoing(N,0,1,w(M.type));return}case 201:case 202:case 204:case 203:{const N=this.o([M.type,M.id],M.data);this.k?.logOutgoing(N,M.id,1,w(M.type),M.data);return}}}o(M,N=void 0){const G=new t;return l(G,M),l(G,N),this.p(G.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const N=new a(M),G=p(N),z=p(N),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,z),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:z});case 102:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,z),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:z});case 101:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(M.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(M){const N=this.b.get(M.channelName);if(!N){this.v(M);return}const G=new O.$ee;let z;try{z=N.call(this.j,M.name,M.arg,G.token)}catch(X){z=Promise.reject(X)}const oe=M.id;z.then(X=>{this.m({id:oe,data:X,type:201})},X=>{X instanceof Error?this.m({id:oe,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:oe,data:X,type:203})}).finally(()=>{he.dispose(),this.d.delete(M.id)});const he=(0,c.$Sc)(()=>G.cancel());this.d.set(M.id,he)}t(M){const N=this.b.get(M.channelName);if(!N){this.v(M);return}const G=M.id,oe=N.listen(this.j,M.name,M.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(M.id,oe)}u(M){const N=this.d.get(M.id);N&&(N.dispose(),this.d.delete(M.id))}v(M){let N=this.g.get(M.channelName);N||(N=[],this.g.set(M.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:M,timeoutTimer:G})}w(M){const N=this.g.get(M);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=D;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class S{constructor(M,N=null){this.l=M,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(M){const N=this;return{call(G,z,oe){return N.a?Promise.reject(new E.$5):N.m(M,G,z,oe)},listen(G,z){return N.a?u.Event.None:N.o(M,G,z)}}}m(M,N,G,z=O.CancellationToken.None){const oe=this.g++,X={id:oe,type:100,channelName:M,name:N,arg:G};if(z.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,re)=>{if(z.isCancellationRequested)return re(new E.$5);const K=()=>{const Q=te=>{switch(te.type){case 201:this.f.delete(oe),_(te.data);break;case 202:{this.f.delete(oe);const fe=new Error(te.data.message);fe.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,fe.name=te.data.name,re(fe);break}case 203:this.f.delete(oe),re(te.data);break}};this.f.set(oe,Q),this.p(X)};let V=null;this.b===g.Idle?K():(V=(0,C.$7g)(Q=>this.u()),V.then(()=>{V=null,K()}));const H=()=>{V?(V.cancel(),V=null):this.p({id:oe,type:101}),re(new E.$5)},T=z.onCancellationRequested(H);A=(0,c.$Rc)((0,c.$Sc)(H),T),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(M,N,G){const z=this.g++,he={id:z,type:102,channelName:M,name:N,arg:G};let X=null;const A=new u.$7d({onWillAddFirstListener:()=>{X=(0,C.$7g)(_=>this.u()),X.then(()=>{X=null,this.d.add(A),this.p(he)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(A),this.p({id:z,type:103}))}}),F=_=>A.fire(_.data);return this.f.set(z,F),A.event}p(M){switch(M.type){case 100:case 102:{const N=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(N,M.id,0,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const N=this.q([M.type,M.id]);this.j?.logOutgoing(N,M.id,0,m(M.type));return}}}q(M,N=void 0){const G=new t;return l(G,M),l(G,N),this.r(G.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const N=new a(M),G=p(N),z=p(N),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(M.byteLength,0,0,w(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,G[1],0,w(oe),z),this.t({type:G[0],id:G[1],data:z})}}t(M){if(M.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=S,ve([j.$Lh],S.prototype,"onDidInitializePromise",null);class R{get connections(){const M=[];return this.f.forEach(N=>M.push(N)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$7d,this.onDidAddConnection=this.g.event,this.h=new u.$7d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(M(({protocol:N,onDidClientDisconnect:G})=>{const z=u.Event.once(N.onMessage);this.j.add(z(oe=>{const he=new a(oe),X=p(he),A=new D(N,X),F=new S(N);this.a.forEach((re,K)=>A.registerChannel(K,re));const _={channelServer:A,channelClient:F,ctx:X};this.f.add(_),this.g.fire(_),this.j.add(G(()=>{A.dispose(),F.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(M,N){const G=this;return{call(z,oe,he){let X;if((0,k.$9f)(N)){const F=(0,n.$4b)(G.connections.filter(N));X=F?Promise.resolve(F):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,N))}else X=N.routeCall(G,z,oe);const A=X.then(F=>F.channelClient.getChannel(M));return L(A).call(z,oe,he)},listen(z,oe){if((0,k.$9f)(N))return G.k(M,N,z,oe);const he=N.routeEvent(G,z,oe).then(X=>X.channelClient.getChannel(M));return L(he).listen(z,oe)}}}k(M,N,G,z){const oe=this;let he;const X=new u.$7d({onWillAddFirstListener:()=>{he=new c.$Tc;const A=new u.$ae,F=new Map,_=K=>{const H=K.channelClient.getChannel(M).listen(G,z),T=A.add(H);F.set(K,T)},re=K=>{const V=F.get(K);V&&(V.dispose(),F.delete(K))};oe.connections.filter(N).forEach(_),u.Event.filter(oe.onDidAddConnection,N)(_,void 0,he),oe.onDidRemoveConnection(re,void 0,he),A.event(X.fire,X,he),he.add(A)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return X.event}registerChannel(M,N){this.a.set(M,N);for(const G of this.f)G.channelServer.registerChannel(M,N)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=R;class B{constructor(M,N,G=null){const z=new t;l(z,N),M.send(z.buffer),this.a=new S(M,G),this.d=new D(M,N,G)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,N){this.d.registerChannel(M,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=B;function L(q){return{call(M,N,G){return q.then(z=>z.call(M,N,G))},listen(M,N){const G=new u.$de;return q.then(z=>G.input=z.listen(M,N)),G.event}}}function W(q){let M=!1;return{call(N,G,z){return M?q.call(N,G,z):(0,C.$ih)(0).then(()=>M=!0).then(()=>q.call(N,G,z))},listen(N,G){if(M)return q.listen(N,G);const z=new u.$de;return(0,C.$ih)(0).then(()=>M=!0).then(()=>z.input=q.listen(N,G)),z.event}}}class U{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const N of M.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$2h=U;var x;(function(q){function M(oe,he,X){const A=oe,F=X&&X.disableMarshalling,_=new Map;for(const re in A)G(re)&&_.set(re,u.Event.buffer(A[re],!0,void 0,he));return new class{listen(re,K,V){const H=_.get(K);if(H)return H;const T=A[K];if(typeof T=="function"){if(z(K))return T.call(A,V);if(G(K))return _.set(K,u.Event.buffer(A[K],!0,void 0,he)),_.get(K)}throw new E.$bb(`Event not found: ${K}`)}call(re,K,V){const H=A[K];if(typeof H=="function"){if(!F&&Array.isArray(V))for(let Q=0;Q<V.length;Q++)V[Q]=(0,b.$Qh)(V[Q]);let T=H.apply(A,V);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new E.$bb(`Method not found: ${K}`)}}}q.fromService=M;function N(oe,he){const X=he&&he.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):z(F)?function(_){return oe.listen(F,_)}:G(F)?oe.listen(F):async function(..._){let re;he&&!(0,k.$4f)(he.context)?re=[he.context,..._]:re=_;const K=await oe.call(F,re);return X?K:(0,b.$Qh)(K)};throw new E.$bb(`Property not found: ${String(F)}`)}})}q.toService=N;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&y.$kf(oe.charCodeAt(2))}function z(oe){return/^onDynamic/.test(oe)&&y.$kf(oe.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const M=q.toString();if(M!=="[object Object]")return M}return q}function ue(q){return Array.isArray(q)?q.map(se):se(q)}function Y(q,M,N,G,z,oe,he){he=ue(he);const X=le[z],A=X[G%X.length];let F=[`%c[${q}]%c[${String(M).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(oe)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class Z{constructor(M,N){this.d=M,this.f=N,this.a=0,this.b=0}logOutgoing(M,N,G,z,oe){this.b+=M,Y(this.d,this.b,M,N,G,z,oe)}logIncoming(M,N,G,z,oe){this.a+=M,Y(this.f,this.a,M,N,G,z,oe)}}e.$3h=Z}),define(ae[159],ce([0,1,17,3,44]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2V=e.$1V=void 0;class O{constructor(u){this.a=u,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$ue.wrap(c.data):n.$ue.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$1V=O;class j extends P.$Yh{constructor(u,c){const b=new O(u);super(b,c),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$2V=j}),define(ae[113],ce([0,1,17,3,2,44]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function p(I,S){if(!s.has(I)){const R=String(++l);s.set(I,R)}return s.get(I)}function D(I,S,R,B){if(!i.enableDiagnostics)return;const L=p(I,S);if(B instanceof n.$ue||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const W=n.$ue.alloc(B.byteLength);W.set(B),i.records.push({timestamp:Date.now(),id:L,label:S,type:R,buff:W})}else i.records.push({timestamp:Date.now(),id:L,label:S,type:R,data:B})}i.traceSocketEvent=D})(E||(e.SocketDiagnostics=E={}));var u;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let c=null;function b(){return c||(c=n.$ue.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return b();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const S=this.a[0];return l&&(this.a.shift(),this.b-=s),S}if(this.a[0].byteLength>s){const S=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),S}const p=n.$ue.alloc(s);let D=0,I=0;for(;s>0;){const S=this.a[I];if(S.byteLength>s){const R=S.slice(0,s);p.set(R,D),D+=s,l&&(this.a[I]=S.slice(s),this.b-=s),s-=s}else p.set(S,D),D+=S.byteLength,l?(this.a.shift(),this.b-=S.byteLength):I++,s-=S.byteLength}return p}}e.$4h=y;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class v{constructor(s,l,p,D){this.type=s,this.id=l,this.ack=p,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.$Uc{constructor(s){super(),this.f=this.B(new C.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,D=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new v(p,D,I,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$ue.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const p=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,p}h(){const s=n.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends P.$Uc{constructor(s){super(),this.f=new C.$7d,this.onMessage=this.f.event,this.g=new C.$7d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new g(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new v(1,0,0,s))}}e.$5h=f;class h extends O.$Yh{static fromSocket(s,l){return new h(new f(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,p=null){super(s,l,p),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$6h=h;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$7h=$;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,p=this.a;for(;p;)s[l++]=p.data,p=p.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new a(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<o.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+o.a)*1e3;let p=0;for(let D=0;D<o.a;D++)s-this.c[D]<=l&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Tc,this.o=s.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new v(5,0,0,b());this.p.write(s),this.p.flush()}sendPause(){const s=new v(7,0,0,b());this.p.write(s)}sendResume(){const s=new v(8,0,0,b());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r.dispose(),this.r=new P.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new v(3,0,this.h,b());this.p.write(s);const l=this.b.toArray();for(let p=0,D=l.length;p<D;p++)this.p.write(l[p]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new v(6,0,0,b())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let p=0,D=l.length;p<D;p++)this.p.write(l[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const p=new v(1,l,this.h,s);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(s){const l=new v(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,p=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(l>=2e4&&p>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:p});return}const I=Math.max(2e4-l,2e4-p,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new v(3,0,this.h,b());this.p.write(s)}D(){this.h=this.g;const s=new v(9,0,this.h,b());this.p.write(s)}}e.$8h=r}),define(ae[37],ce([0,1,14,15,13]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XV=void 0;class O{constructor(){this.a=new WeakMap}on(E,u){const c=(b,...y)=>{this.b(E,b)&&u(b,...y)};return this.a.set(u,c),n.ipcMain.on(E,c),this}once(E,u){return n.ipcMain.once(E,(c,...b)=>{this.b(E,c)&&u(c,...b)}),this}handle(E,u){return n.ipcMain.handle(E,(c,...b)=>this.b(E,c)?u(c,...b):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,u){const c=this.a.get(u);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(u)),this}b(E,u){if(!E||!E.startsWith("vscode:"))return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=u.senderFrame,b=c.url;if(!b||b==="about:blank")return!0;let y="unknown";try{y=new URL(b).host}catch{return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${b}'.`),!1}return y!==P.$Ag?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):c.parent!==null?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$XV=new O}),define(ae[160],ce([0,1,14,37,148]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YV=O;function O(){C.$XV.on(P.$VV,(E,u,c,b,y)=>{const k=j(E,b,c);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(P.$WV,u)}})})}function j(E,u,c){const b=new n.Menu;return c.forEach(y=>{let k;y.type==="separator"?k=new n.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new n.MenuItem({submenu:j(E,u,y.submenu),label:y.label}):k=new n.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,m,v)=>E.sender.send(u,y.id,v)}),b.append(k)}),b}}),define(ae[161],ce([0,1,37,17,3,2,44,149]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5V=void 0;function u(b,y){const k=P.Event.fromNodeEventEmitter(n.$XV,y,(m,v)=>({event:m,message:v})),d=P.Event.filter(k,({event:m})=>m.sender.id===b);return P.Event.map(d,({message:m})=>m&&C.$ue.wrap(m))}class c extends j.$Xh{static{this.b=new Map}static d(){const y=P.Event.fromNodeEventEmitter(n.$XV,"vscode:hello",({sender:k})=>k);return P.Event.map(y,k=>{const d=k.id;c.b.get(d)?.dispose();const v=new P.$7d;c.b.set(d,(0,O.$Sc)(()=>v.fire()));const w=u(d,"vscode:message"),g=P.Event.any(P.Event.signal(u(d,"vscode:disconnect")),v.event);return{protocol:new E.$4V(k,w),onDidClientDisconnect:g}})}constructor(){super(c.d())}}e.$5V=c}),define(ae[114],ce([0,1,37,3,32,159]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=void 0,e.$7V=E;class j extends O.$2V{constructor(c,b){super({addEventListener:(y,k)=>c.addListener(y,k),removeEventListener:(y,k)=>c.removeListener(y,k),postMessage:y=>c.postMessage(y),start:()=>c.start(),close:()=>c.close()},b)}}e.$6V=j;async function E(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Dg)();u.webContents.send("vscode:createMessageChannel",c);const b=C.Event.fromNodeEventEmitter(n.$XV,"vscode:createMessageChannelResult",(k,d)=>({nonce:d,port:k.ports[0]})),{port:y}=await C.Event.toPromise(C.Event.once(C.Event.filter(b,k=>k.nonce===c)));return y}}),define(ae[162],ce([0,1,48,8,17,23,156,15,3,2,35,90,75,44]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class m extends d.$Vh{constructor(g){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>P.$ue.wrap(Buffer.from(f,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Hq=m;class v{constructor(g,f){this.i=g,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$7d,this.onDidProcessExit=this.h.event;const h=f&&f.timeout?f.timeout:6e4;this.b=new C.$eh(h),this.d=null,this.f=null}getChannel(g){const f=this;return{call(h,$,a){return f.k(g,h,$,a)},listen(h,$){return f.l(g,h,$)}}}k(g,f,h,$=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n(g),t=(0,C.$7g)(i=>a.call(f,h,i)),o=$.onCancellationRequested(()=>t.cancel()),r=(0,c.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,f,h){if(!this.b)return u.Event.None;this.b.cancel();let $;const a=new u.$7d({onWillAddFirstListener:()=>{$=this.n(g).listen(f,h)(a.fire,a),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,k.$$l)(f.env),this.d=(0,n.fork)(this.i,g,f);const h=new u.$7d;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,j.$Dq)(s)){(0,j.log)(s,`IPC Library: ${this.j.serverName}`);return}h.fire(P.$ue.wrap(Buffer.from(s,"base64")))});const a=this.j.useQueue?(0,y.$am)(this.d):this.d,t=s=>this.d&&this.d.connected&&a.send(s.buffer.toString("base64")),o=h.event,r={send:t,onMessage:o};this.f=new d.$Wh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",i),this.c.forEach(p=>(0,c.$Pc)(p)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(g){let f=this.g.get(g);return f||(f=this.m.getChannel(g),this.g.set(g,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Iq=v}),define(ae[115],ce([0,1,8,3,2,76,12]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=u;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(k){const d=k;return d?.changed instanceof Map||d?.deleted instanceof Set}var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class b extends P.$Uc{static{this.a=100}constructor(d,m=Object.create(null)){super(),this.r=d,this.s=m,this.b=this.B(new C.$0d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$fh(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((m,v)=>this.w(v,m)),d.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(d,m){if(this.c===c.Closed)return;let v=!1;(0,j.$4f)(m)?v=this.f.delete(d):this.f.get(d)!==m&&(this.f.set(d,m),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,m){const v=this.f.get(d);return(0,j.$4f)(v)?m:v}getBoolean(d,m){const v=this.get(d);return(0,j.$4f)(v)?m:v==="true"}getNumber(d,m){const v=this.get(d);return(0,j.$4f)(v)?m:parseInt(v,10)}getObject(d,m){const v=this.get(d);return(0,j.$4f)(v)?m:(0,O.$Ph)(v)}async set(d,m,v=!1){if(this.c===c.Closed)return;if((0,j.$4f)(m))return this.delete(d,v);const w=(0,j.$Wf)(m)||Array.isArray(m)?(0,O.$Oh)(m):String(m);if(this.f.get(d)!==w)return this.f.set(d,w),this.j.set(d,w),this.h.delete(d),this.b.fire({key:d,external:v}),this.D()}async delete(d,m=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Hp=b;class y{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((m,v)=>this.a.set(v,m)),d.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Ip=y}),define(ae[163],ce([0,1,8,3,31,9,21]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,y=Object.create(null)){this.g=b,this.h=y,this.c=(0,O.$oc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,y=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(d=>y.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(b){const y=await this.f;return this.j(y,b)}j(b,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,P.$zc)(y.insert):"0"}), delete(${y.delete?(0,P.$Ac)(y.delete):"0"})`),this.t(b,()=>{const k=y.insert,d=y.delete;if(k&&k.size>0){const m=[];m.push([]);let v=0;k.forEach((w,g)=>{let f=m[v];f.length>E.b&&(v++,f=[],m.push(f)),f.push(g,w)}),m.forEach(w=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,g=>g.run(w),()=>{const g=[];let f=0;return k.forEach((h,$)=>{g.push($),f+=h.length}),`Keys: ${g.join(", ")} Length: ${f}`})})}if(d&&d.size){const m=[];m.push([]);let v=0;d.forEach(w=>{let g=m[v];g.length>E.b&&(v++,g=[],m.push(g)),g.push(w)}),m.forEach(w=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,g=>g.run(w),()=>{const g=[];return d.forEach(f=>{g.push(f)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,b)}k(b,y){return new Promise((k,d)=>{b.db.close(m=>(m&&this.o(b,`[storage ${this.c}] close(): ${m}`),this.g===E.IN_MEMORY_PATH?k():!b.isErroneous&&!b.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const w=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>w(),g=>(w(),Promise.reject(g)))})).then(k,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return j.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const y=await this.f,k=await this.r(y,b?"PRAGMA integrity_check":"PRAGMA quick_check"),d=b?k.integrity_check:k.quick_check;return y.isErroneous?`${d} (last error: ${y.lastError})`:y.isInMemory?`${d} (in-memory!)`:d}async n(b,y=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${y})`);try{return await this.p(b)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,n.$ih)(E.a),this.n(b,!1);try{await j.Promises.unlink(b);try{await j.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(E.IN_MEMORY_PATH)}}}o(b,y){b.isErroneous=!0,b.lastError=y,this.d.error(y)}p(b){return new Promise((y,k)=>{new Promise((d,m)=>{J(["@vscode/sqlite3"],d,m)}).then(d=>{const m={db:new(this.d.isTracing?d.verbose().Database:d.Database)(b,v=>v?m.db&&v.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(v)):k(v):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),w=>m.db.close(()=>k(w)))),isInMemory:b===E.IN_MEMORY_PATH};m.db.on("error",v=>this.o(m,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&m.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(b,y){return new Promise((k,d)=>{b.db.exec(y,m=>m?(this.o(b,`[storage ${this.c}] exec(): ${m}`),d(m)):k())})}r(b,y){return new Promise((k,d)=>{b.db.get(y,(m,v)=>m?(this.o(b,`[storage ${this.c}] get(): ${m}`),d(m)):k(v))})}s(b,y){return new Promise((k,d)=>{b.db.all(y,(m,v)=>m?(this.o(b,`[storage ${this.c}] all(): ${m}`),d(m)):k(v))})}t(b,y){return new Promise((k,d)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),y(),b.db.run("END TRANSACTION",m=>m?(this.o(b,`[storage ${this.c}] transaction(): ${m}`),d(m)):k())})})}u(b,y,k,d){const m=b.db.prepare(y),v=w=>{this.o(b,`[storage ${this.c}] prepare(): ${w} (${y}). Details: ${d()}`)};m.on("error",v),k(m),m.finalize(w=>{w&&v(w),m.removeListener("error",v)})}}e.$qW=E;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[u.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(ae[164],ce([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ae[165],ce([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[166],ce([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[167],ce([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ae[168],ce([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[169],ce([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[170],ce([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ae[171],ce([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ae[172],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[173],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[174],ce([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[175],ce([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[176],ce([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[177],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ae[178],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ae[179],ce([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ae[180],ce([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[181],ce([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[182],ce([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[183],ce([11,10]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ae[184],ce([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[185],ce([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[186],ce([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ae[187],ce([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ae[188],ce([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[189],ce([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[190],ce([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[191],ce([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[192],ce([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[193],ce([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[194],ce([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[195],ce([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ae[196],ce([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[197],ce([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[198],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ueb=n,e.$veb=C;function n(P){return P&&P.hasOwnProperty("folderUri")}function C(P){return P&&P.hasOwnProperty("workspace")}}),define(ae[199],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=C,e.$w_b=P,e.$x_b=O;function C(j){return typeof j?.backupFolder=="string"}function P(j){let E=[];try{Array.isArray(j.workspaces)&&(E=j.workspaces.map(u=>({workspace:{id:u.id,configPath:n.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return E}function O(j){let E=[];try{Array.isArray(j.folders)&&(E=j.folders.map(u=>({folderUri:n.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return E}}),define(ae[200],ce([0,1,15,167]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var P;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(P||(e.TokenType=P={}));function O(...c){switch(c.length){case 1:return(0,C.localize)(0,null,c[0]);case 2:return(0,C.localize)(1,null,c[0],c[1]);case 3:return(0,C.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,C.localize)(3,null),E=(0,C.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const y=this.d,k=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:b}),this.f.push(d)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const y=this.c.substring(this.d,this.e),k=u.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,y=!1,k=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(E);return}const m=this.c.charCodeAt(b);if(y)y=!1;else if(m===47&&!k){b++;break}else m===91?k=!0:m===92?y=!0:m===93&&(k=!1);b++}for(;b<this.c.length&&u.a.has(this.c.charCodeAt(b));)b++;this.e=b;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=u}),define(ae[201],ce([0,1,3,2]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=void 0;class P{constructor(){this.a=new n.$7d,this.b=new n.$7d,this.c=new n.$7d,this.d=new n.$7d}static{this.ChannelName="extensionhostdebugservice"}call(E,u,c){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,u,c){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$to=P;class O extends C.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,u,c){this.b.call("attach",[E,u,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,u){this.b.call("terminate",[E,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,u){return this.b.call("openExtensionDevelopmentHostWindow",[E,u])}}e.$uo=O}),define(ae[202],ce([0,1,151,50,13,9,36,19,7]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Rm=b,e.$Sm=y,e.$Pm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,O.$nc)(P.$Bg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,O.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,n.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$kc)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Ug)(u.URI.file((0,O.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,O.$kc)(d,"argv.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,O.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,O.$lc)(d):(0,O.$ic)((0,O.$kc)(P.$Bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,O.$lc)(d)):u.URI.file((0,O.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,O.$lc)(d);const m=j.env.VSCODE_EXTENSIONS;if(m)return m;const v=j.env.VSCODE_PORTABLE;return v?(0,O.$kc)(v,"extensions"):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,O.$ic)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,O.$ic)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$Pm.test(d))}get extensionLogLevel(){const d=[];for(const m of this.args.log||[]){const v=e.$Pm.exec(m);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,E.$Ug)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,O.$kc)(d,"policy.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,m,v){this.a=d,this.b=m,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Qm=c,ve([C.$Lh],c.prototype,"appRoot",null),ve([C.$Lh],c.prototype,"userHome",null),ve([C.$Lh],c.prototype,"userDataPath",null),ve([C.$Lh],c.prototype,"appSettingsHome",null),ve([C.$Lh],c.prototype,"tmpDir",null),ve([C.$Lh],c.prototype,"cacheHome",null),ve([C.$Lh],c.prototype,"stateResource",null),ve([C.$Lh],c.prototype,"userRoamingDataHome",null),ve([C.$Lh],c.prototype,"userDataSyncHome",null),ve([C.$Lh],c.prototype,"sync",null),ve([C.$Lh],c.prototype,"machineSettingsResource",null),ve([C.$Lh],c.prototype,"workspaceStorageHome",null),ve([C.$Lh],c.prototype,"localHistoryHome",null),ve([C.$Lh],c.prototype,"keyboardLayoutResource",null),ve([C.$Lh],c.prototype,"argvResource",null),ve([C.$Lh],c.prototype,"isExtensionDevelopment",null),ve([C.$Lh],c.prototype,"untitledWorkspacesHome",null),ve([C.$Lh],c.prototype,"builtinExtensionsPath",null),ve([C.$Lh],c.prototype,"extensionsPath",null),ve([C.$Lh],c.prototype,"extensionDevelopmentLocationURI",null),ve([C.$Lh],c.prototype,"extensionDevelopmentKind",null),ve([C.$Lh],c.prototype,"extensionTestsLocationURI",null),ve([C.$Lh],c.prototype,"debugExtensionHost",null),ve([C.$Lh],c.prototype,"logLevel",null),ve([C.$Lh],c.prototype,"extensionLogLevel",null),ve([C.$Lh],c.prototype,"serviceMachineIdResource",null),ve([C.$Lh],c.prototype,"disableTelemetry",null),ve([C.$Lh],c.prototype,"disableWorkspaceTrust",null),ve([C.$Lh],c.prototype,"useInMemorySecretStorage",null),ve([C.$Lh],c.prototype,"policyFile",null);function b(k,d){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,d,k.debugId,k.extensionEnvironment)}function y(k,d,m,v,w,g){const h=Number(d||k)||(v?null:m),$=h?!!d:!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:h,break:$,debugId:w,env:a}}}),define(ae[116],ce([0,1,313,4,170]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=void 0,e.$em=E,e.$fm=c,e.$gm=d,e.$hm=m;const O={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$cm=["tunnel","serve-web"],e.$dm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,w,g=j){const f=v.find(l=>l.length>0&&l[0]!=="-"),h={},$=["_"],a=[],t={};let o;for(const l in w){const p=w[l];p.type==="subcommand"?l===f&&(o=p):(p.alias&&(h[l]=p.alias),p.type==="string"||p.type==="string[]"?($.push(l),p.deprecates&&$.push(...p.deprecates)):p.type==="boolean"&&(a.push(l),p.deprecates&&a.push(...p.deprecates)),p.global&&(t[l]=p))}if(o&&f){const l=t;for(const S in o.options)l[S]=o.options[S];const p=v.filter(S=>S!==f),D=g.getSubcommandReporter?g.getSubcommandReporter(f):void 0,I=E(p,l,D);return{[f]:I,_:[]}}const r=n(v,{string:$,boolean:a,alias:h}),i={},s=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in w){const p=w[l];if(p.type==="subcommand")continue;p.alias&&delete s[p.alias];let D=s[l];if(p.deprecates)for(const I of p.deprecates)s.hasOwnProperty(I)&&(D||(D=s[I],D&&g.onDeprecatedOption(I,p.deprecationMessage||(0,P.localize)(38,null,l))),delete s[I]);if(typeof D<"u"){if(p.type==="string[]"){if(Array.isArray(D)||(D=[D]),!p.allowEmptyValue){const I=D.filter(S=>S.length>0);I.length!==D.length&&(g.onEmptyValue(l),D=I.length>0?I:void 0)}}else p.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(l,D)):!D&&!p.allowEmptyValue&&(g.onEmptyValue(l),D=void 0));i[l]=D,p.deprecationMessage&&g.onDeprecatedOption(l,p.deprecationMessage)}delete s[l]}for(const l in s)g.onUnknownOption(l);return i}function u(v,w){let g="";return w.args&&(Array.isArray(w.args)?g=` <${w.args.join("> <")}>`:g=` <${w.args}>`),w.alias?`-${w.alias} --${v}${g}`:`--${v}${g}`}function c(v,w){const g=[];for(const f in v){const h=v[f],$=u(f,h);g.push([$,h.description])}return b(g,w)}function b(v,w){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=w-f-1,$=[];for(const a of v){const t=a[0],o=k(a[1],h),r=y(f-t.length-2);$.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)$.push(y(f)+o[i])}return $}function y(v){return" ".repeat(v)}function k(v,w){const g=[];for(;v.length;){const f=v.length<w?v.length:v.lastIndexOf(" ",w),h=v.slice(0,f).trim();v=v.slice(f),g.push(h)}return g}function d(v,w,g,f,h){const $=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${v} ${g}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${w} [${(0,P.localize)(41,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(C.$i?t.push((0,P.localize)(42,null,w)):t.push((0,P.localize)(43,null,w)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[i]=s}}for(const i in o){const s=i,l=o[s];l&&(t.push(O[s]),t.push(...c(l,$)),t.push(""))}return r.length&&(t.push((0,P.localize)(44,null)),t.push(...b(r.map(i=>[i.command,i.description]),$)),t.push("")),t.join(`
`)}function m(v,w){return`${v||(0,P.localize)(45,null)}
${w||(0,P.localize)(46,null)}
${process.arch}`}}),define(ae[203],ce([0,1,88,201,116]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=void 0;class O extends C.$to{constructor(E){super(),this.f=E}call(E,u,c){return u==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,u,c)}async g(E,u){const c=(0,P.$em)(E,P.$dm);c.debugRenderer=u;const b=c.extensionDevelopmentPath;if(!b)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!u)return{success:!0};const k=y.win;if(!k)return{success:!0};const d=k.webContents.debugger;let m=d.isAttached()?1/0:0;const v=(0,n.createServer)(w=>{m++===0&&d.attach();let g=!1;const f=a=>{g||w.write(JSON.stringify(a)+"\0")},h=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{d.removeListener("message",h),w.end(),g=!0}),d.addListener("message",h);let $=Buffer.alloc(0);w.on("data",a=>{$=Buffer.concat([$,a]);for(let t=$.indexOf(0);t!==-1;t=$.indexOf(0)){let o;try{const r=$.slice(0,t).toString("utf8");$=$.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{g=!0,--m===0&&d.detach()})});return await new Promise(w=>v.listen(0,w)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$0_b=O}),define(ae[63],ce([0,1,314,171,116]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=E,e.$jm=u,e.$km=c,e.$lm=b;function O(y,k){const d=(h,$)=>{console.warn((0,C.localize)(0,null,h,$))},m=h=>{console.warn((0,C.localize)(1,null,h))},v=(h,$)=>{console.warn((0,C.localize)(2,null,h,$))},w=h=>({onUnknownOption:$=>{P.$cm.includes(h)||console.warn((0,C.localize)(3,null,$,h))},onMultipleValues:d,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:P.$cm.includes(h)?w:void 0}),g={onUnknownOption:h=>{console.warn((0,C.localize)(4,null,h))},onMultipleValues:d,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:w},f=(0,P.$em)(y,P.$dm,k?g:void 0);return f.goto&&f._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,C.localize)(5,null))),f}function j(y){const k=y.findIndex(d=>!/^-/.test(d));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=j(k)||[]);const d=!b(process.env);return O(k,d)}function u(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=j(k)||[]),O(k,!0)}function c(y,...k){const d=y.indexOf("--");return d===-1?y.push(...k):y.splice(d,0,...k),y}function b(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,n,C){function P(j,E){const u=O(j,E),c=[u];return e.isAbsolute(u)||c.unshift(C),e.resolve(...c)}function O(j,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const b=j["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(y,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:P}}if(typeof define=="function")define(ae[204],ce([117,26,36]),function(e,n,C){return J(e,n,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=J(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[91],ce([0,1,26,202,204]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0,e.$Um=j,e.$Vm=E;class O extends C.$Qm{constructor(c,b){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,b.nameShort)},b)}}e.$Tm=O;function j(u,c){return(0,C.$Sm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}function E(u,c){return(0,C.$Sm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}}),define(ae[205],ce([0,1,43,26,33]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=O;function O(j){const E=(0,P.$pg)((0,C.tmpdir)());try{return(0,n.writeFileSync)(E,""),j&&console.log(`Marker file for --wait created: ${E}`),E}catch(u){j&&console.error(`Failed to create marker file for --wait: ${u}`);return}}}),define(ae[206],ce([0,1,12,173]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=P;function P(j,E,u,c){try{O(j,E,u,c)}catch(b){j.error(b?.message??b)}return E}function O(j,E,u,c){const b=(y,k,d)=>{const m=y[k];if((0,n.$Uf)(m)){const v=m,w=v.length;if(w>1&&v[0]==="%"&&v[w-1]==="%"){const g=v.substr(1,w-2);let f=u[g];f===void 0&&c&&(f=c[g]);const h=typeof f=="string"?f:f?.message,$=c?.[g],a=typeof $=="string"?$:$?.message;if(!h){a||j.warn(`[${E.name}]: ${(0,C.localize)(0,null,g)}`);return}if(d&&(k==="title"||k==="category")&&a&&a!==h){const t={value:h,original:a};y[k]=t}else y[k]=h}}else if((0,n.$Wf)(m))for(const v in m)m.hasOwnProperty(v)&&(v==="commands"?b(m,v,!0):b(m,v,d));else if(Array.isArray(m))for(let v=0;v<m.length;v++)b(m,v,d)};for(const y in E)E.hasOwnProperty(y)&&b(E,y)}}),define(ae[207],ce([0,1,19,73,175,208]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=u,e.$sp=c,e.$tp=b,e.$up=y,e.$vp=k,e.$wp=d,e.$xp=m;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(g){return g=g.trim(),g==="*"||j.test(g)}function c(g){if(!u(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=g.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function b(g){if(!g)return null;const f=g.majorBase,h=g.majorMustEqual,$=g.minorBase;let a=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if(g.preRelease){const i=E.exec(g.preRelease);if(i){const[,s,l,p]=i;r=Date.UTC(Number(s),Number(l)-1,Number(p))}}return{majorBase:f,majorMustEqual:h,minorBase:$,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}function y(g,f,h){let $;typeof g=="string"?$=b(c(g)):$=g;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof h=="string"?t=b(c(h)):t=h,!$||!t)return!1;const o=$.majorBase,r=$.minorBase,i=$.patchBase;let s=t.majorBase,l=t.minorBase,p=t.patchBase;const D=t.notBefore;let I=t.majorMustEqual,S=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>l?!0:r<l||a&&a<D?!1:i>=p:(o===1&&s===0&&(!I||!S||!R)&&(s=1,l=0,p=0,I=!0,S=!1,R=!1),o<s?!1:o>s?!I:r<l?!1:r>l?!S:i<p?!1:i>p?!R:!(a&&a<D))}function k(g,f,h,$,a){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([C.default.Error,P.localize(0,null)]),t;if(typeof $.name!="string")return t.push([C.default.Error,P.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([C.default.Error,P.localize(2,null,"version")]),t;if(!$.engines)return t.push([C.default.Error,P.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([C.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!w($.extensionDependencies))return t.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!w($.activationEvents))return t.push([C.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([C.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([C.default.Error,P.localize(9,null,"main")]),t;{const i=(0,n.$Ug)(h,$.main);(0,n.$Og)(i,h)||t.push([C.default.Warning,P.localize(10,null,i.path,h.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([C.default.Error,P.localize(11,null,"browser")]),t;{const i=(0,n.$Ug)(h,$.browser);(0,n.$Og)(i,h)||t.push([C.default.Warning,P.localize(12,null,i.path,h.path)])}}if(!O.valid($.version))return t.push([C.default.Error,P.localize(13,null)]),t;const o=[];if(!d(g,f,$,a,o))for(const i of o)t.push([C.default.Error,i]);return t}function d(g,f,h,$,a){return $||typeof h.main>"u"&&typeof h.browser>"u"?!0:v(g,f,h.engines.vscode,a)}function m(g,f,h){return g==="*"||v(f,h,g)}function v(g,f,h,$=[]){const a=b(c(h));if(!a)return $.push(P.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return $.push(P.localize(15,null,h)),!1}else if(!a.majorMustEqual)return $.push(P.localize(16,null,h)),!1;return y(g,f,a)?!0:($.push(P.localize(17,null,g,h)),!1)}function w(g){if(!Array.isArray(g))return!1;for(let f=0,h=g.length;f<h;f++)if(typeof g[f]!="string")return!1;return!0}}),define(ae[209],ce([0,1,17,32]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=P;async function P(O,j,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await j.readFile(O.serviceMachineIdResource)).value.toString();u=(0,C.$Cg)(b)?b:null}catch{u=null}if(!u){u=(0,C.$Dg)();try{await j.writeFile(O.serviceMachineIdResource,n.$ue.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}}),define(ae[210],ce([0,1,43,2,3,7]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class j extends C.$Uc{constructor(){super(),this.a=this.B(new P.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new P.$7d),this.f=this.c.event,this.g=new Set,this.h=this.B(new C.$4c),this.B(this.f(u=>this.m(u)))}m(u){this.n(u)&&this.s(u)}n(u){return typeof u.correlationId=="number"}async watch(u){this.g=new Set([...u]);for(const[c]of this.h)this.g.has(c)||this.h.deleteAndDispose(c);return this.r()}r(){return this.z(Array.from(this.g).filter(u=>!this.h.has(u)))}s(u){if(this.h.has(u))return;const c=new C.$Tc;this.h.set(u,c),this.u(u,c),this.r()}t(u){this.h.deleteAndDispose(u),this.r()}u(u,c){const b=O.URI.file(u.path),y=this;let k=!1;const d=(m,v)=>{if(c.isDisposed)return;const w=this.w(m),g=this.w(v),f=k;if(k=w,g&&!w||f&&!w&&!g){this.C(`fs.watchFile() detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const h={resource:b,type:1,cId:u.correlationId};y.a.fire([h]),this.y(h,u),this.t(u)}};this.C(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.watchFile)(u.path,{persistent:!1,interval:this.j},d)}catch(m){this.D(`fs.watchFile() failed with error ${m} on path ${u.path} (correlationId: ${u.correlationId})`)}c.add((0,C.$Sc)(()=>{this.C(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.unwatchFile)(u.path,d)}catch(m){this.D(`fs.unwatchFile() failed with error ${m} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}w(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.h.clearAndDisposeAll()}y(u,c){const b=` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.C(typeof c.correlationId=="number"?`${b} (correlationId: ${c.correlationId})`:b)}}e.$Kq=j}),define(ae[77],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class n{constructor(P,O=[],j=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=j}}e.$ei=n}),define(ae[211],ce([0,1,77]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$es=O,e.$fs=j;const C=[];var P;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(E,u,c){u instanceof n.$ei||(u=new n.$ei(u,[],!!c)),C.push([E,u])}function j(){return C}}),define(ae[212],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class n{constructor(O,j){this.key=O,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$Uq=n;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const j of this.a.values())j.outgoing.size===0&&O.push(j);return O}insertEdge(O,j){const E=this.lookupOrInsertNode(O),u=this.lookupOrInsertNode(j);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(O){const j=this.b(O);this.a.delete(j);for(const E of this.a.values())E.outgoing.delete(j),E.incoming.delete(j)}lookupOrInsertNode(O){const j=this.b(O);let E=this.a.get(j);return E||(E=new n(j,O),this.a.set(j,E)),E}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[j,E]of this.a)O.push(`${j}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,j]of this.a){const E=new Set([O]),u=this.c(j,E);if(u)return u}}c(O,j){for(const[E,u]of O.outgoing){if(j.has(E))return[...j,E].join(" -> ");j.add(E);const c=this.c(u,j);if(c)return c;j.delete(E)}}}e.$Vq=C}),define(ae[6],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=P,e.$ii=O;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function E(u){return u[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=E})(n||(e._util=n={})),e.$gi=P("instantiationService");function C(j,E,u){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:j,index:u}):(E[n.DI_DEPENDENCIES]=[{id:j,index:u}],E[n.DI_TARGET]=E)}function P(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const E=function(u,c,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(E,u,b)};return E.toString=()=>j,n.serviceIds.set(j,E),E}function O(j){return j}}),define(ae[78],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0,e.$pac=(0,n.$hi)("auxiliaryWindowsMainService")}),define(ae[64],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0,e.$y_b=(0,n.$hi)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=O,e.$Pi=j,e.$Qi=u,e.$Ri=c,e.$Si=b,e.$Ti=y,e.$Ui=k,e.$Vi=m,e.$Wi=v,e.$Xi=w,e.$Ni=(0,P.$hi)("configurationService");function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof C.URI)}function j(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof C.URI)}var E;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function b(g,f){const h=Object.create(null);for(const $ in g)y(h,$,g[$],f);return h}function y(g,f,h,$){const a=f.split("."),t=a.pop();let o=g;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:$(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=h}catch{$(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k(g,f){const h=f.split(".");d(g,h)}function d(g,f){const h=f.shift();if(f.length===0){delete g[h];return}if(Object.keys(g).indexOf(h)!==-1){const $=g[h];typeof $=="object"&&!Array.isArray($)&&(d($,f),Object.keys($).length===0&&delete g[h])}}function m(g,f,h){function $(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=$(g,a);return typeof t>"u"?h:t}function v(g,f,h){Object.keys(f).forEach($=>{$!=="__proto__"&&($ in g?n.$Wf(g[$])&&n.$Wf(f[$])?v(g[$],f[$],h):h&&(g[$]=f[$]):g[$]=f[$])})}function w(g){return g.replace(/[\[\]]/g,"")}}),define(ae[118],ce([0,1,4,25,200,6,166,15]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=c,e.$gj=o,e.$hj=r,e.$Aj=z;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",n.$j),u.set("isLinux",n.$k),u.set("isWindows",n.$i),u.set("isWeb",n.$o),u.set("isMacNative",n.$j&&!n.$o),u.set("isEdge",n.$H),u.set("isFirefox",n.$F),u.set("isChrome",n.$E),u.set("isSafari",n.$G);function c(X,A){if(u.get(X)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(X,A)}const b=Object.prototype.hasOwnProperty;var y;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),m=(0,j.localize)(1,null),v=(0,j.localize)(2,null),w=(0,j.localize)(3,null),g=(0,j.localize)(4,null),f=(0,j.localize)(5,null),h=(0,j.localize)(6,null),$=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=k){this.k=A,this.d=new P.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),re=_.type===17?f:void 0;throw this.h.push({message:g,offset:_.offset,lexeme:P.$cj.getLexeme(_),additionalInfo:re}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const F=this.o();A.push(F)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const F=this.s();A.push(F)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),B.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=A.lexeme;if(this.z(),this.y(9)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==10)throw this.B("REGEX",re);const K=re.lexeme,V=K.lastIndexOf("/"),H=V===K.length-1?void 0:this.w(K.substring(V+1));let T;try{T=new RegExp(K.substring(1,V),H)}catch{throw this.B("REGEX",re)}return se.create(F,T)}switch(re.type){case 10:case 19:{const K=[re.lexeme];this.z();let V=this.D(),H=0;for(let me=0;me<re.lexeme.length;me++)re.lexeme.charCodeAt(me)===40?H++:re.lexeme.charCodeAt(me)===41&&H--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?H++:re.lexeme.charCodeAt(me)===41&&H--}if(H<0)break;K.push(P.$cj.getLexeme(V)),this.z(),V=this.D()}const T=K.join(""),Q=T.lastIndexOf("/"),te=Q===T.length-1?void 0:this.w(T.substring(Q+1));let fe;try{fe=new RegExp(T.substring(1,Q),te)}catch{throw this.B("REGEX",re)}return t.regex(F,fe)}case 18:{const K=re.lexeme;this.z();let V=null;if(!(0,C.$Ue)(K)){const H=K.indexOf("/"),T=K.lastIndexOf("/");if(H!==T&&H>=0){const Q=K.slice(H+1,T),te=K[T+1]==="i"?"i":"";try{V=new RegExp(Q,te)}catch{throw this.B("REGEX",re)}}}if(V===null)throw this.B("REGEX",re);return se.create(F,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const re=this.u();return t.notIn(F,re)}switch(this.D().type){case 3:{this.z();const re=this.u();if(this.x().type===18)return t.equals(F,re);switch(re){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,re)}}case 4:{this.z();const re=this.u();if(this.x().type===18)return t.notEquals(F,re);switch(re){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,re)}}case 5:return this.z(),x.create(F,this.u());case 6:return this.z(),le.create(F,this.u());case 7:return this.z(),W.create(F,this.u());case 8:return this.z(),U.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:A.offset,lexeme:"",additionalInfo:$}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,F){if(this.C(A))return this.z();throw this.B(F,this.D())}B(A,F,_){const re=(0,j.localize)(8,null,A,P.$cj.getLexeme(F)),K=F.offset,V=P.$cj.getLexeme(F);return this.h.push({message:re,offset:K,lexeme:V,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=a;class t{static false(){return s.INSTANCE}static true(){return l.INSTANCE}static has(A){return p.create(A)}static equals(A,F){return D.create(A,F)}static notEquals(A,F){return R.create(A,F)}static regex(A,F){return se.create(A,F)}static in(A,F){return I.create(A,F)}static notIn(A,F){return S.create(A,F)}static not(A){return B.create(A)}static and(...A){return Z.create(A,null,!0)}static or(...A){return q.create(A,null,!0)}static greater(A,F){return W.create(A,F)}static greaterEquals(A,F){return U.create(A,F)}static smaller(A,F){return x.create(A,F)}static smallerEquals(A,F){return le.create(A,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$fj=t;function o(X){const A=new a({regexParsingWithErrorRecovery:!1});return X.map(F=>(A.parse(F),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function r(X,A){const F=X?X.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}function i(X,A){return X.cmp(A)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return l.INSTANCE}}e.$ij=s;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return s.INSTANCE}}e.$jj=l;class p{static create(A,F=null){const _=u.get(A);return typeof _=="boolean"?_?l.INSTANCE:s.INSTANCE:new p(A,F)}constructor(A,F){this.key=A,this.c=F,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:N(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=u.get(this.key);return typeof A=="boolean"?A?l.INSTANCE:s.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$kj=p;class D{static create(A,F,_=null){if(typeof F=="boolean")return F?p.create(A,_):B.create(A,_);const re=u.get(A);return typeof re=="boolean"?F===(re?"true":"false")?l.INSTANCE:s.INSTANCE:new D(A,F,_)}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=u.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?l.INSTANCE:s.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$lj=D;class I{static create(A,F){return new I(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:G(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?b.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$mj=I;class S{static create(A,F){return new S(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=11,this.c=I.create(A,F)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=S;class R{static create(A,F,_=null){if(typeof F=="boolean")return F?B.create(A,_):p.create(A,_);const re=u.get(A);return typeof re=="boolean"?F===(re?"true":"false")?s.INSTANCE:l.INSTANCE:new R(A,F,_)}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=u.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?s.INSTANCE:l.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$oj=R;class B{static create(A,F=null){const _=u.get(A);return typeof _=="boolean"?_?s.INSTANCE:l.INSTANCE:new B(A,F)}constructor(A,F){this.c=A,this.d=F,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:N(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=u.get(this.c);return typeof A=="boolean"?A?s.INSTANCE:l.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$pj=B;function L(X,A){if(typeof X=="string"){const F=parseFloat(X);isNaN(F)||(X=F)}return typeof X=="string"||typeof X=="number"?A(X):s.INSTANCE}class W{static create(A,F,_=null){return L(F,re=>new W(A,re,_))}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$qj=W;class U{static create(A,F,_=null){return L(F,re=>new U(A,re,_))}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$rj=U;class x{static create(A,F,_=null){return L(F,re=>new x(A,re,_))}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$sj=x;class le{static create(A,F,_=null){return L(F,re=>new le(A,re,_))}constructor(A,F,_){this.c=A,this.d=F,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$tj=le;class se{static create(A,F){return new se(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const F=this.f?this.f.source:"",_=A.f?A.f.source:"";return F<_?-1:F>_?1:0}equals(A){if(A.type===this.type){const F=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&F===_}return!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$uj=se;class ue{static create(A){return new ue(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ue(this.c.map(A))}negate(){return this.c}}e.$vj=ue;function Y(X){let A=null;for(let F=0,_=X.length;F<_;F++){const re=X[F].substituteConstants();if(X[F]!==re&&A===null){A=[];for(let K=0;K<F;K++)A[K]=X[K]}A!==null&&(A[F]=re)}return A===null?X:A}class Z{static create(A,F,_){return Z.d(A,F,_)}constructor(A,F){this.expr=A,this.c=F,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const re=i(this.expr[F],A.expr[F]);if(re!==0)return re}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:Z.create(A,this.c,!1)}evaluate(A){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(A))return!1;return!0}static d(A,F,_){const re=[];let K=!1;for(const V of A)if(V){if(V.type===1){K=!0;continue}if(V.type===0)return s.INSTANCE;if(V.type===6){re.push(...V.expr);continue}re.push(V)}if(re.length===0&&K)return l.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(i);for(let V=1;V<re.length;V++)re[V-1].equals(re[V])&&(re.splice(V,1),V--);if(re.length===1)return re[0];for(;re.length>1;){const V=re[re.length-1];if(V.type!==9)break;re.pop();const H=re.pop(),T=re.length===0,Q=q.create(V.expr.map(te=>Z.create([te,H],null,_)),null,T);Q&&(re.push(Q),re.sort(i))}if(re.length===1)return re[0];if(_){for(let V=0;V<re.length;V++)for(let H=V+1;H<re.length;H++)if(re[V].negate().equals(re[H]))return s.INSTANCE;if(re.length===1)return re[0]}return new Z(re,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new Z(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());this.c=q.create(A,this,!0)}return this.c}}e.$wj=Z;class q{static create(A,F,_){return q.d(A,F,_)}constructor(A,F){this.expr=A,this.c=F,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const re=i(this.expr[F],A.expr[F]);if(re!==0)return re}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:q.create(A,this.c,!1)}evaluate(A){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(A))return!0;return!1}static d(A,F,_){let re=[],K=!1;if(A){for(let V=0,H=A.length;V<H;V++){const T=A[V];if(T){if(T.type===0){K=!0;continue}if(T.type===1)return l.INSTANCE;if(T.type===9){re=re.concat(T.expr);continue}re.push(T)}}if(re.length===0&&K)return s.INSTANCE;re.sort(i)}if(re.length!==0){if(re.length===1)return re[0];for(let V=1;V<re.length;V++)re[V-1].equals(re[V])&&(re.splice(V,1),V--);if(re.length===1)return re[0];if(_){for(let V=0;V<re.length;V++)for(let H=V+1;H<re.length;H++)if(re[V].negate().equals(re[H]))return l.INSTANCE;if(re.length===1)return re[0]}return new q(re,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new q(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());for(;A.length>1;){const F=A.shift(),_=A.shift(),re=[];for(const K of he(F))for(const V of he(_))re.push(Z.create([K,V],null,!1));A.unshift(q.create(re,null,!1))}this.c=q.create(A,this,!0)}return this.c}}e.$xj=q;class M extends p{static{this.d=[]}static all(){return M.d.values()}constructor(A,F,_){super(A,null),this.f=F,typeof _=="object"?M.d.push({..._,key:A}):_!==!0&&M.d.push({key:A,description:_,type:F!=null?typeof F:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return D.create(this.key,A)}notEqualsTo(A){return R.create(this.key,A)}}e.$yj=M,e.$zj=(0,O.$hi)("contextKeyService");function N(X,A){return X<A?-1:X>A?1:0}function G(X,A,F,_){return X<F?-1:X>F?1:A<_?-1:A>_?1:0}function z(X,A){if(X.type===0||A.type===1)return!0;if(X.type===9)return A.type===9?oe(X.expr,A.expr):!1;if(A.type===9){for(const F of A.expr)if(z(X,F))return!0;return!1}if(X.type===6){if(A.type===6)return oe(A.expr,X.expr);for(const F of X.expr)if(z(F,A))return!0;return!1}return X.equals(A)}function oe(X,A){let F=0,_=0;for(;F<X.length&&_<A.length;){const re=X[F].cmp(A[_]);if(re<0)return!1;re===0&&F++,_++}return F===X.length}function he(X){return X.type===9?X.expr:[X]}}),define(ae[92],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$1m=e.ID=void 0,e.$2m=C,e.ID="diagnosticsService",e.$1m=(0,n.$hi)(e.ID);function C(O){return!!O.hostName&&!!O.errorMessage}class P{async getPerformanceInfo(j,E){return{}}async getSystemInfo(j,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,E){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$3m=P}),define(ae[119],ce([0,1,19,73,168,6,47,4,35]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$qw=e.$pw=e.$ow=void 0,e.$rw=d,e.$sw=m,e.$ow=(0,O.$hi)("dialogService");var c;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(c||(c={}));class b{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,g){const f=[];switch(g){case c.Confirmation:{const h=w;h.primaryButton?f.push(h.primaryButton):f.push((0,P.localize)(0,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,P.localize)(1,null));break}case c.Prompt:{const h=w;Array.isArray(h.buttons)&&h.buttons.length>0&&f.push(...h.buttons.map($=>$.label)),h.cancelButton&&(h.cancelButton===!0?f.push((0,P.localize)(2,null)):typeof h.cancelButton=="string"?f.push(h.cancelButton):h.cancelButton.label?f.push(h.cancelButton.label):f.push((0,P.localize)(3,null))),f.length===0&&f.push((0,P.localize)(4,null));break}case c.Input:{const h=w;h.primaryButton?f.push(h.primaryButton):f.push((0,P.localize)(5,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,P.localize)(6,null));break}}return f}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===C.default.Info?"info":w===C.default.Error?"error":w===C.default.Warning?"warning":"none"}f(w,g,f){const h=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&h.push(w.cancelButton);let $=h[g]?.run({checkboxChecked:f});return $ instanceof Promise||($=Promise.resolve($)),{result:$,checkboxChecked:f}}}e.$pw=b,e.$qw=(0,O.$hi)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function d(v){const w=[];return w.push(...v.slice(0,k).map(g=>typeof g=="string"?g:(0,n.$Rg)(g))),v.length>k&&(v.length-k===1?w.push((0,P.localize)(7,null)):w.push((0,P.localize)(8,null,v.length-k))),w.push(""),w.join(`
`)}function m(v,w){const g=(0,u.$Nn)(v);let f=(g.buttons??[]).map(t=>(0,j.$lw)(t)),h=(v.buttons||[]).map((t,o)=>o),$=0,a=g.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=h[a];h.splice(a,1),h.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),h=h.reverse(),$=f.length-1,typeof t=="string"&&(a=$-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=h[a];h.splice(a,1),h.push(o),a=f.length-1}}return g.buttons=f,g.defaultId=$,g.cancelId=a,g.noLink=!0,g.title=g.title||w.nameLong,{options:g,buttonIndeces:h}}}),define(ae[120],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$GW=e.$FW=void 0,e.$HW=O,e.$IW=j,e.$FW=(0,n.$hi)("encryptionService"),e.$GW=(0,n.$hi)("encryptionMainService");var C;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var P;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function O(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function j(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(ae[38],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,n.$hi)("environmentService"),e.$pi=(0,n.$ii)(e.$oi)}),define(ae[121],ce([0,1,172,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=P,e.$Lo=O,e.$Mo=j,e.$No=E,e.$Oo=u,e.$Po=c,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function P(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function j(h,$){switch(h){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(h,$){return $==="web"&&!h.includes("web")}function u(h,$,a){return E($,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}function c(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Qo=(0,C.$hi)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var v;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class w extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Ro=w;var g;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class f extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$So=f,e.$To=(0,C.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,C.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,C.$hi)("IExtensionTipsService"),e.$Yo=(0,n.localize2)(0,"Extensions"),e.$Zo=(0,n.localize2)(1,"Preferences")}),define(ae[213],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=e.$eac=void 0,e.$eac=(0,n.$hi)("extensionHostStarter"),e.$fac="extensionHostStarter"}),define(ae[214],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=e.$f5b=void 0,e.$f5b=(0,n.$hi)("externalTerminal"),e.$g5b="Terminal.app"}),define(ae[215],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=void 0,e.$hac=(0,n.$hi)("externalTerminal")}),define(ae[216],ce([0,1,48,50,13,9,4,75,21,90,176,214]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=e.$jac=e.$iac=void 0;const k=b.localize(0,null);class d{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends d{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$_l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=O.$oc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),s==="wt"&&l.push("-d ."),new Promise((p,D)=>{const I=g(process),S=a.spawn(o,l,{cwd:r,env:I,detached:!0});S.on("error",D),S.on("exit",()=>p())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),l=await m.f();return new Promise((p,D)=>{const I=`"${t} - ${k}"`,S=`"${o.join('" "')}" & pause`,R=Object.assign({},g(process),r);Object.keys(R).filter(x=>R[x]===null).forEach(x=>delete R[x]);const B={cwd:t,env:R,windowsVerbatimArguments:!0};let L,W;O.$oc(s,".exe")==="wt"?(L=s,W=["-d",".",m.b,"/c",S]):l?(L=l,W=["-d",".",s,"/c",S]):(L=m.b,W=["/c","start",I,"/wait",s,"/c",`"${S}"`]),n.spawn(L,W,B).on("error",x=>{D(f(x))}),p(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await u.Promises.exists(a)?a:void 0}catch{return}}}e.$iac=m,ve([C.$Lh],m,"f",null);class v extends d{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||y.$g5b;return new Promise((l,p)=>{if(s===y.$g5b||s==="iTerm.app"){const D=s===y.$g5b?"TerminalHelper":"iTermHelper",S=[P.$Bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||k,"-w",t];for(const L of o)S.push("-a"),S.push(L);if(r){const L=Object.assign({},g(process),r);for(const W in L){const U=L[W];U===null?(S.push("-u"),S.push(W)):(S.push("-e"),S.push(`${W}=${U}`))}}let R="";const B=n.spawn(v.b,S);B.on("error",L=>{p(f(L))}),B.stderr.on("data",L=>{R+=L.toString()}),B.on("exit",L=>{if(L===0)l(void 0);else if(R){const W=R.split(`
`,1);p(new Error(W[0]))}else p(new Error(b.localize(1,null,D,L)))})}else p(new Error(b.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||y.$g5b;return new Promise((i,s)=>{const l=["-a",r];o&&l.push(o);const p=g(process),D=a.spawn("/usr/bin/open",l,{cwd:o,env:p});D.on("error",s),D.on("exit",()=>i())})}}e.$jac=v;class w extends d{static{this.b=b.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,p)=>{const D=[];s.then(I=>{I.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const S=`${h(o)}; echo; read -p "${w.b}" -n1;`;D.push(`''${S}''`);const R=Object.assign({},g(process),r);Object.keys(R).filter(U=>R[U]===null).forEach(U=>delete R[U]);const B={cwd:t,env:R};let L="";const W=n.spawn(I,D,B);W.on("error",U=>{p(f(U))}),W.stderr.on("data",U=>{L+=U.toString()}),W.on("exit",U=>{if(U===0)l(void 0);else if(L){const x=L.split(`
`,1);p(new Error(x[0]))}else p(new Error(b.localize(4,null,I,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!j.$k)w.d=Promise.resolve("xterm");else{const a=await u.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(l=>{const p=g(process),D=a.spawn(l,[],{cwd:o,env:p});D.on("error",s),D.on("exit",()=>i())})})}}e.$kac=w;function g($){const a={...$.env};return(0,E.$0l)(a),a}function f($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(b.localize(5,null,$.path)):$}function h($){let a="";for(const t of $)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,178,6,4,13,61]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=k,e.$Pk=v,e.$Qk=g,e.$Rk=f,e.$Sk=h,e.$Tk=$,e.$Uk=a,e.$Vk=t,e.$Wk=o,e.$Xk=r,e.$Yk=i,e.$1k=p,e.$2k=D,e.$3k=I,e.$4k=S,e.$5k=R,e.$8k=x,e.$hl=q,e.$il=M,e.$kl=G,e.$Nk=(0,u.$hi)("fileService");function k(z){return z.create===!0}var d;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var m;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function v(z){const oe=z;return!!oe&&typeof oe.onDidChange=="function"}var w;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function g(z){return!!(z.capabilities&2)}function f(z){return!!(z.capabilities&8)}function h(z){return!!(z.capabilities&131072)}function $(z){return!!(z.capabilities&4)}function a(z){return!!(z.capabilities&16)}function t(z){return g(z)?!!(z.capabilities&16384):!1}function o(z){return g(z)?!!(z.capabilities&32768):!1}function r(z){return!!(z.capabilities&65536)}function i(z){return!!(z.capabilities&2048)}var s;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class l extends Error{static create(oe,he){const X=new l(oe.toString(),he);return I(X,he),X}constructor(oe,he){super(oe),this.code=he}}e.$Zk=l;function p(z,oe){return l.create(z,oe)}function D(z){return z||p((0,E.localize)(0,null),s.Unknown)}function I(z,oe){return z.name=oe?`${oe} (FileSystemError)`:"FileSystemError",z}function S(z){if(!z)return s.Unknown;if(z instanceof l)return z.code;const oe=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!oe)return s.Unknown;switch(oe[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function R(z){if(z instanceof le)return z.fileOperationResult;switch(S(z)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var B;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(B||(e.FileOperation=B={}));class L{constructor(oe,he,X){this.resource=oe,this.operation=he,this.target=X}isOperation(oe){return this.operation===oe}}e.$6k=L;var W;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class U{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const X=n.$ni.forUris(()=>this.c);return X.fill(this.rawAdded.map(A=>[A,!0])),X}),this.f=new y.$V(()=>{const X=n.$ni.forUris(()=>this.c);return X.fill(this.rawUpdated.map(A=>[A,!0])),X}),this.g=new y.$V(()=>{const X=n.$ni.forUris(()=>this.c);return X.fill(this.rawDeleted.map(A=>[A,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of oe){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==U.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...X){if(!oe)return!1;const A=X.length>0;return!!((!A||X.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!A||X.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!A||X.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$7k=U;function x(z,oe,he){return!z||!oe||z===oe||oe.length>z.length?!1:(oe.charAt(oe.length-1)!==C.sep&&(oe+=C.sep),he?(0,P.$mf)(z,oe):z.indexOf(oe)===0)}class le extends Error{constructor(oe,he,X){super(oe),this.fileOperationResult=he,this.options=X}}e.$9k=le;class se extends le{constructor(oe,he,X,A){super(oe,he,A),this.fileOperationResult=he,this.size=X}}e.$0k=se;class ue extends le{constructor(oe,he,X){super(oe,2,X),this.stat=he}}e.$$k=ue;var Y;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var Z;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$gl="";function q(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}async function M(z,oe){if(!oe.hasProvider(j.URI.from({scheme:z.scheme})))return new Promise(he=>{const X=oe.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===z.scheme&&A.added&&(X.dispose(),he())})})}class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(oe){return(0,O.$Yf)(oe)||(oe=0),oe<N.KB?(0,E.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,E.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,E.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,E.localize)(4,null,(oe/N.GB).toFixed(2)):(0,E.localize)(5,null,(oe/N.TB).toFixed(2))}}e.$jl=N;function G(z){const oe=typeof z=="string"||z?.scheme===b.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===b.Schemas.file?1024*N.MB:oe?10*N.MB:c.$o?50*N.MB:1024*N.MB}}),define(ae[122],ce([0,1,17,15,179,16]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=j;async function j(b,y,k,d,m,v){let w;try{await E(b,y,k,d,m,v)}catch(g){w=g}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&k.error(w),k.end()}}async function E(b,y,k,d,m,v){u(v);const w=await b.open(y,{create:!1});try{u(v);let g=0,f=0,h=m&&typeof m.length=="number"?m.length:void 0,$=n.$ue.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await b.read(w,a,$.buffer,t,$.byteLength-t),a+=f,t+=f,g+=f,typeof h=="number"&&(h-=f),t===$.byteLength&&(await k.write(d($)),$=n.$ue.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),t=0);while(f>0&&(typeof h!="number"||h>0)&&u(v)&&c(g,m));if(t>0){let o=t;typeof h=="number"&&(o=Math.min(t,h)),k.write(d($.slice(0,o)))}}catch(g){throw(0,O.$2k)(g)}finally{await b.close(w)}}function u(b){if(b.isCancellationRequested)throw(0,C.$6)();return!0}function c(b,y){if(typeof y?.limits?.size=="number"&&b>y.limits.size)throw(0,O.$1k)((0,P.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[65],ce([0,1,108,2,9,4,7,16]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0,e.$uq=u,e.$yq=k,e.$zq=d,e.$Aq=m,e.$Bq=v;function u(g){return g.recursive===!0}class c extends C.$Uc{static{this.a=5}constructor(f,h,$,a){super(),this.h=f,this.j=h,this.m=$,this.n=a,this.c=this.B(new C.$Vc),this.f=void 0,this.g=0}s(){const f=new C.$Tc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(h=>this.h(h))),f.add(this.b.onDidLogMessage(h=>this.j(h))),f.add(this.b.onDidError(h=>this.t(h)))}t(f){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$vq=c;class b extends c{constructor(f,h,$){super(f,h,$,{type:"node.js",restartOnError:!1})}}e.$wq=b;class y extends c{constructor(f,h,$){super(f,h,$,{type:"universal",restartOnError:!0})}}e.$xq=y;function k(g){return g.map(f=>({type:f.type,resource:j.URI.revive(f.resource),cId:f.cId}))}function d(g){const f=new w;for(const h of g)f.processEvent(h);return f.coalesce()}function m(g,f){return typeof f=="string"&&!f.startsWith(n.$0j)&&!(0,P.$jc)(f)?{base:g,pattern:f}:f}function v(g,f){const h=[];for(const $ of f)h.push((0,n.$bk)(m(g,$)));return h}class w{constructor(){this.a=new Set,this.b=new Map}c(f){return O.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const h=this.b.get(this.c(f));let $=!1;if(h){const a=h.type,t=f.type;h.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?$=!0:a===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(h)):a===2&&t===1?h.type=0:a===1&&t===0||(h.type=t)}else $=!0;$&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],h=[];return Array.from(this.a).filter($=>$.type!==2?(f.push($),!1):!0).sort(($,a)=>$.resource.fsPath.length-a.resource.fsPath.length).filter($=>h.some(a=>(0,E.$8k)($.resource.fsPath,a,!O.$k))?!1:(h.push($.resource.fsPath),!0)).concat(f)}}}),define(ae[217],ce([0,1,17,51,15,3,2,62,32,16,65]),function(J,e,n,C,P,O,j,E,u,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0,e.$GP="localFilesystem";class y extends j.$Uc{constructor(d,m){super(),this.a=d,this.b=m,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$7d),this.onDidWatchError=this.g.event,this.h=(0,u.$Dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,m){const{buffer:v}=await this.a.call("readFile",[d,m]);return v}readFileStream(d,m,v){const w=(0,E.$ie)(f=>n.$ue.concat(f.map(h=>n.$ue.wrap(h))).buffer),g=new j.$Tc;return g.add(this.a.listen("readFileStream",[d,m])(f=>{if(f instanceof n.$ue)w.write(f.buffer);else{if(f==="end")w.end();else{let h;if(f instanceof Error)h=f;else{const $=f;h=(0,c.$1k)($.message??(0,C.$5i)($),$.code??c.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}g.dispose()}})),g.add(v.onCancellationRequested(()=>{w.error((0,P.$6)()),w.end(),g.dispose()})),w}writeFile(d,m,v){return this.a.call("writeFile",[d,n.$ue.wrap(m),v])}open(d,m){return this.a.call("open",[d,m])}close(d){return this.a.call("close",[d])}async read(d,m,v,w,g){const[f,h]=await this.a.call("read",[d,m,g]);return v.set(f.buffer.slice(0,h),w),h}write(d,m,v,w,g){return this.a.call("write",[d,m,n.$ue.wrap(v),w,g])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,m){return this.a.call("delete",[d,m])}rename(d,m,v){return this.a.call("rename",[d,m,v])}copy(d,m,v){return this.a.call("copy",[d,m,v])}cloneFile(d,m){return this.a.call("cloneFile",[d,m])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const m=d;this.f.fire((0,b.$yq)(m))}else{const m=d;this.g.fire(m)}}))}watch(d,m){const v=(0,u.$Dg)();return this.a.call("watch",[this.h,v,d,m]),(0,j.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$HP=y}),define(ae[218],ce([0,1,43,8,23,33,2,86,9,4,19,7,109,21,65]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,e.$Qq=w;class v extends j.$Uc{static{this.a=100}static{this.b=75}constructor(f,h,$,a,t){super(),this.m=f,this.n=h,this.r=$,this.s=a,this.t=t,this.c=this.B(new C.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.n(o))),this.f=this.B(new C.$vh(o=>this.D(o),v.b)),this.g=(0,m.$Bq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$Bq)(this.m.path,this.m.includes):void 0,this.j=new P.$ee,this.ready=this.u()}async u(){try{const f=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const h=await d.Promises.stat(f);this.B(await this.y(f,h.isDirectory()))}catch(f){f.code!=="ENOENT"?this.G(f):this.I(f),this.r?.()}}async w(f){let h=f.path;try{h=await d.Promises.realpath(f.path),f.path===h&&(h=await(0,k.$Mq)(f.path)??f.path),f.path!==h&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${h})`)}catch{}return h}async y(f,h){if(c.$j&&(0,O.$hg)(f,"/Volumes/",!0))return this.G(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),j.$Uc.None;const $=new P.$ee(this.j.token),a=new j.$Tc;try{const t=y.URI.file(this.m.path),o=(0,u.$oc)(f),r=(0,n.watch)(f);a.add((0,j.$Sc)(()=>{r.removeAllListeners(),r.close()})),this.I(`Started watching: '${f}'`);const i=new Set;if(h)try{for(const l of await d.Promises.readdir(f))i.add(l)}catch(l){this.G(l)}const s=new Map;a.add((0,j.$Sc)(()=>{for(const[,l]of s)l.dispose();s.clear()})),r.on("error",(l,p)=>{this.G(`Failed to watch ${f} for changes using fs.watch() (${l}, ${p})`),this.r?.()}),r.on("change",(l,p)=>{if($.token.isCancellationRequested)return;this.I(`[raw] ["${l}"] ${p}`);let D="";if(p&&(D=p.toString(),c.$j&&(D=(0,E.$Yl)(D))),!(!D||l!=="change"&&l!=="rename"))if(h)if(l==="rename"){s.get(D)?.dispose();const I=setTimeout(async()=>{if(s.delete(D),D===o&&!await d.Promises.exists(f)){this.z(t);return}const S=await this.F((0,u.$kc)(f,D));if($.token.isCancellationRequested)return;let R;S?i.has(D)?R=0:(R=1,i.add(D)):(i.delete(D),R=2),this.C({resource:(0,b.$Ug)(t,D),type:R,cId:this.m.correlationId})},v.a);s.set(D,(0,j.$Sc)(()=>clearTimeout(I)))}else{let I;i.has(D)?I=0:(I=1,i.add(D)),this.C({resource:(0,b.$Ug)(t,D),type:I,cId:this.m.correlationId})}else if(l==="rename"||D!==o){const I=setTimeout(async()=>{const S=await d.Promises.exists(f);$.token.isCancellationRequested||(S?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.y(f,!1))):this.z(t))},v.a);a.clear(),a.add((0,j.$Sc)(()=>clearTimeout(I)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){return!$.token.isCancellationRequested&&await d.Promises.exists(f)&&this.G(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`),this.r?.(),j.$Uc.None}return(0,j.$Sc)(()=>{$.dispose(!0),a.dispose()})}z(f){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:f,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(f,h=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!h&&this.g.some($=>$(f.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${f.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some($=>$(f.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}D(f){const h=(0,m.$zq)(f);if(h.length>0){if(this.t)for(const a of h)this.I(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(f){if(c.$k)return d.Promises.exists(f);try{const h=(0,u.$oc)(f);return(await d.Promises.readdir((0,u.$nc)(f))).some(a=>a===h)}catch(h){return this.I(h),!1}}setVerboseLogging(f){this.t=f}G(f){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}H(f){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}I(f){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.I(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Pq=v;async function w(g,f,h,$,a=512){const t=await d.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),r=new P.$ee($);let i,s=!1;const l={path:g,excludes:[],recursive:!1},p=new v(l,D=>{(async()=>{for(const{type:I}of D)if(I===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:S}=await d.Promises.read(t,o,0,a,null);if(!S||r.token.isCancellationRequested)break;f(o.slice(0,S))}}catch(S){i=new Error(S),r.dispose(!0)}finally{s=!1}}})()});return await p.ready,h(),new Promise((D,I)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await d.Promises.close(t)}catch(S){i=new Error(S)}i?I(i):D()})})}}),define(ae[219],ce([0,1,3,108,210,4,218]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class E extends P.$Kq{constructor(){super(...arguments),this.onDidError=n.Event.None,this.F=new Map,this.G=!1}async z(c){const b=this.L(c),y=b.filter(d=>{const m=this.F.get(d.path);return m?!(0,C.$fk)(m.request.excludes,d.excludes)||!(0,C.$fk)(m.request.includes,d.includes):!0}),k=Array.from(this.F.values()).filter(({request:d})=>!b.find(m=>m.path===d.path&&(0,C.$fk)(m.excludes,d.excludes)&&(0,C.$fk)(m.includes,d.includes))).map(({request:d})=>d.path);y.length&&this.C(`Request to start watching: ${y.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),k.length&&this.C(`Request to stop watching: ${k.join(",")}`);for(const d of k)this.J(d);for(const d of y)this.I(d)}I(c){const b=new j.$Pq(c,k=>this.a.fire(k),()=>this.c.fire(c),k=>this.b.fire(k),this.G),y={request:c,instance:b};this.F.set(c.path,y)}async stop(){await super.stop();for(const[c]of this.F)this.J(c);this.F.clear()}J(c){const b=this.F.get(c);b&&(this.F.delete(c),b.instance.dispose())}L(c){const b=new Map;for(const y of c){const k=O.$k?y.path:y.path.toLowerCase();let d=b.get(y.correlationId);d||(d=new Map,b.set(y.correlationId,d)),d.set(k,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(c){this.G=c;for(const[,b]of this.F)b.instance.setVerboseLogging(c)}C(c){this.G&&this.b.fire({type:"trace",message:this.O(c)})}D(c){this.G&&this.b.fire({type:"warn",message:this.O(c)})}O(c){return`[File Watcher (node.js)] ${c}`}}e.$Rq=E}),define(ae[220],ce([0,1,65,219]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class P extends n.$wq{constructor(j,E,u){super(j,E,u),this.s()}r(j){return j.add(new C.$Rq)}}e.$Sq=P}),define(ae[221],ce([0,1,13,44,162,65]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class j extends O.$xq{constructor(u,c,b){super(u,c,b),this.s()}r(u){const c=u.add(new P.$Iq(n.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:b,signal:y})=>this.t(`terminated by itself with code ${b}, signal: ${y}`))),C.ProxyChannel.toService((0,C.$1h)(c.getChannel("watcher")))}}e.$Jq=j}),define(ae[93],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class n{constructor(...P){this.a=new Map;for(const[O,j]of P)this.set(O,j)}set(P,O){const j=this.a.get(P);return this.a.set(P,O),j}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$fi=n}),define(ae[222],ce([0,1,8,15,2,77,212,6,93,104]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;const b=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class k{constructor(w=new u.$fi,g=!1,f,h=b){this.f=w,this.g=g,this.h=f,this.i=h,this.o=new Set,this.f.set(E.$gi,this),this._globalGraph=h?f?._globalGraph??new j.$Vq($=>$):void 0}createChild(w){return new k(w,this.g,this,this.i)}invokeFunction(w,...g){const f=m.traceInvocation(this.i,w);let h=!1;try{return w({get:a=>{if(h)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...g)}finally{h=!0,f.stop()}}createInstance(w,...g){let f,h;return w instanceof O.$ei?(f=m.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat(g),f)):(f=m.traceCreation(this.i,w),h=this.j(w,g,f)),f.stop(),h}j(w,g=[],f){const h=E._util.getServiceDependencies(w).sort((t,o)=>t.index-o.index),$=[];for(const t of h){const o=this.m(t.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const a=h.length>0?h[0].index:g.length;if(g.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${g.length} static arguments`);const t=a-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,a)}return Reflect.construct(w,g.concat($))}k(w,g){if(this.f.get(w)instanceof O.$ei)this.f.set(w,g);else if(this.h)this.h.k(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const g=this.f.get(w);return!g&&this.h?this.h.l(w):g}m(w,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof O.$ei?this.q(w,f,g.branch(w,!0)):(g.branch(w,!1),f)}q(w,g,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,g,f)}finally{this.o.delete(w)}}r(w,g,f){const h=new j.$Vq(t=>t.id.toString());let $=0;const a=[{id:w,desc:g,_trace:f}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),$++>1e3)throw new y(h);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof O.$ei){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};h.insertEdge(t,i),a.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new y(h);break}for(const{data:o}of t){if(this.l(o.id)instanceof O.$ei){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(w)}s(w,g,f=[],h,$){if(this.f.get(w)instanceof O.$ei)return this.t(w,g,f,h,$);if(this.h)return this.h.s(w,g,f,h,$);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(w,g,f=[],h,$){if(h){const a=new k(void 0,this.g,this,this.i);a.c=String(w);const t=new Map,o=new n.$Ah(()=>{const r=a.j(g,f,$);for(const[i,s]of t){const l=r[i];if(typeof l=="function")for(const p of s)p.disposable=l.apply(r,p.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=t.get(i);return p||(p=new c.$5c,t.set(i,p)),(I,S,R)=>{if(o.isInitialized)return o.value[i](I,S,R);{const B={listener:[I,S,R],disposable:void 0},L=p.push(B);return(0,P.$Sc)(()=>{L(),B.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),r[i]=l),l},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,f,$)}u(w,g){if(g&&console.warn(w),this.g)throw new Error(w)}}e.$Wq=k;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,g){return w?new m(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(w,g){return w?new m(1,g.name):m.c}static{this.f=0}constructor(w,g){this.type=w,this.name=g,this.g=Date.now(),this.h=[]}branch(w,g){const f=new m(3,w.toString());return this.h.push([w,g,f]),f}stop(){const w=Date.now()-this.g;m.f+=w;let g=!1;function f($,a){const t=[],o=new Array($+1).join("	");for(const[r,i,s]of a.h)if(i&&s){g=!0,t.push(`${o}CREATES -> ${r}`);const l=f($+1,s);l&&t.push(l)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(w>2||g)&&m.all.add(h.join(`
`))}}e.$Xq=m}),define(ae[223],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hCb=e.IssueSource=e.IssueType=void 0;var C;(function(O){O[O.Bug=0]="Bug",O[O.PerformanceIssue=1]="PerformanceIssue",O[O.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={}));var P;(function(O){O.VSCode="vscode",O.Extension="extension",O.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$hCb=(0,n.$hi)("issueService")}),define(ae[5],ce([0,1,183,51,3,46,2,31,4,19,12,7,118,6]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=v,e.log=g,e.$2j=p,e.$3j=D,e.$4j=I,e.$5j=S,e.$Nj=(0,d.$hi)("logService"),e.$Oj=(0,d.$hi)("loggerService");function m(){return new Date().toISOString()}function v(R){return(0,b.$Yf)(R)}var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Qj=w.Info;function g(R,B,L){switch(B){case w.Trace:R.trace(L);break;case w.Debug:R.debug(L);break;case w.Info:R.info(L);break;case w.Warning:R.warn(L);break;case w.Error:R.error(L);break;case w.Off:break;default:throw new Error(`Invalid log level ${B}`)}}function f(R,B=!1){let L="";for(let W=0;W<R.length;W++){let U=R[W];if(U instanceof Error&&(U=(0,C.$5i)(U,B)),typeof U=="object")try{U=JSON.stringify(U)}catch{}L+=(W>0?" ":"")+U}return L}class h extends j.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new P.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(B){this.b!==B&&(this.b=B,this.c.fire(this.b))}getLevel(){return this.b}f(B){return this.b!==w.Off&&this.b<=B}}e.$Sj=h;class $ extends h{constructor(B){super(),this.h=B}f(B){return this.h||super.f(B)}trace(B,...L){this.f(w.Trace)&&this.g(w.Trace,f([B,...L],!0))}debug(B,...L){this.f(w.Debug)&&this.g(w.Debug,f([B,...L]))}info(B,...L){this.f(w.Info)&&this.g(w.Info,f([B,...L]))}warn(B,...L){this.f(w.Warning)&&this.g(w.Warning,f([B,...L]))}error(B,...L){if(this.f(w.Error))if(B instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=B.stack,this.g(w.Error,f(W))}else this.g(w.Error,f([B,...L]))}flush(){}}e.$Tj=$;class a extends h{constructor(B=e.$Qj){super(),this.setLevel(B),this.g=!u.$i}trace(B,...L){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,B,...L):console.log(`[main ${m()}]`,B,...L))}debug(B,...L){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,B,...L):console.log(`[main ${m()}]`,B,...L))}info(B,...L){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,B,...L):console.log(`[main ${m()}]`,B,...L))}warn(B,...L){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,B,...L):console.warn(`[main ${m()}]`,B,...L))}error(B,...L){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,B,...L):console.error(`[main ${m()}]`,B,...L))}flush(){}}e.$Uj=a;class t extends h{constructor(B=e.$Qj,L=!0){super(),this.g=L,this.setLevel(B)}trace(B,...L){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",B,...L):console.log(B,...L))}debug(B,...L){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",B,...L):console.log(B,...L))}info(B,...L){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",B,...L):console.log(B,...L))}warn(B,...L){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",B,...L):console.log(B,...L))}error(B,...L){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",B,...L):console.error(B,...L))}flush(){}}e.$Vj=t;class o extends h{constructor(B,L=e.$Qj){super(),this.g=B,this.setLevel(L)}trace(B,...L){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(B),...L])}debug(B,...L){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(B),...L])}info(B,...L){this.f(w.Info)&&this.g.log(w.Info,[this.h(B),...L])}warn(B,...L){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(B),...L])}error(B,...L){this.f(w.Error)&&this.g.log(w.Error,[this.h(B),...L])}h(B){return typeof B=="string"?B:(0,C.$5i)(B,this.f(w.Trace))}flush(){}}e.$Wj=o;class r extends h{constructor(B){super(),this.g=B,B.length&&this.setLevel(B[0].getLevel())}setLevel(B){for(const L of this.g)L.setLevel(B);super.setLevel(B)}trace(B,...L){for(const W of this.g)W.trace(B,...L)}debug(B,...L){for(const W of this.g)W.debug(B,...L)}info(B,...L){for(const W of this.g)W.info(B,...L)}warn(B,...L){for(const W of this.g)W.warn(B,...L)}error(B,...L){for(const W of this.g)W.error(B,...L)}flush(){for(const B of this.g)B.flush()}dispose(){for(const B of this.g)B.dispose();super.dispose()}}e.$Xj=r;class i extends j.$Uc{constructor(B,L,W){if(super(),this.h=B,this.j=L,this.b=new E.$Bc,this.c=this.B(new P.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$7d),this.onDidChangeVisibility=this.g.event,W)for(const U of W)this.b.set(U.resource,{logger:void 0,info:U})}m(B){return(0,b.$Uf)(B)?[...this.b.values()].find(L=>L.info.id===B):this.b.get(B)}getLogger(B){return this.m(B)?.logger}createLogger(B,L){const W=this.n(B),U=(0,b.$Uf)(B)?B:L?.id??(0,O.$8i)(W.toString()).toString(16);let x=this.b.get(W)?.logger;const le=L?.logLevel==="always"?w.Trace:L?.logLevel;x||(x=this.s(W,le??this.getLogLevel(W)??this.h,{...L,id:U}));const se={logger:x,info:{resource:W,id:U,logLevel:le,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(se.info),this.b.set(W,se),x}n(B){return(0,b.$Uf)(B)?(0,c.$Ug)(this.j,`${B}.log`):B}setLogLevel(B,L){if(y.URI.isUri(B)){const W=B,U=L,x=this.b.get(W);x&&U!==x.info.logLevel&&(x.info.logLevel=U===this.h?void 0:U,x.logger?.setLevel(U),this.b.set(x.info.resource,x),this.f.fire([W,U]))}else{this.h=B;for(const[W,U]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(B,L){const W=this.m(B);W&&L!==!W.info.hidden&&(W.info.hidden=!L,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,L]))}getLogLevel(B){let L;return B&&(L=this.b.get(B)?.info.logLevel),L??this.h}registerLogger(B){const L=this.b.get(B.resource);L?L.info.hidden!==B.hidden&&this.setVisibility(B.resource,!B.hidden):(this.b.set(B.resource,{info:B,logger:void 0}),this.c.fire({added:[B],removed:[]}))}deregisterLogger(B){const L=this.b.get(B);L&&(L.logger&&L.logger.dispose(),this.b.delete(B),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const B of this.b.values())yield B.info}getRegisteredLogger(B){return this.b.get(B)?.info}dispose(){this.b.forEach(B=>B.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=i;class s{constructor(){this.onDidChangeLogLevel=new P.$7d().event}setLevel(B){}getLevel(){return w.Info}trace(B,...L){}debug(B,...L){}info(B,...L){}warn(B,...L){}error(B,...L){}critical(B,...L){}dispose(){}flush(){}}e.$Zj=s;class l extends s{}e.$1j=l;function p(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const B=S(R.logLevel.toLowerCase());if(B!==void 0)return B}return e.$Qj}function D(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function I(R){switch(R){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function S(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$6j=new k.$yj("logLevel",D(w.Info))});var ne=this&&this.__param||function(J,e){return function(n,C){e(n,C,J)}};define(ae[224],ce([0,1,14,4,5]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=void 0;const O=n.safeStorage;let j=class{constructor(u){this.a=u,n.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(O.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(u){let c;try{if(c=JSON.parse(u),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const b=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=O.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const u=O.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$dac=j,e.$dac=j=ve([ne(0,P.$Nj)],j)}),define(ae[225],ce([0,1,22,8,15,3,2,9,65,5]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class b extends j.$Uc{constructor(k,d){super(),this.a=k,this.b=d,this.c=this.B(new O.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$fh(0)),this.w=[],this.y=this.B(new C.$fh(0))}watch(k,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(k,d):this.z(k,d)}n(k,d){const m={path:this.H(k),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},v=(0,n.$Ub)(this.j,m);return this.r(),(0,j.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$1)(k))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$yq)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const d of this.j)(0,u.$uq)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const d of this.j)(0,u.$uq)(d)&&k.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,d){const m={path:this.H(k),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},v=(0,n.$Ub)(this.w,m);return this.C(),(0,j.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,u.$yq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,E.$ic)(k.fsPath)}}e.$Cq=b}),define(ae[226],ce([0,1,22,8,17,23,3,46,71,2,59,13,66,19,62,177,16,122,5,15]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let a=class extends c.$Uc{static{$=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new j.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$7d),this.Y=this.B(new j.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$qh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Tc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const l=new w.$7k(s,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Pc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await C.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return u.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,d.$Yg)(o))throw new w.$9k((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new h.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,w.$Tk)(r)||(0,w.$Qk)(r)||(0,w.$Uk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$Tk)(r)||(0,w.$Qk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,w.$4k)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$9k((0,v.localize)(2,null,this.sb(o)),1):(0,w.$2k)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),l=r?.resolveTo,p=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,I=await i.stat(o);let S;return this.t(i,o,I,void 0,!!D,(R,B)=>(S||(S=b.$ni.forUris(()=>!s),S.set(o,!0),l&&S.fill(!0,l)),S.get(R.resource)||S.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&p?B===1:!1))}async t(o,r,i,s,l,p){const{providerExtUri:D}=this.R(o),I={resource:r,name:D.basename(r),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$hl)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&p(I,s)){try{const S=await o.readdir(r),R=await C.Promises.settled(S.map(async([B,L])=>{try{const W=D.joinPath(r,B),U=l?await o.stat(W):{type:L};return await this.t(o,W,U,S.length,l,p)}catch(W){return this.b.trace(W),null}}));I.children=(0,n.$Hb)(R)}catch(S){this.b.trace(S),I.children=[]}return I}return I}async resolveAll(o){return C.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$9k((0,v.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=P.$ue.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new w.$6k(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(s);let p=i;if((0,w.$Wk)(s)&&!p?.atomic){const D=s.enforceAtomicWriteFile?.(o);D&&(p={...i,atomic:D})}try{await this.w(s,o,p)||await this.U(s,l.dirname(o));let I;if((0,w.$Qk)(s)&&!(r instanceof P.$ue))if((0,m.$ge)(r)){const S=await(0,m.$ne)(r,3);S.ended?I=P.$ue.concat(S.buffer):I=S}else I=(0,m.$ke)(r,S=>P.$ue.concat(S),3);else I=r;!(0,w.$Tk)(s)||(0,w.$Qk)(s)&&I instanceof P.$ue||(0,w.$Qk)(s)&&(0,w.$Wk)(s)&&p?.atomic?await this.hb(s,o,p,I):await this.db(s,o,p,I instanceof P.$ue?(0,P.$Fe)(I):I),this.r.fire(new w.$6k(o,4))}catch(D){throw new w.$9k((0,v.localize)(4,null,this.sb(o),(0,w.$2k)(D).toString()),(0,w.$5k)(D),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(r)));if(s)throw new Error((0,v.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&w.FileType.Directory)throw new w.$9k((0,v.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,p),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$gl&&typeof p.mtime=="number"&&typeof p.size=="number"&&i.mtime<p.mtime&&i.etag!==(0,w.$hl)({mtime:i.mtime,size:p.size}))throw new w.$9k((0,v.localize)(10,null),3,i);return p}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((l,p)=>{this.cb.queueFor(r,async()=>{try{const D=await this.C(o,r,i,s);l(D)}catch(D){p(D)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const l=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...l,value:await(0,P.$Ge)(l.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const l=new O.$ee(s);let p=i;(0,w.$Vk)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...i,atomic:!0});const D=this.J(r,p).then(S=>S,S=>{throw l.dispose(!0),S});let I;try{return typeof p?.etag=="string"&&p.etag!==w.$gl&&await D,p?.atomic&&(0,w.$Vk)(o)||!((0,w.$Tk)(o)||(0,w.$Uk)(o))||(0,w.$Qk)(o)&&p?.preferUnbuffered?I=this.I(o,r,p):(0,w.$Uk)(o)?I=this.G(o,r,l.token,p):I=this.H(o,r,l.token,p),I.on("end",()=>l.dispose()),I.on("error",()=>l.dispose()),{...await D,value:I}}catch(S){throw I&&await(0,m.$le)(I),this.F(S,r,p)}}F(o,r,i){const s=(0,v.localize)(11,null,this.sb(r),(0,w.$2k)(o).toString());return o instanceof w.$$k?new w.$$k(s,o.stat,i):o instanceof w.$0k?new w.$0k(s,o.fileOperationResult,o.size,o.options):new w.$9k(s,(0,w.$5k)(o),i)}G(o,r,i,s=Object.create(null)){const l=o.readFileStream(r,s,i);return(0,m.$re)(l,{data:p=>p instanceof P.$ue?p:P.$ue.wrap(p),error:p=>this.F(p,r,s)},p=>P.$ue.concat(p))}H(o,r,i,s=Object.create(null)){const l=(0,P.$Ke)();return(0,g.$sq)(o,r,l,p=>p,{...s,bufferSize:this.a,errorTransformer:p=>this.F(p,r,s)},i),l}I(o,r,i){const s=(0,m.$ie)(l=>P.$ue.concat(l));return(async()=>{try{let l;i?.atomic&&(0,w.$Vk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),s.end(P.$ue.wrap(l))}catch(l){s.error(l),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$9k((0,v.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$gl&&r.etag===i.etag)throw new w.$$k((0,v.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new w.$0k((0,v.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(l,o,p,r,i,s)}catch(l){return l}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),p=await this.N(s,o,l,r,"move",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,p==="move"?2:3,D)),D}async copy(o,r,i){const s=await this.m(o),l=this.qb(await this.n(r),r),p=await this.N(s,o,l,r,"copy",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,p==="copy"?3:2,D)),D}async N(o,r,i,s,l,p){if(r.toString()===s.toString())return l;const{exists:D,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,s,l,p);if(D&&!I&&p&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),l==="copy"){if(o===i&&(0,w.$Rk)(o))await o.copy(r,s,{overwrite:p});else{const S=await this.resolve(r);S.isDirectory?await this.P(o,S,i,s):await this.O(o,r,i,s)}return l}else return o===i?(await o.rename(r,s,{overwrite:p}),l):(await this.N(o,r,i,s,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,w.$Tk)(o)&&(0,w.$Tk)(i))return this.jb(o,r,i,s);if((0,w.$Tk)(o)&&(0,w.$Qk)(i))return this.pb(o,r,i,s);if((0,w.$Qk)(o)&&(0,w.$Tk)(i))return this.nb(o,r,i,s);if((0,w.$Qk)(o)&&(0,w.$Qk)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await C.Promises.settled(r.children.map(async l=>{const p=this.R(i).providerExtUri.joinPath(s,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),i,p):this.O(o,l.resource,i,p)}))}async Q(o,r,i,s,l,p){let D=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:R}=this.R(o);if(R||(D=S.isEqual(r,s)),D&&l==="copy")throw new Error((0,v.localize)(15,null,this.sb(r),this.sb(s)));if(!D&&S.isEqualOrParent(s,r))throw new Error((0,v.localize)(16,null,this.sb(r),this.sb(s)))}const I=await this.exists(s);if(I&&!D){if(!p)throw new w.$9k((0,v.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:S}=this.R(o);if(S.isEqualOrParent(r,s))throw new Error((0,v.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?d.$Kg:d.$Mg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$6k(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(r)));break}catch(l){if((0,w.$4k)(l)!==w.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(s.basename(r)),r=s.dirname(r)}for(let l=i.length-1;l>=0;l--){r=s.joinPath(r,i[l]);try{await o.mkdir(r)}catch(p){if((0,w.$4k)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(s&&l)throw new Error((0,v.localize)(22,null,this.sb(o)));let p;try{p=await i.stat(o)}catch{}if(p)this.rb(o,p);else throw new w.$9k((0,v.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,w.$Xk)(i)&&!s?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(s={...r,atomic:I})}const l=!!s?.useTrash,p=!!s?.recursive,D=s?.atomic??!1;await i.delete(o,{recursive:p,useTrash:l,atomic:D}),this.r.fire(new w.$6k(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,w.$Sk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,w.$Rk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:$.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Tc;let s=!1,l=()=>{s=!0};i.add((0,c.$Sc)(()=>l())),(async()=>{try{const D=await this.bb(o,r);s?(0,c.$Pc)(D):l=()=>(0,c.$Pc)(D)}catch(D){this.b.error(D)}})();const p=r.correlationId;if(typeof p=="number"){const D=i.add(new j.$7d);return i.add(this.X.event(S=>{S.correlates(p)&&D.fire(S)})),{onDidChange:D.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,E.$8i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(s);return l||(l={count:0,disposable:i.watch(o,r)},this.$.set(s,l)),l.count+=1,(0,c.$Sc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Pc)(l.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Pc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const l=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$ge)(s)||(0,m.$he)(s)?await this.eb(o,l,s):await this.fb(o,l,s)}catch(p){throw(0,w.$2k)(p)}finally{await o.close(l)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,l;if((0,m.$he)(i)){if(i.buffer.length>0){const p=P.$ue.concat(i.buffer);await this.gb(o,r,p,p.byteLength,s,0),s+=p.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((p,D)=>{(0,m.$me)(l,{onData:async I=>{l.pause();try{await this.gb(o,r,I,I.byteLength,s,0)}catch(S){return D(S)}s+=I.byteLength,setTimeout(()=>l.resume())},onError:I=>D(I),onEnd:()=>p()})})}async fb(o,r,i){let s=0,l;for(;(l=i.read())!==null;)await this.gb(o,r,l,l.byteLength,s,0),s+=l.byteLength}async gb(o,r,i,s,l,p){let D=0;for(;D<s;){const I=await o.write(r,l+D,i.buffer,p+D,s-D);D+=I}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let l;s instanceof P.$ue?l=s:(0,m.$ge)(s)?l=await(0,P.$Ge)(s):(0,m.$he)(s)?l=await(0,P.$He)(s):l=(0,P.$Ee)(s),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let l,p;try{l=await o.open(r,{create:!1}),p=await i.open(s,{create:!0,unlock:!1});const D=P.$ue.alloc(this.a);let I=0,S=0,R=0;do R=await o.read(l,I,D.buffer,S,D.byteLength-S),await this.gb(i,p,D,R,I,S),I+=R,S+=R,S===D.byteLength&&(S=0);while(R>0)}catch(D){throw(0,w.$2k)(D)}finally{await C.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof p=="number"?i.close(p):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const l=await i.open(s,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(i,l,P.$ue.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.$2k)(p)}finally{await i.close(l)}}async pb(o,r,i,s){const l=await(0,P.$Ge)(this.H(o,r,O.CancellationToken.None));await this.hb(i,s,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new w.$9k((0,v.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$9k((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$tq=a,e.$tq=a=$=ve([ne(0,f.$Nj)],a)}),define(ae[94],ce([0,1,43,315,8,31,17,3,33,2,9,4,19,62,21,181,16,122,225,51,221,220]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,(()=>{try{(0,C.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$5i)(o)}`)}})();class t extends f.$Cq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new O.$Bc(s=>k.$Lg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let p;l.isSymbolicLink()?p=(await this.stat((0,k.$Ug)(r,l.name))).type:p=this.M(l),s.push([l.name,p])}catch(p){this.a.trace(p)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=w.FileType.Unknown:r.isFile()?s=w.FileType.File:r.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const l=new P.$gh;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const l=this.H(r);return await m.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const l=(0,d.$ie)(p=>j.$ue.concat(p.map(D=>j.$ue.wrap(D))).buffer);return(0,g.$sq)(this,r,l,p=>p.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Ug)((0,k.$Tg)(r),`${(0,k.$Rg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,l){const p=new c.$Tc;try{p.add(await this.O(r)),p.add(await this.O(i)),await this.S(i,s,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{p.dispose()}}async S(r,i,s,l){let p;try{const D=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(D)){if(!s.overwrite)throw(0,w.$1k)((0,v.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.$1k)((0,v.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:s.unlock},l),await this.write(p,0,i,0,i.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const l=this.H(r);let p;(0,w.$Ok)(i)&&!s&&(p=await this.O(r));let D;try{if((0,w.$Ok)(i)&&i.unlock)try{const{stat:S}=await m.SymlinkSupport.stat(l);S.mode&128||await m.Promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let I;if((0,w.$Ok)(i)){if(y.$i)try{await m.Promises.truncate(l,0),I="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}I||(I="w")}else I="r";D=await m.Promises.open(l,I)}catch(I){throw p?.dispose(),(0,w.$Ok)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(D,0),(0,w.$Ok)(i)&&this.X.set(D,r),p){const I=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${l})`),this.W.set(D,p),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${l})`),I.dispose())}return D}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,l,p){const D=this.Z(r,i);let I=null;try{I=(await m.Promises.read(r,s,l,p,D)).bytesRead}catch(S){throw this.fb(S)}finally{this.$(r,D,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const l=this.U.get(r);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,l+s):this.U.delete(r)))}async write(r,i,s,l,p){return(0,P.$Bh)(()=>this.ab(r,i,s,l,p),100,3)}async ab(r,i,s,l,p){const D=this.Z(r,i);let I=null;try{I=(await m.Promises.write(r,s,l,p,D)).bytesWritten}catch(S){throw await this.gb(this.X.get(r),S)}finally{this.$(r,D,I)}return I}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,b.$kc)((0,b.$nc)(s),`${(0,b.$oc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,l)}else try{await m.Promises.unlink(s)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let p=!1;try{const{stat:D,symbolicLink:I}=await m.SymlinkSupport.stat(s);p=D.isDirectory()&&!I}catch{}if(p)await m.Promises.rmdir(s);else throw l}else throw l}}catch(s){throw this.fb(s)}}async rename(r,i,s){const l=this.H(r),p=this.H(i);if(l!==p)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(l,p)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(2,null,(0,b.$oc)(l),(0,b.$oc)((0,b.$nc)(p)),D.toString()))),this.fb(D)}}async copy(r,i,s){const l=this.H(r),p=this.H(i);if(l!==p)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(l,p,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,v.localize)(3,null,(0,b.$oc)(l),(0,b.$oc)((0,b.$nc)(p)),D.toString()))),this.fb(D)}}async bb(r,i,s,l){const p=this.H(r),D=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$gg)(p,D,!0)),I){if(s==="copy")throw(0,w.$1k)((0,v.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const R=await this.L(r);if(!R)throw(0,w.$1k)((0,v.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(i);if(B){if(!l)throw(0,w.$1k)((0,v.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);R.type&w.FileType.File&&B.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const l=this.H(r),p=this.H(i),D=!!(this.capabilities&1024);if((0,u.$gg)(l,p,!D))return;const I=new c.$Tc;try{I.add(await this.O(r)),I.add(await this.O(i)),s&&await m.Promises.mkdir((0,b.$nc)(p),{recursive:!0}),await m.Promises.copyFile(l,p)}catch(S){if(S.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(S)}finally{I.dispose()}}t(r,i,s){return new $.$Jq(l=>r(l),l=>i(l),s)}F(r,i,s){return new a.$Sq(l=>r(l),l=>i(l),s)}fb(r){if(r instanceof w.$Zk)return r;let i=r,s;switch(r.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=w.FileSystemProviderErrorCode.Unknown;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.$1k)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.H(r));l.mode&128||(s=(0,w.$1k)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.$Tq=t}),define(ae[227],ce([0,1,3,94,2,17,62,23]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=void 0;class u extends P.$Uc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,d){const m=this.c(y);switch(k){case"stat":return this.g(m,d[0]);case"readdir":return this.h(m,d[0]);case"open":return this.r(m,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(m,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(m,d[0],d[1],d[2]);case"rename":return this.z(m,d[0],d[1],d[2]);case"copy":return this.C(m,d[0],d[1],d[2]);case"cloneFile":return this.D(m,d[0],d[1]);case"mkdir":return this.w(m,d[0]);case"delete":return this.y(m,d[0],d[1]);case"watch":return this.I(m,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,d){const m=this.c(y);switch(k){case"fileChange":return this.H(m,d[0]);case"readFileStream":return this.m(m,d[0],d[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const d=this.f(y,k,!0);return this.a.stat(d)}h(y,k){const d=this.f(y,k);return this.a.readdir(d)}async j(y,k,d){const m=this.f(y,k,!0),v=await this.a.readFile(m,d);return O.$ue.wrap(v)}m(y,k,d){const m=this.f(y,k,!0),v=new E.$ee,w=new n.$7d({onDidRemoveLastListener:()=>{v.cancel()}}),g=this.a.readFileStream(m,d,v.token);return(0,j.$me)(g,{onData:f=>w.fire(O.$ue.wrap(f)),onError:f=>w.fire(f),onEnd:()=>{w.fire("end"),w.dispose(),v.dispose()}}),w.event}n(y,k,d,m){const v=this.f(y,k);return this.a.writeFile(v,d.buffer,m)}r(y,k,d){const m=this.f(y,k,!0);return this.a.open(m,d)}s(y){return this.a.close(y)}async t(y,k,d){const m=O.$ue.alloc(d),w=await this.a.read(y,k,m.buffer,0,d);return[m,w]}u(y,k,d,m,v){return this.a.write(y,k,d.buffer,m,v)}w(y,k){const d=this.f(y,k);return this.a.mkdir(d)}y(y,k,d){const m=this.f(y,k);return this.a.delete(m,d)}z(y,k,d,m){const v=this.f(y,k),w=this.f(y,d);return this.a.rename(v,w,m)}C(y,k,d,m){const v=this.f(y,k),w=this.f(y,d);return this.a.copy(v,w,m)}D(y,k,d){const m=this.f(y,k),v=this.f(y,d);return this.a.cloneFile(m,v)}H(y,k){const d=new n.$7d({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,d))},onDidRemoveLastListener:()=>{(0,P.$Pc)(this.F.get(k)),this.F.delete(k)}});return d.event}async I(y,k,d,m,v){const w=this.F.get(k);if(w){const g=this.f(y,m),f=w.watch(d,g,v);this.G.set(k+d,f)}}async J(y,k){const d=y+k,m=this.G.get(d);m&&((0,P.$Pc)(m),this.G.delete(d))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$qs=u;class c extends P.$Uc{constructor(y,k,d,m){super(),this.c=y,this.f=d,this.g=m,this.a=new Map,this.b=this.B(new C.$Tq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new n.$7d);this.B(k.event(d=>{y.fire(d.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(d=>k.fire(d))),this.B(this.b.onDidWatchError(d=>y.fire(d)))}j(y){}m(y){}watch(y,k,d){const m=this.m(this.g);return Array.isArray(m)&&(d.excludes=[...d.excludes,...m]),this.a.set(y,this.b.watch(k,d)),(0,P.$Sc)(()=>{(0,P.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$rs=c}),define(ae[228],ce([0,1,14,180,4,7,16,9,227,157]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=void 0;class b extends u.$qs{constructor(d,m,v){super(d,m),this.M=v}c(d){return c.$kn}f(d,m){return O.URI.revive(m)}async y(d,m,v){if(!v.useTrash)return super.y(d,m,v);const w=this.f(d,m),g=(0,E.$ic)(w.fsPath);try{await n.shell.trashItem(g)}catch{throw(0,j.$1k)(P.$i?(0,C.localize)(0,null,(0,E.$oc)(g)):(0,C.localize)(1,null,(0,E.$oc)(g)),j.FileSystemProviderErrorCode.Unknown)}}L(d,m){return new y(d,m,this.b,this.M)}}e.$lac=b;class y extends u.$rs{watch(d,m,v){if(v.recursive)throw(0,j.$1k)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(d,m,v)}}}),define(ae[229],ce([0,1,5]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_9b=void 0;class C extends n.$Tj{constructor(O=n.$Qj){super(),this.m=[],this.n=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(O){this.n=O;for(const{level:j,message:E}of this.m)(0,n.log)(O,j,E);this.m=[]}g(O,j){this.n?(0,n.log)(this.n,O,j):this.getLevel()<=O&&this.m.push({level:O,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$_9b=C}),define(ae[230],ce([0,1,7,3,5,2]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=void 0;class j extends P.$Yj{constructor(y,k,d,m,v){super(k,d,m),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(w=>{(0,P.$Pj)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(v.listen("onDidChangeVisibility",y)(([w,g])=>super.setVisibility(n.URI.revive(w),g))),this.B(v.listen("onDidChangeLoggers",y)(({added:w,removed:g})=>{for(const f of w)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of g)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new P.$Wj({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,d){return new E(this.t,y,k,d,this.r)}static setLogLevel(y,k,d){return y.call("setLogLevel",[k,d])}}e.$Sr=j;class E extends P.$Tj{constructor(y,k,d,m,v){super(m?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[k,m,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const d=[[y,k]];this.m?this.u(d):this.n.push(...d)}u(y){this.r.call("log",[this.s,y])}}class u{constructor(y,k){this.a=y,this.b=k}listen(y,k){const d=this.b(y);switch(k){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(v=>this.c(v,d)),removed:[...m.removed].map(v=>this.c(v,d))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,m=>[d.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,m=>(0,P.$Pj)(m)?m:[d.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,d){const m=this.b(y);switch(k){case"setLogLevel":return(0,P.$Pj)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,m)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$Tr=u;class c extends O.$Uc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(d=>k.call("setLogLevel",[d]))),k.call("getRegisteredLoggers").then(d=>{for(const m of d)y.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([d,m])=>y.setVisibility(n.URI.revive(d),m))),this.B(k.listen("onDidChangeLoggers")(({added:d,removed:m})=>{for(const v of d)y.registerLogger({...v,resource:n.URI.revive(v.resource)});for(const v of m)y.deregisterLogger(v.resource)}))}}e.$Ur=c}),define(ae[231],ce([0,1,2,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;class P extends n.$Uc{constructor(j,E=[]){super(),this.a=new C.$Xj([j,...E]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...E){this.a.trace(j,...E)}debug(j,...E){this.a.debug(j,...E)}info(j,...E){this.a.info(j,...E)}warn(j,...E){this.a.warn(j,...E)}error(j,...E){this.a.error(j,...E)}flush(){this.a.flush()}}e.$YP=P}),define(ae[232],ce([0,1,31,7,5]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=void 0;class O{constructor(E){this.b=E,this.a=new n.$Bc}listen(E,u,c){switch(u){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(E,u,c){switch(u){case"createLogger":this.c(C.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(C.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$Pj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(C.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:C.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(c[0]))}throw new Error(`Call not found: ${u}`)}c(E,u,c){this.a.set(E,this.b.createLogger(E,u,c))}d(E,u){let c=console.log;switch(E){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...u)}e(E,u){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[b,y]of u)(0,P.log)(c,b,y)}}e.$gbc=O}),define(ae[233],ce([0,1,16,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function O(c,b,y,k,d){try{const m=await new Promise((w,g)=>{J(["@vscode/spdlog"],w,g)});m.setFlushOn(P.Trace);const v=await m.createAsyncRotatingLogger(c,b,y,k);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function j(c,b,y){switch(b){case C.LogLevel.Trace:c.trace(y);break;case C.LogLevel.Debug:c.debug(y);break;case C.LogLevel.Info:c.info(y);break;case C.LogLevel.Warning:c.warn(y);break;case C.LogLevel.Error:c.error(y);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function E(c,b){switch(b){case C.LogLevel.Trace:c.setLevel(P.Trace);break;case C.LogLevel.Debug:c.setLevel(P.Debug);break;case C.LogLevel.Info:c.setLevel(P.Info);break;case C.LogLevel.Warning:c.setLevel(P.Warning);break;case C.LogLevel.Error:c.setLevel(P.Error);break;case C.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends C.$Tj{constructor(b,y,k,d,m){super(),this.m=[],this.setLevel(m),this.n=this.s(b,y,k,d),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(b,y,k,d){const m=k?6:1,v=30/m*n.$jl.MB,w=await O(b,y,v,m,d);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:g,message:f}of this.m)j(this.r,g,f);this.m=[]}}g(b,y){this.r?j(this.r,b,y):this.getLevel()<=b&&this.m.push({level:b,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NP=u}),define(ae[234],ce([0,1,32,5,233]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;class O extends C.$Yj{s(E,u,c){return new P.$NP((0,n.$Dg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$OP=O}),define(ae[67],ce([0,1,31,3,6,5,234]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=e.$S_b=void 0,e.$S_b=(0,P.$ii)(O.$Oj);class E extends j.$OP{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(c,b,y){y!==void 0&&this.u.set(this.n(c),y);try{return super.createLogger(c,b)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,b){b!==void 0&&this.u.set(c.resource,b),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const b=[];for(const y of super.getRegisteredLoggers())c===this.u.get(y.resource)&&b.push(y);return b}getOnDidChangeLogLevelEvent(c){return C.Event.filter(this.onDidChangeLogLevel,b=>(0,O.$Pj)(b)||this.w(b[0],c))}getOnDidChangeVisibilityEvent(c){return C.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,c))}getOnDidChangeLoggersEvent(c){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(k=>this.w(k.resource,c)),removed:[...b.removed].filter(k=>this.w(k.resource,c))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(c){for(const[b,y]of this.u)y===c&&this.deregisterLogger(b)}w(c,b){const y=this.u.get(c);return y===void 0||y===b}dispose(){super.dispose(),this.u.clear()}}e.$T_b=E}),define(ae[235],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=n,e.$zac=C,e.$Aac=P,e.$Bac=O;function n(j){return j.submenu!==void 0}function C(j){return j.id==="vscode.menubar.separator"}function P(j){return j.uri!==void 0}function O(j){return!n(j)&&!C(j)&&!P(j)}}),define(ae[39],ce([0,1,3,71,2,6]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=void 0,e.$2n=(0,O.$hi)("policy");class j extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.j(c),C.Iterable.reduce(this.g.entries(),(y,[k,d])=>({...y,[k]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(c,[b,y])=>({...c,[b]:{definition:y,value:this.g.get(b)}}),{})}}e.$3n=j;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$4n=E}),define(ae[236],ce([0,1,8,3,71,12,16,5,39]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;function c(y,k){const d=[];for(const m of new Set(P.Iterable.concat(y.keys(),k.keys())))y.get(m)!==k.get(m)&&d.push(m);return d}let b=class extends u.$3n{constructor(k,d,m){super(),this.m=k,this.n=d,this.s=m,this.c=this.B(new n.$fh(500));const v=C.Event.filter(d.onDidFilesChange,w=>w.affects(k));this.B(d.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const d=await this.n.readFile(this.m),m=JSON.parse(d.value.toString());if(!(0,O.$Wf)(m))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(m))this.f[v]&&k.set(v,m[v])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return k}async w(){const k=await this.u(),d=c(this.g,k);this.g=k,d.length>0&&this.h.fire(d)}};e.$zbc=b,e.$zbc=b=ve([ne(1,j.$Nk),ne(2,E.$Nj)],b)}),define(ae[237],ce([0,1,3,2,39]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=void 0;class O{constructor(u){this.b=u,this.a=new C.$Tc}listen(u,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,b=>b.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(u,c,b){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$0ac=O;class j extends P.$3n{constructor(u,c){super(),this.a=c;for(const b in u){const{definition:y,value:k}=u[b];this.f[b]=y,k!==void 0&&this.g.set(b,k)}this.a.listen("onDidChange")(b=>{for(const y in b){const k=b[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(b))})}async j(u){const c=await this.a.call("updatePolicyDefinitions",u);for(const b in c)this.g.set(b,c[b])}}e.$$ac=j}),define(ae[238],ce([0,1,39,8,2,5]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;let j=class extends n.$3n{constructor(u,c){super(),this.m=u,this.n=c,this.a=new C.$bh,this.b=this.B(new P.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:c}=await new Promise((b,y)=>{J(["@vscode/policy-watcher"],b,y)});await this.a.queue(()=>new Promise((b,y)=>{try{this.b.value=c(this.n,u,k=>{this.t(k),b()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const c in u){const b=u[c];b===void 0?this.g.delete(c):this.g.set(c,b)}this.h.fire(Object.keys(u))}};e.$ybc=j,e.$ybc=j=ve([ne(0,O.$Nj)],j)}),define(ae[79],ce([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const O=P.context.configuration();if(O)C=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:O.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ae[27],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,n.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"}),define(ae[239],ce([0,1,8,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;let P=class{constructor(j,E,u){this.a=j,this.b=E,this.c=u}async inspect(j){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$ih)(j);const u=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$oac=P,e.$oac=P=ve([ne(2,C.$Nj)],P)}),define(ae[80],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0,e.$B_b=(0,n.$hi)("protocolMainService")}),define(ae[45],ce([0,1,139,12]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class P{constructor(){this.a=new Map}add(j,E){n.ok(C.$Uf(j)),n.ok(C.$Wf(E)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,E)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$Zn=new P}),define(ae[240],ce([0,1,3,45]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function P(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class O{constructor(){this.b=new n.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[P(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new O;C.$Zn.add(e.$1n.JSONContribution,j)}),define(ae[52],ce([0,1,22,3,12,165,18,240,45]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=v,e.$eo=w,e.$fo=g,e.$go=h,e.$ho=$;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$5n={Configuration:"base.contributions.configuration"};var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const y=u.$Zn.as(E.$1n.JSONContribution);class k{constructor(){this.h=new Set,this.i=new C.$7d,this.onDidSchemaChange=this.i.event,this.j=new C.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),y.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const l in i)if(o.add(l),e.$co.test(l)){const p=this.a.get(l),D=p?.valuesSources??new Map;if(s)for(const B of Object.keys(i[l]))D.set(B,s);const I={...p?.value||{},...i[l]};this.a.set(l,{source:s,value:I,valuesSources:D});const S=(0,j.$Xi)(l),R={type:"object",default:I,description:O.localize(1,null,S),$ref:e.$_n,defaultDefaultValue:I,source:P.$Uf(s)?void 0:s,defaultValueSource:s};r.push(...v(l)),this.d[l]=R,this.b.properties[l]=R}else{this.a.set(l,{value:i[l],source:s});const p=this.d[l];p&&(this.w(l,p),this.r(l,p))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const l=this.a.get(s),p=P.$Uf(i)?i:i?.id,D=P.$Uf(l?.source)?l?.source:l?.source?.id;if(p===D)if(o.add(s),this.a.delete(s),e.$co.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,l){s=P.$4f(t.scope)?s:t.scope;const p=t.properties;if(p)for(const I in p){const S=p[I];if(o&&h(I,S)){delete p[I];continue}if(S.source=r,S.defaultDefaultValue=p[I].default,this.w(I,S),e.$co.test(I)?S.scope=void 0:(S.scope=P.$4f(S.scope)?s:S.scope,S.restricted=P.$4f(S.restricted)?!!i?.includes(I):S.restricted),p[I].hasOwnProperty("included")&&!p[I].included){this.f[I]=p[I],delete p[I];continue}else this.d[I]=p[I],p[I].policy?.name&&this.e.set(p[I].policy.name,I);!p[I].deprecationMessage&&p[I].markdownDeprecationMessage&&(p[I].deprecationMessage=p[I].markdownDeprecationMessage),l.add(I)}const D=t.allOf;if(D)for(const I of D)this.p(I,o,r,i,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$6n.properties[t]=o,o.scope){case 1:e.$7n.properties[t]=o;break;case 2:e.$8n.properties[t]=o;break;case 6:e.$9n.properties[t]=o;break;case 3:e.$0n.properties[t]=o;break;case 4:e.$$n.properties[t]=o;break;case 5:e.$$n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$6n.properties[t],o.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$_n};this.w(o,r),e.$6n.properties[o]=r,e.$7n.properties[o]=r,e.$8n.properties[o]=r,e.$9n.properties[o]=r,e.$0n.properties[o]=r,e.$$n.properties[o]=r}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;P.$2f(i)&&(i=o.defaultDefaultValue,s=void 0),P.$2f(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.$bo=`^(${d})+$`,e.$co=new RegExp(e.$bo);function v(a){const t=[];if(e.$co.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function g(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;u.$Zn.add(e.$5n.Configuration,f);function h(a,t){return a.trim()?e.$co.test(a)?O.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function $(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(ae[123],ce([0,1,22,3,42,2,31,35,12,7,18,52,45]),function(J,e,n,C,P,O,j,E,u,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=h;function d(o){return Object.isFrozen(o)?o:E.$On(o)}class m{constructor(r={},i=[],s=[],l){this.b=r,this.c=i,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new v("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$Vi)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return d(s.rawConfiguration.getValue(r))},get override(){return i?d(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return d(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:p,identifiers:D,keys:I}of s.rawConfiguration.overrides){const S=new m(p,I).getValue(r);S!==void 0&&l.push({identifiers:D,value:S})}return l.length?d(l):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,b.$Vi)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$Nn(this.contents),s=E.$Nn(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const D of r)if(p.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(i,D.contents);for(const I of D.overrides){const[S]=s.filter(R=>n.$ub(R.identifiers,I.identifiers));S?(this.h(S.contents,I.contents),S.keys.push(...I.keys),S.keys=n.$Mb(S.keys)):s.push(E.$Nn(I))}for(const I of D.keys)l.indexOf(I)===-1&&l.push(I)}return new m(i,l,s,p.every(D=>D instanceof m)?void 0:p)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[l];const D=i[l];D&&(typeof p=="object"&&typeof D=="object"?(p=E.$Nn(p),this.h(p,D)):p=D),s[l]=p}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&u.$Wf(r[s])&&u.$Wf(i[s])){this.h(r[s],i[s]);continue}r[s]=E.$Nn(i[s])}}i(r){let i=null,s=null;const l=p=>{p&&(s?this.h(s,p):s=E.$Nn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&l(p.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$Ui)(this.contents,r),y.$co.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,y.$do)(r))),1))}j(r,i,s){(0,b.$Ti)(this.contents,r,i,l=>console.error(l)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),y.$co.test(r)&&this.overrides.push({identifiers:(0,y.$do)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$Si)(this.contents[r],l=>console.error(l))})}}e.$io=m;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!u.$4f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:l,overrides:p,restricted:D,hasExcludedProperties:I}=this.h(r,i);this.b=new m(s,l,p,I?[r]:void 0),this.c=D||[]}g(r){let i={},s=null,l=[];const p=[],D=[];function I(R){Array.isArray(l)?l.push(R):s!==null&&(l[s]=R)}const S={onObjectBegin:()=>{const R={};I(R),p.push(l),l=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const R=[];I(R),p.push(l),l=R,s=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:I,onError:(R,B,L)=>{D.push({error:R,offset:B,length:L})}};if(r)try{P.$Bn(r,S),i=l[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(r,i){const s=k.$Zn.as(y.$5n.Configuration).getConfigurationProperties(),l=this.i(r,s,!0,i);r=l.raw;const p=(0,b.$Si)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(r),I=this.j(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:p,keys:D,overrides:I,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,s,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const D={},I=[];for(const S in r)if(y.$co.test(S)&&s){const R=this.i(r[S],i,!1,l);D[S]=R.raw,p=p||R.hasExcludedProperties,I.push(...R.restricted)}else{const R=i[S],B=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&I.push(S),!l.exclude?.includes(S)&&(l.include?.includes(S)||(B===void 0||l.scopes===void 0||l.scopes.includes(B))&&!(l.skipRestricted&&R?.restricted))?D[S]=r[S]:p=!0}return{raw:D,restricted:I,hasExcludedProperties:p}}j(r,i){const s=[];for(const l of Object.keys(r))if(y.$co.test(l)){const p={};for(const D in r[l])p[D]=r[l][D];s.push({identifiers:(0,y.$do)(l),keys:Object.keys(p),contents:(0,b.$Si)(p,i)})}return s}}e.$jo=v;class w extends O.$Uc{constructor(r,i,s,l){super(),this.c=r,this.f=i,this.g=l,this.b=this.B(new C.$7d),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&s.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=w;class g{constructor(r,i,s,l,p,D,I,S,R,B,L,W,U){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=l,this.d=p,this.f=D,this.g=I,this.h=S,this.i=R,this.j=B,this.k=L,this.l=W,this.m=U}get value(){return d(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,l,p=new m,D=new m,I=new j.$Bc,S=new m,R=new j.$Bc){this.c=r,this.d=i,this.f=s,this.g=l,this.h=p,this.i=D,this.j=I,this.l=S,this.m=R,this.a=null,this.b=new j.$Bc,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new m,this.m.set(s.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const l=this.p(r,i,s),p=this.t(i.resource,s),D=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const S of l.overrides)for(const R of S.identifiers)l.getOverrideValue(r,R)!==void 0&&I.add(R);return new g(r,i,l.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,p||void 0,D)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:l,updated:p,removed:D}=a(this.c,r);i=[...l,...p,...D]}for(const l of i)for(const p of(0,y.$do)(l)){const D=this.c.getKeysForOverrideIdentifier(p),I=r.getKeysForOverrideIdentifier(p),S=[...I.filter(R=>D.indexOf(R)===-1),...D.filter(R=>I.indexOf(R)===-1),...D.filter(R=>!E.$Rn(this.c.override(p).getValue(R),r.override(p).getValue(R)))];s.push([p,S])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:l}=a(this.d,r),p=[...i,...s,...l];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.applicationConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.localUserConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.remoteUserConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:l,overrides:p}=a(this.workspaceConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:l,updated:p,removed:D,overrides:I}=a(s,i),S=[...l,...p,...D];return(S.length||!s)&&this.updateFolderConfiguration(r,i),{keys:S,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:l,removed:p,overrides:D}=a(i,void 0);return{keys:[...s,...l,...p],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let l=this.q(i,s);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},i){let s=this.r();if(i&&r){const l=i.getFolder(r);l&&(s=this.s(l.uri)||s);const p=this.m.get(r);p&&(s=s.merge(p))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),l=this.j.get(r);l?(i=s.merge(l),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:l,keys:p}=this.j.get(i);return r.push([i,{contents:s,overrides:l,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),l=this.w(r.application),p=this.w(r.user),D=this.w(r.workspace),I=r.folders.reduce((S,R)=>(S.set(c.URI.revive(R[0]),this.w(R[1])),S),new j.$Bc);return new f(i,s,l,p,new m,D,I,new m,new j.$Bc)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$lo=f;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const l of o)l.keys.forEach(p=>r.add(p)),l.overrides.forEach(([p,D])=>{const I=(0,j.$yc)(i,p,new Set);D.forEach(S=>I.add(S))});const s=[];return i.forEach((l,p)=>s.push([p,[...l.values()]])),{keys:[...r.values()],overrides:s}}class ${constructor(r,i,s,l){this.change=r,this.f=i,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const D of p)this.affectedKeys.add(D);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,l=this.d.indexOf(s);if(l<0)return!1;const p=l+s.length;if(p>=this.d.length)return!1;const D=this.d.charCodeAt(p);if(D!==this.b&&D!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,S=this.g.getValue(r,i,this.h);return!E.$Rn(I,S)}return!0}}e.$no=$;function a(o,r){const{added:i,removed:s,updated:l}=t(r?.rawConfiguration,o?.rawConfiguration),p=[],D=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const S=I.filter(R=>!D.includes(R));for(const R of S)p.push([R,r.getKeysForOverrideIdentifier(R)])}if(o){const S=D.filter(R=>!I.includes(R));for(const R of S)p.push([R,o.getKeysForOverrideIdentifier(R)])}if(r&&o){for(const S of D)if(I.includes(S)){const R=t({contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});p.push([S,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:s,updated:l,overrides:p}}function t(o,r){const i=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],s=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],l=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const D=(0,b.$Vi)(r.contents,p),I=(0,b.$Vi)(o.contents,p);E.$Rn(D,I)||l.push(p)}}return{added:i,removed:s,updated:l}}}),define(ae[241],ce([0,1,22,3,2,35,12,123,52,5,39,45]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0;class k extends P.$Uc{constructor(){super(...arguments),this.a=this.B(new C.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$Zn.as(u.$5n.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:g})=>this.c(Array.from(w),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,g){this.h(w,y.$Zn.as(u.$5n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new E.$io;const w=y.$Zn.as(u.$5n.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,g){const f=this.f();for(const h of w){const $=f[h],a=g[h];$!==void 0?this.b.addValue(h,$):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$oo=k;class d{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new E.$io}async initialize(){return this.configurationModel}}e.$po=d;let m=class extends P.$Uc{get configurationModel(){return this.b}constructor(w,g,f){super(),this.c=w,this.f=g,this.g=f,this.a=this.B(new C.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const g={},f=[],h=y.$Zn.as(u.$5n.Configuration).getConfigurationProperties();for(const $ of w){const a=h[$];if(!a){f.push($);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push($),g[a.policy.name]={type:a.type}}}return(0,j.$8f)(g)||await this.f.updatePolicyDefinitions(g),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const g=y.$Zn.as(u.$5n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(w.map(h=>g.get(h)));this.m(f,!0)}m(w,g){this.g.trace("PolicyConfiguration#update",w);const f=y.$Zn.as(u.$5n.Configuration).getConfigurationProperties(),h=[],$=this.b.isEmpty();for(const a of w){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);($?o!==void 0:!(0,O.$Rn)(this.b.getValue(a),o))&&h.push([a,o])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=new E.$io;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of h)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);g&&this.a.fire(this.b)}}};e.$qo=m,e.$qo=m=ve([ne(1,b.$2n),ne(2,c.$Nj)],m)}),define(ae[242],ce([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,241,39]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0;class g extends u.$Uc{constructor($,a,t,o){super(),this.m=$,this.h=this.B(new O.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$oo),this.c=t instanceof w.$4n?new v.$po:this.B(new v.$qo(this.b,t,o)),this.f=this.B(new d.$ko(this.m,{},y.$Lg,a)),this.a=new d.$lo(this.b.configurationModel,this.c.configurationModel,new d.$io,new d.$io),this.j=new f($,a,this),this.g=this.B(new C.$th(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$lo($,a,new d.$io,t)}getConfigurationData(){return this.a.toData()}getValue($,a){const t=typeof $=="string"?$:void 0,o=(0,k.$Oi)($)?$:(0,k.$Oi)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue($,a,t,o,r){const i=(0,k.$Pi)(t)?t:(0,k.$Oi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${$} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const l=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(l.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,c.$Rn)(a,l.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const D=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(S=>(0,n.$ub)([...S.identifiers].sort(),D));I&&(i.overrideIdentifiers=I.identifiers)}const p=i?.overrideIdentifiers?.length?[(0,m.$eo)(i.overrideIdentifiers),$]:[$];await this.j.write(p,a),await this.reloadConfiguration()}inspect($,a={}){return this.a.inspect($,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.n($)}n($){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration($);this.t(t,a,2)}r($,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration($,a);this.t(o,t,7)}s($){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration($);this.t(t,a,7)}t($,a,t){const o=new d.$no($,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$ro=g;class f{constructor($,a,t){this.b=$,this.c=a,this.d=t,this.a=new C.$oh}write($,a){return this.a.queue(()=>this.e($,a))}async e($,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,j.$un)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,$,a);t=(0,E.$Mn)(t,r),await this.c.writeFile(this.b,P.$ue.fromString(t))}f($,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$Jn)($,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let $=b.OS===3||b.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&($=a),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[243],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=e.$lbc=void 0,e.$lbc="request",e.$mbc="remoteResourceHandler";class n{async routeCall(P,O,j){if(O!==e.$lbc)throw new Error(`Call not found: ${O}`);const E=j[0];if(E?.authority){const u=P.connections.find(c=>c.ctx===E.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(P,O){throw new Error(`Event not found: ${O}`)}}e.$nbc=n}),define(ae[244],ce([0,1,15,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=c,e.$sl=(0,C.$hi)("remoteAuthorityResolverService");var P;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=O;class j{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=j;var E;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class u extends n.$bb{static isNotAvailable(y){return y instanceof u&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof u&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof u&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof u&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof u&&y.isHandled}constructor(y,k=E.Unknown,d){super(y),this._message=y,this._code=k,this._detail=d,this.isHandled=k===E.NotAvailable&&d===!0,Object.setPrototypeOf(this,u.prototype)}}e.$vl=u;function c(b){const y=b.indexOf("+");return y===-1?b:b.substring(0,y)}}),define(ae[245],ce([0,1,8,17,23,15,3,2,13,66,72,32,113,244]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=D,e.$Cl=I,e.$Dl=R;const m=30*1e3;var v;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function w(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(X){const A=new P.$ee;return setTimeout(()=>A.cancel(),X),A.token}function f(X,A){if(X.isCancellationRequested||A.isCancellationRequested)return P.CancellationToken.Cancelled;const F=new P.$ee;return X.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$ah)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function $(X,A){const F=new h(A);return F.registerDisposable(X.onControlMessage(_=>{const re=JSON.parse(_.toString()),K=M(re);K?F.reject(K):F.resolve(re)})),F.promise}function a(X,A,F,_,re,K,V,H){const T=new h(H),Q=b.$3d.create(!1);return X.info(`Creating a socket (${V})...`),c.mark(`code/willCreateSocket/${K}`),A.connect(F,_,re,V).then(te=>{T.didTimeout?(c.mark(`code/didCreateSocketError/${K}`),X.info(`Creating a socket (${V}) finished after ${Q.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(c.mark(`code/didCreateSocketOK/${K}`),X.info(`Creating a socket (${V}) was successful after ${Q.elapsed()} ms.`),T.resolve(te))},te=>{c.mark(`code/didCreateSocketError/${K}`),X.info(`Creating a socket (${V}) returned an error after ${Q.elapsed()} ms.`),X.error(te),T.reject(te)}),T.promise}function t(X,A){const F=new h(A);return X.then(_=>{F.didTimeout||F.resolve(_)},_=>{F.didTimeout||F.reject(_)}),F.promise}async function o(X,A,F,_){const re=oe(X,A);X.logService.trace(`${re} 1/6. invoking socketFactory.connect().`);let K;try{K=await a(X.logService,X.remoteSocketFactoryService,X.connectTo,u.$ug.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,w(A),`renderer-${w(A)}-${X.reconnectionToken}`,_)}catch(te){throw X.logService.error(`${re} socketFactory.connect() failed or timed out. Error:`),X.logService.error(te),te}X.logService.trace(`${re} 2/6. socketFactory.connect() was successful.`);let V,H;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(K,null),V=X.reconnectionProtocol,H=!1):(V=new k.$8h({socket:K}),H=!0),X.logService.trace(`${re} 3/6. sending AuthRequest control message.`);const T=await t(X.signService.createNewMessage((0,y.$Dg)()),_),Q={type:"auth",auth:X.connectionToken||"00000000000000000000",data:T.data};V.sendControl(C.$ue.fromString(JSON.stringify(Q)));try{const te=await $(V,f(_,g(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(X.logService.trace(`${re} 4/6. received SignRequest control message.`),!await t(X.signService.validate(T,te.signedData),_)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await t(X.signService.sign(te.data),_),ke={type:"connectionType",commit:X.commit,signedData:me,desiredConnectionType:A};return F&&(ke.args=F),X.logService.trace(`${re} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(C.$ue.fromString(JSON.stringify(ke))),{protocol:V,ownsProtocol:H}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(X.logService.error(`${re} the handshake timed out. Error:`),X.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${re} received error control message when negotiating connection. Error:`),X.logService.error(te)),H&&q(V),te}}async function r(X,A,F,_){const re=Date.now(),K=oe(X,A),{protocol:V,ownsProtocol:H}=await o(X,A,F,_),T=new h(_);return T.registerDisposable(V.onControlMessage(Q=>{const te=JSON.parse(Q.toString()),fe=M(te);fe?(X.logService.error(`${K} received error control message when negotiating connection. Error:`),X.logService.error(fe),H&&q(V),T.reject(fe)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${he(re)}!`),T.resolve({protocol:V,firstMessage:te}))})),T.promise}async function i(X,A){const{protocol:F}=await r(X,1,void 0,A);return{protocol:F}}async function s(X,A,F){const{protocol:_,firstMessage:re}=await r(X,2,A,F),K=re&&re.debugPort;return{protocol:_,debugPort:K}}async function l(X,A,F){const _=Date.now(),re=oe(X,3),{protocol:K}=await o(X,3,A,F);return X.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${he(_)}!`),K}async function p(X,A,F){const{connectTo:_,connectionToken:re}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:_,connectionToken:re,reconnectionToken:A,reconnectionProtocol:F,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function D(X,A,F){return S(X,async _=>{const{protocol:re}=await i(_,P.CancellationToken.None);return new Y(X,A,F,_.reconnectionToken,re)})}async function I(X,A){return S(X,async F=>{const{protocol:_,debugPort:re}=await s(F,A,P.CancellationToken.None);return new Z(X,A,F.reconnectionToken,_,re)})}async function S(X,A){for(let _=1;;_++)try{const re=(0,y.$Dg)(),K=await p(X,re,null);return await A(K)}catch(re){if(_<5)X.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(re);else throw X.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(re),ue.triggerPermanentFailure(0,0,d.$vl.isHandled(re)),re}}async function R(X,A,F){const _=await p(X,(0,y.$Dg)(),null);return await l(_,{host:A,port:F},P.CancellationToken.None)}function B(X){return(0,n.$7g)(A=>new Promise((F,_)=>{const re=setTimeout(F,X*1e3);A.onCancellationRequested(()=>{clearTimeout(re),F()})}))}var L;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class W{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.$El=W;class U{constructor(A,F,_,re){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=_,this.c=re,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=U;class x{constructor(A,F,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=2}}e.$Gl=x;class le{constructor(A,F,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=4}}e.$Hl=le;class se{constructor(A,F,_,re){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=_,this.handled=re,this.type=3}}e.$Il=se;class ue extends E.$Uc{static triggerPermanentFailure(A,F,_){this._permanentFailure=!0,this.f=A,this.g=F,this.h=_,this.j.forEach(re=>re.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(A,F,_,re,K){super(),this.t=A,this.u=F,this.reconnectionToken=_,this.protocol=re,this.w=K,this.m=this.B(new j.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(re.onSocketClose(V=>{const H=z(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${H} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${H} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${H} received socket close event.`),this.y()})),this.B(re.onSocketTimeout(V=>{const H=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,E.$Sc)(()=>{const V=ue.j.indexOf(this);V>=0&&ue.j.splice(V,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const re=_<F.length?F[_]:F[F.length-1];try{if(re>0){const V=B(re);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re,V)),this.u.logService.info(`${A} waiting for ${re} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const K=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${K.connectTo}...`),await this.G(K,g(m)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(d.$vl.isTemporarilyNotAvailable(K)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,O.$4)(K)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof d.$vl){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,d.$vl.isHandled(K));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,F,_){this.w?ue.triggerPermanentFailure(A,F,_):this.D(A,F,_)}D(A,F,_){this.m.fire(new se(this.reconnectionToken,A,F,_)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=ue;class Y extends ue{constructor(A,F,_,re,K){super(1,A,re,K,!0),this.client=this.B(new k.$6h(K,{remoteAuthority:F,clientId:_},A.ipcLogger))}async G(A,F){await i(A,F)}}e.$Kl=Y;class Z extends ue{constructor(A,F,_,re,K){super(2,A,_,re,!1),this.H=F,this.debugPort=K}async G(A,F){await s(A,this.H,F)}}e.$Ll=Z;function q(X){try{X.acceptDisconnect();const A=X.getSocket();X.dispose(),A.dispose()}catch(A){(0,O.$1)(A)}}function M(X){if(X&&X.type==="error"){const A=new Error(`Connection error: ${X.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function N(X,A){for(;X.length<A;)X+=" ";return X}function G(X,A){return`[remote-connection][${N(w(X),13)}][${A.substr(0,5)}\u2026]`}function z(X,A,F){return`${G(X,A)}[${F?"reconnect":"initial"}]`}function oe(X,A){return`${z(A,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function he(X){return`${Date.now()-X} ms`}}),define(ae[68],ce([0,1,13]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=C,e.$tm=P,e.$um=O,e.$vm=j;function C(u){return u.scheme===n.Schemas.vscodeRemote?u.authority:void 0}function P(u){if(!u)return;const c=u.indexOf("+");return c<0?u:u.substr(0,c)}function O(u){const{host:c,port:b}=E(u);if(typeof b>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:b}}function j(u,c){let{host:b,port:y}=E(u);return typeof y>"u"&&(y=c),{host:b,port:y}}function E(u){const c=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const b=u.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=u.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:u,port:void 0}}}),define(ae[124],ce([0,1,25,6,68]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=O,e.$Fm=y,e.$Gm=k,e.$Hm=d,e.$Im=m,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function O(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(j||(e.ExtensionType=j={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,g){if(typeof w>"u"||w===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof w=="string"||typeof g=="string"){const f=typeof w=="string"?w:w.value,h=typeof g=="string"?g:g.value;return n.$lf(f,h)}return w._lower===g._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Cm=u;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const g of w)this.add(g)}add(w){this.c.add(u.toKey(w))}delete(w){return this.c.delete(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}}e.$Dm=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(u.toKey(w))}get(w){return this.c.get(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}set(w,g){this.c.set(u.toKey(w),g)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=b;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function m(v,w){if(w){const g=`onResolveRemoteAuthority:${(0,P.$tm)(w)}`;return!!v.activationEvents?.includes(g)}return!1}e.$Jm=(0,C.$hi)("IBuiltinExtensionsScannerService")}),define(ae[246],ce([0,1,2,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,C.$hi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(j,E){return this.a[j]??=[],this.a[j].push(E),(0,n.$Sc)(()=>{const u=this.a[j]?.indexOf(E);typeof u=="number"&&u>=0&&this.a[j]?.splice(u,1)})}b(j){return(this.a[j.type]||[]).find(u=>u.supports(j))}connect(j,E,u,c){const b=this.b(j);if(!b)throw new Error(`No socket factory found for ${j}`);return b.connect(j,E,u,c)}}e.$yl=P}),define(ae[247],ce([0,1,26,48,21,117]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=E;let j;async function E(d=!1){return(j===void 0||d)&&(j=u()),j}async function u(){const d=c();if(d===void 0)return!1;if(d>=22e3){const m=y();if(m)return new Promise(v=>{C.execFile(m,["--status"],w=>v(!w))})}else{const m=k();if(m)try{if((await P.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(d)return parseInt(d[3])}function b(d){const m=process.env.SystemRoot;if(m){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(m,v?"Sysnative":"System32",d)}}function y(){return b("wsl.exe")}function k(){return b("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,15,2,186,52,6,5,45]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=void 0,e.$Ap=k,e.$Bp=d,e.$Cp=m,e.$Dp=v,e.$Ep=w,e.$Fp=g,e.$yp=(0,E.$hi)("requestService");class b{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends P.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,O.localize)(0,null),when:u.$6j.isEqualTo((0,u.$3j)(u.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,C.$0)(i)),i}}}e.$zp=y;function k($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function d($){return $.res.statusCode===204}async function m($){return d($)?null:(await(0,n.$Ge)($.stream)).toString()}async function v($){if(!k($))throw new Error("Server returned "+$.res.statusCode);return m($)}async function w($){if(!k($))throw new Error("Server returned "+$.res.statusCode);if(d($))return null;const t=(await(0,n.$Ge)($.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function g($){h($)}let f;function h($){const a=c.$Zn.as(j.$5n.Configuration),t=f;f={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}h(1)}),define(ae[248],ce([0,1,17,23]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class P{constructor(E){this.a=E}listen(E,u){throw new Error("Invalid listen")}call(E,u,c,b=C.CancellationToken.None){switch(u){case"request":return this.a.request(c[0],b).then(async({res:y,stream:k})=>{const d=await(0,n.$Ge)(k);return[{statusCode:y.statusCode,headers:y.headers},d]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Cr=P;class O{constructor(E){this.a=E}async request(E,u){const[c,b]=await this.a.call("request",[E],u);return{res:c,stream:(0,n.$Ie)(b)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Dr=O}),define(ae[249],ce([0,1,250,12]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=O;function P(j,E){return j.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:j.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function O(j,E,u={}){const c=(0,n.parse)(j),b=u.proxyUrl||P(c,E);if(!b)return null;const y=(0,n.parse)(b);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,C.$1f)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,m)=>{J(["http-proxy-agent"],d,m)})).HttpProxyAgent(b,k):new(await new Promise((d,m)=>{J(["https-proxy-agent"],d,m)})).HttpsProxyAgent(b,k)}}),define(ae[251],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=e.$Hac=void 0,e.$Hac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Iac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Jac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[95],ce([0,1,48,9,187,23,51,15,4,32,112,63,8,141]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=v;let m;async function v(g,f,h,$){return h["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$lm)($)&&!h["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$lm)($)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new O.$ee;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.$mm)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,P.localize)(0,null)))},r);try{a(await w(f,o.token))}catch(l){!(0,E.$4)(l)&&!o.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,j.$5i)(l)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}async function w(g,f){const h=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",h);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",$);const a=(0,c.$Dg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,b.$bm)(u.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new E.$5);const l=(0,C.$oc)(r);let p,D;const I="";/^pwsh(-preview)?$/.test(l)?(p=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,D=["-Login","-Command"]):l==="nu"?(p=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,D=["-i","-l","-c"]):l==="xonsh"?(p=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,D=["-i","-l","-c"]):(p=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),p);const S=(0,n.spawn)(r,[...D,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(S.kill(),s(new E.$5))),S.on("error",L=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,j.$5i)(L)),s(L)});const R=[];S.stdout.on("data",L=>R.push(L));const B=[];S.stderr.on("data",L=>B.push(L)),S.on("close",(L,W)=>{const U=Buffer.concat(R).toString("utf8");g.trace("getUnixShellEnvironment#raw",U);const x=Buffer.concat(B).toString("utf8");if(x.trim()&&g.trace("getUnixShellEnvironment#stderr",x),L||W)return s(new Error((0,P.localize)(2,null,L,W)));const le=t.exec(U),se=le?le[1]:"{}";try{const ue=JSON.parse(se);h?ue.ELECTRON_RUN_AS_NODE=h:delete ue.ELECTRON_RUN_AS_NODE,$?ue.ELECTRON_NO_ATTACH_CONSOLE=$:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,j.$5i)(ue)),s(ue)}})})}}),define(ae[252],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const O=await this.c();if(O){const j=String(n.a++);return this.b.set(j,O),{id:j,data:O.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,O){if(!P.id)return!0;const j=this.b.get(P.id);if(!j)return!1;this.b.delete(P.id);try{return j.validate(O)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$B9b=n}),define(ae[96],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,n.$hi)(e.$zl)}),define(ae[253],ce([0,1,252]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class C extends n.$B9b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(j=>new j.signer().sign(O))}h(){return new Promise((O,j)=>J(["vsda"],O,j))}}e.$xbc=C}),define(ae[34],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=void 0,e.$PP=(0,n.$hi)("stateReadService"),e.$QP=(0,n.$hi)("stateService")}),define(ae[125],ce([0,1,8,17,2,12,38,16,5]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=e.$RP=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class b extends P.$Uc{constructor(m,v,w,g){super(),this.h=m,this.j=v,this.m=w,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new n.$fh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,v){const w=this.a[m];return(0,O.$4f)(w)?v:w}setItem(m,v){this.setItems([{key:m,data:v}])}setItems(m){let v=!1;for(const{key:w,data:g}of m)this.a[w]!==g&&((0,O.$4f)(g)?(0,O.$2f)(this.a[w])||(this.a[w]=void 0,v=!0):(this.a[w]=g,v=!0));v&&this.s()}removeItem(m){(0,O.$2f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,C.$ue.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$RP=b;let y=class extends P.$Uc{constructor(m,v,w,g){super(),this.a=this.B(new b(v.stateResource,m,w,g))}async init(){await this.a.init()}getItem(m,v){return this.a.getItem(m,v)}};e.$SP=y,e.$SP=y=ve([ne(1,j.$oi),ne(2,u.$Nj),ne(3,E.$Nk)],y);class k extends y{setItem(m,v){this.a.setItem(m,v)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$TP=k}),define(ae[126],ce([0,1,4,36,32]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=j,e.$2o=E;function O(u){if(n.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,b,y,k,d,m,v,w){const g=Object.create(null);g["common.machineId"]=d,g["common.sqmId"]=m,g.sessionID=(0,P.$Dg)()+Date.now(),g.commitHash=y,g.version=k,g["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,n.$h)(n.$u),g["common.nodePlatform"]=C.$ec,g["common.nodeArch"]=b,g["common.product"]=w||"desktop",v&&(g["common.msftInternal"]=v);let f=0;const h=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&(g["common.snap"]="true");const $=O(c);return $&&(g["common.platformDetail"]=$),g}function E(u){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return u.some(y=>b===y)}}),define(ae[28],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,n.$hi)("telemetryService"),e.$Nl=(0,n.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ae[254],ce([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0,e.$ls=g,e.$ms=h,e.$ns=$;const w=new Map;async function g(t,o){const r=`${t}::${o.join(":")}`,i=w.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,p=new Map,D=2e4;function I(R,B,L,W){const U=B.substring(R.length+1);return C.Promises.withAsyncBody(async x=>{let le;try{le=await b.Promises.readdir(B,{withFileTypes:!0})}catch{x();return}if(W.count>=D){W.count+=le.length,W.maxReached=!0,x();return}let se=le.length;if(se===0){x();return}let ue=le;W.count+le.length>D&&(W.maxReached=!0,se=D-W.count,ue=le.slice(0,se)),W.count+=le.length;for(const Y of ue)if(Y.isDirectory()){if(L.includes(Y.name)||await I(R,(0,j.$kc)(B,Y.name),L,W),--se===0){x();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const q=Y.name.substring(Z+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of s)q.relativePathPattern?.test(U)!==!1&&q.filePattern.test(Y.name)&&p.set(q.tag,(p.get(q.tag)??0)+1);if(--se===0){x();return}}})}const S=C.Promises.withAsyncBody(async R=>{const B={count:0,maxReached:!1};await I(t,t,o,B);const L=await $(t);R({configFiles:f(p),fileTypes:f(l),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:L})});return w.set(r,S),S}function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/d.$jl.GB).toFixed(2)}GB (${(n.freemem()/d.$jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$pn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function $(t){try{const o=new Map,r=(0,j.$kc)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),s=[],l=(0,P.$un)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,P.$Dn)(l)==="object"&&l.configurations)for(const p of l.configurations){const D=p.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return f(o)}catch{return[]}}let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/d.$jl.GB).toFixed(2)}GB (${(n.freemem()/d.$jl.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$pn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,y.$ks)(o.mainPID),this.k(o)]).then(async i=>{let[s,l]=i,p=this.m(o,s);return r.forEach(D=>{if((0,k.$2m)(D))p+=`
${D.errorMessage}`,l+=`
${D.errorMessage}`;else if(p+=`

Remote: ${D.hostName}`,D.processes&&(p+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){l+=`
|  Remote: ${D.hostName}`;for(const I of Object.keys(D.workspaceMetadata)){const S=D.workspaceMetadata[I];let R=`${S.fileCount} files`;S.maxFilesReached&&(R=`more than ${R}`),l+=`|    Folder (${I}): ${R}`,l+=this.h(S)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:l,cpus:p}=h(),D={os:l,memory:i,cpus:p,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(D.load=`${n.loadavg().map(I=>Math.round(I)).join(", ")}`),E.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const i=[];return(0,y.$ks)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(l=>{if((0,k.$2m)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(o,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const D=l.workspaceMetadata[p];let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${p}): ${I}`),i.push(this.h(D))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const l=(S,R)=>{const B=` ${S}(${R})`;s+B.length>60?(r.push(p),p="|                 ",s=p.length):s+=B.length,p+=B};let p="|      File types:";const D=10,I=o.fileTypes.length>D?D:o.fileTypes.length;for(let S=0;S<I;S++){const R=o.fileTypes[S];l(R.name,R.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",s=0,o.configFiles.forEach(S=>{l(S.name,S.count)}),r.push(p)),o.launchConfigFiles.length>0){let S="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{const B=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;S+=B}),r.push(S)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const p=u.URI.revive(l);if(p.scheme===O.Schemas.file){const D=p.fsPath;i.push(g(D,["node_modules",".git"]).then(I=>{let S=`${I.fileCount} files`;I.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,j.$oc)(D)}): ${S}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${I.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:p})=>i.set(l,p));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,l){const p=l===0;let D;p?D=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?D=r.get(s.pid):D=`${"  ".repeat(l)} ${s.name}`;const I=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/d.$jl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(s.children)&&s.children.forEach(S=>this.n(o,r,i,S,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=u.URI.revive(i);if(s.scheme!==O.Schemas.file)continue;const l=s.fsPath;try{(await g(l,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=u.URI.revive(r);if(i.scheme!==O.Schemas.file)continue;const s=i.fsPath;try{const l=await g(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$os=a,e.$os=a=ve([ne(0,v.$Ml),ne(1,m.$7j)],a)}),define(ae[255],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=e.$Mac=void 0;class n{constructor(O){this.b=O}listen(O,j){throw new Error(`Event not found: ${j}`)}call(O,j,{eventName:E,data:u}){return this.b.forEach(c=>c.log(E,u)),Promise.resolve(null)}}e.$Mac=n;class C{constructor(O){this.b=O}log(O,j){return this.b.call("log",{eventName:O,data:j}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Nac=C}),define(ae[54],ce([0,1,35,12,68,126,28]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=b,e.$$o=y,e.$_o=k,e.$ap=d,e.$bp=v,e.$cp=g,e.$dp=f,e.$ep=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$3o=E;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=u,e.$5o=new u;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$6o=c,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(j.$Ul),r=t.getValue(j.$Vl);if(t.getValue(j.$Wl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function d(t){const o={},r={},i={};w(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const l=i[s];typeof l=="number"?r[s]=l:typeof l=="boolean"?r[s]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${l.length}`),o[s]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[s]=l)}return{properties:o,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,P.$tm)(t);return m.has(o)?o:"other"}function w(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const l=t[s],p=i?i+s:s;Array.isArray(l)?o[p]=(0,n.$Sn)(l):l instanceof Date?o[p]=l.toISOString():(0,C.$Wf)(l)?r<2?w(l,o,r+1,p+"."):o[p]=(0,n.$Sn)(l):o[p]=l}}function g(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.$2o)(r)||i}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const D of o)for(;;){const I=D.exec(t);if(!I)break;i.push([I.index,D.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const D=l.exec(t);if(!D)break;const I=i.some(([S,R])=>D.index<R&&S<l.lastIndex);!s.test(D[0])&&!I&&(r+=t.substring(p,D.index)+"<REDACTED: user-file-path>",p=l.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function $(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$Pn)(t,r=>{if(r instanceof E||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=h(i,o);for(const s of o)i=i.replace(s,"");return i=$(i),i}})}}),define(ae[127],ce([0,1,25,121,124,4,7,15,36,54]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=b,e.$hp=m,e.$ip=v,e.$jp=w,e.$kp=g,e.$lp=f,e.$mp=h,e.$np=$,e.$pp=a,e.$qp=o;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$gf)(r.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,l)}static parse(i){const s=y.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$gp=k;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=d.exec(r);return i&&i[1]?[w(i[1]),i[2]]:[w(r),void 0]}function v(r,i){return`${r}.${i}`}function w(r){return r.toLowerCase()}function g(r,i){return w(v(r??P.$ym,i))}function f(r,i){const s=[],l=p=>{for(const D of s)if(D.some(I=>b(i(I),i(p))))return D;return null};for(const p of r){const D=l(p);D?D.push(p):s.push([p])}return s}function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function $(r){return{id:new c.$3o(r.identifier.id),name:new c.$3o(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$op=new P.$Cm("pprice.better-merge");function a(r,i){const s=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const p=l.shift();if(p&&s.every(D=>!b(D.identifier,{id:p}))){const D=r.filter(I=>b(I.identifier,{id:p}));D.length===1&&(s.push(D[0]),l.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,E.$0)(p))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),l=(0,C.$Mo)(s?"alpine":O.$u,u.$fc);return i.debug("ComputeTargetPlatform:",l),l}}),define(ae[256],ce([0,1,209,54]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=P;async function P(O,j,E,u,c,b,y){const k={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${j.nameShort})`};if((0,C.$0o)(j,E)&&(0,C.$_o)(u)===3){const d=await(0,n.$Rp)(E,c,b);k["X-Market-User-Id"]=d,k["VSCode-SessionId"]=y.machineId||d}return k}}),define(ae[257],ce([0,1,2,35,4,25,188,18,52,79,27,45,28,54]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,f,h){this.k=f,this.l=h,this.d={},this.i=new n.$Tc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,O.$Ze)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$Ze)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(k.$Ul)||$.affectsConfiguration(k.$Wl)||$.affectsConfiguration(k.$Vl))&&this.m()}))}setExperimentProperty(g,f){this.d[g]=f}m(){let g=(0,d.$_o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;g=Math.min(g,h)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,f,h){this.g<f||(h=(0,C.$Qn)(h,this.d),h=(0,d.$ep)(h,this.j),h=(0,C.$Qn)(h,this.c),this.b.forEach($=>$.log(g,h)))}publicLog(g,f){this.n(g,3,f)}publicLog2(g,f){this.publicLog(g,f)}publicLogError(g,f){this.h&&this.n(g,2,f)}publicLogError2(g,f){this.publicLogError(g,f)}};e.$Hr=m,e.$Hr=m=ve([ne(1,E.$Ni),ne(2,b.$7j)],m);function v(){const w=(0,j.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.$o?"":(0,j.localize)(3,null),h=(0,j.localize)(4,null),$=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),o=`
|       | ${h} | ${$} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,j.localize)(8,null);return`
${w} ${g} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}y.$Zn.as(u.$5n.Configuration).registerConfiguration({id:k.$Tl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[k.$Ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$Zn.as(u.$5n.Configuration).registerConfiguration({id:k.$Tl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[k.$Wl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${k.$Ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[258],ce([0,1,4,89,28]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=O,e.$dbc=j;async function O(E,u){let c=E.getItem(P.$Rl);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,C.$qn)(u.error.bind(u))),c}async function j(E,u){let c=E.getItem(P.$Sl);return typeof c!="string"&&(c=await(0,C.$rn)(u.error.bind(u))),c}}),define(ae[259],ce([0,1,28,258]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=P,e.$fbc=O;async function P(j,E){const u=await(0,C.$cbc)(j,E);return j.setItem(n.$Rl,u),u}async function O(j,E){const u=await(0,C.$dbc)(j,E);return j.setItem(n.$Sl,u),u}}),define(ae[128],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ae[260],ce([0,1,4,128]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0;const P=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((y,k)=>{this.d(y,k);const d=y.map.entries();let m=d.next();for(;!m.done;){const v=m.value[1],w=m.value[0];let g=this.a.get(w);if(g||(g=[],this.a.set(w,g)),g.length>0&&g[0].type===C.EnvironmentVariableMutatorType.Replace){m=d.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,g.unshift(f),m=d.next()}})}async applyToProcessEnvironment(b,y,k){let d;n.$i&&(d={},Object.keys(b).forEach(m=>d[m.toLowerCase()]=m));for(const[m,v]of this.getVariableMap(y)){const w=n.$i&&d[m.toLowerCase()]||m;for(const g of v){const f=k?await k(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case C.EnvironmentVariableMutatorType.Append:b[w]=(b[w]||"")+f;break;case C.EnvironmentVariableMutatorType.Prepend:b[w]=f+(b[w]||"");break;case C.EnvironmentVariableMutatorType.Replace:b[w]=f;break}if(g.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${P.get(g.type)}`;b[h]=(b[h]?b[h]+":":"")+m+"="+this.c(f)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,y){const k=new Map,d=new Map,m=new Map;if(b.getVariableMap(y).forEach((v,w)=>{const g=this.getVariableMap(y).get(w),f=E(v,g);f&&k.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const g=b.getVariableMap(y).get(w),f=E(v,g);f&&m.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const g=b.getVariableMap(y).get(w),f=u(v,g);f&&d.set(w,f)}),!(k.size===0&&d.size===0&&m.size===0))return{added:k,changed:d,removed:m}}getVariableMap(b){const y=new Map;for(const k of this.a.values()){const d=k.filter(m=>j(m,b));d.length>0&&y.set(d[0].variable,d)}return y}getDescriptionMap(b){const y=new Map;for(const k of this.b.values()){const d=k.filter(m=>j(m,b,!0));for(const m of d)y.set(m.extensionIdentifier,m.description)}return y}d(b,y){if(!b.descriptionMap)return;const k=b.descriptionMap.entries();let d=k.next();for(;!d.done;){const m=d.value[1],v=d.value[0];let w=this.b.get(v);w||(w=[],this.b.set(v,w));const g={extensionIdentifier:y,scope:m.scope,description:m.description};g.scope||delete g.scope,w.push(g),d=k.next()}}}e.$$r=O;function j(c,b,y=!1){return c.scope?!!(c.scope.workspaceFolder&&b?.workspaceFolder&&c.scope.workspaceFolder.index===b.workspaceFolder.index):y?b===c.scope:!0}function E(c,b){if(!b)return c;const y=new Set;b.forEach(d=>y.add(d.extensionIdentifier));const k=[];return c.forEach(d=>{y.has(d.extensionIdentifier)||k.push(d)}),k.length===0?void 0:k}function u(c,b){if(!b)return;const y=new Map;b.forEach(d=>y.set(d.extensionIdentifier,d));const k=[];return c.forEach(d=>{const m=y.get(d.extensionIdentifier);m&&(d.type!==m.type||d.value!==m.value||d.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(ae[261],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=n,e.$6r=C,e.$7r=P,e.$8r=O,e.$9r=j,e.$0r=E;function n(u){return[...u.entries()]}function C(u){return u?[...u.entries()]:[]}function P(u){return new Map(u)}function O(u){return new Map(u??[])}function j(u){return Array.from(u.entries()).map(c=>[c[0],n(c[1].map),C(c[1].descriptionMap)])}function E(u){return new Map(u.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}}),define(ae[262],ce([0,1,8,23,3,2,5]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0;let E=class extends O.$Uc{constructor(c,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$7d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,O.$Sc)(()=>{for(const y of this.f.values())(0,O.$Pc)(y)}))}createRequest(c){return new Promise((b,y)=>{const k=++this.a;this.c.set(k,b),this.g.fire({requestId:k,...c});const d=new C.$ee;(0,n.$ih)(this.b,d.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,O.$Sc)(()=>d.cancel())])})}acceptReply(c,b){const y=this.c.get(c);y?(this.c.delete(c),(0,O.$Pc)(this.f.get(c)||[]),this.f.delete(c),y(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Vr=E,e.$Vr=E=ve([ne(1,j.$Nj)],E)}),define(ae[129],ce([0,1,6,118,45]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Or=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Nr=void 0,e.$Nr=new C.$yj("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="workbench.action.terminal.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var u;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(u||(e.WindowsShellType=u={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Or=(0,n.$hi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var d;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$Pr={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$Zn.add(e.$Pr.Backend,new $),e.$Qr=(0,n.$hi)("localPtyService"),e.$Rr=(0,n.$hi)("terminalLogService")}),define(ae[263],ce([0,1,74,7,190,106]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=j,e.$Xr=c,e.$Yr=b,e.$Zr=y;function j(k,d){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...k.map(v=>({name:v.profileName,description:E(v)}))),d&&m.push(...d.map(v=>({name:v.title,description:u(v)}))),{values:m.map(v=>v.name),markdownDescriptions:m.map(v=>v.description)}}function E(k){let d=`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Gj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?d+=`
- args: "${k.args}"`:d+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(d+=`
- overrideName: ${k.overrideName}`),k.color&&(d+=`
- color: ${k.color}`),k.env&&(d+=`
- env: ${JSON.stringify(k.env)}`),d}function u(k){return`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Gj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,d){if(!k&&!d)return!0;if(typeof k=="string"&&typeof d=="string")return k===d;if(Array.isArray(k)&&Array.isArray(d)){if(k.length!==d.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==d[m])return!1;return!0}return!1}function b(k,d){if(!k&&!d)return!0;if(!k||!d)return!1;if(O.ThemeIcon.isThemeIcon(k)&&O.ThemeIcon.isThemeIcon(d))return k.id===d.id&&k.color===d.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof d=="object"&&"light"in d&&"dark"in d){const m=k,v=d;if((C.URI.isUri(m.light)||y(m.light))&&(C.URI.isUri(m.dark)||y(m.dark))&&(C.URI.isUri(v.light)||y(v.light))&&(C.URI.isUri(v.dark)||y(v.dark)))return m.light.path===v.light.path&&m.dark.path===v.dark.path}if(C.URI.isUri(k)&&C.URI.isUri(d)||y(k)||y(d)){const m=k,v=d;return m.path===v.path&&m.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(ae[264],ce([0,1,74,4,189,52,45,263]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0,e.$3r=d,e.$4r=v,e.$1r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$2r={type:"string",enum:Array.from((0,n.$Ej)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Ej)(),w=>`$(${w.id})`)};const u={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$2r},color:{description:(0,P.localize)(3,null),...e.$1r},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},b={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function y(w){const g=w===2?"linux":w===1?"osx":"windows";return(0,P.localize)(7,null,(0,C.$h)(w),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){j.$Zn.as(O.$5n.Configuration).registerConfiguration(k),v()}let m;function v(w,g){const f=j.$Zn.as(O.$5n.Configuration);let h;w&&(h=(0,E.$Wr)(w?.profiles,g));const $=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?h?.values:void 0,markdownEnumDescriptions:w?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?h?.values:void 0,markdownEnumDescriptions:w?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?h?.values:void 0,markdownEnumDescriptions:w?.os===1?h?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:$?[$]:[]})}}),define(ae[265],ce([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=m,e.$as=v,e.$bs=w;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}async function v(i,s,l,p=E.env,D=b.Promises.exists){if(O.$jc(i))return await D(i)?i:void 0;if(s===void 0&&(s=E.cwd()),O.$nc(i)!=="."){const B=O.$kc(s,i);return await D(B)?B:void 0}const S=(0,P.$Un)(p,"PATH");if(l===void 0&&(0,c.$Uf)(S)&&(l=S.split(O.$uc)),l===void 0||l.length===0){const B=O.$kc(s,i);return await D(B)?B:void 0}for(const B of l){let L;if(O.$jc(B)?L=O.$kc(B,i):L=O.$kc(s,B,i),await D(L))return L;if(j.$i){let W=L+".com";if(await D(W)||(W=L+".exe",await D(W)))return W}}const R=O.$kc(s,i);return await D(R)?R:void 0}function w(i,s,l,p,D){const I=j.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.hideFromUser||i.ignoreShellIntegration||I)return;const S=i.args,R=E.$ec==="win32"?O.$oc(i.executable).toLowerCase():O.$oc(i.executable),B=O.$nc(C.$Bg.asFileUri("").fsPath);let L;const W={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(W.VSCODE_NONCE=s.shellIntegration.nonce),j.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!S||o(S)?L=h.get(f.WindowsPwsh):t(S)&&(L=h.get(f.WindowsPwshLogin)),L?(L=[...L],L[L.length-1]=(0,u.$Ve)(L[L.length-1],B,""),s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:L,envMixin:W}):void 0;p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!S||S.length===0?L=h.get(f.Bash):r(S)&&(W.VSCODE_SHELL_LOGIN="1",g(s,W),L=h.get(f.Bash)),L?(L=[...L],L[L.length-1]=(0,u.$Ve)(L[L.length-1],B),{newArgs:L,envMixin:W}):void 0;case"fish":{const U=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=O.$kc(B,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${U}:${x}`,g(s,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!S||o(S)?L=h.get(f.Pwsh):t(S)&&(L=h.get(f.PwshLogin)),L?(s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),L=[...L],L[L.length-1]=(0,u.$Ve)(L[L.length-1],B,""),{newArgs:L,envMixin:W}):void 0;case"zsh":{if(!S||S.length===0?L=h.get(f.Zsh):r(S)?(L=h.get(f.ZshLogin),g(s,W)):(S===h.get(f.Zsh)||S===h.get(f.ZshLogin))&&(L=S),!L)return;L=[...L],L[L.length-1]=(0,u.$Ve)(L[L.length-1],B);let U;try{U=n.userInfo().username}catch{U="unknown"}const x=O.$kc(n.tmpdir(),`${U}-${D.applicationName}-zsh`);W.ZDOTDIR=x;const le=l?.ZDOTDIR??n.homedir()??"~";W.USER_ZDOTDIR=le;const se=[];return se.push({source:O.$kc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$kc(x,".zshrc")}),se.push({source:O.$kc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$kc(x,".zprofile")}),se.push({source:O.$kc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$kc(x,".zshenv")}),se.push({source:O.$kc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$kc(x,".zlogin")}),{newArgs:L,envMixin:W,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function g(i,s){if(j.$j&&i.environmentVariableCollections){const l=(0,k.$0r)(i.environmentVariableCollections),D=new d.$$r(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(D)for(const S of D)S.type===y.EnvironmentVariableMutatorType.Prepend&&I.push(S.value);I.length>0&&(s.VSCODE_PATH_PREFIX=I.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const h=new Map;h.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(f.Zsh,["-i"]),h.set(f.ZshLogin,["-il"]),h.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?$.includes(i.toLowerCase()):i.length===1&&$.includes(i[0].toLowerCase())||i.length===2&&($.includes(i[0].toLowerCase())||$.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&$.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&$.includes(i[0].toLowerCase())}}),define(ae[266],ce([0,1,48,74,9,4,12,21,110,265,117]),function(J,e,n,C,P,O,j,E,u,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=m;var y;(function(l){l.UnixShellsPath="/etc/shells"})(y||(y={}));let k,d=!0;function m(l,p,D,I,S=process.env,R,B,L,W){return R=R||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},O.$i?v(D,R,S,B,I.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:I.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:I.getValue("terminal.integrated.defaultProfile.windows"),W,L):r(R,B,D,l&&typeof l=="object"?{...l}:I.getValue(O.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:I.getValue(O.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),W,L,S)}async function v(l,p,D,I,S,R,B,L,W){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let le=!1;(0,c.$_r)()>=16299&&(le=!0),await h(L);const se=new Map;if(l){se.set("PowerShell",{source:"PowerShell",icon:C.$Gj.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Gj.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:C.$Gj.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Gj.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}i(R,se);const ue=await w(se.entries(),B,p,D,I,W);if(l&&S)try{const Y=await t(`${x}\\${le?"wsl":"bash"}.exe`,B);for(const Z of Y)(!R||!(Z.profileName in R))&&ue.push(Z)}catch{d&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return ue}async function w(l,p,D,I=process.env,S,R){const B=[];for(const[L,W]of l)B.push(g(L,W,p,D,I,S,R));return(await Promise.all(B)).filter(L=>!!L)}async function g(l,p,D,I,S=process.env,R,B){if(p===null)return;let L,W,U;if("source"in p&&!("path"in p)){const ue=k?.get(p.source);if(!ue)return;L=ue.paths,W=p.args||ue.args,p.icon?U=f(p.icon):ue.icon&&(U=ue.icon)}else L=Array.isArray(p.path)?p.path:[p.path],W=O.$i||Array.isArray(p.args)?p.args:void 0,U=f(p.icon);let x;if(B){const ue=L.map(Z=>typeof Z=="string"?Z:Z.path),Y=await B(ue);x=new Array(L.length);for(let Z=0;Z<L.length;Z++)typeof L[Z]=="string"?x[Z]=Y[Z]:x[Z]={path:Y[Z],isUnsafe:!0}}else x=L.slice();let le;if(p.requiresPath){let ue;if((0,j.$Uf)(p.requiresPath)?ue=p.requiresPath:(ue=p.requiresPath.path,p.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const se=await s(l,D,x,I,S,W,p.env,p.overrideName,p.isAutoDetected,le);if(!se){R?.debug("Terminal profile not validated",l,L);return}return se.isAutoDetected=p.isAutoDetected,se.icon=U,se.color=p.color,se}function f(l){return typeof l=="string"?{id:l}:l}async function h(l){if(k&&!l)return;const[p,D]=await Promise.all([$(),l||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:D,icon:C.$Gj.terminalPowershell})}async function $(){const l=new Set,p=await(0,c.$as)("git.exe");if(p){const S=(0,b.dirname)(p);l.add((0,b.resolve)(S,"../.."))}function D(S,R){R&&S.add(R)}D(l,process.env.ProgramW6432),D(l,process.env.ProgramFiles),D(l,process.env["ProgramFiles(X86)"]),D(l,`${process.env.LocalAppData}\\Program`);const I=[];for(const S of l)I.push(`${S}\\Git\\bin\\bash.exe`,`${S}\\Git\\usr\\bin\\bash.exe`,`${S}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const l=[];for await(const p of(0,u.$8l)())l.push(p.exePath);return l}async function t(l,p){const D=[],I=await new Promise((B,L)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(W,U)=>{if(W)return L("Problem occurred when getting wsl distros");B(U)})});if(!I)return[];const S=new RegExp(/[\r?\n]/),R=I.split(S).filter(B=>B.trim().length>0&&B!=="");for(const B of R){if(B===""||B.startsWith("docker-desktop"))continue;const L=`${B} (WSL)`,W={profileName:L,path:l,args:["-d",`${B}`],isDefault:L===p,icon:o(B),isAutoDetected:!1};D.push(W)}return D}function o(l){return l.includes("Ubuntu")?C.$Gj.terminalUbuntu:l.includes("Debian")?C.$Gj.terminalDebian:C.$Gj.terminalLinux}async function r(l,p,D,I,S,R,B,L){const W=new Map;if(D&&await l.existsFile("/etc/shells")){const U=(await l.readFile("/etc/shells")).toString(),x=(R||U.split(`
`)).map(se=>{const ue=se.indexOf("#");return ue===-1?se:se.substring(0,ue)}).filter(se=>se.trim().length>0),le=new Map;for(const se of x){let ue=(0,P.$oc)(se),Y=le.get(ue)||0;Y++,Y>1&&(ue=`${ue} (${Y})`),le.set(ue,Y),W.set(ue,{path:se,isAutoDetected:!0})}}return i(I,W),await w(W.entries(),S,l,L,p,B)}function i(l,p){if(l)for(const[D,I]of Object.entries(l))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?p.delete(D):(I.icon=I.icon||p.get(D)?.icon,p.set(D,I))}async function s(l,p,D,I,S,R,B,L,W,U){if(D.length===0)return Promise.resolve(void 0);const x=D.shift();if(x==="")return s(l,p,D,I,S,R,B,L,W);const le=typeof x!="string"&&x.isUnsafe,se=typeof x=="string"?x:x.path,ue={profileName:l,path:se,args:R,env:B,overrideName:L,isAutoDetected:W,isDefault:l===p,isUnsafePath:le,requiresUnsafePath:U};if((0,P.$oc)(se)===se){const Z=S.PATH?S.PATH.split(P.$uc):void 0,q=await(0,c.$as)(se,void 0,Z,void 0,I.existsFile);return q?(ue.path=q,ue.isFromPath=!0,ue):s(l,p,D,I,S,R)}return await I.existsFile((0,P.$ic)(se))?ue:s(l,p,D,I,S,R,B,L,W)}}),define(ae[267],ce([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,72]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;var w;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let g=class extends C.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,$,a,t){super(),this.M=h,this.N=$,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$7d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$7d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$7d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$7d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$7d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$7d),this.onProcessData=this.D.event,this.F=this.B(new n.$7d),this.onProcessReady=this.F.event,this.G=this.B(new n.$7d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$7d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$7d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$7d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$7d),this.onProcessExit=this.L.event,(0,k.$3r)(),this.B(this.M),this.B((0,C.$Sc)(()=>this.W())),this.j=this.B(new b.$Vr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,c.$rm)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),$=h.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService($.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService($.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new u.$Ur(this.P,$.getChannel(y.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,$,a,t,o,r,i,s,l,p,D){const I=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),S=await this.f.createProcess(h,$,a,t,o,r,i,s,l,p,D);return clearTimeout(I),S}updateTitle(h,$,a){return this.f.updateTitle(h,$,a)}updateIcon(h,$,a,t){return this.f.updateIcon(h,$,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,$){return this.f.detachFromProcess(h,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,$){return this.f.shutdown(h,$)}input(h,$){return this.f.input(h,$)}processBinary(h,$){return this.f.processBinary(h,$)}resize(h,$,a){return this.f.resize(h,$,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,$){return this.f.acknowledgeDataEvent(h,$)}setUnicodeVersion(h,$){return this.f.setUnicodeVersion(h,$)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new v.$3d,$=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...$]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,$){return this.f.installAutoReply(h,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,m.$bm)(h??P.OS,process.env)}async getProfiles(h,$,a,t=!1){const o=await this.S();return(0,d.$cs)($,a,t,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,$){return this.f.getWslPath(h,$)}getRevivedPtyNewId(h,$){return this.f.getRevivedPtyNewId(h,$)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,$){return this.f.requestDetachInstance(h,$)}async acceptDetachInstanceReply(h,$){return this.f.acceptDetachInstanceReply(h,$)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,$,a){return this.f.reviveTerminalProcesses(h,$,a)}async refreshProperty(h,$){return this.f.refreshProperty(h,$)}async updateProperty(h,$,a){return this.f.updateProperty(h,$,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,$){return this.j.createRequest({workspaceId:h,originalText:$})}async acceptPtyHostResolvedVariables(h,$){this.j.acceptReply(h,$)}};e.$ds=g,e.$ds=g=ve([ne(1,j.$Ni),ne(2,E.$Nj),ne(3,E.$Oj)],g)}),define(ae[69],ce([0,1,14,3,2,4,18,6,34]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=e.$C_b=void 0;const c="#FFFFFF",b="#1E1E1E",y="#000000",k="#FFFFFF",d="theme",m="themeBackground",v="windowSplash";e.$C_b=(0,E.$hi)("themeMainService");let w=class extends P.$Uc{constructor(f,h){super(),this.b=f,this.c=h,this.a=this.B(new C.$7d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration($=>{$.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(C.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let h=this.b.getItem(m,null);if(!h)switch(this.g()){case"vs":h=c;break;case"hc-black":h=y;break;case"hc-light":h=k;break;default:h=b}return O.$j&&h.toUpperCase()===b&&(h="#171717"),h}g(){switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,h){this.b.setItems([{key:d,data:h.baseTheme},{key:m,data:h.colorInfo.background},{key:v,data:h}]),typeof f=="number"&&this.h(f,h),this.f()}h(f,h){for(const $ of n.BrowserWindow.getAllWindows())if($.id===f){$.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$D_b=w,e.$D_b=w=ve([ne(0,u.$QP),ne(1,j.$Ni)],w)}),define(ae[130],ce([0,1,3,7,18,6,5]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$2v=e.$Zv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Vv=e.$Uv=void 0,e.$Wv=c,e.$Xv=y,e.$Yv=k,e.$1v=d,e.$3v=m,e.$4v=v,e.$Uv=(0,O.$hi)("tunnelService"),e.$Vv=(0,O.$hi)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var u;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(u||(e.TunnelPrivacyId=u={}));function c(f){return!!f.forwardPort}var b;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(h)return{address:h[1],port:+h[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const h=f.query.split("&");for(const $ of h){const a=$.split("=")[1];if(/^https?:/.exec(a)){const t=y(C.URI.parse(a));if(t)return t}}}e.$Zv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(f){return e.$Zv.indexOf(f)>=0}e.$2v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$2v.indexOf(f)>=0}function v(f,h,$,a){if($===1)return!1;if($===2&&m(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class w{constructor(h,$,a){this.remoteAddress=h,this.localAddress=$,this.b=a,this.a=new n.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5v=w;let g=class{constructor(h,$){this.k=h,this.l=$,this.a=new n.$7d,this.onTunnelOpened=this.a.event,this.b=new n.$7d,this.onTunnelClosed=this.b.event,this.c=new n.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],$=Array.from(this.e.values());for(const a of $){const t=Array.from(a.values());for(const o of t){const r=await o.value;r&&typeof r!="string"&&h.push(r)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:$}of h.values())await $.then(a=>typeof a!="string"?a?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,$,a,t,o){this.q(h,$,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:$,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,$){(m(h)||d(h))&&(h=e.$Zv[0]);const a=this.s(h,$);if(a)return++a.refcount,a.value}openTunnel(h,$,a,t,o,r=!1,i,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${$}:${a} on local port ${o}.`);const l=this.f??h;if(!l)return;if($||($="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.t(l,$,a,t,o,r,i,s);return p?p.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r($,a),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r($,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o(D);return(D.tunnelRemoteHost!==$||D.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&D.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const $=this.e.get(h.tunnelRemoteHost);if($){const a=$.get(h.tunnelRemotePort);a&&(a.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,a))}}}}async p(h,$,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${$}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete($),t}}async closeTunnel(h,$){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${$} `);const a=this.e.get(h);if(a&&a.has($)){const t=a.get($);t.refcount=0,await this.p(h,$,t)}}q(h,$,a){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set($,{refcount:1,value:a})}async r(h,$){const a=this.e.get(h);if(a){const t=a.get($),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete($),a.size===0&&this.e.delete(h)}}s(h,$){const a=[h];d(h)?(a.push(...e.$Zv),a.push(...e.$2v)):m(h)&&a.push(...e.$2v);const t=a.map(o=>this.e.get(o));for(const o of t){const r=o?.get($);if(r)return r}}canTunnel(h){return!!y(h)}u(h,$,a,t,o,r,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${$}:${a} on local port ${t}.`);const s=a;this.j.add(s);const l=t===void 0?a:t,p={elevationRequired:o?this.isPortPrivileged(l):!1},D={remoteAddress:{host:$,port:a},localAddressPort:t,privacy:r,public:r?r!==u.Private:void 0,protocol:i},I=h.forwardPort(D,p);return I?(this.q($,a,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),I}};e.$6v=g,e.$6v=g=ve([ne(0,j.$Nj),ne(1,P.$Ni)],g)}),define(ae[49],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WW=e.$VW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(C||(e.StateType=C={}));var P;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var O;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$VW={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,E)=>({type:"idle",updateType:j,error:E}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$WW=(0,n.$hi)("updateService")}),define(ae[268],ce([0,1,4,191,52,45]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$Zn.as(P.$5n.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[269],ce([0,1,3,49]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0;class P{constructor(E){this.a=E}listen(E,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${u}`)}}e.$Oac=P;class O{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$7d,this.onStateChange=this.a.event,this.b=C.$VW.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Pac=O}),define(ae[40],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,n.$hi)("IUriIdentityService")}),define(ae[270],ce([0,1,40,211,16,19,142,3,2]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let b=class{constructor(k){this.g=k,this.c=new u.$Tc,this.f=2**16;const d=new Map,m=v=>{let w=d.get(v.scheme);return w===void 0&&(w=k.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,w)),w};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new O.$Jg(m),this.d=new j.$gs((v,w)=>this.extUri.compare(v,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,O.$Vg)(k));const d=this.d.get(k);return d?d.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,v)=>m[1].time<v[1].time?1:m[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let m=0;m<d;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$hs=b,e.$hs=b=ve([ne(0,P.$Nk)],b),(0,C.$es)(n.$ll,b,1)}),define(ae[131],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MW=void 0,e.$MW=(0,n.$hi)("urlService")}),define(ae[271],ce([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=e.$Wac=void 0;class C{constructor(E){this.a=E}listen(E,u){throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${u}`)}}e.$Wac=C;class P{constructor(E){this.a=E}handleURL(E,u){return this.a.call("handleURL",[E.toJSON(),u])}}e.$Xac=P;class O{constructor(E,u){this.a=E,this.b=u}async routeCall(E,u,c,b){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(c)&&c.length>0){const y=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const d=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,y.toString(!0));const m=new RegExp(`window:${d}`),v=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),m.test(w.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,u,c,b)}routeEvent(E,u){throw new Error(`Event not found: ${u}`)}}e.$Yac=O}),define(ae[272],ce([0,1,8,2,7,27]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=e.$NW=void 0;class j extends C.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,b){const y=[...this.a.values()];return(0,n.$lh)(y.map(k=>()=>k.handleURL(c,b)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,C.$Sc)(()=>this.a.delete(c))}}e.$NW=j;let E=class extends j{constructor(c){super(),this.b=c}create(c){let{authority:b,path:y,query:k,fragment:d}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&y&&y.indexOf("/")!==0&&(y=`/${y}`),P.URI.from({scheme:this.b.urlProtocol,authority:b,path:y,query:k,fragment:d})}};e.$OW=E,e.$OW=E=ve([ne(0,O.$7j)],E)}),define(ae[273],ce([0,1,14,8,3,2,4,7]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;class u extends O.$Uc{constructor(b,y,k,d,m,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,b&&(v.trace("ElectronURLListener initialUrisToHandle:",b.map(f=>f.originalUrl)),this.a=b),j.$i){const f=d.isBuilt?[]:[`"${d.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const w=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(f,h)=>({event:f,url:h})),({event:f,url:h})=>(f.preventDefault(),h));this.B(w(f=>{const h=this.g(f);h&&this.c.open(h,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(b){try{return E.URI.parse(b)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),b.push(y));b.length!==0&&(this.a=b,(0,C.$jh)(()=>this.h(),500,this.q))}}e.$Zac=u}),define(ae[274],ce([0,1,3,2,16,59,31]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class E extends C.$Uc{constructor(c,b,y,k,d,m){super(),this.f=c,this.g=b,this.h=y,this.j=k,this.m=d,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$7d),this.onDidChangeFile=this.a.event,this.b=O.$ni.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,b){return this.g.open(this.t(c),b)}close(c){return this.g.close(c)}read(c,b,y,k,d){return this.g.read(c,b,y,k,d)}write(c,b,y,k,d){return this.g.write(c,b,y,k,d)}watch(c,b){this.b.set(c,c);const y=this.g.watch(this.t(c),b);return(0,C.$Sc)(()=>{this.b.delete(c),y.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,b,y){return this.g.rename(this.t(c),this.t(b),y)}readFile(c,b){return this.g.readFile(this.t(c),b)}readFileStream(c,b,y){return this.g.readFileStream(this.t(c),b,y)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,b,y){return this.g.writeFile(this.t(c),b,y)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,b){return this.g.delete(this.t(c),b)}copy(c,b,y){if((0,P.$Rk)(this.g))return this.g.copy(this.t(c),this.t(b),y);throw new Error("copy not supported")}cloneFile(c,b){if((0,P.$Sk)(this.g))return this.g.cloneFile(this.t(c),this.t(b));throw new Error("clone not supported")}s(c){const b=[];for(const y of c){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&b.push({resource:k,type:y.type,cId:y.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Abc=E}),define(ae[275],ce([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0,e.$hbc="utilityProcessWorker"}),define(ae[276],ce([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0,e.$1ac=(0,n.$hi)("webviewManagerService")}),define(ae[277],ce([0,1,14,2,13,7]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class j extends C.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,u)}b(u,c){try{const b=O.URI.parse(u.url),y=j.a.get(b.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,d=P.$Bg.asFileUri(k);return c({path:d.fsPath,headers:{...P.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$2ac=j}),define(ae[55],ce([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$9C=void 0,e.$0C=C,e.$$C=P,e.$_C=O,e.$aD=j,e.$bD=E,e.$cD=y,e.$dD=k,e.$eD=d,e.$fD=m,e.$gD=v,e.$hD=w,e.$9C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(g){return typeof g.parentId=="number"}function P(g){return!!g.workspaceUri}function O(g){return!!g.folderUri}function j(g){return!!g.fileUri}function E(g){const f=k(g),h=g.getValue("window.menuBarVisibility");return h==="default"||f&&h==="compact"||n.$j&&n.$m?"classic":h}var u;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(u||(e.TitleBarSetting=u={}));var c;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var b;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(b||(e.CustomTitleBarVisibility=b={}));function y(g,f){return!0}function k(g,f){return f||(f=d(g)),f==="native"}function d(g){if(n.$o)return"custom";const f=g.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function m(g){return!(!n.$i||n.$o||k(g))}function v(g){const f=g.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function w(g=0){return Math.pow(1.2,g)}}),define(ae[81],ce([0,1,14]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$s_b=e.$r_b=e.UnloadReason=e.LoadReason=void 0;var C;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const O=function(c=1){return{width:1024,height:768,mode:c}};e.$r_b=O;const j=function(){const y=n.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),d=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:d,width:800,height:600,mode:1}};e.$s_b=j;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var u;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(u||(e.WindowError=u={}))}),define(ae[278],ce([0,1,8,3,2]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class O extends P.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:u,getActiveWindowId:c}){super(),this.a=this.B(new P.$Tc),C.Event.latch(C.Event.any(E,u))(this.f,this,this.a),this.b=(0,n.$7g)(()=>c()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$8ac=O}),define(ae[30],ce([0,1,195,9,59,19,7,6,13]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=c,e.$si=b,e.$vi=y,e.$wi=k,e.$xi=d,e.$yi=v,e.$zi=w,e.$Ci=h,e.$Hi=$,e.$Ii=a,e.$Ki=t,e.$Li=o,e.$Mi=r,e.$qi=(0,E.$hi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&j.URI.isUri(s.uri)}function b(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function y(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$oc)(i)}:s?e.$ti:e.$ui;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function k(i){const s=i;return typeof s?.id=="string"&&j.URI.isUri(s.configPath)}function d(i){const s=i;if(s?.uri)return{id:s.id,uri:j.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:j.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(i){const s=i;return!!(s&&typeof s=="object"&&j.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class g{constructor(s,l,p,D,I){this.h=s,this.j=p,this.k=D,this.l=I,this.c=P.$ni.forUris(this.l,()=>!0),this.folders=l}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$ni.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=g;class f{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$Ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=f;function h(i){return new f({uri:i,index:0,name:(0,O.$Qg)(i)},{uri:i.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,n.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function $(i,s){return O.$Lg.isEqualOrParent(i,s.untitledWorkspacesHome)}function a(i){let s;return j.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===u.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Ji}function o(i,s){return!$(i,s)&&!a(i)}function r(i){return(typeof i=="string"?(0,C.$pc)(i):(0,O.$Sg)(i))===e.$Ei}}),define(ae[56],ce([0,1,14,8,46,47,2,86,4,21,169,119,6,5,27,30]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=e.$z_b=void 0,e.$z_b=(0,k.$hi)("dialogMainService");let w=class{constructor(f,h){this.d=f,this.e=h,this.a=new Map,this.b=new Map,this.c=new C.$oh}pickFileFolder(f,h){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(f,h){return this.f({...f,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(f,h){return this.f({...f,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(f,h){const $=(0,b.localize)(3,null),a=(0,O.$lw)((0,b.localize)(4,null)),t=v.$Fi;return this.f({...f,pickFiles:!0,title:$,filters:t,buttonLabel:a},h)}async f(f,h){const $={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&($.properties=void 0,f.pickFiles&&f.pickFolders&&($.properties=["multiSelections","openDirectory","openFile","createDirectory"])),$.properties||($.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$j&&$.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog($,(h||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let h=this.b.get(f.id);return h||(h=new C.$oh,this.b.set(f.id,h)),h}else return this.c}showMessageBox(f,h){return this.g(h).queue(async()=>{const{options:$,buttonIndeces:a}=(0,y.$sw)(f,this.e);let t;return h?t=await n.dialog.showMessageBox(h,$):t=await n.dialog.showMessageBox($),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,h){const $=this.j(f,h);if(!$)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showSaveDialog(h,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Pc)($)}}h(f){return f&&u.$j&&(f=(0,E.$Yl)(f)),f}i(f){return f.map(h=>this.h(h))}async showOpenDialog(f,h){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const $=this.j(f,h);if(!$)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showOpenDialog(h,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Pc)($)}}j(f,h){if(!h)return j.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let $=this.a.get(h.id);$||($=new Set,this.a.set(h.id,$));const a=(0,P.$8i)(f);if(!$.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),$.add(a),(0,j.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),$?.delete(a),$?.size===0&&this.a.delete(h.id)})}};e.$A_b=w,e.$A_b=w=ve([ne(0,d.$Nj),ne(1,m.$7j)],w)}),define(ae[279],ce([0,1,3,2,76,30]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class j extends C.$Uc{static{this.a=100}constructor(u,c){super(),this.f=u,this.g=c,this.b=this.B(new n.$7d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(u,c){this.B(n.Event.debounce(u.onDidChangeStorage,(b,y)=>(b?b.push(y):b=[y],b),j.a)(b=>{b.length&&c.fire(this.j(b,u))}))}j(u,c){const b=new Map,y=new Set;return u.forEach(k=>{const d=c.get(k.key);typeof d=="string"?b.set(k.key,d):y.add(k.key)}),{changed:Array.from(b.entries()),deleted:Array.from(y.values())}}listen(u,c,b){switch(c){case"onDidChangeStorage":{const y=b.profile?(0,P.$Qh)(b.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new n.$7d),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(u,c,b){const y=b.profile?(0,P.$Qh)(b.profile):void 0,k=(0,O.$xi)(b.workspace),d=await this.m(y,k);switch(c){case"getItems":return Array.from(d.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[v,w]of m.insert)d.set(v,w);m.delete?.forEach(v=>d.delete(v));break}case"optimize":return d.optimize();case"isUsed":{const m=b.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(u,c){let b;c?b=this.g.workspaceStorage(c):u?b=this.g.profileStorage(u):b=this.g.applicationStorage;try{await b.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":u?"profile":"application"} storage due to ${y}`)}return b}}e.$Lac=j}),define(ae[41],ce([0,1,46,3,2,19,7,192,38,16,6,5,30,31,40,8,32,25,12]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=$,e.$ol=a,e.$pl=t;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function $(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&j.URI.isUri(s.location)&&j.URI.isUri(s.globalStorageHome)&&j.URI.isUri(s.settingsResource)&&j.URI.isUri(s.keybindingsResource)&&j.URI.isUri(s.tasksResource)&&j.URI.isUri(s.snippetsHome)&&j.URI.isUri(s.extensionsResource))}e.$nl=(0,b.$hi)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:s}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,s,l,p,D,I){return{id:i,name:s,location:l,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:I&&D?.useDefaultFlags?.globalState?I.globalStorageHome:(0,O.$Ug)(l,"globalStorage"),settingsResource:I&&D?.useDefaultFlags?.settings?I.settingsResource:(0,O.$Ug)(l,"settings.json"),keybindingsResource:I&&D?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,O.$Ug)(l,"keybindings.json"),tasksResource:I&&D?.useDefaultFlags?.tasks?I.tasksResource:(0,O.$Ug)(l,"tasks.json"),snippetsHome:I&&D?.useDefaultFlags?.snippets?I.snippetsHome:(0,O.$Ug)(l,"snippets"),extensionsResource:I&&D?.useDefaultFlags?.extensions?I.extensionsResource:(0,O.$Ug)(l,"extensions.json"),cacheHome:(0,O.$Ug)(p,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let o=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,l,p,D){super(),this.t=s,this.u=l,this.w=p,this.y=D,this.f=!0,this.h=this.B(new C.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Bc,emptyWindows:new Map},this.profilesHome=(0,O.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),l=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$Uf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}l.push(t((0,O.$Rg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const p=new d.$Bc,D=new Map;if(l.length)try{const I=this.Q();if(I.workspaces)for(const[S,R]of Object.entries(I.workspaces)){const B=j.URI.parse(S),L=l.find(W=>W.id===R);L&&p.set(B,L)}if(I.emptyWindows)for(const[S,R]of Object.entries(I.emptyWindows)){const B=l.find(L=>L.id===R);B&&D.set(S,B)}}catch(I){this.y.error(I)}this.z={profiles:l,workspaces:p,emptyWindows:D}}return this.z}D(){const s=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const l="Temp",p=new RegExp(`${(0,g.$Ze)(l)}\\s(\\d+)`);let D=0;for(const S of this.profiles){const R=p.exec(S.name),B=R?parseInt(R[1]):0;D=B>D?B:D}const I=`${l} ${D+1}`;return this.createProfile((0,n.$8i)((0,w.$Dg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,l,p){return this.createProfile((0,n.$8i)((0,w.$Dg)()).toString(16),s,l,p)}async createProfile(s,l,p,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,l,p);return D&&await this.setProfileForWorkspace(D,I),I}async F(s,l,p){if(!(0,f.$Uf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(l);return D||(D=(async()=>{try{const I=this.profiles.find(B=>B.name===l||B.id===s);if(I)return I;const S=t(s,l,(0,O.$Ug)(this.profilesHome,s),this.g,p,this.defaultProfile);await this.u.createFolder(S.location);const R=[];return this.j.fire({profile:S,join(B){R.push(B)}}),await v.Promises.settled(R),this.I([S],[],[]),S}finally{this.r.delete(l)}})(),this.r.set(l,D)),D}async updateProfile(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(D=>D.id===s.id);if(!p)throw new Error(`Profile '${s.name}' does not exist`);return p=t(p.id,l.name??p.name,p.location,this.g,{shortName:l.shortName??p.shortName,icon:l.icon===null?void 0:l.icon??p.icon,transient:l.transient??p.isTransient,useDefaultFlags:l.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(D=>D.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const p=[];this.m.fire({profile:l,join(D){p.push(D)}});try{await Promise.allSettled(p)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(D){(0,c.$5k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(D=>D.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);this.L(s,p)}unsetWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.G(s);return j.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(s){return(0,k.$ri)(s)?s.uri:(0,k.$wi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location)))}I(s,l,p){const D=[...this.profiles,...s],I=[];this.s.profiles=[];for(let S of D)S.isDefault||l.some(R=>S.id===R.id)||(S=p.find(R=>S.id===R.id)??S,S.isTransient?this.s.profiles.push(S):I.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,l,p)}J(s,l,p){this.h.fire({added:s,removed:l,updated:p,all:this.profiles})}L(s,l,p){p=l?.isTransient?!0:p,p||this.L(s,void 0,!0);const D=this.G(s),I=p?this.s:this.C;j.URI.isUri(D)?(I.workspaces.delete(D),l&&I.workspaces.set(D,l)):(I.emptyWindows.delete(D),l&&I.emptyWindows.set(D,l)),p||this.M()}M(){const s={};for(const[p,D]of this.C.workspaces.entries())s[p.toString()]=D.id;const l={};for(const[p,D]of this.C.emptyWindows.entries())l[p.toString()]=D.id;this.R({workspaces:s,emptyWindows:l}),this.z=void 0}N(s){const l={},p=this.D();if(s.workspaces)for(const[I,S]of Object.entries(s.workspaces)){const R=j.URI.parse(S);l[I]=this.w.extUri.isEqual(R,p.location)?p.id:this.w.extUri.basename(R)}const D={};if(s.emptyWindows)for(const[I,S]of Object.entries(s.emptyWindows)){const R=j.URI.parse(S);D[I]=this.w.extUri.isEqual(R,p.location)?p.id:this.w.extUri.basename(R)}return{workspaces:l,emptyWindows:D}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$ql=o,e.$ql=o=ve([ne(0,u.$oi),ne(1,c.$Nk),ne(2,m.$ll),ne(3,y.$Nj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$rl=r}),define(ae[82],ce([0,1,8,17,2,3,31,7,121,127,16,6,5,41,40,12,15,28]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class h extends Error{constructor(r,i){super(r),this.code=i}}e.$_p=h,e.$aq=(0,y.$hi)("IExtensionsProfileScannerService");let $=class extends P.$Uc{constructor(r,i,s,l,p,D){super(),this.j=r,this.m=i,this.n=s,this.r=l,this.s=p,this.t=D,this.b=this.B(new O.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new O.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const l=[],p=[];try{return await this.u(i,D=>{const I=[];if(s)I.push(...D);else for(const S of D)r.some(([R])=>(0,c.$fp)(R.identifier,S.identifier)&&R.manifest.version!==S.version)?l.push(S):I.push(S);for(const[S,R]of r){const B=I.findIndex(W=>(0,c.$fp)(W.identifier,S.identifier)&&W.version===S.manifest.version),L={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:R};B===-1?(p.push(L),I.push(L)):I.splice(B,1,L)}return p.length&&this.b.fire({extensions:p,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),I}),p.length&&this.c.fire({extensions:p,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),p}catch(D){throw p.length&&this.c.fire({extensions:p,error:D,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:D,profileLocation:i}),D}}async updateMetadata(r,i){const s=[];return await this.u(i,l=>{const p=[];for(const D of l){const I=r.find(([S])=>(0,c.$fp)(S.identifier,D.identifier)&&S.manifest.version===D.version);I&&(D.metadata={...D.metadata,...I[1]},s.push(D)),p.push(D)}return p}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,l=>{const p=[];for(const D of l)(0,c.$fp)(D.identifier,r.identifier)?s.push(D):p.push(D);return s.length&&this.f.fire({extensions:s,profileLocation:i}),p}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(l){throw s.length&&this.g.fire({extensions:s,error:l,profileLocation:i}),l}}async u(r,i,s){return this.F(r).queue(async()=>{let l=[],p;try{const D=await this.m.readFile(r);p=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,b.$5k)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&s?.bailOutWhenFileNotFound)throw new h((0,w.$0)(D),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let D=!1;for(const I of p){a(I)||this.w(r);let S;if((0,v.$Uf)(I.relativeLocation)&&I.relativeLocation)S=this.z(I.relativeLocation);else if((0,v.$Uf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{S=E.URI.revive(I.location);const R=this.y(S);R&&(D=!0,I.relativeLocation=R)}(0,v.$2f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(D=!0,I.metadata.hasPreReleaseVersion=!0),l.push({identifier:I.identifier,location:S,version:I.version,metadata:I.metadata})}D&&await this.m.writeFile(r,C.$ue.fromString(JSON.stringify(p)))}if(i){l=i(l);const D=l.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,C.$ue.fromString(JSON.stringify(D)))}return l})}w(r){const i=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(p){if((0,b.$5k)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const p=JSON.parse(s);Array.isArray(p)&&p.every(D=>a(D))?l=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$ue.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,b.$5k)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,b.$5k)(p)!==1&&this.t.error(p)}try{await this.m.del(i)}catch(p){(0,b.$5k)(p)!==1&&this.t.error(p)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$oh,this.h.set(r,i)),i}};e.$bq=$,e.$bq=$=ve([ne(1,b.$Nk),ne(2,d.$nl),ne(3,m.$ll),ne(4,g.$Ml),ne(5,k.$Nj)],$);function a(o){return(0,v.$Wf)(o)&&(0,u.$Po)(o.identifier)&&(t(o.location)||(0,v.$Uf)(o.location)&&o.location)&&((0,v.$2f)(o.relativeLocation)||(0,v.$Uf)(o.relativeLocation))&&o.version&&(0,v.$Uf)(o.version)}function t(o){return o?(0,v.$Uf)(o.path)&&(0,v.$Uf)(o.scheme):!1}}),define(ae[132],ce([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,73,12,7,174,38,127,124,207,16,6,5,27,3,76,82,41,40,206]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.$fq=e.$eq=e.Translations=void 0,e.$hq=le;var B;(function(ue){function Y(Z,q){if(Z===q)return!0;const M=Object.keys(Z),N=new Set;for(const G of Object.keys(q))N.add(G);if(M.length!==N.size)return!1;for(const G of M){if(Z[G]!==q[G])return!1;N.delete(G)}return N.size===0}ue.equals=Y})(B||(e.Translations=B={})),e.$eq=(0,r.$hi)("IExtensionsScannerService");let L=class extends c.$Uc{constructor(Y,Z,q,M,N,G,z,oe,he,X,A,F){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.r=q,this.s=M,this.t=N,this.u=G,this.w=z,this.y=oe,this.z=he,this.C=X,this.D=A,this.F=F,this.g=this.B(new l.$7d),this.onDidChangeCache=this.g.event,this.h=(0,d.$Ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$qp)(this.w,this.y)),this.G}async scanAllExtensions(Y,Z,q){const[M,N]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),G=q?await this.scanExtensionsUnderDevelopment(Y,[...M,...N]):[];return this.L(M,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.M(!!Y.useCache,Y.language)),Z.push(this.N(Y.language,!!Y.checkControlFile));const[q,M]=await Promise.all(Z);return this.J([...q,...M],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const q=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,q,Y.productVersion??this.R()),N=Y.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(M)}catch(z){if(z instanceof D.$_p&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(M);else throw z}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===b.Schemas.file).map(async M=>{const N=await this.P(M,!1,1,!0,Y.language,!1,void 0,Y.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(N)).map(z=>(z.type=Z.find(oe=>(0,$.$fp)(oe.identifier,z.identifier))?.type??z.type,this.n.validate(z,N)))}))).flat();return this.J(q,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,q){const M=await this.P(Y,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),N=await this.n.scanExtension(M);return!N||!q.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Y,Z,q){const M=await this.P(Y,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),N=await this.n.scanOneOrMultipleExtensions(M);return this.J(N,Z,q,!0)}async scanMetadata(Y){const Z=(0,d.$Ug)(Y,"package.json"),q=(await this.w.readFile(Z)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Y,Z){const q=(0,d.$Ug)(Y,"package.json"),M=(await this.w.readFile(q)).value.toString(),N=JSON.parse(M);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,N.__metadata={...N.__metadata,...Z},await this.w.writeFile((0,d.$Ug)(Y,"package.json"),O.$ue.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof D.$_p&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$ue.fromString(JSON.stringify([])))}catch(Z){(0,o.$5k)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,Z,q,M){return q.includeAllVersions||(Y=this.L(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),M)),q.includeInvalid||(Y=Y.filter(N=>N.isValid)),Y.sort((N,G)=>{const z=y.$oc(N.location.fsPath),oe=y.$oc(G.location.fsPath);return z<oe?-1:z>oe?1:0})}L(Y,Z,q,M,N){const G=(oe,he,X)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(N&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===M)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},z=new a.$Em;return Y?.forEach(oe=>{const he=z.get(oe.identifier.id);(!he||G(he,oe,!1))&&z.set(oe.identifier.id,oe)}),Z?.forEach(oe=>{const he=z.get(oe.identifier.id);if(!he&&Y&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&z.set(oe.identifier.id,oe)}),q?.forEach(oe=>{const he=z.get(oe.identifier.id);(!he||G(he,oe,!0))&&z.set(oe.identifier.id,oe),z.set(oe.identifier.id,oe)}),[...z.values()]}async M(Y,Z){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),N=await(Y&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",N.length),N}async N(Y,Z){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const M=Z?await this.O():{},N=[],G=g.URI.file(y.$ic(y.$kc(b.$Bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of q){const he=M[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,d.$Ug)(G,oe.name));break;default:N.push(g.URI.file(he));break}}const z=await Promise.all(N.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Y,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",z.length),(0,n.$Hb)(z)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,Z,q,M,N,G,z,oe){const he=await this.f(N??k.$w),X=await this.Q(Y),A=Z&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=A?await this.Q(A):void 0;return new W(Y,X,A,F,Z,z,q,M,G,oe.version,oe.date,this.C.commit,!this.z.isBuilt,N,he)}async Q(Y){try{const Z=await this.w.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$fq=L,e.$fq=L=ve([ne(4,I.$nl),ne(5,D.$aq),ne(6,o.$Nk),ne(7,i.$Nj),ne(8,h.$oi),ne(9,s.$7j),ne(10,S.$ll),ne(11,r.$gi)],L);class W{constructor(Y,Z,q,M,N,G,z,oe,he,X,A,F,_,re,K){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=M,this.profile=N,this.profileScanOptions=G,this.type=z,this.excludeObsolete=oe,this.validate=he,this.productVersion=X,this.productDate=A,this.productCommit=F,this.devMode=_,this.language=re,this.translations=K}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,d.$Ng)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,d.$Ng)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&P.$Rn(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&B.equals(Y.translations,Z.translations)}}e.$gq=W;let U=class extends c.$Uc{constructor(Y,Z,q,M,N){super(),this.f=Y,this.g=Z,this.h=q,this.j=M,this.m=N}async scanExtensions(Y){const Z=Y.profile?await this.r(Y):await this.n(Y);let q={};if(Y.excludeObsolete&&Y.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(M)}catch{}return(0,w.$8f)(q)?Z:Z.filter(M=>!q[$.$gp.create(M).toString()])}async n(Y){const Z=await this.j.resolve(Y.location);if(!Z.children?.length)return[];const q=await Promise.all(Z.children.map(async M=>{if(!M.isDirectory||Y.type===1&&(0,d.$Rg)(M.resource).indexOf(".")===0)return null;const N=new W(M.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(N)}));return(0,n.$Hb)(q).sort((M,N)=>M.location.path<N.location.path?-1:1)}async r(Y){let Z=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter(M=>!M.metadata?.isApplicationScoped);const q=await this.s(Y.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,Y);Z.push(...q)}return Z}async s(Y,Z,q){const M=await this.g.scanProfileExtensions(Y,q.profileScanOptions);if(!M.length)return[];const N=await Promise.all(M.map(async G=>{if(Z(G)){const z=new W(G.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(z,G.metadata)}return null}));return(0,n.$Hb)(N)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,d.$Ug)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,j.$0)(Z)),[]}}async scanExtension(Y,Z){try{let q=await this.scanExtensionManifest(Y.location);if(q){q.publisher||(q.publisher=a.$ym),Z=Z??q.__metadata,delete q.__metadata;const M=(0,$.$kp)(q.publisher,q.name),N=Z?.id?{id:M,uuid:Z.id}:{id:M},G=Z?.isSystem?0:Y.type,z=G===0||!!Z?.isBuiltin;q=await this.t(Y.location,q,W.createNlsConfiguration(Y));const oe={type:G,identifier:N,manifest:q,location:Y.location,isBuiltin:z,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(oe,Y):oe}}catch(q){Y.type!==0&&this.m.error(q)}return null}validate(Y,Z){let q=!0;const M=(0,t.$vp)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[N,G]of M)N===v.default.Error&&(q=!1,this.m.error(this.z(Z.location,G)));return Y.isValid=q,Y.validations=M,Y}async scanExtensionManifest(Y){const Z=(0,d.$Ug)(Y,"package.json");let q;try{q=(await this.j.readFile(Z)).value.toString()}catch(N){return(0,o.$5k)(N)!==1&&this.m.error(this.z(Y,(0,f.localize)(0,null,Z.path,N.message))),null}let M;try{M=JSON.parse(q)}catch{const G=[];(0,E.$un)(q,G);for(const z of G)this.m.error(this.z(Y,(0,f.localize)(1,null,Z.path,z.offset,z.length,(0,u.$cq)(z.error))));return null}return(0,E.$Dn)(M)!=="object"?(this.m.error(this.z(Y,(0,f.localize)(2,null,Z.path))),null):M}async t(Y,Z,q){const M=await this.u(Y,Z,q);if(M)try{const N=[],G=await this.w(M.default,N);if(N.length>0)return N.forEach(oe=>{this.m.error(this.z(Y,(0,f.localize)(3,null,M.default?.path,(0,u.$cq)(oe.error))))}),Z;if((0,E.$Dn)(M)!=="object")return this.m.error(this.z(Y,(0,f.localize)(4,null,M.default?.path))),Z;const z=M.values||Object.create(null);return(0,R.$dq)(this.m,Z,z,G)}catch{}return Z}async u(Y,Z,q){const M=(0,d.$Ug)(Y,"package.nls.json"),N=(he,X)=>{X.forEach(A=>{this.m.error(this.z(Y,(0,f.localize)(5,null,he?.path,(0,u.$cq)(A.error))))})},G=he=>{this.m.error(this.z(Y,(0,f.localize)(6,null,he?.path)))},z=`${Z.publisher}.${Z.name}`,oe=q.translations[z];if(oe)try{const he=g.URI.file(oe),X=(await this.j.readFile(he)).value.toString(),A=[],F=(0,E.$un)(X,A);return A.length>0?(N(he,A),{values:void 0,default:M}):(0,E.$Dn)(F)!=="object"?(G(he),{values:void 0,default:M}):{values:F.contents?F.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let X;try{X=await this.y(Y,q)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const A=(await this.j.readFile(X.localized)).value.toString(),F=[],_=(0,E.$un)(A,F);return F.length>0?(N(X.localized,F),{values:void 0,default:X.original}):(0,E.$Dn)(_)!=="object"?(G(X.localized),{values:void 0,default:X.original}):{values:_,default:X.original}}catch{return{values:void 0,default:X.original}}}}async w(Y,Z){if(Y)try{const q=(await this.j.readFile(Y)).value.toString();return(0,E.$un)(q,Z)}catch{}}y(Y,Z){return new Promise((q,M)=>{const N=G=>{const z=(0,d.$Ug)(Y,`package.nls.${G}.json`);this.j.exists(z).then(oe=>{oe&&q({localized:z,original:(0,d.$Ug)(Y,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?q({localized:(0,d.$Ug)(Y,"package.nls.json"),original:null}):(G=G.substring(0,he),N(G))})};if(Z.devMode||Z.pseudo||!Z.language)return q({localized:(0,d.$Ug)(Y,"package.nls.json"),original:null});N(Z.language)})}z(Y,Z){return`[${Y.path}]: ${Z}`}};U=ve([ne(1,D.$aq),ne(2,S.$ll),ne(3,o.$Nk),ne(4,i.$Nj)],U);let x=class extends U{constructor(Y,Z,q,M,N,G,z){super(Z,M,N,G,z),this.G=Y,this.H=q,this.D=this.B(new C.$fh(3e3)),this.F=this.B(new l.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const Z=this.M(Y),q=await this.I(Z);if(this.C=Y,q&&q.input&&W.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),q.result.map(N=>(N.location=g.URI.revive(N.location),N));const M=await super.scanExtensions(Y);return await this.J(Z,{input:Y,result:M}),M}async I(Y){try{const Z=await this.j.readFile(Y),q=JSON.parse(Z.value.toString());return{result:q.result,input:(0,p.$Qh)(q.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",Y.path,(0,j.$0)(Z))}return null}async J(Y,Z){try{await this.j.writeFile(Y,O.$ue.fromString(JSON.stringify(Z)))}catch(q){this.m.debug("Error while writing the extension cache file:",Y.path,(0,j.$0)(q))}}async L(){if(!this.C)return;const Y=this.M(this.C),Z=await this.I(Y);if(!Z)return;const q=Z.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$Rn(M,q))try{this.m.info("Invalidating Cache",q,M),await this.j.del(Y),this.F.fire()}catch(N){this.m.error(N)}}M(Y){const Z=this.N(Y);return this.h.extUri.joinPath(Z.cacheHome,Y.type===0?a.$xm:a.$wm)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(Y.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};x=ve([ne(2,I.$nl),ne(3,D.$aq),ne(4,S.$ll),ne(5,o.$Nk),ne(6,i.$Nj)],x);function le(ue,Y){const Z=(0,$.$ip)(ue.manifest.publisher,ue.manifest.name);return{id:Z,identifier:new a.$Cm(Z),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Y,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}class se extends L{constructor(Y,Z,q,M,N,G,z,oe,he,X,A,F){super(Y,Z,(0,d.$Ug)(q,".vscode-oss-dev","extensions","control.json"),M,N,G,z,oe,he,X,A,F),this.S=(async()=>{if(k.$z)try{const _=await this.w.readFile(g.URI.file(k.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.S}}e.$iq=se}),define(ae[280],ce([0,1,5,41,40,28,82,16,38,7]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;let b=class extends j.$bq{constructor(k,d,m,v,w,g){super(c.URI.file(k.extensionsPath),d,m,v,w,g)}};e.$XP=b,e.$XP=b=ve([ne(0,u.$pi),ne(1,E.$Nk),ne(2,C.$nl),ne(3,P.$ll),ne(4,O.$Ml),ne(5,n.$Nj)],b)}),define(ae[281],ce([0,1,7,38,82,132,16,6,5,27,40,41]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;let k=class extends O.$iq{constructor(m,v,w,g,f,h,$,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,v,w,g,f,h,$,a)}};e.$_ac=k,e.$_ac=k=ve([ne(0,y.$nl),ne(1,P.$aq),ne(2,j.$Nk),ne(3,u.$Nj),ne(4,C.$pi),ne(5,c.$7j),ne(6,b.$ll),ne(7,E.$gi)],k)}),define(ae[282],ce([0,1,14,2,13,9,4,59,7,32,37,38,5,41]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let m=class extends C.$Uc{constructor(w,g,f){super(),this.c=w,this.f=f,this.a=E.$ni.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(g,f)=>this.j(g,f)),w.protocol.interceptFileProtocol(P.Schemas.file,(g,f)=>this.h(g,f)),this.B((0,C.$Sc)(()=>{w.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(w){const g=(0,O.$ic)(w);return this.a.get(g)?C.$Uc.None:(this.a.set(g,!0),(0,C.$Sc)(()=>this.a.delete(g)))}h(w,g){const f=u.URI.parse(w.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${P.Schemas.file}: protocol (original URL: ${w.url})`),g({error:-3})}j(w,g){const f=this.m(w);let h;return this.c.crossOriginIsolated&&((0,O.$oc)(f)==="workbench.html"||(0,O.$oc)(f)==="workbench-dev.html"?h=P.COI.CoopAndCoep:h=P.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(f)?g({path:f,headers:h}):this.b.has((0,O.$pc)(f).toLowerCase())?g({path:f}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),g({error:-3}))}m(w){const g=u.URI.parse(w.url),f=P.$Bg.uriToFileUri(g);return(0,O.$ic)(f.fsPath)}createIPCObjectUrl(){let w;const g=u.URI.from({scheme:"vscode",path:(0,c.$Dg)()}),f=g.toString(),h=async()=>w;return b.$XV.handle(f,h),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:g,update:$=>w=$,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),b.$XV.removeHandler(f)}}}};e.$rbc=m,e.$rbc=m=ve([ne(0,y.$pi),ne(1,d.$nl),ne(2,k.$Nj)],m)}),define(ae[97],ce([0,1,8,3,2,66,12,115,6,41]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=d,e.$Op=v,e.$Qp=g,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,u.$hi)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function d(f){const h=f.get(e.$Kp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class m extends P.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:m.a}){super(),this.m=h,this.b=this.B(new C.$0d),this.c=this.B(new C.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,$,a){return C.Event.filter(this.b.event,t=>t.scope===h&&($===void 0||t.key===$),a)}n(){this.j.value=(0,n.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,$){const{key:a,external:t}=$;if(a===e.$Kp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,$,a){return this.P($)?.get(h,a)}getBoolean(h,$,a){return this.P($)?.getBoolean(h,a)}getNumber(h,$,a){return this.P($)?.getNumber(h,a)}getObject(h,$,a){return this.P($)?.getObject(h,a)}storeAll(h,$){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,$)})}store(h,$,a,t,o=!1){if((0,j.$4f)($)){this.remove(h,a,o);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,$,o)})}remove(h,$,a=!1){this.y(()=>{this.z(h,$,void 0),this.P($)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,$){const a=[],t=this.J(h);for(const o of Object.keys(t))t[o]===$&&a.push(o);return a}z(h,$,a,t=!1){const o=this.J($);typeof a=="number"?o[h]!==a&&(o[h]=a,this.P($)?.set(e.$Kp,JSON.stringify(o),t)):typeof o[h]=="number"&&(delete o[h],this.P($)?.set(e.$Kp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const $=this.P(h);return $?d($):Object.create(null)}isNew(h){return this.getBoolean(e.$Jp,h)===!0}async flush(h=b.NONE){this.f.fire({reason:h});const $=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case b.NONE:await n.Promises.settled([$?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await n.Promises.settled([$?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return g(h,$,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,$){return this.w(b.NONE),(0,c.$ml)(h)?this.R(h,$):this.S(h,$)}M(h,$){return!(h.id===$.id||v($)&&v(h))}N(h,$,a){this.y(()=>{const t=new Set;for(const[o,r]of h)t.add(o),$.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Np=m;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class w extends m{constructor(){super(),this.U=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Pp=w;async function g(f,h,$,a,t,o){const r=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,s=new Map;f.forEach((B,L)=>{i.set(L,B),s.set(L,r(B))});const l=new Map,p=new Map;h.forEach((B,L)=>{l.set(L,B),p.set(L,r(B))});const D=new Map,I=new Map;$.forEach((B,L)=>{D.set(L,B),I.set(L,r(B))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const S=[];if(i.forEach((B,L)=>{S.push({key:L,value:B})}),console.table(S),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const B=[];l.forEach((L,W)=>{B.push({key:W,value:L})}),console.table(B),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const R=[];D.forEach((B,L)=>{R.push({key:L,value:B})}),console.table(R),console.groupEnd(),console.log(I)}}),define(ae[283],ce([0,1,22,8,3,2,9,72,7,21,115,163,5,97,28,30,13]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=e.$1_b=e.$Z_b=void 0;class g extends O.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new P.$7d),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$7d),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$Hp(new b.$Ip,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Eh,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean(d.$Jp);i===void 0?r.set(d.$Jp,!0):i&&r.set(d.$Jp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$3d(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,p])=>({key:l,length:p.length})),(l,p)=>p.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),s=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class f extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$kc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,f.y)}constructor(r,i,s,l){super(s,l),this.z=r,this.C=i}async t(){return new b.$Hp(new y.$qW(this.path??y.$qW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class h extends f{constructor(r,i,s,l){super(r,i,s,l)}}e.$Z_b=h;class $ extends f{constructor(r,i,s,l){super(i.defaultProfile,r,s,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Pl,void 0)===void 0&&r.set(m.$Pl,new Date().toUTCString());const s=r.get(m.$Ol,void 0),l=new Date().toUTCString();r.set(m.$Ql,typeof s>"u"?null:s),r.set(m.$Ol,l)}}e.$1_b=$;class a extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,l,p){super(s,p),this.C=r,this.D=i,this.F=l}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$Hp(new y.$qW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$qW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,j.$kc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,v.$ri)(this.C)?i={folder:this.C.uri.toString()}:(0,v.$wi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,j.$kc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$2_b=a;class t extends g{get path(){}async t(){return new b.$Hp(new b.$Ip,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$3_b=t}),define(ae[284],ce([0,1,3,2,97]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;class O extends C.$Uc{constructor(E,u,c){super(),this.b=E,this.c=u,this.f=c;const b=this.B(new C.$Vc);this.a=this.B(new n.$7d({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new C.$Tc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,c)=>(u?u.push(c.key):u=[c.key],u),100)(u=>this.h(u))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(u,c)=>{u||(u=new Map);let b=u.get(c.profile.id);return b||u.set(c.profile.id,b={profile:c.profile,keys:[],storage:c.storage}),b.keys.push(c.key),u},100)(u=>this.j(u))),E}h(E){const u=E.includes(P.$Kp)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(b=>b!==P.$Kp),E.length){const b=(0,P.$Mp)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:b[y]}))})}this.m(u,c)}j(E){const u=[],c=new Map;for(const[b,y]of E.entries()){y.keys.includes(P.$Kp)&&u.push(y.profile);const k=y.keys.filter(d=>d!==P.$Kp);if(k.length){const d=(0,P.$Mp)(y.storage.storage);c.set(b,{profile:y.profile,changes:k.map(m=>({key:m,scope:0,target:d[m]}))})}}this.m(u,[...c.values()])}m(E,u){(E.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:E})}listen(E,u,c){switch(u){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${u}`)}async call(E,u){throw new Error(`Call not found: ${u}`)}}e.$bbc=O}),define(ae[285],ce([0,1,7,38,16,5,34,40,41,12,125]),function(J,e,n,C,P,O,j,E,u,c,b){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=e.$UP=void 0;let d=class extends u.$ql{static{y=this}static{this.a="profileAssociationsMigration"}constructor(g,f,h,$,a){super(h,$,f,a),this.U=g,this.W=h}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,c.$Uf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const g=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$UP=d,e.$UP=d=y=ve([ne(0,j.$PP),ne(1,E.$ll),ne(2,C.$pi),ne(3,P.$Nk),ne(4,O.$Nj)],d);let m=k=class extends d{constructor(g,f,h,$,a){super(g,f,h,$,a),this.$=g}P(g){g.length?this.$.setItem(k.b,g.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(k.c,g):this.$.removeItem(k.c)}Q(){const g="workspaceAndProfileInfo",f=this.$.getItem(g,void 0);if(f){this.$.removeItem(g);const $=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:$})}const h=super.Q();return this.$.getItem(k.a,!1)||(this.R(h),this.$.setItem(k.a,!0)),h}};e.$VP=m,e.$VP=m=k=ve([ne(0,j.$QP),ne(1,E.$ll),ne(2,C.$pi),ne(3,P.$Nk),ne(4,O.$Nj)],m);let v=class extends m{constructor(g,f,h,$){super(new b.$TP(0,f,$,h),g,f,h,$)}async init(){return await this.$.init(),super.init()}};e.$WP=v,e.$WP=v=ve([ne(0,E.$ll),ne(1,C.$pi),ne(2,P.$Nk),ne(3,O.$Nj)],v)}),define(ae[57],ce([0,1,38,16,6,5,40,41,285,34]),function(J,e,n,C,P,O,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=e.$H_b=void 0,e.$H_b=(0,P.$ii)(E.$nl);let b=class extends u.$VP{constructor(k,d,m,v,w){super(k,d,m,v,w)}getAssociatedEmptyWindows(){const k=[];for(const d of this.C.emptyWindows.keys())k.push({id:d});return k}};e.$I_b=b,e.$I_b=b=ve([ne(0,c.$QP),ne(1,j.$ll),ne(2,n.$pi),ne(3,C.$Nk),ne(4,O.$Nj)],b)}),define(ae[133],ce([0,1,19,7,30]),function(J,e,n,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=O,e.$K_b=j,e.$L_b=E;async function O(u,c,b){for(const k of u){const d=k.openedWorkspace;if((0,P.$wi)(d)){const m=await b(d);if(m){if(m.folders.some(v=>n.$Lg.isEqualOrParent(c,v.uri)))return k}else if(n.$Lg.isEqualOrParent(c,d.configPath))return k}}const y=u.filter(k=>(0,P.$ri)(k.openedWorkspace)&&n.$Lg.isEqualOrParent(c,k.openedWorkspace.uri));if(y.length)return y.sort((k,d)=>-(k.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}function j(u,c){for(const b of u)if((0,P.$wi)(b.openedWorkspace)&&n.$Lg.isEqual(b.openedWorkspace.configPath,c)||(0,P.$ri)(b.openedWorkspace)&&n.$Lg.isEqual(b.openedWorkspace.uri,c))return b}function E(u,c){const b=y=>c.some(k=>n.$Lg.isEqual(C.URI.file(k),C.URI.file(y)));for(const y of u)if(y.config?.extensionDevelopmentPath?.some(k=>b(k)))return y}}),define(ae[98],ce([0,1,33,42,103,47,13,9,4,19,7,6,68,30]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$web=void 0,e.$xeb=m,e.$yeb=v,e.$zeb=w,e.$Aeb=g,e.$Beb=$,e.$Ceb=t,e.$Deb=o,e.$Eeb=p,e.$Feb=D,e.$web=(0,y.$hi)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}function v(I){return I.hasOwnProperty("folderUri")}function w(I){return I.hasOwnProperty("fileUri")}function g(I){return f(I)||h(I)}function f(I){const S=I;return typeof S?.path=="string"&&(!S.name||typeof S.name=="string")}function h(I){const S=I;return typeof S?.uri=="string"&&(!S.name||typeof S.name=="string")}function $(I,S,R,B,L){if(I.scheme!==B.scheme)return{name:R,uri:I.toString(!0)};let W=S?void 0:L.relativePath(B,I);if(W!==void 0)W.length===0?W=".":u.$i&&(W=a(W));else if(I.scheme===j.Schemas.file)W=I.fsPath,u.$i&&(W=a(W));else if(L.isEqualAuthority(I.authority,B.authority))W=I.path;else return{name:R,uri:I.toString(!0)};return{name:R,path:W}}function a(I){return I=(0,O.$fw)(I),(0,n.$eg)(I)||(I=(0,n.$bg)(I)),I}function t(I,S,R){const B=[],L=new Set,W=R.dirname(S);for(const U of I){let x;if(f(U))U.path&&(x=R.resolvePath(W,U.path));else if(h(U))try{x=b.URI.parse(U.uri),x.path[0]!==E.$hc.sep&&(x=x.with({path:E.$hc.sep+x.path}))}catch(le){console.warn(le)}if(x){const le=R.getComparisonKey(x);if(!L.has(le)){L.add(le);const se=U.name||R.basenameOrAuthority(x);B.push(new d.$Bi({uri:x,name:se,index:B.length},U))}}}return B}function o(I,S,R,B,L){const W=r(S,I),U=L.dirname(S),x=L.dirname(B),le=[];for(const Z of W.folders){const q=f(Z)?L.resolvePath(U,Z.path):b.URI.parse(Z.uri);let M;R?M=!1:M=!f(Z)||(0,E.$jc)(Z.path),le.push($(q,M,Z.name,x,L))}const se={insertSpaces:!1,tabSize:4,eol:u.$k||u.$j?`
`:`\r
`},ue=P.$Jn(I,["folders"],le,se);let Y=P.$Mn(I,ue);return(0,c.$Zg)(W.remoteAuthority,(0,k.$sm)(B))&&(Y=P.$Mn(Y,P.$In(Y,["remoteAuthority"],se))),Y}function r(I,S){const R=C.$un(S);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(B=>g(B));else throw new Error(`${I} looks like an invalid workspace file.`);return R}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function s(I){return typeof I.folderUri=="string"}function l(I){return typeof I.fileUri=="string"}function p(I,S){const R={workspaces:[],files:[]};if(I){const B=function(W,U){for(let x=0;x<W.length;x++)try{U(W[x],x)}catch(le){S.warn(`Error restoring recent entry ${JSON.stringify(W[x])}: ${le.toString()}. Skip entry.`)}},L=I;Array.isArray(L.entries)&&B(L.entries,W=>{const U=W.label,x=W.remoteAuthority;i(W)?R.workspaces.push({label:U,remoteAuthority:x,workspace:{id:W.workspace.id,configPath:b.URI.parse(W.workspace.configPath)}}):s(W)?R.workspaces.push({label:U,remoteAuthority:x,folderUri:b.URI.parse(W.folderUri)}):l(W)&&R.files.push({label:U,remoteAuthority:x,fileUri:b.URI.parse(W.fileUri)})})}return R}function D(I){const S={entries:[]};for(const R of I.workspaces)v(R)?S.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):S.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of I.files)S.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return S}}),define(ae[99],ce([0,1,87,13,4,19]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=void 0,e.$N_b=j,e.$O_b=E,e.$P_b=u,e.$M_b=128/4;function j(c){function b(){let y=c.scheme===C.Schemas.file?(0,O.$Ig)(c):c.toString();return P.$k||(y=y.toLowerCase()),(0,n.createHash)("md5").update(y).digest("hex")}return{id:b(),configPath:c}}function E(c,b){function y(){if(c.scheme!==C.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!b)return;let d;return P.$k?d=b.ino:P.$j?d=b.birthtime.getTime():P.$i&&(typeof b.birthtimeMs=="number"?d=Math.floor(b.birthtimeMs):d=b.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(d?String(d):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:c}}function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[100],ce([0,1,87,88,26,286,17,15,3,2,9,4,32,44,113]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=r,e.$ai=i,e.$ci=p,e.$di=D;class v{traceSocketEvent(S,R){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,R)}constructor(S,R=""){this.f=!0,this.debugLabel=R,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=B=>{if(this.traceSocketEvent("error",{code:B?.code,message:B?.message}),B){if(B.code==="EPIPE")return;(0,E.$1)(B)}},this.socket.on("error",this.a),this.b=B=>{this.traceSocketEvent("close",{hadError:B}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const R=B=>{this.traceSocketEvent("read",B),S(j.$ue.wrap(B))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(S){const R=B=>{S({type:0,hadError:B,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(S){const R=()=>{S()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,E.$1)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,E.$1)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const B=()=>{this.socket.off("close",B),this.socket.off("end",B),this.socket.off("error",B),this.socket.off("timeout",B),this.socket.off("drain",B),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",B),this.socket.on("end",B),this.socket.on("error",B),this.socket.on("timeout",B),this.socket.on("drain",B)})}}e.$9h=v;var w;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class f extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,R){this.socket.traceSocketEvent(S,R)}constructor(S,R,B,L){super(),this.f=this.B(new u.$7d),this.g=this.B(new u.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:B?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new h(this,R,B,L,this.f,(W,U)=>this.m(W,U))),this.B(this.a.onError(W=>{console.error(W),(0,E.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new m.$4h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let R=0;for(;R<S.byteLength;)this.a.writeMessage(S.slice(R,Math.min(R+262144,S.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(S,{compressed:R,opcode:B}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let L=2;S.byteLength<126?L+=0:S.byteLength<2**16?L+=2:L+=8;const W=j.$ue.alloc(L),U=R?64:0,x=B&15;if(W.writeUInt8(128|U|x,0),S.byteLength<126)W.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){W.writeUInt8(126,1);let le=1;W.writeUInt8(S.byteLength>>>8&255,++le),W.writeUInt8(S.byteLength>>>0&255,++le)}else{W.writeUInt8(127,1);let le=1;W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(S.byteLength>>>24&255,++le),W.writeUInt8(S.byteLength>>>16&255,++le),W.writeUInt8(S.byteLength>>>8&255,++le),W.writeUInt8(S.byteLength>>>0&255,++le)}this.socket.write(j.$ue.concat([W,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),B=R.readUInt8(0),L=(B&128)>>>7,W=(B&64)>>>6,U=B&15,x=R.readUInt8(1),le=(x&128)>>>7,se=x&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!L,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),B=R.readUInt8(1),L=(B&128)>>>7;let W=B&127,U=1;W===126?W=R.readUInt8(++U)*2**8+R.readUInt8(++U):W===127&&(W=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let x=0;L&&(x=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this.j.state=3,this.j.readLen=W,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=f;class h extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$ue.alloc(0)}constructor(S,R,B,L,W,U){super(),this.n=S,this.r=W,this.s=U,this.a=this.B(new u.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new $(this.n,L,B,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(S,R){this.g.push({data:S,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:R}=this.g.shift();if(this.f&&R.compressed){const B=await this.w(this.f,S);this.s(B,R)}else this.s(S,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,R){return new Promise((B,L)=>{S.write(R),S.flush(W=>B(W))})}acceptFrame(S,R,B){this.h.push({data:S,isCompressed:R,isLastFrameOfMessage:B}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const R=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,R,B){return new Promise((L,W)=>{S.write(R),B&&S.write(j.$ue.fromByteArray([0,0,255,255])),S.flush(U=>L(U))})}}class $ extends c.$Uc{get recordedInflateBytes(){return this.j?j.$ue.concat(this.f):j.$ue.alloc(0)}constructor(S,R,B,L){super(),this.h=S,this.j=R,this.a=this.B(new u.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(L),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(j.$ue.wrap(W))}),B&&(this.h.traceSocketEvent("zlibInflateInitialWrite",B.buffer),this.b.write(B.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=j.$ue.concat(this.g);this.g.length=0,S(R)})}}class a extends c.$Uc{constructor(S,R){super(),this.g=S,this.a=this.B(new u.$7d),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",B=>{this.g.traceSocketEvent("zlibDeflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.g.traceSocketEvent("zlibDeflateData",B),this.f.push(j.$ue.wrap(B))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=j.$ue.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),S(R)})}}function t(I,S){if(S===0)return;const R=I.byteLength>>>2;for(let le=0;le<R;le++){const se=I.readUInt32BE(le*4);I.writeUInt32BE(se^S,le*4)}const B=R*4,L=I.byteLength-B,W=S>>>24&255,U=S>>>16&255,x=S>>>8&255;L>=1&&I.writeUInt8(I.readUInt8(B)^W,B),L>=2&&I.writeUInt8(I.readUInt8(B+1)^U,B+1),L>=3&&I.writeUInt8(I.readUInt8(B+2)^x,B+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,k.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const S=process.platform!=="darwin"&&e.$$h?e.$$h:(0,P.tmpdir)(),R=(0,b.$kc)(S,`vscode-ipc-${I}.sock`);return s(R),R}function i(I,S,R){const L=(0,n.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${R}-${S}-sock`;const W=R.substr(0,4),U=S.substr(0,6);let x;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?x=(0,b.$kc)(e.$$h,`vscode-${L}-${W}-${U}.sock`):x=(0,b.$kc)(I,`${W}-${U}.sock`),s(x),x}function s(I){const S=o[y.$u];typeof S=="number"&&I.length>=S&&console.warn(`WARNING: IPC handle "${I}" is longer than ${S} chars, try a shorter --user-data-dir`)}class l extends d.$Xh{static b(S){const R=u.Event.fromNodeEventEmitter(S,"connection");return u.Event.map(R,B=>({protocol:new m.$5h(new v(B,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(B,"close"))}))}constructor(S){super(l.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=l;function p(I){return new Promise((S,R)=>{const B=(0,C.createServer)();B.on("error",R),B.listen(I,()=>{B.removeListener("error",R),S(new l(B))})})}function D(I,S){return new Promise((R,B)=>{const L=(0,C.createConnection)(I,()=>{L.removeListener("error",B),R(m.$6h.fromSocket(new v(L,`ipc-client${S}`),S))});L.once("error",B)})}}),define(ae[24],ce([0,1,50,9,4,100,38,91,6]),function(J,e,n,C,P,O,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u_b=e.$t_b=void 0,e.$t_b=(0,u.$ii)(j.$oi);class c extends E.$Tm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,C.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$ai)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(P.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$u_b=c,ve([n.$Lh],c.prototype,"cachedLanguagesPath",null),ve([n.$Lh],c.prototype,"backupHome",null),ve([n.$Lh],c.prototype,"mainIPCHandle",null),ve([n.$Lh],c.prototype,"mainLockfile",null),ve([n.$Lh],c.prototype,"disableUpdates",null),ve([n.$Lh],c.prototype,"crossOriginIsolated",null),ve([n.$Lh],c.prototype,"codeCachePath",null),ve([n.$Lh],c.prototype,"useCodeCache",null)}),define(ae[287],ce([0,1,87,33,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=void 0;let h=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Lg,this.i={isEqual:(i,s)=>(0,C.$gg)(i,s,!j.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$w_b)(a)),this.e=await this.v((0,c.$x_b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$al.OFF}q(){return this.s()===d.$al.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$al.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,O.$kc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await u.Promises.exists(a)&&await this.z(a),await u.Promises.exists(t))try{await u.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,O.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,O.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,w.$wi)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,O.$kc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==P.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const l=(0,O.$kc)(this.c,this.D(r));await this.B(l)?i.scheme!==P.Schemas.file||await u.Promises.exists(i.fsPath)?t.push(r):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,O.$kc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await u.Promises.rm(a,u.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,g.$P_b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,g.$P_b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,O.$kc)(this.c,t.backupFolder);try{await u.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$v_b)(a)?t=(0,O.$kc)(this.c,a.backupFolder):(0,v.$ueb)(a)?t=(0,O.$kc)(this.c,this.D(a)):t=(0,O.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await u.Promises.readdir(a);for(const o of t)try{if((await u.Promises.readdir((0,O.$kc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===P.Schemas.file?o=j.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$9_b=h,e.$9_b=h=f=ve([ne(0,y.$t_b),ne(1,b.$Ni),ne(2,m.$Nj),ne(3,k.$QP)],h)}),define(ae[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.LifecycleMainPhase=e.ShutdownReason=e.$X_b=void 0,e.$X_b=(0,b.$hi)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let g=class extends j.$Uc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,$,a){super(),this.F=h,this.G=$,this.H=a,this.c=this.B(new O.$7d),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$7d),this.onWillShutdown=this.f.event,this.g=this.B(new O.$7d),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$7d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",h);const $=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",$),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",h),n.app.removeListener("window-all-closed",$),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(h){if(this.y)return this.y;const $=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,o){$.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{$.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const $=this.C.get(this.n);$&&($.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let $=this.C.get(h);$||($=new P.$gh,this.C.set(h,$)),await $.wait()}registerWindow(h){const $=new j.$Tc;this.t++,$.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,c.$6f)(h.win);a.on("close",t=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,$.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}registerAuxWindow(h){const $=(0,c.$6f)(h.win);$.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),$.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`)})}async reload(h,$){await this.unload(h,3)||h.reload($)}unload(h,$){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,$).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,$){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:$,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,$){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;C.$XV.once(o,()=>{a(!1)}),C.$XV.once(r,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:$})})}Q(h,$){return new Promise(a=>{const o=`vscode:reply${this.s++}`;C.$XV.once(o,()=>a()),h.send("vscode:onWillUnload",{replyChannel:o,reason:$})})}quit(h){return this.R(h).then($=>{if(!$&&h)try{if(E.$i){const a=(0,u.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return $})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(m.b,!0),this.u=new Promise($=>{this.w=$,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const $=process.argv.slice(1);if(h?.addArgs&&$.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=$.indexOf(o);r>=0&&$.splice(r,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:$}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,P.$ih)(1e3),(async()=>{for(const $ of n.BrowserWindow.getAllWindows())if($&&!$.isDestroyed()){let a;$.webContents&&!$.webContents.isDestroyed()?a=new Promise(t=>$.once("closed",t)):a=Promise.resolve(),$.destroy(),await a}})()]),n.app.exit(h)}};e.$Y_b=g,e.$Y_b=g=m=ve([ne(0,y.$Nj),ne(1,k.$QP),ne(2,d.$t_b)],g)}),define(ae[288],ce([0,1,4,3,2,6,20]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=e.$tac=void 0,e.$tac=(0,O.$hi)("keyboardLayoutMainService");let E=class extends P.$Uc{constructor(b){super(),this.a=this.B(new C.$7d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((y,k)=>{J(["native-keymap"],y,k)});this.c=u(b),n.$t||b.onDidChangeKeyboardLayout(()=>{this.c=u(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$uac=E,e.$uac=E=ve([ne(0,j.$X_b)],E);function u(c){const b=c.getKeyMap(),y=c.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:y}}}),define(ae[289],ce([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0,e.$Gr=w;let m=class extends y.$zp{constructor(f,h,$,a){super(a),this.m=f,this.n=h,this.r=$,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,h){const{f:$,g:a}=this;let t;try{t=await(0,c.$rm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Er)(f.url||"",o,{proxyUrl:$,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>w(f,h))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((h,$)=>{J(["@vscode/proxy-agent"],h,$)})).loadSystemCertificates({log:this.r})}};e.$Fr=m,e.$Fr=m=ve([ne(0,E.$Ni),ne(1,u.$pi),ne(2,b.$Nj),ne(3,b.$Oj)],m);async function v(g){return((0,n.parse)(g.url).protocol==="https:"?await new Promise(($,a)=>{J(["https"],$,a)}):await new Promise(($,a)=>{J(["http"],$,a)})).request}async function w(g,f){return C.Promises.withAsyncBody(async(h,$)=>{const a=(0,n.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await v(g),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,j.$1f)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=t(o,i=>{const s=(0,j.$Yf)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)w({...g,url:i.headers.location,followRedirects:s-1},f).then(h,$);else{let l=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,d.createGunzip)())),h({res:i,stream:(0,P.$Je)(l)})}});r.on("error",$),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),f.onCancellationRequested(()=>{r.abort(),$(new O.$5)})})}}),define(ae[290],ce([0,1,14,289]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;function P(j){return n.net.request}class O extends C.$Fr{request(E,u){return super.request({...E||{},getRawRequest:P,isChromiumNetwork:!0},u)}}e.$wbc=O}),define(ae[83],ce([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=e.$5_b=e.$4_b=void 0,e.$4_b=(0,E.$hi)("storageMainService");let w=class extends P.$Uc{constructor(h,$,a,t,o,r){super(),this.c=h,this.f=$,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new C.$7d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,$]of this.t)h.join("profileStorage",$.close());for(const[,$]of this.w)h.join("workspaceStorage",$.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const $=this.t.get(h.profile.id);$&&h.join($.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new y.$1_b(this.n(),this.g,this.c,this.j);return this.B(C.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,b.$Op)(h))return this.applicationStorage;let $=this.t.get(h.id);if(!$){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),$=this.B(this.u(h)),this.t.set(h.id,$);const a=this.B($.onDidChangeStorage(t=>this.b.fire({...t,storage:$,profile:h})));this.B(C.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return $}u(h){return this.a===2?new y.$3_b(this.c,this.j):new y.$Z_b(h,this.n(),this.c,this.j)}workspaceStorage(h){let $=this.w.get(h.id);return $||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),$=this.B(this.y(h)),this.w.set(h.id,$),this.B(C.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),$}y(h){return this.a===2?new y.$3_b(this.c,this.j):new y.$2_b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const $=n.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),$))return!0;return!1}};e.$5_b=w,e.$5_b=w=ve([ne(0,c.$Nj),ne(1,O.$oi),ne(2,d.$H_b),ne(3,u.$X_b),ne(4,j.$Nk),ne(5,m.$ll)],w),e.$6_b=(0,E.$hi)("applicationStorageMainService");let g=class extends b.$Np{constructor(h,$){super(),this.s=h,this.U=$,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$7_b=g,e.$7_b=g=ve([ne(0,k.$nl),ne(1,e.$4_b)],g)}),define(ae[291],ce([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=e.$tbc=e.$sbc=void 0;async function g(t,o,r,i,s){let l;for(let p=3;p&&(l?.dispose(),l=await new f(t,o,r,i,s).waitForReady(),!(s&&P.$Gg[s]||!P.$Gg[l.tunnelLocalPort]));p--);return l}class f extends E.$Uc{constructor(o,r,i,s,l){super(),this.m=r,this.n=l,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new j.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,v.$3v)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,P.$Hg)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,v.$1v)(this.tunnelRemoteHost)||(0,v.$3v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$Dl)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof O.$9h?s.socket.destroy():s.end()}),s instanceof O.$9h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(w.$ue.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$sbc=f;let h=class extends v.$6v{constructor(o,r,i,s,l){super(r,l),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,v.$4v)(o,this.m,u.OS,C.release())}t(o,r,i,s,l,p,D,I){const S=this.s(r,i);if(S)return++S.refcount,S.value;if((0,v.$Wv)(o))return this.u(o,r,i,l,p,D,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${l}.`);const R={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},B=g(R,s,r,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,B),B}}};e.$tbc=h,e.$tbc=h=ve([ne(0,d.$xl),ne(1,b.$Nj),ne(2,m.$Al),ne(3,y.$7j),ne(4,c.$Ni)],h);let $=class extends h{constructor(o,r,i,s,l){super(o,r,i,s,l)}};e.$ubc=$,e.$ubc=$=ve([ne(0,d.$xl),ne(1,b.$Nj),ne(2,m.$Al),ne(3,y.$7j),ne(4,c.$Ni)],$);let a=class extends E.$Uc{constructor(o,r,i,s,l){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=l,this.a=new Map}async openTunnel(o,r,i,s,l,p,D,I,S){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${p}.`),!this.a.has(o)){const R=new $(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(o,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,l,p,D,I,S)}};e.$vbc=a,e.$vbc=a=ve([ne(0,d.$xl),ne(1,b.$Nj),ne(2,y.$7j),ne(3,m.$Al),ne(4,c.$Ni)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0,e.$Qac=k;function k(m,v,w){return`${w.updateUrl}/api/update/${m}/${v}/${w.commit}`}let d=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,w,g,f,h,$){this.f=v,this.g=w,this.h=g,this.i=f,this.j=h,this.k=$,this.b=y.$VW.Uninitialized,this.c=new P.$7d,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$VW.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$VW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$VW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),w=this.m(v);if(!w){this.d(y.$VW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(y.$VW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(y.$VW.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,n.$ih)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$Rac=d,e.$Rac=d=ve([ne(0,E.$X_b),ne(1,O.$Ni),ne(2,j.$t_b),ne(3,b.$yp),ne(4,u.$Nj),ne(5,c.$7j)],d)}),define(ae[292],ce([0,1,14,50,3,46,2,18,24,20,5,27,53,28,49,101]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let w=class extends v.$Rac{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,h)=>h)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,h,$,a)=>({version:$,productVersion:$,timestamp:a}))}constructor(f,h,$,a,t,o,r){super(f,h,a,t,o,r),this.z=$,this.u=new j.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,O.$8i)(String(f)))}),this.j.error("UpdateService error:",f);const h=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$VW.Idle(1,h))}s(f){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,v.$Qac)(h,f,this.k);try{n.autoUpdater.setFeedURL({url:$})}catch(a){this.j.error("Failed to set update feed URL",a);return}return $}t(f){this.d(m.$VW.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(m.$VW.Downloading)}F(f){this.state.type==="downloading"&&(this.d(m.$VW.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$VW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$VW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Sac=w,ve([C.$Lh],w.prototype,"v",null),ve([C.$Lh],w.prototype,"w",null),ve([C.$Lh],w.prototype,"x",null),ve([C.$Lh],w.prototype,"y",null),e.$Sac=w=ve([ne(0,c.$X_b),ne(1,E.$Ni),ne(2,d.$Ml),ne(3,u.$t_b),ne(4,k.$yp),ne(5,b.$Nj),ne(6,y.$7j)],w)}),define(ae[293],ce([0,1,48,43,8,3,9,24,20,5,28,49]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,w,g){if(this.f=v,this.g=g,this.a=y.$VW.Uninitialized,this.b=new O.$7d,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$VW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,P.$ih)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=ve([ne(0,u.$X_b),ne(1,E.$t_b),ne(2,c.$Nj)],k);let d=class extends k{constructor(v,w,g,f,h,$){super(g,f,h),this.o=v,this.p=w,this.q=$;const a=(0,C.watch)(j.$nc(this.o)),t=O.Event.fromNodeEventEmitter(a,"change",(s,l)=>l),o=O.Event.filter(t,s=>s==="current"),i=O.Event.debounce(o,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(y.$VW.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$VW.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$VW.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$VW.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((g,f)=>(0,C.realpath)(`${j.$nc(this.o)}/current`,(h,$)=>h?f(h):g($))),w=j.$oc(v);return this.p!==w}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Uac=d,e.$Uac=d=ve([ne(2,u.$X_b),ne(3,E.$t_b),ne(4,c.$Nj),ne(5,b.$Ml)],d)}),define(ae[29],ce([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(J,e,n,C,P,O,j,E,u,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$E_b=void 0,e.$F_b=m,e.$G_b=v,e.$E_b=(0,P.$hi)("windowsMainService");var d;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(d||(e.OpenContext=d={}));function m(g,f,h){const $=g.get(E.$C_b),a=g.get(u.$7j),t=g.get(c.$Ni),o=g.get(b.$t_b),r=t.getValue("window"),i={backgroundColor:$.getBackgroundColor(),minWidth:j.$9C.WIDTH,minHeight:j.$9C.HEIGHT,title:a.nameLong,...h,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$hD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(C.$k?i.icon=(0,y.$kc)(o.appRoot,"resources/linux/code.png"):C.$i&&!o.isBuilt&&(i.icon=(0,y.$kc)(o.appRoot,"resources/win32/code_150x150.png")),C.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),C.$j&&!(0,j.$gD)(t)&&(i.fullscreenable=!1),C.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$dD)(t)&&(i.titleBarStyle="hidden",C.$j||(i.frame=!1),(0,j.$fD)(t))){const p=$.getWindowSplash()?.colorInfo.titleBarBackground??$.getBackgroundColor(),D=k.$Et.fromHex(p).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:p,symbolColor:D}}return i}function v(g){let f,h=Number.MIN_VALUE;for(const $ of g)$.lastFocusTime>h&&(h=$.lastFocusTime,f=$);return f}var w;(function(g){function f($,a,t=n.screen.getAllDisplays()){if($.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){$.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){$.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=h(t[0]);if($.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){$.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,O.$r_b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=h(o),$.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){$.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;$.trace("window#validateWindowState: state is outside of the multi-monitor working area")}g.validateWindowState=f;function h($){if($.workArea.width>0&&$.workArea.height>0)return $.workArea;if($.bounds.width>0&&$.bounds.height>0)return $.bounds}})(w||(e.WindowStateValidator=w={}))}),define(ae[294],ce([0,1,14,23,3,46,2,32,120,5,83,29]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let d=class extends j.$Uc{constructor(v,w,g,f){super(),this.g=v,this.h=w,this.j=g,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=P.Event.fromNodeEventEmitter(n.app,"login",(w,g,f,h,$)=>({event:w,webContents:g,req:f,authInfo:h,callback:$}));this.B(v(this.r,this))}async r({event:v,authInfo:w,req:g,callback:f}){if(!w.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{h=await this.b}finally{this.b=void 0}}f(h?.username,h?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(v);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const w=String((0,O.$8i)({scheme:v.scheme,host:v.host,port:v.port}));let g,f;try{const t=this.m.get(this.a+w,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));g=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof g=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:g,password:f};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const $={authInfo:v,username:this.f?.username??g,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Dg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,$),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===$.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),s){const l={username:s.username,password:s.password};try{if(s.remember){const p=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+w,p,-1,1)}else this.m.remove(this.a+w,-1)}catch(p){this.g.error(p)}t({username:l.username,password:l.password})}else t(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$8_b=d,e.$8_b=d=ve([ne(0,c.$Nj),ne(1,y.$E_b),ne(2,u.$GW),ne(3,b.$6_b)],d)}),define(ae[295],ce([0,1,14,22,4,7,21,18,63,6,5,131,29]),function(J,e,n,C,P,O,j,E,u,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=e.ID=void 0,e.ID="launchMainService",e.$wac=(0,c.$hi)(e.ID);let d=class{constructor(v,w,g,f){this.a=v,this.b=w,this.c=g,this.d=f}async start(v,w){this.a.trace("Received data from other instance: ",v,w),P.$j&&n.app.focus({steal:!0});const g=this.e(v);if(g.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,C.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(f=h.ready())}f.then(()=>{for(const{uri:h,originalUrl:$}of g)this.c.open(h,{originalUrl:$})})}else return this.f(v,w)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,C.$Hb)(v._urls.map(w=>{try{return{uri:O.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(v,w){const g=(0,u.$lm)(w)?0:4;let f=[];const h=v.wait&&v.waitMarkerFilePath?O.URI.file(v.waitMarkerFilePath):void 0,$=v.remote||void 0,a={context:g,cli:v,userEnv:v["preserve-env"]||g===0?w:void 0,waitMarkerFileURI:h,remoteAuthority:$,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(h&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,j.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$xac=d,e.$xac=d=ve([ne(0,b.$Nj),ne(1,k.$E_b),ne(2,y.$MW),ne(3,E.$Ni)],d)}),define(ae[296],ce([0,1,2,20,57,30,8,29]),function(J,e,n,C,P,O,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0;let u=class extends n.$Uc{constructor(b,y,k){super(),this.a=y,this.b=k,this.B(b.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(b.onBeforeCloseWindow(d=>this.c(d))),this.B(new j.$th(()=>this.g(),30*1e3)).schedule()}async c(b){const y=this.f(b),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,O.$vi)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of b)y.some(d=>d.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$abc=u,e.$abc=u=ve([ne(0,C.$X_b),ne(1,P.$H_b),ne(2,E.$E_b)],u)}),define(ae[60],ce([0,1,14,2,3,5,316,8,13,29,73,28,20,75,35,4,102]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=e.$$_b=void 0;function f(a){return typeof a.responseWindowId=="number"}let h=class extends C.$Uc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new P.$7d),this.onStdout=this.f.event,this.g=this.B(new P.$7d),this.onStderr=this.g.event,this.h=this.B(new P.$7d),this.onMessage=this.h.event,this.j=this.B(new P.$7d),this.onSpawn=this.j.event,this.m=this.B(new P.$7d),this.onExit=this.m.event,this.n=this.B(new P.$7d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case b.default.Error:this.u.error(r);break;case b.default.Warning:this.u.warn(r);break;case b.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",b.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=u.$Bg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,p=this.t.forceAllocationsToV8Sandbox,D="pipe",I=this.F(t);return this.z("creating new...",b.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:s,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:p,stdio:D}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Nn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,d.$$l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(P.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",b.default.Info),this.j.fire(t.pid)})),this.B(P.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,b.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",b.default.Info),this.r.kill()?(this.z("successfully killed the process",b.default.Info),this.H()):this.z("unable to kill the process",b.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",b.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,E.$ih)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$$_b=h,e.$$_b=h=g=ve([ne(0,O.$Nj),ne(1,y.$Ml),ne(2,k.$X_b)],h);let $=class extends h{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(P.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$__b=$,e.$__b=$=ve([ne(0,O.$Nj),ne(1,c.$E_b),ne(2,y.$Ml),ne(3,k.$X_b)],$)}),define(ae[297],ce([0,1,15,3,5,20,8,60,29,28]),function(J,e,n,C,P,O,j,E,u,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;let y=class{static{b=this}static{this.a=0}constructor(d,m,v,w){this.d=d,this.f=m,this.g=v,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(d){const m=this.b.get(d);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(d){return this.i(d).onStdout}onDynamicStderr(d){return this.i(d).onStderr}onDynamicMessage(d){return this.i(d).onMessage}onDynamicExit(d){return this.i(d).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const d=String(++b.a),m=new E.$__b(this.d,this.g,this.h,this.f);return this.b.set(d,m),m.onExit(({pid:v,code:w,signal:g})=>{this.d.info(`Extension host with pid ${v} exited with code: ${w}, signal: ${g}.`),setTimeout(()=>{m.dispose(),this.b.delete(d)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:d}}async start(d,m){if(this.c)throw(0,n.$6)();const v=this.i(d);return v.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d}),{pid:await C.Event.toPromise(v.onSpawn)}}async enableInspectPort(d){if(this.c)throw(0,n.$6)();const m=this.b.get(d);return m?m.enableInspectPort():!1}async kill(d){if(this.c)throw(0,n.$6)();const m=this.b.get(d);m&&m.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const m=[];for(const[,v]of this.b)m.push(v.waitForExit(d));return j.Promises.settled(m).then(()=>{})}};e.$gac=y,e.$gac=y=b=ve([ne(0,P.$Nj),ne(1,O.$X_b),ne(2,u.$E_b),ne(3,c.$Ml)],y)}),define(ae[298],ce([0,1,37,8,2,24,20,5,41,39,67,60,54,91,12,251]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;let w=class extends P.$Uc{constructor(f,h,$,a,t,o,r,i){super(),this.f=f,this.g=h,this.h=$,this.j=a,this.m=t,this.n=o,this.r=r,this.s=i,this.a=new C.$gh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$XV.on(v.$Iac.request,(f,h)=>this.u(f,h,v.$Iac.response)),n.$XV.on(v.$Jac.request,(f,h)=>this.u(f,h,v.$Jac.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,h,$){this.n.trace(`[SharedProcess] onWindowConnection for: ${$}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect($);if(f.sender.isDestroyed())return a.close();f.sender.postMessage($,h,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$Hac.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new C.$Eh;this.b?.once(v.$Hac.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new C.$Eh;this.b?.once(v.$Hac.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$$_b(this.n,k.$5o,this.m)),this.c=this.b.onMessage($=>{typeof $.warning=="string"?this.n.warn($.warning):typeof $.error=="string"&&this.n.error($.error)});const f=(0,d.$Vm)(this.h.args,this.h.isBuilt);let h;f.port&&(h=["--nolazy"],f.break?h.push(`--inspect-brk=${f.port}`):h.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:h})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$6f)(this.b).connect(f)}};e.$Kac=w,e.$Kac=w=ve([ne(2,O.$t_b),ne(3,u.$nl),ne(4,j.$X_b),ne(5,E.$Nj),ne(6,b.$S_b),ne(7,c.$2n)],w)}),define(ae[299],ce([0,1,24,91,20,5,54,60,114,37,2,3,35,18,13]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;let v=class extends b.$Uc{constructor(g,f,h,$,a){super(),this.f=g,this.g=f,this.h=h,this.j=$,this.m=a,this.a=void 0,this.b=new y.$7d,this.onRequestConnection=this.b.event,this.c=new y.$7d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$XV.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,b.$Sc)(()=>{c.$XV.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$$_b(this.m,j.$5o,this.j);const g=(0,C.$Um)(this.h.args,this.h.isBuilt),f=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),$=new u.$6V(h,"ptyHost"),a=new b.$Tc;return a.add($),a.add((0,b.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:$,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,k.$Nn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(g.VSCODE_LATENCY=String(f));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(g.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),g}r(g,f){this.b.fire();const h=this.a.connect();if(g.sender.isDestroyed()){h.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[h])}};e.$kbc=v,e.$kbc=v=ve([ne(1,d.$Ni),ne(2,n.$t_b),ne(3,P.$X_b),ne(4,O.$Nj)],v)}),define(ae[300],ce([0,1,2,6,5,29,60,28,46,3,8,20]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0,e.$ibc=(0,C.$hi)("utilityProcessWorker");let k=class extends n.$Uc{constructor(v,w,g,f){super(),this.b=v,this.c=w,this.f=g,this.g=f,this.a=new Map}async createWorker(v){const w=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const g=this.h(v);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(v));const f=new d(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,f);const h=new b.$Eh;return c.Event.once(f.onDidTerminate)($=>{$.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${$.code}, signal: ${$.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${$.code}, signal: ${$.signal}`),this.a.delete(g),h.complete({reason:$})}),h.p}h(v){return(0,u.$8i)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const w=this.h(v),g=this.a.get(w);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g.kill(),this.a.delete(w))}};e.$jbc=k,e.$jbc=k=ve([ne(0,P.$Nj),ne(1,O.$E_b),ne(2,E.$Ml),ne(3,y.$X_b)],k);let d=class extends n.$Uc{constructor(v,w,g,f,h){super(),this.c=v,this.f=w,this.g=g,this.h=f,this.j=h,this.a=this.B(new c.$7d),this.onDidTerminate=this.a.event,this.b=new j.$__b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ve([ne(0,P.$Nj),ne(1,O.$E_b),ne(2,E.$Ml),ne(3,y.$X_b)],d)}),define(ae[301],ce([0,1,14,3,2,277,29]),function(J,e,n,C,P,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;let E=class extends P.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new C.$7d),this.onFoundInFrame=this.a.event,this.B(new O.$2ac)}async setIgnoreMenuShortcuts(c,b){let y;if(typeof c.windowId=="number"){const{windowId:k}=c,d=this.b.getWindowById(k);if(!d?.win)throw new Error(`Invalid windowId: ${k}`);y=d.win.webContents}else{const{webContentsId:k}=c;if(y=n.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(b)}async findInFrame(c,b,y,k){const m=this.c(c,b);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(w,g)=>{g.finalUpdate&&(this.a.fire(g),m.removeListener("found-in-frame",v))};m.on("found-in-frame",v)}}async stopFindInFrame(c,b,y){const d=this.c(c,b);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(c,b){const y=this.b.getWindowById(c.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${c}`);const k=y.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===b);if(!k)throw new Error(`Unknown frame: ${b}`);return k}};e.$3ac=E,e.$3ac=E=ve([ne(0,j.$E_b)],E)}),define(ae[302],ce([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0,e.$5ac=w,e.$6ac=f;let v=class extends C.$Uc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=w(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?P.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,d.$wi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,d.$ri)(a.openedWorkspace)&&o.folderUri&&O.$Lg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,d.$wi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,d.$ri)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=a.workspace;if((0,d.$wi)(p)){const I=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===p.id).map(S=>S.uiState);if(I.length)return I[0]}if((0,d.$ri)(p)){const I=this.state.openedWindows.filter(S=>S.folderUri&&O.$Lg.isEqual(S.folderUri,p.uri)).map(S=>S.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(S=>S.backupPath===a.backupPath).map(S=>S.uiState);if(I.length)return I[0]}const D=this.c||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(P.$j){const p=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(p)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$r_b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let l=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const p=t.serializeWindowState();p.mode===3?i.mode=3:i={...p,zoomLevel:void 0},l=i.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$4ac=v,e.$4ac=v=m=ve([ne(0,y.$E_b),ne(1,b.$QP),ne(2,u.$X_b),ne(3,c.$Nj),ne(4,E.$Ni)],v);function w($){const a={openedWindows:[]},t=$||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>g(o))),a}function g($){const a={uiState:$.uiState};return $.backupPath&&(a.backupPath=$.backupPath),$.remoteAuthority&&(a.remoteAuthority=$.remoteAuthority),$.folder&&(a.folderUri=j.URI.parse($.folder)),$.workspaceIdentifier&&(a.workspace={id:$.workspaceIdentifier.id,configPath:j.URI.parse($.workspaceIdentifier.configURIPath)}),a}function f($){return{lastActiveWindow:$.lastActiveWindow&&h($.lastActiveWindow),lastPluginDevelopmentHostWindow:$.lastPluginDevelopmentHostWindow&&h($.lastPluginDevelopmentHostWindow),openedWindows:$.openedWindows.map(a=>h(a))}}function h($){return{workspaceIdentifier:$.workspace&&{id:$.workspace.id,configURIPath:$.workspace.configPath.toString()},folder:$.folderUri&&$.folderUri.toString(),backupPath:$.backupPath,remoteAuthority:$.remoteAuthority,uiState:$.uiState}}}),define(ae[58],ce([0,1,14,3,42,2,13,9,19,21,197,64,56,24,6,5,57,133,30,98,99]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=void 0,e.$Q_b=(0,m.$hi)("workspacesManagementMainService");let a=class extends O.$Uc{constructor(o,r,i,s,l){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=l,this.a=this.B(new C.$7d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$7d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(r=>(0,u.$Ug)(this.c,r,f.$Gi));for(const r of o){const i=(0,$.$N_b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===j.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Hi)(o,this.g)||(0,f.$Mi)(o)}t(o,r){try{const i=this.u(o,r),s=(0,$.$N_b)(o);return{id:s.id,configPath:s.configPath,folders:(0,h.$Ceb)(i.folders,s.configPath,u.$Lg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,P.$un)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,h.$Aeb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),l=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$nc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,u.$Ug)(this.c,i),l=(0,u.$Ug)(s,f.$Gi),p=[];for(const D of o)p.push((0,h.$Beb)(D.uri,!0,D.name,s,u.$Lg));return{workspace:(0,$.$N_b)(l),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,$.$N_b)(o)}isUntitledWorkspace(o){return(0,f.$Hi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,u.$Ig)(o.configPath);try{await c.Promises.rm((0,E.$nc)(r));const i=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$kc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const l=await this.C(o,(0,$.$N_b)(i));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,i){return i?(0,f.$wi)(o.openedWorkspace)&&u.$Lg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,g.$K_b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,u.$Rg)(i)),detail:(0,b.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$wi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$R_b=a,e.$R_b=a=ve([ne(0,d.$t_b),ne(1,v.$Nj),ne(2,w.$H_b),ne(3,y.$y_b),ne(4,k.$z_b)],a)}),define(ae[134],ce([0,1,14,37,23,6,29,30,58,12,5,60]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=e.ID=void 0,e.ID="diagnosticsMainService",e.$bac=(0,O.$hi)(e.ID);let k=class{constructor(m,v,w){this.a=m,this.b=v,this.c=w}async getRemoteDiagnostics(m){const v=this.a.getWindows();return(await Promise.all(v.map(async g=>{const f=g.remoteAuthority;if(!f)return;const h=`vscode:getDiagnosticInfoResponse${g.id}`,$={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(a=>{g.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:h,args:$}),C.$XV.once(h,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const w of n.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(w.id);g?m.push(await this.d(g)):m.push(this.e(w))}const v=[];for(const{pid:w,name:g}of y.$$_b.getAll())v.push({pid:w,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:v,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const v=await this.f(m),w=(0,c.$6f)(m.win);return this.e(w,v,m.remoteAuthority)}e(m,v=[],w){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:v,remoteAuthority:w}}async f(m){const v=[],w=m.openedWorkspace;if((0,E.$ri)(w))v.push(w.uri);else if((0,E.$wi)(w)){const g=await this.b.resolveLocalWorkspace(w.configPath);g&&g.folders.forEach(h=>{v.push(h.uri)})}return v}};e.$cac=k,e.$cac=k=ve([ne(0,j.$E_b),ne(1,u.$Q_b),ne(2,b.$Nj)],k)}),define(ae[70],ce([0,1,48,14,26,158,50,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,78,15]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=void 0,e.$qac=(0,$.$hi)("nativeHostMainService");let B=class extends u.$Uc{constructor(W,U,x,le,se,ue,Y,Z,q){super(),this.a=W,this.b=U,this.c=x,this.f=le,this.g=se,this.h=ue,this.j=Y,this.m=Z,this.n=q,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,M=>M.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:M,x:N,y:G})=>({windowId:M.id,x:N,y:G})),({windowId:M})=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:M,x:N,y:G})=>({windowId:M.id,x:N,y:G})),({windowId:M})=>!!this.b.getWindowById(M))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,M=>M.id),M=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,M=>M.id),M=>!!this.b.getWindowById(M))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,M=>M.id),M=>!!this.a.getWindowById(M)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,M=>M.id),M=>!!this.b.getWindowById(M))),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,M=>({windowId:M.window.id,fullscreen:M.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(M,N)=>N.id),M=>!!this.a.getWindowById(M)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),M=>!!M),M=>M.id),E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(M,N)=>N.id),M=>!!this.a.getWindowById(M))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(M,N)=>N.id),M=>!!this.b.getWindowById(M))),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(M,N)=>N.id),M=>!!this.b.getWindowById(M))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$7d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(M,N,G)=>G),M=>!(Array.isArray(M)&&M.length===1&&M[0]==="workArea")),E.Event.fromNodeEventEmitter(C.screen,"display-added"),E.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,U){const x=this.a.getWindows().map(se=>({id:se.id,workspace:se.openedWorkspace??(0,s.$vi)(se.backupPath,se.isExtensionDevelopmentHost),title:se.win?.getTitle()??"",filename:se.getRepresentedFilename(),dirty:se.isDocumentEdited()})),le=[];return U.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(se=>({id:se.id,parentId:se.parentId,title:se.win?.getTitle()??"",filename:se.getRepresentedFilename()}))),[...x,...le]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const U=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(W,U,x){return Array.isArray(U)?this.s(W,U,x):this.t(W,U)}async s(W,U,x=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:W,urisToOpen:U,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async t(W,U){await this.a.openEmptyWindow({context:5,contextWindowId:W},U)}async toggleFullScreen(W,U){this.C(U?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,U){this.C(U?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const U=C.screen.getCursorScreenPoint(),x=C.screen.getDisplayNearestPoint(U);return{point:U,display:x.bounds}}async isMaximized(W,U){return this.C(U?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,U){this.C(U?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,U){this.C(U?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,U){this.C(U?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,U){this.C(U?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,U,x){const le=this.C(x?.targetWindowId,W);if(le?.win){if(le.win.isFullScreen()){const se=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await se}le.win.setBounds(U)}}async updateWindowControls(W,U){this.C(U?.targetWindowId,W)?.updateWindowControls(U)}async focusWindow(W,U){this.C(U?.targetWindowId,W)?.focus({force:U?.force??!1})}async setMinimumSize(W,U,x){const le=this.D(W);if(le?.win){const[se,ue]=le.win.getSize(),[Y,Z]=le.win.getMinimumSize(),[q,M]=[U??Y,x??Z],[N,G]=[Math.max(se,q),Math.max(ue,M)];(Y!==q||Z!==M)&&le.win.setMinimumSize(q,M),(se!==N||ue!==G)&&le.win.setSize(N,G)}}async saveWindowSplash(W,U){this.m.saveWindowSplash(W,U)}async installShellCommand(W){const{source:U,target:x}=await this.u();try{const{symbolicLink:le}=await v.SymlinkSupport.stat(U);if(le&&!le.dangling){const se=await(0,d.$Nq)(U);if(x===se)return}await v.Promises.unlink(U)}catch(le){if(le.code!=="ENOENT")throw le}try{await v.Promises.symlink(x,U)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:se}=await this.showMessageBox(W,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(se===1)throw new R.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${U}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(W){const{source:U}=await this.u();try{await v.Promises.unlink(U)}catch(x){switch(x.code){case"EACCES":{const{response:le}=await this.showMessageBox(W,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(le===1)throw new R.$5;try{const se=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(se)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw x}}}async u(){const W=(0,b.$lc)(this.g.appRoot,"bin","code"),U=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(W))throw new Error((0,g.localize)(8,null,W));return{source:U,target:W}}async showMessageBox(W,U){const x=this.C(U?.targetWindowId,W);return this.c.showMessageBox(U,x?.win??void 0)}async showSaveDialog(W,U){const x=this.C(U?.targetWindowId,W);return this.c.showSaveDialog(U,x?.win??void 0)}async showOpenDialog(W,U){const x=this.C(U?.targetWindowId,W);return this.c.showOpenDialog(U,x?.win??void 0)}async pickFileFolderAndOpen(W,U){const x=await this.c.pickFileFolder(U);x&&await this.w(await Promise.all(x.map(async le=>await v.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),U,W)}async pickFolderAndOpen(W,U){const x=await this.c.pickFolder(U);x&&await this.w(x.map(le=>({folderUri:k.URI.file(le)})),U,W)}async pickFileAndOpen(W,U){const x=await this.c.pickFile(U);x&&await this.w(x.map(le=>({fileUri:k.URI.file(le)})),U,W)}async pickWorkspaceAndOpen(W,U){const x=await this.c.pickWorkspace(U);x&&await this.w(x.map(le=>({workspaceUri:k.URI.file(le)})),U,W)}async w(W,U,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:W,forceNewWindow:U.forceNewWindow})}async showItemInFolder(W,U){C.shell.showItemInFolder(U)}async setRepresentedFilename(W,U,x){this.C(x?.targetWindowId,W)?.setRepresentedFilename(U)}async setDocumentEdited(W,U,x){this.C(x?.targetWindowId,W)?.setDocumentEdited(U)}async openExternal(W,U){return this.g.unsetSnapExportedVariables(),C.shell.openExternal(U),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,U){return C.shell.trashItem(U)}async isAdmin(){let W;return y.$i?W=(await new Promise((U,x)=>{J(["native-is-elevated"],U,x)}))():W=process.getuid?.()===0,W}async writeElevated(W,U,x,le){const se=await new Promise((ue,Y)=>{J(["@vscode/sudo-prompt"],ue,Y)});return new Promise((ue,Y)=>{const Z=[`"${this.z}"`];le?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${U.fsPath}"`,`"${x.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,b.$kc)((0,b.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};se.exec(Z.join(" "),q,(M,N,G)=>{N&&this.h.trace(`[sudo-prompt] received stdout: ${N}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),M?Y(M):ue(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:C.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,b.$kc)((0,b.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,b.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,b.$kc)((0,b.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,b.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.$kc)(this.g.appRoot,"bin","code"):(0,b.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return m.$pn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,D.$nac)()}async killProcess(W,U,x){process.kill(U,x)}async readClipboardText(W,U){return C.clipboard.readText(U)}async writeClipboardText(W,U,x){return C.clipboard.writeText(U,x)}async readClipboardFindText(W){return C.clipboard.readFindText()}async writeClipboardFindText(W,U){return C.clipboard.writeFindText(U)}async writeClipboardBuffer(W,U,x,le){return C.clipboard.writeBuffer(U,Buffer.from(x.buffer),le)}async readClipboardBuffer(W,U){return p.$ue.wrap(C.clipboard.readBuffer(U))}async hasClipboard(W,U,x){return C.clipboard.has(U,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,U){this.D(W)?.updateTouchBar(U)}async notifyReady(W){this.D(W)?.setReady()}async relaunch(W,U){return this.f.relaunch(U)}async reload(W,U){const x=this.D(W);if(x){if((0,s.$wi)(x.openedWorkspace)){const le=x.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(W,U){return this.C(U?.targetWindowId,W)?.win?.close()}async quit(W){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.f.quit()}async exit(W,U){await this.f.kill(U)}async resolveProxy(W,U){return this.D(W)?.win?.webContents?.session?.resolveProxy(U)}async loadCertificates(W){return(await new Promise((x,le)=>{J(["@vscode/proxy-agent"],x,le)})).loadSystemCertificates({log:this.h})}findFreePort(W,U,x,le,se=1){return(0,w.$Fg)(U,x,le,se)}async openDevTools(W,U){this.C(U?.targetWindowId,W)?.win?.webContents.openDevTools(U?.mode?{mode:U.mode,activate:U.activate}:void 0)}async toggleDevTools(W,U){this.C(U?.targetWindowId,W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,U,x){const le=this.D(W);if(!le||!le.win)throw new Error;return await new I.$oac(le.win,U,this.h).inspect(x)}async windowsGetStringRegKey(W,U,x,le){if(!y.$i)return;const se=await new Promise((ue,Y)=>{J(["@vscode/windows-registry"],ue,Y)});try{return se.GetStringRegKey(U,x,le)}catch{return}}C(W,U){return this.D(W)??this.F(W)??this.D(U)}D(W){if(typeof W=="number")return this.a.getWindowById(W)}F(W){if(typeof W=="number")return this.b.getWindowById(W)}};e.$rac=B,ve([j.$Lh],B.prototype,"z",null),e.$rac=B=ve([ne(0,i.$E_b),ne(1,S.$pac),ne(2,f.$z_b),ne(3,a.$X_b),ne(4,h.$t_b),ne(5,t.$Nj),ne(6,o.$7j),ne(7,r.$C_b),ne(8,l.$Q_b)],B)}),define(ae[303],ce([0,1,14,26,8,23,33,2,13,4,7,111,37,182,92,134,56,24,5,70,79,27,80,34,60,55,29]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;const p="issue.processExplorerWindowState";let D=class{static{l=this}static{this.a="#1E1E1E"}constructor(R,B,L,W,U,x,le,se,ue,Y,Z){this.g=R,this.h=B,this.i=L,this.j=W,this.k=U,this.l=x,this.m=le,this.n=se,this.o=ue,this.p=Y,this.q=Z,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$XV.on("vscode:listProcesses",async R=>{const B=[];try{B.push({name:(0,d.localize)(0,null),rootProcess:await(0,y.$ks)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$2m)(W)?B.push({name:W.hostName,rootProcess:W}):W.processes&&B.push({name:W.hostName,rootProcess:W.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.t(R,"vscode:listProcessesResponse",B)}),k.$XV.on("vscode:workbenchCommand",(R,B)=>{const{id:L,from:W,args:U}=B;let x;switch(W){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}x?.webContents.send("vscode:runAction",{id:L,from:W,args:U})}),k.$XV.on("vscode:closeProcessExplorer",R=>{this.d?.close()}),k.$XV.on("vscode:pidToNameRequest",async R=>{const B=await this.k.getMainDiagnostics(),L=[];for(const W of B.windows)L.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:U}of r.$$_b.getAll())L.push([W,U]);this.t(R,"vscode:pidToNameResponse",L)})}async openReporter(R){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const B=new E.$Tc,L=B.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,L,{backgroundColor:R.styles.backgroundColor,title:(0,d.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:R,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:$.default}),this.b.loadURL(u.$Bg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,B.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,B.dispose())})}}async openProcessExplorer(R){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const B=new E.$Tc,L=B.add(this.n.createIPCObjectUrl()),W=this.p.getItem(p,void 0),U=I(W)?W:this.v(this.f,800,500);this.d=this.u(U,L,{backgroundColor:R.styles.backgroundColor,title:(0,d.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:R,product:$.default}),this.d.loadURL(u.$Bg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,B.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,B.dispose())});const x=()=>{if(!this.d)return;const le=this.d.getSize(),se=this.d.getPosition();if(!le||!se)return;const ue={width:le[0],height:le[1],x:se[0],y:se[1]};this.p.setItem(p,ue)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const R=await n.contentTracing.stopRecording(`${(0,j.$pg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null,R),buttons:[(0,d.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,B]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(R,B)}async $getSystemInfo(){const[R,B]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(R,B)}async $getPerformanceInfo(){try{const[R,B]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(R,B)}catch(R){throw this.i.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(R){this.i.error(R)}}async $showConfirmCloseDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(6,null),buttons:[(0,d.localize)(7,null),(0,d.localize)(8,null)]},this.b);R===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(9,null),buttons:[(0,d.localize)(10,null),(0,d.localize)(11,null)]},this.b);return R===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const R=this.q.getWindowById(this.c.id);if(!R)throw new Error("Window not found");return R}async $getIssueReporterUri(R){const B=this.issueReporterWindowCheck(),L=`vscode:triggerIssueUriRequestHandlerResponse${B.id}`;return P.Promises.withAsyncBody(async(W,U)=>{const x=new O.$ee;B.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:L,extensionId:R}),k.$XV.once(L,(le,se)=>{W(b.URI.parse(se))});try{await(0,P.$ih)(5e3),x.cancel(),U(new Error("Timed out waiting for issue reporter URI"))}finally{k.$XV.removeHandler(L)}})}async $getIssueReporterData(R){const B=this.issueReporterWindowCheck(),L=`vscode:triggerIssueDataProviderResponse${B.id}`;return P.Promises.withAsyncBody(async W=>{const U=new O.$ee;B.sendWhenReady("vscode:triggerIssueDataProvider",U.token,{replyChannel:L,extensionId:R}),k.$XV.once(L,(x,le)=>{W(le)});try{await(0,P.$ih)(5e3),U.cancel(),W("Error: Extension timed out waiting for issue reporter data")}finally{k.$XV.removeHandler(L)}})}async $getIssueReporterTemplate(R){const B=this.issueReporterWindowCheck(),L=`vscode:triggerIssueDataTemplateResponse${B.id}`;return P.Promises.withAsyncBody(async W=>{const U=new O.$ee;B.sendWhenReady("vscode:triggerIssueDataTemplate",U.token,{replyChannel:L,extensionId:R}),k.$XV.once(L,(x,le)=>{W(le)});try{await(0,P.$ih)(5e3),U.cancel(),W("Error: Extension timed out waiting for issue reporter template")}finally{k.$XV.removeHandler(L)}})}async $getReporterStatus(R,B){const L=[!1,!1],W=this.issueReporterWindowCheck(),U="vscode:triggerReporterStatus",x=new O.$ee;return W.sendWhenReady(U,x.token,{replyChannel:U,extensionId:R,extensionName:B}),await(0,P.$$g)(new Promise(se=>k.$XV.once("vscode:triggerReporterStatusResponse",(ue,Y)=>se(Y))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),x.cancel()})??L}async $sendReporterMenu(R,B){const L=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",U=new O.$ee;return L.sendWhenReady(W,U.token,{replyChannel:W,extensionId:R,extensionName:B}),await(0,P.$$g)(new Promise(le=>k.$XV.once(`vscode:triggerReporterMenuResponse:${R}`,(se,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${R} timed out waiting for menu response`),U.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(R){R.isMinimized()&&R.restore(),R.focus()}t(R,B,...L){R.sender.isDestroyed()||R.sender.send(B,...L)}u(R,B,L,W){const U=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:L.title,backgroundColor:L.backgroundColor||l.a,webPreferences:{preload:u.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${B.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$hD)(L.zoomLevel),sandbox:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return U.setMenuBarVisibility(!1),U}v(R,B,L){let W;const U=n.screen.getAllDisplays();if(U.length===1)W=U[0];else{if(c.$j){const se=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(se)}!W&&R&&(W=n.screen.getDisplayMatching(R.getBounds())),W||(W=n.screen.getPrimaryDisplay()||U[0])}const x=W.bounds,le={width:B,height:L,x:x.x+x.width/2-B/2,y:x.y+x.height/2-L/2};return x.width>0&&x.height>0&&(le.x<x.x&&(le.x=x.x),le.y<x.y&&(le.y=x.y),le.x>x.x+x.width&&(le.x=x.x),le.y>x.y+x.height&&(le.y=x.y),le.width>x.width&&(le.width=x.width),le.height>x.height&&(le.height=x.height)),le}};e.$sac=D,e.$sac=D=l=ve([ne(1,g.$t_b),ne(2,f.$Nj),ne(3,m.$1m),ne(4,v.$bac),ne(5,w.$z_b),ne(6,h.$qac),ne(7,t.$B_b),ne(8,a.$7j),ne(9,o.$QP),ne(10,s.$E_b)],D);function I(S){return typeof S!="object"||S===null?!1:"x"in S&&"y"in S&&"width"in S&&"height"in S}}),define(ae[304],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(J,e,n,C,P,O,j,E,u,c,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;let d=class extends k.$Rac{constructor(v,w,g,f,h,$,a,t){super(v,w,f,h,$,t),this.e=g,this.u=a}s(v){return(0,k.$Qac)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$VW.CheckingForUpdates(v)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Ep).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$VW.Idle(1))):this.d(y.$VW.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const g=v?w.message||w:void 0;this.d(y.$VW.Idle(1,g))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$VW.Idle(1))}};e.$Tac=d,e.$Tac=d=ve([ne(0,O.$X_b),ne(1,C.$Ni),ne(2,b.$Ml),ne(3,P.$t_b),ne(4,c.$yp),ne(5,j.$Nj),ne(6,E.$qac),ne(7,u.$7j)],d)}),define(ae[305],ce([0,1,48,43,26,8,23,50,46,9,7,146,21,18,24,16,20,5,70,27,53,28,49,101]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;async function r(p,D=1e3){for(;!p();)await(0,O.$ih)(D)}let i;function s(){return typeof i>"u"&&(i=C.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends o.$Rac{get cachePath(){const D=c.$kc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,I,S,R,B,L,W,U,x){super(D,I,R,B,L,x),this.u=S,this.v=W,this.w=U,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$VW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(D){let I=`win32-${process.arch}`;return s()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$Qac)(I,D,this.k)}t(D){this.a&&(this.d(t.$VW.CheckingForUpdates(D)),this.i.request({url:this.a},j.CancellationToken.None).then($.$Ep).then(I=>{const S=s();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!D}),this.d(t.$VW.Idle(S)),Promise.resolve(null)):S===1?(this.d(t.$VW.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$VW.Downloading),this.C(I.version).then(()=>this.B(I.version).then(R=>k.Promises.exists(R).then(B=>{if(B)return Promise.resolve(R);const L=`${R}.tmp`;return this.i.request({url:I.url},j.CancellationToken.None).then(W=>this.v.writeFile(b.URI.file(L),W.stream)).then(I.sha256hash?()=>(0,y.$SV)(L,I.sha256hash):()=>{}).then(()=>k.Promises.rename(L,R,!1)).then(()=>R)})).then(R=>{this.e={packagePath:R},this.d(t.$VW.Downloaded(I)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$VW.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,u.$8i)(String(I)))}),this.j.error(I);const S=D?I.message||I:void 0;this.d(t.$VW.Idle(s(),S))}))}async o(D){D.update.url&&this.w.openExternal(void 0,D.update.url),this.d(t.$VW.Idle(s()))}async B(D){const I=await this.cachePath;return c.$kc(I,`CodeSetup-${this.k.quality}-${D}.exe`)}async C(D=null){const I=D?L=>!new RegExp(`${this.k.quality}-${D}\\.exe$`).test(L):()=>!0,S=await this.cachePath,B=(await k.Promises.readdir(S)).filter(I).map(async L=>{try{await k.Promises.unlink(c.$kc(S,L))}catch{}});await Promise.all(B)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const D=this.state.update;this.d(t.$VW.Updating(D));const I=await this.cachePath;this.e.updateFilePath=c.$kc(I,`CodeSetup-${this.k.quality}-${D.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$VW.Idle(s()))});const R=`${this.k.win32MutexName}-ready`,B=await new Promise((L,W)=>{J(["@vscode/windows-mutex"],L,W)});r(()=>B.isActive(R)).then(()=>this.d(t.$VW.Ready(D)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(D){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),S={version:"unknown",productVersion:"unknown"};this.d(t.$VW.Downloading),this.e={packagePath:D},this.d(t.$VW.Downloaded(S)),I?this.k.target==="user"&&this.p():this.d(t.$VW.Ready(S))}};e.$Vac=l,ve([E.$Lh],l.prototype,"cachePath",null),e.$Vac=l=ve([ne(0,w.$X_b),ne(1,d.$Ni),ne(2,a.$Ml),ne(3,m.$t_b),ne(4,$.$yp),ne(5,g.$Nj),ne(6,v.$Nk),ne(7,f.$qac),ne(8,h.$7j)],l)}),define(ae[135],ce([0,1,14,8,23,51,3,2,13,66,4,7,193,26,64,18,56,24,63,16,20,5,27,80,256,83,28,106,69,55,29,30,58,81,39,34,57,67,22,6]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R,B,L,W,U,x,le,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0;var ue;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ue||(ue={}));class Y extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(M){this.m=M,this.B(j.Event.fromNodeEventEmitter(M,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(M,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(M,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(M,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,D.$dD)(this.r);if(b.$j&&N&&M.setSheetOffset((0,b.$J)((0,d.release)())?28:22),N&&(b.$i&&(0,D.$fD)(this.r)||b.$j)){const G=this.s.getItem(Y.C);G&&this.updateWindowControls({height:G})}b.$i&&N&&M.hookWindowMessage(278,()=>{const[z,oe]=M.getPosition(),he=n.screen.getCursorScreenPoint(),X=he.x-z,A=he.y-oe;return!(X>30&&A>=0&&A<=Math.max(M.getBounds().height*.15,35))||(M.setEnabled(!1),M.setEnabled(!0),this.f.fire({x:X,y:A})),0}),this.t.args["open-devtools"]===!0&&M.webContents.openDevTools(),b.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(M,N,G,z){super(),this.r=M,this.s=N,this.t=G,this.u=z,this.a=this.B(new j.$7d),this.onDidClose=this.a.event,this.b=this.B(new j.$7d),this.onDidMaximize=this.b.event,this.c=this.B(new j.$7d),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$7d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$7d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,D.$fD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(M){b.$j?this.win?.setRepresentedFilename(M):this.w=M}getRepresentedFilename(){return b.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(M){b.$j&&this.win?.setDocumentEdited(M),this.z=M}isDocumentEdited(){return b.$j?!!this.win?.isDocumentEdited():!!this.z}focus(M){b.$j&&M?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const M=this.win;if(M)if(b.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":M.minimize();break;case"None":break;case"Maximize":default:M.isMaximized()?M.unmaximize():M.maximize()}else M.isMaximized()?M.unmaximize():M.maximize()}static{this.C="windowControlHeight"}updateWindowControls(M){const N=this.win;if(N){if(M.height&&this.s.setItem(Z.C,M.height),b.$i&&this.D)N.setTitleBarOverlay({color:M.backgroundColor?.trim()===""?void 0:M.backgroundColor,symbolColor:M.foregroundColor?.trim()===""?void 0:M.foregroundColor,height:M.height?M.height-1:void 0});else if(b.$j&&M.height!==void 0){const G=(M.height-15)/2;G?N.setWindowButtonPosition({x:G,y:G}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(M,N){(0,D.$gD)(this.r)?this.I(M,N):this.L(M)}get isFullScreen(){if(b.$j&&typeof this.F=="boolean")return this.F;const M=this.win,N=M?.isFullScreen(),G=M?.isSimpleFullScreen();return!!(N||G)}I(M,N){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(M,N)}J(M,N){if(b.$j){this.F=M;const z=this.G=new C.$Eh;(async()=>{const oe=await Promise.race([z.p,(0,C.$ih)(1e4).then(()=>!1)]);this.G===z&&(this.F=void 0,this.G=void 0,!oe&&M&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(M)}L(M){const N=this.win;N?.isFullScreen()&&this.J(!1,!1),N?.setSimpleFullScreen(M),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$U_b=Y;let Z=class extends Y{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const M=this.gb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&M?M:this.gb.getProfileForWorkspace(this.config.workspace??(0,S.$vi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(M,N,G,z,oe,he,X,A,F,_,re,K,V,H,T,Q,te,fe,me,ke,Se){super(_,ke,z,N),this.eb=G,this.fb=oe,this.gb=he,this.hb=X,this.ib=A,this.jb=F,this.kb=re,this.lb=K,this.mb=V,this.nb=H,this.ob=T,this.pb=Q,this.qb=te,this.rb=fe,this.sb=me,this.M=this.B(new j.$7d),this.onWillLoad=this.M.event,this.N=this.B(new j.$7d),this.onDidSignalReady=this.N.event,this.O=this.B(new j.$7d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Oe,Ve]=this.Db(M.state);this.S=Oe,this.u.trace("window#ctor: using window state",Oe);const ye=this.S.mode===0||this.S.mode===3,ee=Se.invokeFunction(I.$F_b,this.S,{show:!ye,webPreferences:{preload:u.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(ee),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const de=this.r.getValue("window"),$e=b.$j&&de?.nativeTabs===!0;(b.$j||b.$i)&&Ve&&(!$e||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(M=>{if(this.isReady)return M(this);this.W.push(M)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(M=>{function N(){G.dispose(),z.dispose(),M()}const G=this.onDidClose(()=>N()),z=this.onWillLoad(()=>N())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,z)=>this.xb(3,{reason:z,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Ab(N))),this.B(this.lb.onDidDeleteUntitledWorkspace(N=>this.zb(N)));const M=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:M},async(N,G)=>{const z=await this.wb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,z)})})}wb(){return this.vb||(this.vb=(0,r.$Sp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(M,N){switch(M){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:M,reason:N?.reason,code:N?.exitCode}),M){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(M===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:z}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,z)}}else if(M===2){let G;N?G=(0,k.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:z,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=z===0;await this.yb(he,oe)}break}}async yb(M,N){const G=this.R?.workspace;if(N&&G)try{const z=this.jb.workspaceStorage(G);await z.init(),z.delete("memento/workbench.parts.editor"),await z.close()}catch(z){this.u.error(z)}this.O.fire();try{if(M&&this.R){let z,oe;(0,S.$ri)(G)?z={folderUri:G.uri}:(0,S.$wi)(G)?z={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:z?[z]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(M){this.R?.workspace?.id===M.id&&(this.R.workspace=void 0)}Ab(M){if(!M||M.affectsConfiguration("window.menuBarVisibility")){const N=this.Fb();N!==this.U&&(this.U=N,this.Gb(N))}if(!M||M.affectsConfiguration("http.proxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Y||G!==this.Z)){this.Y=N,this.Z=G;const z=N||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${z}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:z,proxyBypassRules:oe,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:z,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(M){b.$j&&M.win&&this.m.addTabbedWindow(M.win)}load(M,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!N.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(M,N),this.tb===0?this.R=M:this.bb=M,this.tb=1,this.m.loadURL(u.$Bg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new C.$th(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:M.workspace,reason:N.isReload?3:G?2:1})}Bb(M,N){const G=(this.R??this.bb)?.userEnv;if(G){const z=(0,f.$lm)(G)&&!(0,f.$lm)(M.userEnv),oe=this.isExtensionDevelopmentHost;(z||oe)&&(M.userEnv={...G,...M.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(M.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(M["disable-extensions"]=N.disableExtensions),M.fullscreen=this.isFullScreen,M.maximized=this.m.isMaximized(),M.partsSplash=this.kb.getWindowSplash(),M.zoomLevel=this.Ib(),M.isCustomZoomLevel=typeof this.$=="number",M.isCustomZoomLevel&&M.partsSplash&&(M.partsSplash.zoomLevel=M.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),M.perfMarks=(0,c.getMarks)(),this.ab.update(M)}async reload(M){const N=Object.assign({},this.R);N.workspace=await this.Cb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&M&&(N.verbose=M.verbose,N.debugId=M.debugId,N.extensionEnvironment=M.extensionEnvironment,N["inspect-extensions"]=M["inspect-extensions"],N["inspect-brk-extensions"]=M["inspect-brk-extensions"],N["extensions-dir"]=M["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.fb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},N.logLevel=this.eb.getLogLevel(),N.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:M?.["disable-extensions"]})}async Cb(M){if((0,S.$wi)(M.workspace)){const N=M.workspace.configPath;if(N.scheme===u.Schemas.file&&!await this.hb.exists(N))return}else if((0,S.$ri)(M.workspace)){const N=M.workspace.uri;if(N.scheme===u.Schemas.file&&!await this.hb.exists(N))return}return M.workspace}serializeWindowState(){if(!this.m)return(0,B.$r_b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const z=(0,B.$r_b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||z.width,height:this.S.height||z.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const M=Object.create(null);let N;if(!b.$j&&this.m.isMaximized()?N=0:N=1,N===0?M.mode=0:M.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),M.x=G.x,M.y=G.y,M.width=G.width,M.height=G.height}return M.zoomLevel=this.$,M}Db(M){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(M){this.$=M.zoomLevel;try{const G=n.screen.getAllDisplays();N=G.length>1,M=I.WindowStateValidator.validateWindowState(this.u,M,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[M||(0,B.$r_b)(),N]}getBounds(){const[M,N]=this.m.getPosition(),[G,z]=this.m.getSize();return{x:M,y:N,width:G,height:z}}H(M,N){super.H(M,N),this.sendWhenReady(M?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let M=(0,D.$bD)(this.r);return["visible","toggle","hidden"].indexOf(M)<0&&(M="classic"),M}Gb(M,N=!0){b.$j||(M==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),M==="hidden"?setTimeout(()=>{this.Hb(M)}):this.Hb(M))}Hb(M){const N=this.isFullScreen;switch(M){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(M){this.$=M}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(M,N,...G){this.isReady?this.send(M,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(M,...G)})}send(M,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${M}' for window that is destroyed`);return}try{this.m.webContents.send(M,...N)}catch(G){this.u.warn(`Error sending IPC message to channel '${M}' of window ${this.P}: ${(0,O.$5i)(G)}`)}}}updateTouchBar(M){b.$j&&this.X.forEach((N,G)=>{const z=M[G];N.segments=this.Lb(z)})}Jb(){if(b.$j){for(let M=0;M<10;M++){const N=this.Kb();this.X.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(M=[]){const N=this.Lb(M),G=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:G.segments[z].id,from:"touchbar"})}});return G}Lb(M=[]){return M.map(G=>{let z;G.icon&&!l.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===u.Schemas.file&&(z=n.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:z?void 0:oe,icon:z}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$V_b=Z,e.$V_b=Z=ve([ne(1,a.$Nj),ne(2,x.$S_b),ne(3,g.$t_b),ne(4,L.$2n),ne(5,U.$H_b),ne(6,h.$Nk),ne(7,i.$6_b),ne(8,i.$4_b),ne(9,v.$Ni),ne(10,p.$C_b),ne(11,R.$Q_b),ne(12,m.$y_b),ne(13,s.$Ml),ne(14,w.$z_b),ne(15,$.$X_b),ne(16,t.$7j),ne(17,o.$B_b),ne(18,I.$E_b),ne(19,W.$QP),ne(20,se.$gi)],Z)}),define(ae[306],ce([0,1,14,4,18,24,20,5,34,55,135]),function(J,e,n,C,P,O,j,E,u,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;let y=class extends b.$U_b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(d,m,v,w,g,f){super(w,g,m,v),this.M=d,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const d=n.BrowserWindow.fromWebContents(this.M);d&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(d),d.setMenu(null),(C.$i||C.$k)&&(0,c.$dD)(this.r)&&d.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$W_b=y,e.$W_b=y=ve([ne(1,O.$t_b),ne(2,E.$Nj),ne(3,P.$Ni),ne(4,u.$QP),ne(5,j.$X_b)],y)}),define(ae[307],ce([0,1,14,3,2,13,37,306,6,5,81,29]),function(J,e,n,C,P,O,j,E,u,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;let k=class extends P.$Uc{constructor(m,v){super(),this.h=m,this.j=v,this.a=this.B(new C.$7d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new C.$7d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new C.$7d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new C.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,v)=>{const w=this.getWindowById(v.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),j.$XV.handle("vscode:registerAuxiliaryWindow",async(m,v)=>{const w=this.getWindowById(m.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=v),m.sender.id})}createWindow(m){return this.h.invokeFunction(y.$F_b,this.n(m),{webPreferences:{preload:O.$Bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const v={},w=m.features.split(",");for(const f of w){const[h,$]=f.split("=");switch(h){case"width":v.width=parseInt($,10);break;case"height":v.height=parseInt($,10);break;case"left":v.x=parseInt($,10);break;case"top":v.y=parseInt($,10);break}}const g=y.WindowStateValidator.validateWindowState(this.j,v)??(0,b.$s_b)();return this.j.trace("[aux window] using window state",g),g}registerWindow(m){const v=new P.$Tc,w=this.h.createInstance(E.$W_b,m);this.g.set(w.id,w),v.add((0,P.$Sc)(()=>this.g.delete(w.id))),v.add(w.onDidMaximize(()=>this.a.fire(w))),v.add(w.onDidUnmaximize(()=>this.b.fire(w))),v.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),v.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),v.add(w.onDidTriggerSystemContextMenu(({x:g,y:f})=>this.f.fire({window:w,x:g,y:f}))),C.Event.once(w.onDidClose)(()=>v.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.$G_b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$obc=k,e.$obc=k=ve([ne(0,u.$gi),ne(1,c.$Nj)],k)}),define(ae[84],ce([0,1,14,22,8,3,47,2,13,4,19,7,21,196,6,20,5,83,98,30,58,31,56]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=void 0,e.$Cac=(0,m.$hi)("workspacesHistoryMainService");let r=class extends E.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,l,p,D,I){super(),this.f=s,this.g=l,this.h=p,this.j=D,this.m=I,this.c=this.B(new O.$7d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$fh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let l=[],p=[];for(const I of s)if((0,f.$xeb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(l,I.workspace)&&l.push(I);else if((0,f.$yeb)(I))this.y(l,I.folderUri)||l.push(I);else{const S=this.z(p,I.fileUri),R=I.fileUri.scheme===u.Schemas.file&&o.G.indexOf((0,b.$Rg)(I.fileUri))>=0;!S&&!R&&(p.push(I),c.$i&&I.fileUri.scheme===u.Schemas.file&&n.app.addRecentDocument(I.fileUri.fsPath))}const D=await this.r({workspaces:l,files:p});l=D.workspaces,p=D.files,l.length>o.a&&(l.length=o.a),p.length>o.a&&(p.length=o.a),await this.t({workspaces:l,files:p}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const l=S=>{const R=this.u(S);for(const B of s)if(b.$Lg.isEqual(B,R))return!1;return!0},p=await this.getRecentlyOpened(),D=p.workspaces.filter(l),I=p.files.filter(l);(D.length!==p.workspaces.length||I.length!==p.files.length)&&(await this.t({files:I,workspaces:D}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null)],message:(0,d.localize)(2,null),detail:(0,d.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const l=new a.$Bc(I=>b.$Lg.getComparisonKey(I));if(s?.workspaces)for(const I of s.workspaces)l.set(this.u(I),I);const p=new a.$Bc(I=>b.$Lg.getComparisonKey(I));if(s?.files)for(const I of s.files)p.set(this.u(I),I);const D=await this.s();for(const I of D.workspaces){const S=l.get(this.u(I));S?S.label=S.label??I.label:l.set(this.u(I),I)}for(const I of D.files){const S=p.get(this.u(I));S?S.label=S.label??I.label:p.set(this.u(I),I)}return{workspaces:[...l.values()],files:[...p.values()]}}async s(){await this.j.whenReady;let s;const l=this.j.get(o.b,-1);if(typeof l=="string")try{s=JSON.parse(l)}catch(p){this.f.error("Unexpected error parsing opened paths list",p)}return(0,f.$Eeb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$Feb)(s)),-1,1)}u(s){return(0,f.$yeb)(s)?s.folderUri:(0,f.$zeb)(s)?s.fileUri:s.workspace.configPath}w(s,l){return!!s.find(p=>(0,f.$xeb)(p)&&p.workspace.id===l.id)}y(s,l){return!!s.find(p=>(0,f.$yeb)(p)&&b.$Lg.isEqual(p.folderUri,l))}z(s,l){return!!s.find(p=>b.$Lg.isEqual(p.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(4,null),description:(0,d.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const I of n.app.getJumpListSettings().removedItems){const S=I.args;if(S){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);R&&l.push(y.URI.parse(R[2]))}}await this.removeRecentlyOpened(l);let p=!1;const D=(0,C.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const S=(0,f.$xeb)(I)?I.workspace:I.folderUri,{title:R,description:B}=this.L(S,I.label);let L;return y.URI.isUri(S)?L=`--folder-uri "${S.toString()}"`:(p=!0,L=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:B.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&s.push({type:"custom",name:p?(0,d.localize)(6,null):(0,d.localize)(7,null),items:D})}s.push({type:"recent"});try{const l=n.app.setJumpList(s);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(s,l){if(l)return{title:(0,j.$nw)(l).name,description:l};if(y.URI.isUri(s))return{title:(0,b.$Rg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,d.localize)(8,null),description:""};let p=(0,b.$Rg)(s.configPath);return p.endsWith(h.$Di)&&(p=p.substr(0,p.length-h.$Di.length-1)),{title:(0,d.localize)(9,null,p),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,j.$fw)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),l=[];let p=0;for(let I=0;I<s.workspaces.length&&p<o.C;I++){const S=this.u(s.workspaces[I]);if(S.scheme===u.Schemas.file){const R=(0,b.$Ig)(S);await k.Promises.exists(R)&&(l.push(R),p++)}}const D=[];for(let I=0;I<s.files.length&&p<o.D;I++){const S=this.u(s.files[I]);if(S.scheme===u.Schemas.file){const R=(0,b.$Ig)(S);if(o.G.includes((0,b.$Rg)(S))||l.includes(R))continue;await k.Promises.exists(R)&&(D.push(R),p++)}}D.reverse().forEach(I=>n.app.addRecentDocument(I)),l.reverse().forEach(I=>n.app.addRecentDocument(I))}};e.$Dac=r,e.$Dac=r=o=ve([ne(0,w.$Nj),ne(1,$.$Q_b),ne(2,v.$X_b),ne(3,g.$6_b),ne(4,t.$z_b)],r)}),define(ae[308],ce([0,1,14,8,23,47,4,7,184,78,18,24,20,5,235,70,27,34,28,49,55,29,84]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(p,D,I,S,R,B,L,W,U,x,le,se){this.n=p,this.o=D,this.p=I,this.q=S,this.r=R,this.s=B,this.t=L,this.u=W,this.v=U,this.w=x,this.x=le,this.y=se,this.m=Object.create(null),this.g=new C.$th(()=>this.F(),0),this.h=new C.$th(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,$.$dD)(D))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const p=this.t.getItem(o.a);p&&(p.menus&&(this.k=p.menus),p.keybindings&&(this.l=p.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(B,L,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:L?.id})},this.m["workbench.action.newWindow"]=(B,L,W)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(B,L,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(B,L,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(B,L,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const p=this.x.youTubeUrl;p&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(p,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const B=S.indexOf("?")>0?"&":"?";this.ab(`${S}${B}lang=${j.$w}`,"openLicenseUrl")}else this.ab(S,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(R,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(p=>this.G(p)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const p=this.o.getValue("window.enableMenuBarMnemonics");return typeof p!="boolean"?!0:p}get D(){if(!j.$j)return!1;const p=this.o.getValue("window.nativeTabs");return typeof p!="boolean"?!1:p}updateMenu(p,D){this.k=p.menus,this.l=p.keybindings,this.t.setItem(o.a,p),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(p){j.$j&&(p.oldCount===0&&p.newCount>0||p.oldCount>0&&p.newCount===0)&&(this.d=p.newCount===0,this.E())}H(){if(!j.$j)return;const p=n.BrowserWindow.getFocusedWindow();this.f=!p||!!this.y.getWindowById(p.id),this.E()}I(){const p=n.Menu.getApplicationMenu();if(p&&this.j.push(p),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const D=new n.Menu;let I;if(j.$j){const R=new n.Menu;I=new n.MenuItem({label:this.x.nameShort,submenu:R}),this.K(R),D.append(I)}if(j.$j&&!this.c){this.c=!0;const R=new n.Menu;R.append(new n.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(R)}if(this.M("File")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(1,null)),submenu:R});this.O(R,"File"),D.append(B)}if(this.M("Edit")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(2,null)),submenu:R});this.O(R,"Edit"),D.append(B)}if(this.M("Selection")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(3,null)),submenu:R});this.O(R,"Selection"),D.append(B)}if(this.M("View")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(4,null)),submenu:R});this.O(R,"View"),D.append(B)}if(this.M("Go")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(5,null)),submenu:R});this.O(R,"Go"),D.append(B)}if(this.M("Run")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(6,null)),submenu:R});this.O(R,"Run"),D.append(B)}if(this.M("Terminal")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(7,null)),submenu:R});this.O(R,"Terminal"),D.append(B)}let S;if(this.M("Window")){const R=new n.Menu;S=new n.MenuItem({label:this.cb(u.localize(8,null)),submenu:R,role:"window"}),this.U(R)}if(S&&D.append(S),this.M("Help")){const R=new n.Menu,B=new n.MenuItem({label:this.cb(u.localize(9,null)),submenu:R,role:"help"});this.O(R,"Help"),D.append(B)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(p){if(n.Menu.setApplicationMenu(p),p)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(p){const D=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let S;if(this.M("Preferences")){const se=new n.Menu;this.O(se,"Preferences"),S=new n.MenuItem({label:this.cb(u.localize(11,null)),submenu:se})}const R=new n.Menu,B=new n.MenuItem({label:u.localize(12,null),role:"services",submenu:R}),L=new n.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new n.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),U=new n.MenuItem({label:u.localize(15,null),role:"unhide"}),x=new n.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(se,ue,Y)=>{const Z=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Z?.win?.isMinimized())&&await this.L(Y)&&this.w.quit(void 0)}})),le=[D];le.push(...I),S&&le.push(s(),S),le.push(s(),B,s(),L,W,U,s(),x),le.forEach(se=>p.append(se))}async L(p){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(p)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return I===0}return!0}M(p){if(!j.$j&&!(0,$.$dD)(this.o))return!1;switch(p){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[p];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[p]}}N(p,D){D.forEach(I=>{if((0,m.$zac)(I))p.append(s());else if((0,m.$yac)(I)){const S=new n.Menu,R=new n.MenuItem({label:this.cb(I.label),submenu:S});this.N(S,I.submenu.items),p.append(R)}else(0,m.$Aac)(I)?p.append(this.Q(I)):(0,m.$Bac)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(p),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?p.append(new n.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):p.append(this.W(I.label,I.id,!1,I.checked)):p.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):p.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(p,D){this.k&&this.k[D]&&this.N(p,this.k[D].items)}P(p){const D=this.V();D.length&&(D.forEach(I=>p.append(I)),p.append(s()))}Q(p){const D=E.URI.revive(p.uri),I=p.id,S=I==="openRecentFile"?{fileUri:D}:I==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.$(I,{label:p.label,click:async(R,B,L)=>{const W=this.R(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:p.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(p){return!!(p&&(!j.$j&&(p.ctrlKey||p.shiftKey)||j.$j&&(p.metaKey||p.altKey)))}S(p){return!!(p.triggeredByAccelerator||p.altKey||p.ctrlKey||p.metaKey||p.shiftKey)}T(p,D,I){const S={label:this.cb(p),role:I,enabled:!0};return new n.MenuItem(this.Z(D,S))}U(p){const D=new n.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new n.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.W(u.localize(23,null),"workbench.action.switchWindow"),B=[];this.D&&(B.push(s()),B.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),B.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),B.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),B.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),B.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,I,s(),R,...B,s(),S].forEach(L=>p.append(L))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(p,D,I,S){const R=this.cb(p),B=typeof D=="function"?D:(le,se,ue)=>{const Y=le?le.userSettingsLabel:null;let Z=D;Array.isArray(D)&&(Z=this.R(ue)?D[1]:D[0]),Y&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Y}):this.Y({type:"commandId",commandId:Z})},L=typeof I=="boolean"?I:this.p.getWindowCount()>0,W=typeof S=="boolean"?S:!1,U={label:R,click:B,enabled:L};W&&(U.type="checkbox",U.checked=W);let x;return typeof D=="string"?x=D:Array.isArray(D)&&(x=D[0]),j.$j&&(x==="editor.action.clipboardCutAction"?U.role="cut":x==="editor.action.clipboardCopyAction"?U.role="copy":x==="editor.action.clipboardPasteAction"&&(U.role="paste"),x==="undo"?U.click=this.X(B,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?U.click=this.X(B,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(U.click=this.X(B,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(x,U))}X(p,D){return(I,S,R)=>{const B=n.BrowserWindow.getFocusedWindow();if(!B)return D.inNoWindow();if(B.webContents.isDevToolsFocused()&&B.webContents.devToolsWebContents)return D.inDevTools(B.webContents.devToolsWebContents);p(I,S||B,R)}}Y(p){let D=n.BrowserWindow.getFocusedWindow();if(D){const S=this.y.getWindowById(D.id);S&&(D=this.p.getWindowById(S.parentId)?.win??null)}if(!D){const S=this.p.getLastActiveWindow();S?.win?.isMinimized()&&(D=S.win)}const I=D?this.p.getWindowById(D.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",p),j.$j&&!this.q.isBuilt&&!I.isReady&&(p.type==="commandId"&&p.commandId==="workbench.action.toggleDevTools"||p.type!=="commandId"&&p.userSettingsLabel==="alt+cmd+i"))return!1;if(p.type==="commandId"){const S={id:p.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",P.CancellationToken.None,S)}else{const S={userSettingsLabel:p.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,S)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",p),!1}Z(p,D){const I=typeof p=="string"?this.l[p]:void 0;if(I?.label){if(I.isNative!==!1)D.accelerator=I.label,D.userSettingsLabel=I.userSettingsLabel;else if(typeof D.label=="string"){const S=D.label.indexOf("[");S>=0?D.label=`${D.label.substr(0,S)} [${I.label}]`:D.label=`${D.label} [${I.label}]`}}else D.accelerator=void 0;return D}$(p,D,I=!D.accelerator){I&&(D=this.Z(p,D));const S=D.click;return D.click=(R,B,L)=>{this.bb(p),S?.(R,B,L)},D}ab(p,D){this.w.openExternal(void 0,p),this.bb(D)}bb(p){this.r.publicLog2("workbenchActionExecuted",{id:p,from:r})}cb(p){return(0,O.$kw)(p,!this.C)}};e.$Eac=i,e.$Eac=i=o=ve([ne(0,h.$WW),ne(1,b.$Ni),ne(2,a.$E_b),ne(3,y.$t_b),ne(4,f.$Ml),ne(5,t.$Cac),ne(6,g.$QP),ne(7,k.$X_b),ne(8,d.$Nj),ne(9,v.$qac),ne(10,w.$7j),ne(11,c.$pac)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(ae[309],ce([0,1,6,20,5,308]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=void 0,e.$Fac=(0,n.$hi)("menubarMainService");let j=class{constructor(u,c,b){this.b=u,this.c=c,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$Eac)}async updateMenubar(u,c){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(c,u)}};e.$Gac=j,e.$Gac=j=ve([ne(0,n.$gi),ne(1,C.$X_b),ne(2,P.$Nj)],j)}),define(ae[310],ce([0,1,14,21,102,26,22,23,3,33,47,2,13,9,66,4,36,19,12,7,194,64,18,56,24,16,6,20,5,79,80,68,34,55,135,29,133,302,30,99,84,58,69,39,57,67,78]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R,B,L,W,U,x,le,se,ue,Y,Z,q,M,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;function z(X){return(0,le.$wi)(X?.workspace)}function oe(X){return(0,le.$ri)(X?.workspace)}let he=class extends y.$Uc{constructor(A,F,_,re,K,V,H,T,Q,te,fe,me,ke,Se,Oe,Ve,ye,ee,de,$e){super(),this.s=A,this.t=F,this.u=_,this.w=re,this.z=K,this.C=V,this.D=H,this.F=T,this.G=Q,this.H=te,this.I=fe,this.J=me,this.L=ke,this.M=Se,this.N=Oe,this.O=Ve,this.P=ye,this.Q=ee,this.R=de,this.S=$e,this.a=this.B(new u.$7d),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$7d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$7d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$7d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$7d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new u.$7d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new u.$7d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new u.$7d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new x.$4ac(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new y.$Tc;if(F.add(u.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const _=this.F.args,re=F?.remoteAuthority||void 0,K=!0,V=F?.forceReuseWindow,H=!V;return this.open({...A,cli:_,forceEmpty:K,forceNewWindow:H,forceReuseWindow:V,remoteAuthority:re})}openExistingWindow(A,F){A.focus(),this.W(F,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],_=[],re=[],K=[],V=[];let H,T=0;const Q=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",Q);for(const Se of Q)oe(Se)?A.addMode?F.push(Se):_.push(Se):z(Se)?re.push(Se):Se.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),H.filesToOpenOrCreate.push(Se)):Se.backupPath?V.push({backupFolder:(0,d.$oc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):T++;A.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),A.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&A.waitMarkerFileURI&&(H.filesToWait={paths:(0,j.$Hb)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(K.push(...this.M.getUntitledWorkspaces()),re.push(...K),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:te,filesOpenedInWindow:fe}=await this.X(A,re,_,V,T,H,F);if(this.w.trace(`windowsManager#open used window count ${te.length} (workspacesToOpen: ${re.length}, foldersToOpen: ${_.length}, emptyToRestore: ${V.length}, emptyToOpen: ${T})`),te.length>1)if(fe)fe.focus();else{const Se=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Oe=!0,Ve=!0;if(Se){const ye=te.filter(ee=>this.r.state.lastActiveWindow&&ee.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Oe=!1,Ve=!1)}if(Oe)for(let ye=te.length-1;ye>=0;ye--){const ee=te[ye];if(!(ee.openedWorkspace&&K.some(de=>ee.openedWorkspace&&de.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&V.some(de=>ee.backupPath&&de.backupFolder===(0,d.$oc)(ee.backupPath)))){ee.focus(),Ve=!1;break}}Ve&&te[te.length-1].focus()}const me=H&&H.filesToDiff.length>0,ke=H&&H.filesToMerge.length>0;if(!te.some(Se=>Se.isExtensionDevelopmentHost)&&!me&&!ke&&!A.noRecentEntry){const Se=[];for(const Oe of Q)z(Oe)&&!Oe.transient?Se.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):oe(Oe)?Se.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Se.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.L.addRecentlyOpened(Se)}return this.W(A,te),te}W(A,F){const _=A.waitMarkerFileURI;A.context===0&&_&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,F,_,re,K,V,H){const T=[];let Q;function te(ye,ee){T.push(ye),ee&&(Q=ye,V=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:me}=this.ob(A);if(!A.initialStartup&&H.length>0){const ye=H[0].remoteAuthority,ee=this.ub(ye);ee&&te(this.$(ee,H.map(de=>de.workspace.uri)))}const ke=_.length+F.length+re.length;if(V&&ke===0){const ye=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],ee=this.getWindows().filter($e=>V&&(0,g.$Zg)($e.remoteAuthority,V.remoteAuthority));let de;ye?.fileUri&&!me&&((A.context===4||A.context===0||A.context===1)&&(de=await(0,U.$J_b)(ee,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),de||(de=this.vb(ee))),de?(0,le.$wi)(de.openedWorkspace)?F.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):(0,le.$ri)(de.openedWorkspace)?_.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):te(this.Y(A,de,V),!0):te(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Se=(0,j.$Mb)(F,ye=>ye.workspace.id);if(Se.length>0){const ye=(0,j.$Hb)(Se.map(ee=>(0,U.$K_b)(this.getWindows(),ee.workspace.configPath)));if(ye.length>0){const ee=ye[0],de=(0,g.$Zg)(V?.remoteAuthority,ee.remoteAuthority)?V:void 0;te(this.Y(A,ee,de),!!de),fe=!0}for(const ee of Se){if(ye.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===ee.workspace.id))continue;const de=ee.remoteAuthority,$e=(0,g.$Zg)(V?.remoteAuthority,de)?V:void 0;te(await this.bb(A,ee,fe,$e),!!$e),fe=!0}}const Oe=(0,j.$Mb)(_,ye=>g.$Lg.getComparisonKey(ye.workspace.uri));if(Oe.length>0){const ye=(0,j.$Hb)(Oe.map(ee=>(0,U.$K_b)(this.getWindows(),ee.workspace.uri)));if(ye.length>0){const ee=ye[0],de=(0,g.$Zg)(V?.remoteAuthority,ee.remoteAuthority)?V:void 0;te(this.Y(A,ee,de),!!de),fe=!0}for(const ee of Oe){if(ye.some(Pe=>(0,le.$ri)(Pe.openedWorkspace)&&g.$Lg.isEqual(Pe.openedWorkspace.uri,ee.workspace.uri)))continue;const de=ee.remoteAuthority,$e=(0,g.$Zg)(V?.remoteAuthority,de)?V:void 0;te(await this.bb(A,ee,fe,$e),!!$e),fe=!0}}const Ve=(0,j.$Mb)(re,ye=>ye.backupFolder);if(Ve.length>0)for(const ye of Ve){const ee=ye.remoteAuthority,de=(0,g.$Zg)(V?.remoteAuthority,ee)?V:void 0;te(await this.ab(A,!0,ee,de,ye),!!de),fe=!0}if(T.length===0||V){V&&!K&&K++;const ye=V?V.remoteAuthority:A.remoteAuthority;for(let ee=0;ee<K;ee++)te(await this.ab(A,fe,ye,V),!!V),fe=!0}return{windows:(0,j.$Mb)(T),filesOpenedInWindow:Q}}Y(A,F,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(F);const re={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",E.CancellationToken.None,re),F}Z(A){let F=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const re=this.S.getWindowById(_.id);re&&re.parentId===A.id&&(F=re)}F.focus()}$(A,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const _={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,F,_,re,K){this.w.trace("windowsManager#doOpenEmpty",{restore:!!K,remoteAuthority:_,filesToOpen:re,forceNewWindow:F});let V;return!F&&typeof A.contextWindowId=="number"&&(V=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:re,windowToUse:V,emptyWindowBackupInfo:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,F,_,re,K){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:re}),!_&&!K&&typeof A.contextWindowId=="number"&&(K=this.getWindowById(A.contextWindowId)),this.pb({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:re,windowToUse:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let F,_=!1,re=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=await this.db(A),_=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=await this.eb(A.cli),F.length===0&&F.push(Object.create(null)),_=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),re=!0),!A.addMode&&_){const K=F.filter(V=>oe(V));if(K.length>1){const V=K[0].remoteAuthority;if(K.every(H=>(0,g.$Zg)(H.remoteAuthority,V))){const H=await this.M.createUntitledWorkspace(K.map(T=>({uri:T.workspace.uri})));F.push({workspace:H,remoteAuthority:V}),F=F.filter(T=>!oe(T))}}}if(A.initialStartup&&!re&&this.J.getValue("window")?.restoreWindows==="preserve"){const K=await this.gb();F.unshift(...K.filter(V=>z(V)||oe(V)||V.backupPath))}return F}async db(A){const F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,j.$Hb)(A.urisToOpen||[]).map(async re=>{const K=await this.ib(re,F);if(K)return K.label=re.label,K;const V=this.kb(re);this.O.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:V.scheme===k.Schemas.file?(0,$.localize)(1,null):(0,$.localize)(2,null),detail:V.scheme===k.Schemas.file?(0,$.localize)(3,null,(0,b.$ew)(V,{os:v.OS,tildify:this.F})):(0,$.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(A){const F=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},re=A["folder-uri"];if(re){const H=await Promise.all(re.map(T=>{const Q=this.fb(T);if(Q)return this.ib({folderUri:Q},_)}));F.push(...(0,j.$Hb)(H))}const K=A["file-uri"];if(K){const H=await Promise.all(K.map(T=>{const Q=this.fb(T);if(Q)return this.ib((0,le.$Mi)(T)?{workspaceUri:Q}:{fileUri:Q},_)}));F.push(...(0,j.$Hb)(H))}const V=await Promise.all(A._.map(H=>_.remoteAuthority?this.nb(H,_):this.lb(H,_)));return F.push(...(0,j.$Hb)(V)),F}fb(A){try{const F=h.URI.parse(A);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${A}, ${F.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const _=await Promise.all(F.map(async re=>{if(re.workspace){const K=await this.ib({workspaceUri:re.workspace.configPath},{remoteAuthority:re.remoteAuthority,rejectTransientWorkspaces:!0});if(z(K))return K}else if(re.folderUri){const K=await this.ib({folderUri:re.folderUri},{remoteAuthority:re.remoteAuthority});if(oe(K))return K}else if(A!=="folders"&&re.backupPath)return{backupPath:re.backupPath,remoteAuthority:re.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,F=Object.create(null)){const _=this.kb(A);return _.scheme===k.Schemas.file?((0,B.$aD)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,F)):this.jb(A,F)}jb(A,F){let _=this.kb(A);const re=(0,S.$sm)(_)||F.remoteAuthority;if(_=(0,g.$2g)((0,g.$Vg)(_)),(0,B.$aD)(A)){if(F.gotoLineMode){const{path:K,line:V,column:H}=(0,c.$og)(_.path);return{fileUri:_.with({path:K}),options:{selection:V?{startLineNumber:V,startColumn:H||1}:void 0},remoteAuthority:re}}return{fileUri:_,remoteAuthority:re}}else if((0,B.$$C)(A))return{workspace:(0,se.$N_b)(_),remoteAuthority:re};return{workspace:(0,se.$O_b)(_),remoteAuthority:re}}kb(A){return(0,B.$$C)(A)?A.workspaceUri:(0,B.$_C)(A)?A.folderUri:A.fileUri}async lb(A,F,_){let re,K;F.gotoLineMode&&({path:A,line:re,column:K}=(0,c.$og)(A)),A=(0,c.$jg)((0,d.$ic)(A),(0,w.cwd)());try{const V=await C.Promises.stat(A);if(V.isFile()){if(!F.forceOpenWorkspaceAsFile){const H=await this.M.resolveLocalWorkspace(h.URI.file(A));if(H)return H.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:H.id,configPath:H.configPath},type:i.FileType.File,exists:!0,remoteAuthority:H.remoteAuthority,transient:H.transient}}return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:re?{startLineNumber:re,startColumn:K||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,se.$O_b)(h.URI.file(A),V),type:i.FileType.Directory,exists:!0};if(!v.$i&&A==="/dev/null")return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,F);const H=h.URI.file(A);if(this.L.removeRecentlyOpened([H]),F.ignoreFileNotFound)return{fileUri:H,type:i.FileType.File,exists:!1}}}async mb(A,F){const _=h.URI.file(A),{response:re,checkboxChecked:K}=await this.O.showMessageBox({type:"warning",buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null),(0,$.localize)(7,null)],message:(0,$.localize)(8,null,_.authority),detail:(0,$.localize)(9,null,(0,b.$ew)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,$.localize)(10,null,_.authority),cancelId:1});if(re===0){if((0,P.addUNCHostToAllowlist)(_.authority),K){const V={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(A,F,!0)}if(re===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,F)}nb(A,F){const _=A.charCodeAt(0),re=F.remoteAuthority;let K,V;F.gotoLineMode&&({path:A,line:K,column:V}=(0,c.$og)(A)),_!==47&&((0,c.$ig)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.$bg)(A)),A=`/${A}`);const H=h.URI.from({scheme:k.Schemas.vscodeRemote,authority:re,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.$Mi)(A))return F.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:K?{startLineNumber:K,startColumn:V||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,se.$N_b)(H),remoteAuthority:re};if(F.gotoLineMode||d.$hc.basename(A).indexOf(".")!==-1)return{fileUri:H,options:{selection:K?{startLineNumber:K,startColumn:V||1}:void 0},remoteAuthority:re}}return{workspace:(0,se.$O_b)(H),remoteAuthority:re}}ob(A){const F=this.J.getValue("window"),_=F?.openFoldersInNewWindow||"default",re=F?.openFilesInNewWindow||"off";let K=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(K=_==="on");let V=!1;return A.forceNewWindow||A.forceReuseWindow?V=!!A.forceNewWindow&&!A.forceReuseWindow:(v.$j?A.context===1&&(V=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!A.cli.extensionDevelopmentPath&&(re==="on"||re==="off")&&(V=re==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(A,F){const _=(0,U.$L_b)(this.getWindows(),A);if(_)return this.H.reload(_,F.cli),_.focus(),[_];let re=F.cli["folder-uri"]||[],K=F.cli["file-uri"]||[],V=F.cli._;if(!V.length&&!re.length&&!K.length&&!F.cli.extensionTestsPath){const Q=this.r.state.lastPluginDevelopmentHostWindow,te=Q?.workspace??Q?.folderUri;te&&(h.URI.isUri(te)?te.scheme===k.Schemas.file?V=[te.fsPath]:re=[te.toString()]:te.configPath.scheme===k.Schemas.file?V=[(0,g.$Ig)(te.configPath)]:K=[te.configPath.toString()])}let H=F.remoteAuthority;for(const Q of A)if(Q.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const te=h.URI.parse(Q),fe=(0,S.$sm)(te);fe&&(H?(0,g.$Zg)(fe,H)||this.w.error("more than one extension development path authority"):H=fe)}V=V.filter(Q=>{const te=h.URI.file(Q);return(0,U.$K_b)(this.getWindows(),te)?!1:(0,g.$Zg)((0,S.$sm)(te),H)}),re=re.filter(Q=>{const te=this.fb(Q);return te&&(0,U.$K_b)(this.getWindows(),te)?!1:te?(0,g.$Zg)((0,S.$sm)(te),H):!1}),K=K.filter(Q=>{const te=this.fb(Q);return te&&(0,U.$K_b)(this.getWindows(),te)?!1:te?(0,g.$Zg)((0,S.$sm)(te),H):!1}),F.cli._=V,F.cli["folder-uri"]=re,F.cli["file-uri"]=K;const T={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!V.length&&!re.length&&!K.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:H,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(T)}async pb(A){const F=this.J.getValue("window"),_=this.getLastActiveWindow(),re=_?.profile??this.G.defaultProfile;let K;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(K=A.windowToUse||_,K&&K.focus());const V={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,d.$kc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:re},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(K){const H=K.config;!V.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=H.extensionDevelopmentPath,V.extensionDevelopmentKind=H.extensionDevelopmentKind,V["enable-proposed-api"]=H["enable-proposed-api"],V.verbose=H.verbose,V["inspect-extensions"]=H["inspect-extensions"],V["inspect-brk-extensions"]=H["inspect-brk-extensions"],V.debugId=H.debugId,V.extensionEnvironment=H.extensionEnvironment,V["extensions-dir"]=H["extensions-dir"],V["disable-extensions"]=H["disable-extensions"]),V.loggers={global:V.loggers.global,window:H?.loggers.window??V.loggers.window}}else{const H=this.r.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const T=K=this.N.createInstance(L.$V_b,{state:H,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(T),this.n.set(T.id,T),this.a.fire(T),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const Q=new y.$Tc;Q.add(T.onDidSignalReady(()=>this.b.fire(T))),Q.add(u.Event.once(T.onDidClose)(()=>this.sb(T,Q))),Q.add(u.Event.once(T.onDidDestroy)(()=>this.tb(T))),Q.add(T.onDidMaximize(()=>this.g.fire(T))),Q.add(T.onDidUnmaximize(()=>this.h.fire(T))),Q.add(T.onDidEnterFullScreen(()=>this.j.fire({window:T,fullscreen:!0}))),Q.add(T.onDidLeaveFullScreen(()=>this.j.fire({window:T,fullscreen:!1}))),Q.add(T.onDidTriggerSystemContextMenu(({x:fe,y:me})=>this.m.fire({window:T,x:fe,y:me})));const te=(0,f.$6f)(T.win?.webContents);te.removeAllListeners("devtools-reload-page"),te.on("devtools-reload-page",()=>this.H.reload(T)),this.H.registerWindow(T)}return V.windowId=K.id,K.isReady?this.H.unload(K,4).then(async H=>{H||await this.qb(K,V,A,re)}):await this.qb(K,V,A,re),K}async qb(A,F,_,re){if(F.extensionDevelopmentPath||((0,le.$wi)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,le.$ri)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,se.$P_b)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const K=F.workspace??(0,le.$vi)(F.backupPath,!1),V=this.rb(_,K,re),H=V instanceof Promise?await V:V;F.profiles.profile=H,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(K,H)}A.load(F)}rb(A,F,_){return A.forceProfile?this.G.profiles.find(re=>re.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??_}sb(A,F){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(F=>(0,g.$Zg)(F.remoteAuthority,A)))}vb(A){return(0,W.$G_b)(A)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...F)}sendToOpeningWindow(A,...F){this.B(u.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...F)}))}sendToAll(A,F,_){for(const re of this.getWindows())_&&_.indexOf(re.id)>=0||re.sendWhenReady(A,E.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const F=n.BrowserWindow.fromWebContents(A);if(F)return this.getWindowById(F.id)}};e.$7ac=he,e.$7ac=he=ve([ne(3,p.$Nj),ne(4,N.$S_b),ne(5,R.$QP),ne(6,q.$2n),ne(7,r.$t_b),ne(8,M.$H_b),ne(9,l.$X_b),ne(10,a.$y_b),ne(11,t.$Ni),ne(12,ue.$Cac),ne(13,Y.$Q_b),ne(14,s.$gi),ne(15,o.$z_b),ne(16,i.$Nk),ne(17,I.$B_b),ne(18,Z.$C_b),ne(19,G.$pac)],he)}),define(ae[311],ce([0,1,64,29,84,58]),function(J,e,n,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;let j=class{constructor(u,c,b,y){this.a=u,this.b=c,this.c=b,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,c){const b=this.b.getWindowById(u);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),c)}createUntitledWorkspace(u,c,b){return this.a.createUntitledWorkspace(c,b)}deleteUntitledWorkspace(u,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(u,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(u,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$9ac=j,e.$9ac=j=ve([ne(0,O.$Q_b),ne(1,C.$E_b),ne(2,P.$Cac),ne(3,n.$y_b)],j)}),define(ae[312],ce([0,1,14,102,37,26,17,51,15,33,3,42,47,2,13,9,4,12,7,32,160,44,161,114,294,164,64,287,18,203,92,134,56,120,224,24,63,95,213,297,215,216,217,16,228,94,77,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,83,126,28,255,257,54,49,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,84,311,58,39,237,57,248,53,82,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,61,78,307]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R,B,L,W,U,x,le,se,ue,Y,Z,q,M,N,G,z,oe,he,X,A,F,_,re,K,V,H,T,Q,te,fe,me,ke,Se,Oe,Ve,ye,ee,de,$e,Pe,Re,qe,Be,Le,Ue,xe,Xe,Fe,ie,ge,pe,be,Ee,Ae,Ne,Ke,Ye,Ze,Qe,st,tt,ot,at,yt,vt,kt,Et,Pt,ct,gt,St,jt,It,lt,Dt,$t,ut,Ct,Rt,ht,At,mt,Ot){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;let dt=class extends d.$Uc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,Ie,Ce,we,De,Te,ze,Ge,Me,We,He,Je){super(),this.g=je,this.h=Ie,this.j=Ce,this.m=we,this.n=De,this.s=Te,this.t=ze,this.u=Ge,this.w=Me,this.y=We,this.z=He,this.C=Je,this.D(),this.F()}D(){const je=Me=>Me?.startsWith(`${m.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Me,We,He,Je)=>je(Je.requestingUrl)?He(Ie.has(We)):He(!1)),n.session.defaultSession.setPermissionCheckHandler((Me,We,He,Je)=>je(Je.requestingUrl)?Ie.has(We):!1);const Ce=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Me=>{for(let We=Me;We;We=We.parent)if(We.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},De=Me=>Me.resourceType==="xhr"||we(Me.frame),Te=Me=>{const We=Me.frame;if(!We||!this.b)return!1;const He=n.BrowserWindow.getAllWindows();for(const Je of He)if(We.processId===Je.webContents.mainFrame.processId)return!0;return!1},ze=(Me,We)=>{if(Me.path!=="/index.html")return!0;const He=We.frame;if(!He||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&He.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Me,We)=>{const He=f.URI.parse(Me.url);return He.scheme===m.Schemas.vscodeWebview&&!ze(He,Me)?(this.m.error("Blocked vscode-webview request",Me.url),We({cancel:!0})):He.scheme===m.Schemas.vscodeFileResource&&!Te(Me)?(this.m.error("Blocked vscode-file request",Me.url),We({cancel:!0})):He.path.endsWith(".svg")&&!Ce.has(He.scheme)?We({cancel:!De(Me)}):We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Me,We)=>{const He=Me.responseHeaders,Je=He["content-type"]||He["Content-Type"];if(Je&&Array.isArray(Je)){const _e=f.URI.parse(Me.url);if(_e.path.endsWith(".svg")&&Ce.has(_e.scheme))return He["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:He});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Je.some(it=>it.toLowerCase().includes("image/svg")))return We({cancel:!De(Me)})}return We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Me,We)=>{if(Me.url.startsWith("https://vscode.download.prss.microsoft.com/")){const He=Me.responseHeaders??Object.create(null);if(He["Access-Control-Allow-Origin"]===void 0)return He["Access-Control-Allow-Origin"]=["*"],We({cancel:!1,responseHeaders:He})}return We({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(Ce=>this.H(Ce)),process.on("uncaughtException",Ce=>{(0,u.$Z)(Ce)||(0,u.$1)(Ce)}),process.on("unhandledRejection",Ce=>(0,u.$1)(Ce)),this.t.onWillShutdown(()=>this.dispose()),(0,$.$YV)(),n.app.on("accessibility-support-changed",(Ce,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(Ce,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Ce,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$Ag}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",De=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),we.setWindowOpenHandler(De=>De.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(De)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${De.url}}`),this.f?.openExternal(void 0,De.url),{action:"deny"}))});let je=[],Ie;n.app.on("open-file",(Ce,we)=>{this.m.trace("app#open-file: ",we),Ce.preventDefault(),je.push((0,Ae.$Mi)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],Ie=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),P.$XV.handle("vscode:fetchShellEnv",Ce=>{const we=this.b?.getWindowByWebContents(Ce.sender);let De,Te;return we?.config?(De=we.config,Te={...process.env,...we.config.userEnv}):(De=this.s.args,Te=process.env),this.X(De,Te,!1)}),P.$XV.handle("vscode:writeNlsFile",(Ce,we,De)=>{const Te=this.G([we]);if(!Te||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Te,j.$ue.fromString(De))}),P.$XV.handle("vscode:readNlsFile",async(Ce,...we)=>{const De=this.G(we);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(De)).value.toString()}),P.$XV.on("vscode:toggleDevTools",Ce=>Ce.sender.toggleDevTools()),P.$XV.on("vscode:openDevTools",Ce=>Ce.sender.openDevTools()),P.$XV.on("vscode:reloadWindow",Ce=>Ce.sender.reload()),P.$XV.handle("vscode:notifyZoomLevel",async(Ce,we)=>{const De=this.b?.getWindowById(Ce.sender.id);De&&De.notifyZoomLevel(we)})}G(je){let Ie;for(const Ce of je)typeof Ce=="string"&&(typeof Ie!="string"?Ie=Ce:Ie=(0,v.$kc)(Ie,Ce));if(!(typeof Ie!="string"||!(0,v.$jc)(Ie)||!(0,c.$hg)(Ie,this.s.cachedLanguagesPath,!w.$k)))return f.URI.file(Ie)}H(je){if(je){const Ie={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;w.$i&&je&&n.app.setAppUserModelId(je);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Ie=new t.$5V;this.t.onWillShutdown(We=>{We.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Ce,we]=await Promise.all([(0,gt.$ebc)(this.w,this.m),(0,gt.$fbc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ce}`);const{sharedProcessReady:De,sharedProcessClient:Te}=this.P(Ce,we),ze=await this.Q(Ce,we,De);this.B(ze.createInstance(r.$8_b)),this.B(ze.createInstance(Et.$abc)),ze.invokeFunction(We=>this.R(We,Ie,Te));const Ge=await ze.invokeFunction(We=>this.I(We,Ie));this.J(Ie),this.t.phase=2,await ze.invokeFunction(We=>this.S(We,Ge)),this.t.phase=3,this.U(),this.B(new ct.$th(()=>{this.B((0,ct.$xh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,Ie){const Ce=this.b=je.get(pe.$E_b),we=je.get(Le.$MW),De=this.f=je.get(V.$qac),Te=je.get(R.$z_b),ze=this;we.registerHandler({async handleURL(_e,it){return ze.O(Ce,Te,we,_e,it)}});const Ge=this.B(new Ee.$8ac({onDidOpenMainWindow:De.onDidOpenMainWindow,onDidFocusMainWindow:De.onDidFocusMainWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Me=new a.$2h(_e=>Ge.getActiveClientId().then(it=>_e===it)),We=new Ue.$Yac(Me,this.m),He=Ie.getChannel("urlHandler",We);we.registerHandler(new Ue.$Xac(He));const Je=await this.L(Ce,Te);return this.B(new Xe.$Zac(Je?.urls,we,Ce,this.s,this.z,this.m)),Je}J(je){const Ie=()=>({statusCode:404,data:"Not found"}),Ce=new At.$V(()=>je.getChannel(ht.$mbc,new ht.$nbc));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,De)=>{const Te=f.URI.parse(we.url);if(!Te.authority.startsWith("window:"))return De(Ie());Ce.value.call(ht.$lbc,[Te]).then(ze=>De({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),De({statusCode:500,data:String(ze)})})})}async L(je,Ie){const Ce=this.s.args["open-url"]?this.s.args._urls||[]:[];Ce.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Ce.length+we.length===0)return;const De=[...Ce,...we].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),Te=[],ze=[];for(const Ge of De){if(!Ge)continue;const Me=this.N(Ge.uri);if(Me)if(await this.M(Me,je,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Me),Te.push(Me);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),ze.push(Ge)}return{urls:ze,openables:Te}}async M(je,Ie,Ce){let we,De;if((0,ge.$$C)(je)?(we=je.workspaceUri,De=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,k.$ew)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,ge.$_C)(je)?(we=je.folderUri,De=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,k.$ew)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=je.fileUri,De=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,k.$ew)(we,{os:w.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ge}=await Ce.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:De,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ge){const Me={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};Ie.sendToFocused(Me.channel,Me.args),Ie.sendToOpeningWindow(Me.channel,Me.args)}return!1}N(je){if(je.path){if(je.authority===m.Schemas.file){const Ie=f.URI.file(je.fsPath);return(0,Ae.$Mi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(je.authority===m.Schemas.vscodeRemote){const Ie=je.path.indexOf(v.$hc.sep,1);if(Ie!==-1){const Ce=je.path.substring(1,Ie),we=je.path.substring(Ie);let De=je.query;const Te=new URLSearchParams(je.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),De=Te.toString());const ze=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:Ce,path:we,query:De,fragment:je.fragment});return(0,Ae.$Mi)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(je,Ie,Ce,we,De){this.m.trace("app#handleProtocolUrl():",we.toString(!0),De),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let Te=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Te=!0):w.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Te=!0);const Ge=ze.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Ge??void 0);const Me=this.N(we);return Me?await this.M(Me,je,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Me,we.toString(!0)),(0,$t.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[Me],forceNewWindow:Te,gotoLineMode:!0}))?.focus(),!0):Te?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,T.$sm)(we)}))?.ready(),Ce.open(we,De)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),De),!1)}P(je,Ie){const Ce=this.B(this.j.createInstance(Q.$Kac,je,Ie)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Te=await Ce.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$6V(Te,"main")})();return{sharedProcessReady:(async()=>(await Ce.whenReady(),we))(),sharedProcessClient:we}}async Q(je,Ie,Ce){const we=new oe.$fi;switch(process.platform){case"win32":we.set(de.$WW,new G.$ei(Be.$Vac));break;case"linux":w.$l?we.set(de.$WW,new G.$ei(qe.$Uac,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(de.$WW,new G.$ei(Re.$Tac));break;case"darwin":we.set(de.$WW,new G.$ei(Pe.$Sac));break}we.set(pe.$E_b,new G.$ei(be.$7ac,[je,Ie,this.h],!1)),we.set(mt.$pac,new G.$ei(Ot.$obc,void 0,!1));const De=new R.$A_b(this.m,this.z);we.set(R.$z_b,De),we.set(F.$wac,new G.$ei(F.$xac,void 0,!1)),we.set(S.$bac,new G.$ei(S.$cac,void 0,!1)),we.set(I.$1m,a.ProxyChannel.toService((0,a.$Zh)(Ce.then(We=>We.getChannel("diagnostics"))))),we.set(he.$hCb,new G.$ei(X.$sac,[this.h])),we.set(B.$GW,new G.$ei(L.$dac)),we.set(A.$tac,new G.$ei(A.$uac)),we.set(V.$qac,new G.$ei(V.$rac,void 0,!1)),we.set(Fe.$1ac,new G.$ei(ie.$3ac)),we.set(K.$Fac,new G.$ei(K.$Gac)),we.set(le.$eac,new G.$ei(se.$gac)),we.set(ke.$4_b,new G.$ei(ke.$5_b)),we.set(ke.$6_b,new G.$ei(ke.$7_b));const Te=new Ct.$kbc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Rt.$ds(Te,this.u,this.m,this.n);we.set(ut.$Qr,ze),w.$i?we.set(ue.$hac,new G.$ei(Y.$iac)):w.$j?we.set(ue.$hac,new G.$ei(Y.$jac)):w.$k&&we.set(ue.$hac,new G.$ei(Y.$kac));const Ge=new l.$9_b(this.s,this.u,this.m,this.w);we.set(s.$y_b,Ge);const Me=new Ze.$R_b(this.s,this.m,this.C,Ge,De);if(we.set(Ze.$Q_b,Me),we.set(Ne.$web,new G.$ei(Ye.$9ac,void 0,!1)),we.set(Ke.$Cac,new G.$ei(Ke.$Dac,void 0,!1)),we.set(Le.$MW,new G.$ei(xe.$OW,void 0,!1)),(0,ee.$0o)(this.z,this.s)){const We=(0,ee.$cp)(this.z,this.u),He=(0,a.$Zh)(Ce.then(rt=>rt.getChannel("telemetryAppender"))),Je=new Ve.$Nac(He),_e=(0,Se.$1o)((0,O.release)(),(0,O.hostname)(),process.arch,this.z.commit,this.z.version,je,Ie,We),it=(0,ee.$dp)(this.s),nt={appenders:[Je],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(Oe.$Ml,new G.$ei(ye.$Hr,[nt],!1))}else we.set(Oe.$Ml,ee.$5o);return we.set(yt.$aq,new G.$ei(St.$XP,void 0,!0)),we.set(vt.$eq,new G.$ei(kt.$_ac,void 0,!0)),we.set(lt.$ibc,new G.$ei(lt.$jbc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),Me.initialize()]),this.j.createChild(we)}R(je,Ie,Ce){const we=this.B(new d.$Tc),De=a.ProxyChannel.fromService(je.get(F.$wac),we,{disableMarshalling:!0});this.g.registerChannel("launch",De);const Te=a.ProxyChannel.fromService(je.get(S.$bac),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Te);const ze=new st.$0ac(je.get(Qe.$2n));Ie.registerChannel("policy",ze),Ce.then(et=>et.registerChannel("policy",ze));const Ge=this.y.getProvider(m.Schemas.file);(0,g.$5f)(Ge instanceof N.$Tq);const Me=new M.$lac(Ge,this.m,this.s);Ie.registerChannel(Z.$GP,Me),Ce.then(et=>et.registerChannel(Z.$GP,Me));const We=a.ProxyChannel.fromService(je.get(tt.$H_b),we);Ie.registerChannel("userDataProfiles",We),Ce.then(et=>et.registerChannel("userDataProfiles",We));const He=new ot.$Cr(je.get(at.$yp));Ce.then(et=>et.registerChannel("request",He));const Je=new $e.$Oac(je.get(de.$WW));Ie.registerChannel("update",Je);const _e=a.ProxyChannel.fromService(je.get(he.$hCb),we);Ie.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(je.get(B.$GW),we);Ie.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(je.get(te.$Al),we);Ie.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(je.get(A.$tac),we);Ie.registerChannel("keyboardLayout",rt),this.f=je.get(V.$qac);const wt=a.ProxyChannel.fromService(this.f,we);Ie.registerChannel("nativeHost",wt),Ce.then(et=>et.registerChannel("nativeHost",wt));const Bt=a.ProxyChannel.fromService(je.get(Ne.$web),we);Ie.registerChannel("workspaces",Bt);const Mt=a.ProxyChannel.fromService(je.get(K.$Fac),we);Ie.registerChannel("menubar",Mt);const Lt=a.ProxyChannel.fromService(je.get(Le.$MW),we);Ie.registerChannel("url",Lt);const Wt=a.ProxyChannel.fromService(je.get(Fe.$1ac),we);Ie.registerChannel("webview",Wt);const pt=this.B(new me.$Lac(this.m,je.get(ke.$4_b)));Ie.registerChannel("storage",pt),Ce.then(et=>et.registerChannel("storage",pt));const Ft=this.B(new Pt.$bbc(je.get(ke.$4_b),je.get(tt.$H_b),this.m));Ce.then(et=>et.registerChannel("profileStorageListener",Ft));const Nt=a.ProxyChannel.fromService(je.get(ut.$Qr),we);Ie.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const Tt=a.ProxyChannel.fromService(je.get(ue.$hac),we);Ie.registerChannel("externalTerminal",Tt);const bt=new jt.$gbc(je.get(It.$S_b));Ie.registerChannel("logger",bt),Ce.then(et=>et.registerChannel("logger",bt));const zt=new D.$0_b(je.get(pe.$E_b));Ie.registerChannel("extensionhostdebugservice",zt);const qt=a.ProxyChannel.fromService(je.get(le.$eac),we);Ie.registerChannel(le.$fac,qt);const Ut=a.ProxyChannel.fromService(je.get(lt.$ibc),we);Ie.registerChannel(Dt.$hbc,Ut)}async S(je,Ie){const Ce=this.b=je.get(pe.$E_b);this.c=je.get(mt.$pac);const we=(0,U.$lm)(process.env)?0:4,De=this.s.args;if(Ie){if(Ie.openables.length>0)return Ce.open({context:we,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const nt of Ie.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),Ce.open({context:we,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,ze=De._.length,Ge=!!De["folder-uri"],Me=!!De["file-uri"],We=De["skip-add-to-recently-opened"]===!0,He=De.wait&&De.waitMarkerFilePath?f.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,_e=De.profile,it=De["profile-temp"];if(!ze&&!Ge&&!Me){if(De["new-window"]||_e||it)return Ce.open({context:we,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:He,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:it});if(Te.length)return Ce.open({context:1,cli:De,urisToOpen:Te.map(nt=>(0,Ae.$Mi)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:We,waitMarkerFileURI:He,initialStartup:!0})}return Ce.open({context:we,cli:De,forceNewWindow:De["new-window"]||!ze&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:We,waitMarkerFileURI:He,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(je,Ie)=>{Ie({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(w.$i&&je)try{const Ie=await new Promise((we,De)=>{J(["@vscode/windows-mutex"],we,De)}),Ce=new Ie.Mutex(je);b.Event.once(this.t.onWillShutdown)(()=>Ce.release())}catch(Ie){this.m.error(Ie)}}async X(je,Ie,Ce){try{return await(0,x.$rm)(this.u,this.m,je,Ie)}catch(we){const De=(0,E.$5i)(we);Ce?this.b?.sendToFocused("vscode:showResolveShellEnvError",De):this.m.error(De)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Ce=JSON.parse((0,y.$Cn)(Ie)),De=(0,ee.$_o)(this.u)>=1;if(Ce["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Dg)()}"`,"}"],ze=Ie.substring(0,Ie.length-2).concat(`,
`,Te.join(`
`));await this.y.writeFile(this.s.argvResource,j.$ue.fromString(ze))}else{const Te=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Te!==Ie&&await this.y.writeFile(this.s.argvResource,j.$ue.fromString(Te))}}catch(je){this.m.error(je)}}};e.$pbc=dt,e.$pbc=dt=ft=ve([ne(2,z.$gi),ne(3,re.$Nj),ne(4,re.$Oj),ne(5,W.$t_b),ne(6,_.$X_b),ne(7,p.$Ni),ne(8,fe.$QP),ne(9,q.$Nk),ne(10,H.$7j),ne(11,tt.$H_b)],dt)}),define(ae[317],ce([0,1,14,43,7,22,8,51,15,33,3,47,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,63,205,16,226,94,77,222,93,20,229,5,79,27,80,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(J,e,n,C,P,O,j,E,u,c,b,y,k,d,m,v,w,g,f,h,$,a,t,o,r,i,s,l,p,D,I,S,R,B,L,W,U,x,le,se,ue,Y,Z,q,M,N,G,z,oe,he,X,A,F,_,re,K,V,H,T,Q,te,fe,me,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ye){console.error(ye.message),n.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Le=>console.error(Le));const[ye,ee,de,$e,Pe,Re,qe,Be]=this.b();try{try{await this.d(de,Be,$e,Pe,qe)}catch(Le){throw this.g(de,qe,Le),Le}await ye.invokeFunction(async Le=>{const Ue=Le.get(x.$Nj),xe=Le.get(W.$X_b),Xe=Le.get(D.$Nk),Fe=Le.get(x.$Oj),ie=await this.f(Ue,de,xe,ye,qe,!0);return f.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(ge=>{Ue.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Re.logger=Fe.createLogger("main",{name:(0,t.localize)(0,null)}),b.Event.once(xe.onWillShutdown)(ge=>{Xe.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(de.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$pbc,ie,ee).startup()})}catch(Le){ye.invokeFunction(this.j,Le)}}b(){const ye=new L.$fi,ee=new K.$Tc;process.once("exit",()=>ee.dispose());const de={_serviceBrand:void 0,...le.default};ye.set(se.$7j,de);const $e=new s.$u_b(this.k(),de),Pe=this.c($e);ye.set(s.$t_b,$e);const Re=new T.$T_b((0,x.$2j)($e),$e.logsHome);ye.set(T.$S_b,Re);const qe=new U.$_9b(Re.getLogLevel()),Be=ee.add(new Q.$YP(qe,[new x.$Uj(Re.getLogLevel())]));ye.set(x.$Nj,Be);const Le=new I.$tq(Be);ye.set(D.$Nk,Le);const Ue=new S.$Tq(Be);Le.registerProvider(k.Schemas.file,Ue);const xe=new H.$hs(Le);ye.set(V.$ll,xe);const Xe=new fe.$TP(1,$e,Be,Le);ye.set(oe.$PP,Xe),ye.set(oe.$QP,Xe);const Fe=new A.$I_b(Xe,xe,$e,Le,Be);ye.set(A.$H_b,Fe),Le.registerProvider(k.Schemas.vscodeUserData,new me.$Abc(k.Schemas.file,Ue,k.Schemas.vscodeUserData,Fe,xe,Be));const ie=v.$i&&de.win32RegValueName?ee.add(new _.$ybc(Be,de.win32RegValueName)):$e.policyFile?ee.add(new re.$zbc($e.policyFile,Le,Be)):new F.$4n;ye.set(F.$2n,ie);const ge=new r.$ro(Fe.defaultProfile.settingsResource,Le,ie,Be);return ye.set(o.$Ni,ge),ye.set(W.$X_b,new R.$ei(W.$Y_b,void 0,!1)),ye.set(M.$yp,new R.$ei(N.$wbc,void 0,!0)),ye.set(X.$C_b,new R.$ei(X.$D_b)),ye.set(G.$Al,new R.$ei(z.$xbc,void 0,!1)),ye.set(Z.$Uv,new R.$ei(q.$ubc)),ye.set(ue.$B_b,new Y.$rbc($e,Fe,Be)),[new B.$Wq(ye,!0),Pe,$e,ge,Xe,qe,de,Fe]}c(ye){const ee={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const $e=process.env[de];typeof $e=="string"&&(ee[de]=$e)}),Object.assign(process.env,ee),ee}async d(ye,ee,de,$e,Pe){await j.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(Re=>Re?f.Promises.mkdir(Re,{recursive:!0}):void 0)),$e.init(),de.initialize()]),ee.init()}e(ye){if(v.$i){const ee=(0,ke.getUNCHost)(ye);ee&&(0,ke.addUNCHostToAllowlist)(ee)}return ye}async f(ye,ee,de,$e,Pe,Re){let qe;try{(0,m.mark)("code/willStartMainServer"),qe=await(0,$.$ci)(ee.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),b.Event.once(de.onWillShutdown)(()=>qe.dispose())}catch(Be){if(Be.code!=="EADDRINUSE")throw this.g(ee,Pe,Be),Be;let Le;try{Le=await(0,$.$di)(ee.mainIPCHandle,"main")}catch(Fe){if(!Re||v.$i||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),Fe;try{(0,C.unlinkSync)(ee.mainIPCHandle)}catch(ie){throw ye.warn("Could not delete obsolete instance handle",ie),ie}return this.f(ye,ee,de,$e,Pe,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const Fe=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw ye.error(Fe),Le.dispose(),new Error(Fe)}let Ue;!ee.args.wait&&!ee.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const xe=h.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=h.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return $e.invokeFunction(async()=>{const Fe=new i.$os(he.$5o,Pe),ie=await Xe.getMainDiagnostics(),ge=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Fe.getDiagnostics(ie,ge);throw console.log(pe),new u.$ab});throw v.$i&&await this.i(xe,ye),ye.trace("Sending env to running instance..."),await xe.start(ee.args,process.env),Le.dispose(),Ue&&clearTimeout(Ue),new u.$ab("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new u.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),qe}g(ye,ee,de){if(de.code==="EACCES"||de.code==="EPERM"){const $e=(0,O.$Hb)([ye.userDataPath,ye.extensionsPath,$.$$h]).map(Pe=>(0,y.$ew)(P.URI.file(Pe),{os:v.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$5i)(de),$e.join(`
`)),ee)}}h(ye,ee,de){n.dialog.showMessageBoxSync((0,te.$sw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:ee},de).options)}async i(ye,ee){if(v.$i){const de=await ye.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",de);try{(await new Promise(($e,Pe)=>{J(["windows-foreground-love"],$e,Pe)})).allowSetForegroundWindow(de)}catch($e){ee.error($e)}}}j(ye,ee){const de=ye.get(x.$Nj),$e=ye.get(W.$X_b);let Pe=0;ee&&(ee.isExpected?ee.message&&de.trace(ee.message):(Pe=1,ee.stack?de.error(ee.stack):de.error(`Startup error: ${ee.toString()}`))),$e.kill(Pe)}k(){const ye=this.l((0,l.$im)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const ee=(0,p.$qbc)(ye.verbose);ee&&((0,l.$km)(process.argv,"--waitMarkerFilePath",ee),ye.waitMarkerFilePath=ee)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const ee=this.m(ye._,ye.goto);ye._=ee}return ye}m(ye,ee){const de=(0,w.cwd)(),$e=ye.map(qe=>{let Be=String(qe),Le;ee&&(Le=(0,c.$og)(Be),Be=Le.path),Be&&(Be=this.n(de,Be));const Ue=(0,c.$jg)(Be,de),xe=(0,d.$oc)(Ue);return xe&&!(0,c.$fg)(xe)?null:ee&&Le?(Le.path=Ue,this.o(Le)):Ue}),Pe=v.$i||v.$j,Re=(0,O.$Mb)($e,qe=>qe&&Pe?qe.toLowerCase():qe||"");return(0,O.$Hb)(Re)}n(ye,ee){return v.$i&&(ee=(0,g.$6e)(ee,'"')),ee=(0,g.$4e)((0,g.$4e)(ee," "),"	"),v.$i&&(ee=(0,d.$lc)(ye,ee),ee=(0,g.$6e)(ee,".")),ee}o(ye){const ee=[ye.path];return typeof ye.line=="number"&&ee.push(String(ye.line)),typeof ye.column=="number"&&ee.push(String(ye.column)),ee.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7107b38665e428a974c06b2c6e8f67a9a078aefd/core/vs/code/electron-main/main.js.map
